/* TimedQueue.c generated by valac 0.39.7, the Vala compiler
 * generated from TimedQueue.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* TimedQueue is a specialized collection class.  It holds items in order, but rather than being*/
/* manually dequeued, they are dequeued automatically after a specified amount of time has elapsed*/
/* for that item.  As of today, it's possible the item will be dequeued a bit later than asked*/
/* for, but it will never be early.  Future implementations might tighten up the lateness.*/
/**/
/* The original design was to use a signal to notify when an item has been dequeued, but Vala has*/
/* a bug with passing an unnamed type as a signal parameter:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=628639*/
/**/
/* The rate the items come off the queue can be spaced out.  Note that this can cause items to back*/
/* up.  As of today, TimedQueue makes no effort to combat this.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;
typedef struct _TimedQueuePrivate TimedQueuePrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define TIMED_QUEUE_TYPE_ELEMENT (timed_queue_element_get_type ())
#define TIMED_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement))
#define TIMED_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))
#define TIMED_QUEUE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))

typedef struct _TimedQueueElement TimedQueueElement;
typedef struct _TimedQueueElementClass TimedQueueElementClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TimedQueueElementPrivate TimedQueueElementPrivate;
#define _timed_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_element_unref (var), NULL)))
#define _g_destroy_func0(var) (((var == NULL) || (g_destroy_func == NULL)) ? NULL : (var = (g_destroy_func (var), NULL)))
typedef struct _TimedQueueParamSpecElement TimedQueueParamSpecElement;
typedef struct _ParamSpecTimedQueue ParamSpecTimedQueue;
enum  {
	TIMED_QUEUE_PAUSED_SIGNAL,
	TIMED_QUEUE_NUM_SIGNALS
};
static guint timed_queue_signals[TIMED_QUEUE_NUM_SIGNALS] = {0};

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
typedef struct _HashTimedQueuePrivate HashTimedQueuePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
struct _TimedQueue {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueuePrivate * priv;
};

struct _TimedQueueClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueue *self);
	void (*notify_dequeued) (TimedQueue* self, gconstpointer item);
	void (*clear) (TimedQueue* self);
	gboolean (*contains) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue_many) (TimedQueue* self, GeeCollection* items);
	gboolean (*remove_first) (TimedQueue* self, gconstpointer item);
	void (*paused) (TimedQueue* self, gboolean is_paused);
	gint (*get_size) (TimedQueue* self);
};

struct _TimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	guint hold_msec;
	DequeuedCallback callback;
	gpointer callback_target;
	GeeEqualDataFunc equal_func;
	gpointer equal_func_target;
	GDestroyNotify equal_func_target_destroy_notify;
	gint priority;
	guint timer_id;
	SortedList* queue;
	guint dequeue_spacing_msec;
	gulong last_dequeue;
	gboolean paused_state;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _TimedQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueueElementPrivate * priv;
	gpointer item;
	gulong ready;
};

struct _TimedQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueueElement *self);
};

struct _TimedQueueElementPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
};

struct _TimedQueueParamSpecElement {
	GParamSpec parent_instance;
};

struct _ParamSpecTimedQueue {
	GParamSpec parent_instance;
};

struct _HashTimedQueue {
	TimedQueue parent_instance;
	HashTimedQueuePrivate * priv;
};

struct _HashTimedQueueClass {
	TimedQueueClass parent_class;
};

struct _HashTimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeHashMap* item_count;
};


static gpointer timed_queue_parent_class = NULL;
static gpointer timed_queue_element_parent_class = NULL;
static gpointer hash_timed_queue_parent_class = NULL;

gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_timed_queue (GValue* value,
                            gpointer v_object);
void value_take_timed_queue (GValue* value,
                             gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType sorted_list_get_type (void) G_GNUC_CONST;
static gpointer timed_queue_element_ref (gpointer instance);
static void timed_queue_element_unref (gpointer instance);
static GParamSpec* timed_queue_param_spec_element (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED;
static void timed_queue_value_set_element (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED;
static void timed_queue_value_take_element (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer timed_queue_value_get_element (const GValue* value) G_GNUC_UNUSED;
static GType timed_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define TIMED_QUEUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TIMED_QUEUE, TimedQueuePrivate))
TimedQueue* timed_queue_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             guint hold_msec,
                             DequeuedCallback callback,
                             void* callback_target,
                             GeeEqualDataFunc equal_func,
                             void* equal_func_target,
                             GDestroyNotify equal_func_target_destroy_notify,
                             gint priority);
TimedQueue* timed_queue_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   guint hold_msec,
                                   DequeuedCallback callback,
                                   void* callback_target,
                                   GeeEqualDataFunc equal_func,
                                   void* equal_func_target,
                                   GDestroyNotify equal_func_target_destroy_notify,
                                   gint priority);
static gint64 timed_queue_element_comparator (void* a,
                                       void* b);
static gint64 _timed_queue_element_comparator_comparator (void* a,
                                                   void* b,
                                                   gpointer self);
SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             void* cmp_target);
SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   void* cmp_target);
static guint timed_queue_get_heartbeat_timeout (TimedQueue* self);
static gboolean timed_queue_on_heartbeat (TimedQueue* self);
static gboolean _timed_queue_on_heartbeat_gsource_func (gpointer self);
guint timed_queue_get_dequeue_spacing_msec (TimedQueue* self);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self,
                                           guint msec);
void timed_queue_notify_dequeued (TimedQueue* self,
                                  gconstpointer item);
static void timed_queue_real_notify_dequeued (TimedQueue* self,
                                       gconstpointer item);
gboolean timed_queue_is_paused (TimedQueue* self);
void timed_queue_pause (TimedQueue* self);
void timed_queue_unpause (TimedQueue* self);
void timed_queue_clear (TimedQueue* self);
static void timed_queue_real_clear (TimedQueue* self);
gboolean timed_queue_contains (TimedQueue* self,
                               gconstpointer item);
static gboolean timed_queue_real_contains (TimedQueue* self,
                                    gconstpointer item);
gboolean timed_queue_enqueue (TimedQueue* self,
                              gconstpointer item);
static gboolean timed_queue_real_enqueue (TimedQueue* self,
                                   gconstpointer item);
static gulong timed_queue_calc_ready_time (TimedQueue* self);
static TimedQueueElement* timed_queue_element_new (GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            gconstpointer item,
                                            gulong ready);
static TimedQueueElement* timed_queue_element_construct (GType object_type,
                                                  GType g_type,
                                                  GBoxedCopyFunc g_dup_func,
                                                  GDestroyNotify g_destroy_func,
                                                  gconstpointer item,
                                                  gulong ready);
gboolean timed_queue_enqueue_many (TimedQueue* self,
                                   GeeCollection* items);
static gboolean timed_queue_real_enqueue_many (TimedQueue* self,
                                        GeeCollection* items);
gboolean sorted_list_add_list (SortedList* self,
                               GeeList* items);
gboolean timed_queue_remove_first (TimedQueue* self,
                                   gconstpointer item);
static gboolean timed_queue_real_remove_first (TimedQueue* self,
                                        gconstpointer item);
gulong now_ms (void);
gpointer sorted_list_get_at (SortedList* self,
                             gint index);
gpointer sorted_list_remove_at (SortedList* self,
                                gint index);
gint timed_queue_get_size (TimedQueue* self);
static void timed_queue_real_paused (TimedQueue* self,
                              gboolean is_paused);
#define TIMED_QUEUE_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementPrivate))
static void timed_queue_element_finalize (TimedQueueElement * obj);
static void timed_queue_finalize (TimedQueue * obj);
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
#define HASH_TIMED_QUEUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HASH_TIMED_QUEUE, HashTimedQueuePrivate))
HashTimedQueue* hash_timed_queue_new (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      guint hold_msec,
                                      DequeuedCallback callback,
                                      void* callback_target,
                                      GeeHashDataFunc hash_func,
                                      void* hash_func_target,
                                      GDestroyNotify hash_func_target_destroy_notify,
                                      GeeEqualDataFunc equal_func,
                                      void* equal_func_target,
                                      GDestroyNotify equal_func_target_destroy_notify,
                                      gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            guint hold_msec,
                                            DequeuedCallback callback,
                                            void* callback_target,
                                            GeeHashDataFunc hash_func,
                                            void* hash_func_target,
                                            GDestroyNotify hash_func_target_destroy_notify,
                                            GeeEqualDataFunc equal_func,
                                            void* equal_func_target,
                                            GDestroyNotify equal_func_target_destroy_notify,
                                            gint priority);
static void hash_timed_queue_real_notify_dequeued (TimedQueue* base,
                                            gconstpointer item);
static void hash_timed_queue_removed (HashTimedQueue* self,
                               gconstpointer item);
static void hash_timed_queue_real_clear (TimedQueue* base);
static gboolean hash_timed_queue_real_contains (TimedQueue* base,
                                         gconstpointer item);
static gboolean hash_timed_queue_real_enqueue (TimedQueue* base,
                                        gconstpointer item);
static gboolean hash_timed_queue_real_enqueue_many (TimedQueue* base,
                                             GeeCollection* items);
static gboolean hash_timed_queue_real_remove_first (TimedQueue* base,
                                             gconstpointer item);
static void hash_timed_queue_finalize (TimedQueue * obj);


static gint64
_timed_queue_element_comparator_comparator (void* a,
                                            void* b,
                                            gpointer self)
{
	gint64 result;
	result = timed_queue_element_comparator (a, b);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 360 "TimedQueue.c"
}


static gboolean
_timed_queue_on_heartbeat_gsource_func (gpointer self)
{
	gboolean result;
	result = timed_queue_on_heartbeat ((TimedQueue*) self);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 371 "TimedQueue.c"
}


TimedQueue*
timed_queue_construct (GType object_type,
                       GType g_type,
                       GBoxedCopyFunc g_dup_func,
                       GDestroyNotify g_destroy_func,
                       guint hold_msec,
                       DequeuedCallback callback,
                       void* callback_target,
                       GeeEqualDataFunc equal_func,
                       void* equal_func_target,
                       GDestroyNotify equal_func_target_destroy_notify,
                       gint priority)
{
	TimedQueue* self = NULL;
	SortedList* _tmp4_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (TimedQueue*) g_type_create_instance (object_type);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->hold_msec = hold_msec;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->callback = callback;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->callback_target = callback_target;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (equal_func != NULL) {
#line 406 "TimedQueue.c"
		GeeEqualDataFunc _tmp0_;
		void* _tmp0__target;
		GDestroyNotify _tmp0__target_destroy_notify;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = equal_func;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0__target = equal_func_target;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0__target_destroy_notify = equal_func_target_destroy_notify;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func_target = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func_target_destroy_notify = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = _tmp0_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp0__target;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp0__target_destroy_notify;
#line 436 "TimedQueue.c"
	} else {
		void* _tmp1_;
		GDestroyNotify _tmp2_;
		GeeEqualDataFunc _tmp3_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = gee_functions_get_equal_func_for (g_type, &_tmp1_, &_tmp2_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = (GeeEqualDataFunc) _tmp3_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp1_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp2_;
#line 457 "TimedQueue.c"
	}
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->priority = priority;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = sorted_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, _timed_queue_element_comparator_comparator, NULL);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->queue = _tmp4_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (priority, timed_queue_get_heartbeat_timeout (self), _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 479 "TimedQueue.c"
}


TimedQueue*
timed_queue_new (GType g_type,
                 GBoxedCopyFunc g_dup_func,
                 GDestroyNotify g_destroy_func,
                 guint hold_msec,
                 DequeuedCallback callback,
                 void* callback_target,
                 GeeEqualDataFunc equal_func,
                 void* equal_func_target,
                 GDestroyNotify equal_func_target_destroy_notify,
                 gint priority)
{
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return timed_queue_construct (TYPE_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 497 "TimedQueue.c"
}


guint
timed_queue_get_dequeue_spacing_msec (TimedQueue* self)
{
	guint result = 0U;
	guint _tmp0_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->dequeue_spacing_msec;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp0_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 514 "TimedQueue.c"
}


void
timed_queue_set_dequeue_spacing_msec (TimedQueue* self,
                                      guint msec)
{
	guint _tmp0_;
	guint _tmp1_;
	gint _tmp3_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->dequeue_spacing_msec;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (msec == _tmp0_) {
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 533 "TimedQueue.c"
	}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->timer_id;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 539 "TimedQueue.c"
		guint _tmp2_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = self->priv->timer_id;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_source_remove (_tmp2_);
#line 545 "TimedQueue.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = msec;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = self->priv->priority;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (_tmp3_, timed_queue_get_heartbeat_timeout (self), _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 553 "TimedQueue.c"
}


static guint
timed_queue_get_heartbeat_timeout (TimedQueue* self)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
	guint _tmp1_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->dequeue_spacing_msec;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 569 "TimedQueue.c"
		guint _tmp2_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = self->priv->hold_msec;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = _tmp2_ / 10;
#line 575 "TimedQueue.c"
	} else {
		guint _tmp3_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = self->priv->dequeue_spacing_msec;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = _tmp3_ / 2;
#line 582 "TimedQueue.c"
	}
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = CLAMP (_tmp0_, (guint) 10, G_MAXUINT);
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 588 "TimedQueue.c"
}


static void
timed_queue_real_notify_dequeued (TimedQueue* self,
                                  gconstpointer item)
{
	DequeuedCallback _tmp0_;
	void* _tmp0__target;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->callback;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0__target = self->priv->callback_target;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ (item, _tmp0__target);
#line 604 "TimedQueue.c"
}


void
timed_queue_notify_dequeued (TimedQueue* self,
                             gconstpointer item)
{
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_GET_CLASS (self)->notify_dequeued (self, item);
#line 616 "TimedQueue.c"
}


gboolean
timed_queue_is_paused (TimedQueue* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp0_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 633 "TimedQueue.c"
}


void
timed_queue_pause (TimedQueue* self)
{
	gboolean _tmp0_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_) {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 649 "TimedQueue.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = TRUE;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, TRUE);
#line 655 "TimedQueue.c"
}


void
timed_queue_unpause (TimedQueue* self)
{
	gboolean _tmp0_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp0_) {
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 671 "TimedQueue.c"
	}
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, FALSE);
#line 677 "TimedQueue.c"
}


static void
timed_queue_real_clear (TimedQueue* self)
{
	SortedList* _tmp0_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 689 "TimedQueue.c"
}


void
timed_queue_clear (TimedQueue* self)
{
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_GET_CLASS (self)->clear (self);
#line 700 "TimedQueue.c"
}


static gboolean
timed_queue_real_contains (TimedQueue* self,
                           gconstpointer item)
{
	gboolean result = FALSE;
	{
		GeeIterator* _e_it = NULL;
		SortedList* _tmp0_;
		GeeIterator* _tmp1_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_e_it = _tmp1_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 721 "TimedQueue.c"
			GeeIterator* _tmp2_;
			TimedQueueElement* e = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeEqualDataFunc _tmp5_;
			void* _tmp5__target;
			TimedQueueElement* _tmp6_;
			gconstpointer _tmp7_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = _e_it;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 736 "TimedQueue.c"
			}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = _e_it;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			e = (TimedQueueElement*) _tmp4_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = self->priv->equal_func;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5__target = self->priv->equal_func_target;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = e;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = _tmp6_->item;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp5_ (item, _tmp7_, _tmp5__target)) {
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				result = TRUE;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (e);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_g_object_unref0 (_e_it);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				return result;
#line 762 "TimedQueue.c"
			}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 766 "TimedQueue.c"
		}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_e_it);
#line 770 "TimedQueue.c"
	}
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = FALSE;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 776 "TimedQueue.c"
}


gboolean
timed_queue_contains (TimedQueue* self,
                      gconstpointer item)
{
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->contains (self, item);
#line 788 "TimedQueue.c"
}


static gboolean
timed_queue_real_enqueue (TimedQueue* self,
                          gconstpointer item)
{
	gboolean result = FALSE;
	SortedList* _tmp0_;
	TimedQueueElement* _tmp1_;
	TimedQueueElement* _tmp2_;
	gboolean _tmp3_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, item, timed_queue_calc_ready_time (self));
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = _tmp1_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = gee_collection_add ((GeeCollection*) _tmp0_, _tmp2_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_timed_queue_element_unref0 (_tmp2_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp3_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 815 "TimedQueue.c"
}


gboolean
timed_queue_enqueue (TimedQueue* self,
                     gconstpointer item)
{
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->enqueue (self, item);
#line 827 "TimedQueue.c"
}


static gboolean
timed_queue_real_enqueue_many (TimedQueue* self,
                               GeeCollection* items)
{
	gboolean result = FALSE;
	gulong ready_time = 0UL;
	GeeArrayList* elements = NULL;
	GeeArrayList* _tmp0_;
	SortedList* _tmp10_;
	GeeArrayList* _tmp11_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	ready_time = timed_queue_calc_ready_time (self);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = gee_array_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, NULL, NULL, NULL);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	elements = _tmp0_;
#line 849 "TimedQueue.c"
	{
		GeeIterator* _item_it = NULL;
		GeeIterator* _tmp1_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) items);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_item_it = _tmp1_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 859 "TimedQueue.c"
			GeeIterator* _tmp2_;
			gpointer item = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			gconstpointer _tmp6_;
			gulong _tmp7_;
			TimedQueueElement* _tmp8_;
			TimedQueueElement* _tmp9_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = _item_it;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 875 "TimedQueue.c"
			}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = _item_it;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			item = _tmp4_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = elements;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = item;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = ready_time;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp6_, _tmp7_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp9_ = _tmp8_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp9_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (_tmp9_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 899 "TimedQueue.c"
		}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 903 "TimedQueue.c"
	}
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp10_ = self->priv->queue;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp11_ = elements;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = sorted_list_add_list (_tmp10_, (GeeList*) _tmp11_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (elements);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 915 "TimedQueue.c"
}


gboolean
timed_queue_enqueue_many (TimedQueue* self,
                          GeeCollection* items)
{
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->enqueue_many (self, items);
#line 927 "TimedQueue.c"
}


static gboolean
timed_queue_real_remove_first (TimedQueue* self,
                               gconstpointer item)
{
	gboolean result = FALSE;
	GeeIterator* iter = NULL;
	SortedList* _tmp0_;
	GeeIterator* _tmp1_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	iter = _tmp1_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	while (TRUE) {
#line 947 "TimedQueue.c"
		GeeIterator* _tmp2_;
		TimedQueueElement* e = NULL;
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
		GeeEqualDataFunc _tmp5_;
		void* _tmp5__target;
		TimedQueueElement* _tmp6_;
		gconstpointer _tmp7_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = iter;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			break;
#line 962 "TimedQueue.c"
		}
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = iter;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		e = (TimedQueueElement*) _tmp4_;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp5_ = self->priv->equal_func;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp5__target = self->priv->equal_func_target;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6_ = e;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp7_ = _tmp6_->item;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (_tmp5_ (item, _tmp7_, _tmp5__target)) {
#line 980 "TimedQueue.c"
			GeeIterator* _tmp8_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = iter;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_iterator_remove (_tmp8_);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			result = TRUE;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_g_object_unref0 (iter);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return result;
#line 994 "TimedQueue.c"
		}
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_timed_queue_element_unref0 (e);
#line 998 "TimedQueue.c"
	}
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = FALSE;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (iter);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1006 "TimedQueue.c"
}


gboolean
timed_queue_remove_first (TimedQueue* self,
                          gconstpointer item)
{
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->remove_first (self, item);
#line 1018 "TimedQueue.c"
}


static gulong
timed_queue_calc_ready_time (TimedQueue* self)
{
	gulong result = 0UL;
	guint _tmp0_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->hold_msec;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = now_ms () + ((gulong) _tmp0_);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1035 "TimedQueue.c"
}


static gboolean
timed_queue_on_heartbeat (TimedQueue* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gulong now = 0UL;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_) {
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = TRUE;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 1055 "TimedQueue.c"
	}
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	now = (gulong) 0;
#line 1059 "TimedQueue.c"
	{
		gboolean _tmp1_ = FALSE;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = TRUE;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 1066 "TimedQueue.c"
			SortedList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			TimedQueueElement* head = NULL;
			SortedList* _tmp5_;
			gpointer _tmp6_;
			TimedQueueElement* _tmp7_;
			gulong _tmp8_;
			TimedQueueElement* _tmp9_;
			gulong _tmp10_;
			gulong _tmp11_;
			gboolean _tmp12_ = FALSE;
			guint _tmp13_;
			TimedQueueElement* h = NULL;
			SortedList* _tmp17_;
			gpointer _tmp18_;
			TimedQueueElement* _tmp19_;
			TimedQueueElement* _tmp20_;
			TimedQueueElement* _tmp21_;
			gconstpointer _tmp22_;
			gulong _tmp23_;
			guint _tmp24_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!_tmp1_) {
#line 1091 "TimedQueue.c"
			}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp1_ = FALSE;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = self->priv->queue;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = _tmp3_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp4_ == 0) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1105 "TimedQueue.c"
			}
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = self->priv->queue;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = sorted_list_get_at (_tmp5_, 0);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			head = (TimedQueueElement*) _tmp6_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = head;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_vala_assert (_tmp7_ != NULL, "head != null");
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = now;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp8_ == ((gulong) 0)) {
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				now = now_ms ();
#line 1123 "TimedQueue.c"
			}
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp9_ = head;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = _tmp9_->ready;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = now;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp10_ > _tmp11_) {
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1137 "TimedQueue.c"
			}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp13_ = self->priv->dequeue_spacing_msec;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp13_ != ((guint) 0)) {
#line 1143 "TimedQueue.c"
				gulong _tmp14_;
				gulong _tmp15_;
				guint _tmp16_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp14_ = now;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp15_ = self->priv->last_dequeue;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp16_ = self->priv->dequeue_spacing_msec;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp12_ = (_tmp14_ - _tmp15_) < ((gulong) _tmp16_);
#line 1155 "TimedQueue.c"
			} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp12_ = FALSE;
#line 1159 "TimedQueue.c"
			}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp12_) {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1167 "TimedQueue.c"
			}
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp17_ = self->priv->queue;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp18_ = sorted_list_remove_at (_tmp17_, 0);
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			h = (TimedQueueElement*) _tmp18_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp19_ = head;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp20_ = h;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_vala_assert (_tmp19_ == _tmp20_, "head == h");
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp21_ = head;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp22_ = _tmp21_->item;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			timed_queue_notify_dequeued (self, _tmp22_);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp23_ = now;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			self->priv->last_dequeue = _tmp23_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp24_ = self->priv->dequeue_spacing_msec;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp24_ != ((guint) 0)) {
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (h);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1201 "TimedQueue.c"
			}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (h);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (head);
#line 1207 "TimedQueue.c"
		}
	}
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1214 "TimedQueue.c"
}


gint
timed_queue_get_size (TimedQueue* self)
{
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->get_size (self);
#line 1225 "TimedQueue.c"
}


static gint
timed_queue_real_get_size (TimedQueue* base)
{
	gint result;
	TimedQueue* self;
	SortedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = base;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = _tmp1_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp2_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1249 "TimedQueue.c"
}


static void
timed_queue_real_paused (TimedQueue* self,
                         gboolean is_paused)
{
}


static TimedQueueElement*
timed_queue_element_construct (GType object_type,
                               GType g_type,
                               GBoxedCopyFunc g_dup_func,
                               GDestroyNotify g_destroy_func,
                               gconstpointer item,
                               gulong ready)
{
	TimedQueueElement* self = NULL;
	gpointer _tmp0_;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (TimedQueueElement*) g_type_create_instance (object_type);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = ((item != NULL) && (g_dup_func != NULL)) ? g_dup_func ((gpointer) item) : ((gpointer) item);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_destroy_func0 (self->item);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->item = _tmp0_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ready = ready;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 1288 "TimedQueue.c"
}


static TimedQueueElement*
timed_queue_element_new (GType g_type,
                         GBoxedCopyFunc g_dup_func,
                         GDestroyNotify g_destroy_func,
                         gconstpointer item,
                         gulong ready)
{
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return timed_queue_element_construct (TIMED_QUEUE_TYPE_ELEMENT, g_type, g_dup_func, g_destroy_func, item, ready);
#line 1301 "TimedQueue.c"
}


static gint64
timed_queue_element_comparator (void* a,
                                void* b)
{
	gint64 result = 0LL;
	gulong _tmp0_;
	gulong _tmp1_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = ((TimedQueueElement*) a)->ready;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = ((TimedQueueElement*) b)->ready;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = ((gint64) _tmp0_) - ((gint64) _tmp1_);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1320 "TimedQueue.c"
}


static void
timed_queue_value_element_init (GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1329 "TimedQueue.c"
}


static void
timed_queue_value_element_free_value (GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (value->data[0].v_pointer);
#line 1340 "TimedQueue.c"
	}
}


static void
timed_queue_value_element_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_element_ref (src_value->data[0].v_pointer);
#line 1353 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1357 "TimedQueue.c"
	}
}


static gpointer
timed_queue_value_element_peek_pointer (const GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1367 "TimedQueue.c"
}


static gchar*
timed_queue_value_element_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1379 "TimedQueue.c"
		TimedQueueElement * object;
		object = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1386 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1390 "TimedQueue.c"
		}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_element_ref (object);
#line 1394 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1398 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1402 "TimedQueue.c"
}


static gchar*
timed_queue_value_element_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	TimedQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!object_p) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1418 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = NULL;
#line 1424 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1428 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = timed_queue_element_ref (value->data[0].v_pointer);
#line 1432 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1436 "TimedQueue.c"
}


static GParamSpec*
timed_queue_param_spec_element (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	TimedQueueParamSpecElement* spec;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1456 "TimedQueue.c"
}


static gpointer
timed_queue_value_get_element (const GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1467 "TimedQueue.c"
}


static void
timed_queue_value_set_element (GValue* value,
                               gpointer v_object)
{
	TimedQueueElement * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_ref (value->data[0].v_pointer);
#line 1490 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1494 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1500 "TimedQueue.c"
	}
}


static void
timed_queue_value_take_element (GValue* value,
                                gpointer v_object)
{
	TimedQueueElement * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1522 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1526 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1532 "TimedQueue.c"
	}
}


static void
timed_queue_element_class_init (TimedQueueElementClass * klass)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueElementClass *) klass)->finalize = timed_queue_element_finalize;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (TimedQueueElementPrivate));
#line 1546 "TimedQueue.c"
}


static void
timed_queue_element_instance_init (TimedQueueElement * self)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = TIMED_QUEUE_ELEMENT_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ref_count = 1;
#line 1557 "TimedQueue.c"
}


static void
timed_queue_element_finalize (TimedQueueElement * obj)
{
	TimedQueueElement * self;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((self->item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->item = (self->priv->g_destroy_func (self->item), NULL));
#line 1571 "TimedQueue.c"
}


static GType
timed_queue_element_get_type (void)
{
	static volatile gsize timed_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&timed_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { timed_queue_value_element_init, timed_queue_value_element_free_value, timed_queue_value_element_copy_value, timed_queue_value_element_peek_pointer, "p", timed_queue_value_element_collect_value, "p", timed_queue_value_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TimedQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueueElement), 0, (GInstanceInitFunc) timed_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType timed_queue_element_type_id;
		timed_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&timed_queue_element_type_id__volatile, timed_queue_element_type_id);
	}
	return timed_queue_element_type_id__volatile;
}


static gpointer
timed_queue_element_ref (gpointer instance)
{
	TimedQueueElement * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return instance;
#line 1600 "TimedQueue.c"
}


static void
timed_queue_element_unref (gpointer instance)
{
	TimedQueueElement * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		TIMED_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1615 "TimedQueue.c"
	}
}


static void
value_timed_queue_init (GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1625 "TimedQueue.c"
}


static void
value_timed_queue_free_value (GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (value->data[0].v_pointer);
#line 1636 "TimedQueue.c"
	}
}


static void
value_timed_queue_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_ref (src_value->data[0].v_pointer);
#line 1649 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1653 "TimedQueue.c"
	}
}


static gpointer
value_timed_queue_peek_pointer (const GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1663 "TimedQueue.c"
}


static gchar*
value_timed_queue_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1675 "TimedQueue.c"
		TimedQueue * object;
		object = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1682 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1686 "TimedQueue.c"
		}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_ref (object);
#line 1690 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1694 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1698 "TimedQueue.c"
}


static gchar*
value_timed_queue_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	TimedQueue ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!object_p) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1714 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = NULL;
#line 1720 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1724 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = timed_queue_ref (value->data[0].v_pointer);
#line 1728 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1732 "TimedQueue.c"
}


GParamSpec*
param_spec_timed_queue (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTimedQueue* spec;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TIMED_QUEUE), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1752 "TimedQueue.c"
}


gpointer
value_get_timed_queue (const GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1763 "TimedQueue.c"
}


void
value_set_timed_queue (GValue* value,
                       gpointer v_object)
{
	TimedQueue * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_ref (value->data[0].v_pointer);
#line 1786 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1790 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1796 "TimedQueue.c"
	}
}


void
value_take_timed_queue (GValue* value,
                        gpointer v_object)
{
	TimedQueue * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1818 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1822 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1828 "TimedQueue.c"
	}
}


static void
timed_queue_class_init (TimedQueueClass * klass)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = timed_queue_finalize;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (TimedQueuePrivate));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue *, gconstpointer)) timed_queue_real_notify_dequeued;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue *)) timed_queue_real_clear;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_contains;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_enqueue;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue *, GeeCollection*)) timed_queue_real_enqueue_many;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_remove_first;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->paused = timed_queue_real_paused;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (klass)->get_size = timed_queue_real_get_size;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL] = g_signal_new ("paused", TYPE_TIMED_QUEUE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (TimedQueueClass, paused), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 1860 "TimedQueue.c"
}


static void
timed_queue_instance_init (TimedQueue * self)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = TIMED_QUEUE_GET_PRIVATE (self);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = (guint) 0;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = (guint) 0;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->last_dequeue = (gulong) 0;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ref_count = 1;
#line 1879 "TimedQueue.c"
}


static void
timed_queue_finalize (TimedQueue * obj)
{
	TimedQueue * self;
	guint _tmp0_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMED_QUEUE, TimedQueue);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->timer_id;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 1896 "TimedQueue.c"
		guint _tmp1_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = self->priv->timer_id;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_source_remove (_tmp1_);
#line 1902 "TimedQueue.c"
	}
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func = NULL;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func_target = NULL;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func_target_destroy_notify = NULL;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 1914 "TimedQueue.c"
}


GType
timed_queue_get_type (void)
{
	static volatile gsize timed_queue_type_id__volatile = 0;
	if (g_once_init_enter (&timed_queue_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_timed_queue_init, value_timed_queue_free_value, value_timed_queue_copy_value, value_timed_queue_peek_pointer, "p", value_timed_queue_collect_value, "p", value_timed_queue_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueue), 0, (GInstanceInitFunc) timed_queue_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType timed_queue_type_id;
		timed_queue_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueue", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&timed_queue_type_id__volatile, timed_queue_type_id);
	}
	return timed_queue_type_id__volatile;
}


gpointer
timed_queue_ref (gpointer instance)
{
	TimedQueue * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return instance;
#line 1943 "TimedQueue.c"
}


void
timed_queue_unref (gpointer instance)
{
	TimedQueue * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		TIMED_QUEUE_GET_CLASS (self)->finalize (self);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1958 "TimedQueue.c"
	}
}


HashTimedQueue*
hash_timed_queue_construct (GType object_type,
                            GType g_type,
                            GBoxedCopyFunc g_dup_func,
                            GDestroyNotify g_destroy_func,
                            guint hold_msec,
                            DequeuedCallback callback,
                            void* callback_target,
                            GeeHashDataFunc hash_func,
                            void* hash_func_target,
                            GDestroyNotify hash_func_target_destroy_notify,
                            GeeEqualDataFunc equal_func,
                            void* equal_func_target,
                            GDestroyNotify equal_func_target_destroy_notify,
                            gint priority)
{
	HashTimedQueue* self = NULL;
	GeeEqualDataFunc _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeHashDataFunc _tmp1_;
	void* _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
	GeeEqualDataFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	GeeHashMap* _tmp3_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = equal_func;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0__target = equal_func_target;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0__target_destroy_notify = equal_func_target_destroy_notify;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) timed_queue_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, hold_msec, callback, callback_target, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify, priority);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = hash_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1__target = hash_func_target;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1__target_destroy_notify = hash_func_target_destroy_notify;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = equal_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2__target = equal_func_target;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2__target_destroy_notify = equal_func_target_destroy_notify;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = gee_hash_map_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, G_TYPE_INT, NULL, NULL, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify, _tmp2_, _tmp2__target, _tmp2__target_destroy_notify, NULL, NULL, NULL);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->item_count = _tmp3_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(hash_func_target_destroy_notify == NULL) ? NULL : (hash_func_target_destroy_notify (hash_func_target), NULL);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 2058 "TimedQueue.c"
}


HashTimedQueue*
hash_timed_queue_new (GType g_type,
                      GBoxedCopyFunc g_dup_func,
                      GDestroyNotify g_destroy_func,
                      guint hold_msec,
                      DequeuedCallback callback,
                      void* callback_target,
                      GeeHashDataFunc hash_func,
                      void* hash_func_target,
                      GDestroyNotify hash_func_target_destroy_notify,
                      GeeEqualDataFunc equal_func,
                      void* equal_func_target,
                      GDestroyNotify equal_func_target_destroy_notify,
                      gint priority)
{
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return hash_timed_queue_construct (TYPE_HASH_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, hash_func, hash_func_target, hash_func_target_destroy_notify, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 2079 "TimedQueue.c"
}


static void
hash_timed_queue_real_notify_dequeued (TimedQueue* base,
                                       gconstpointer item)
{
	HashTimedQueue * self;
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_removed (self, item);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->notify_dequeued (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item);
#line 2094 "TimedQueue.c"
}


static void
hash_timed_queue_real_clear (TimedQueue* base)
{
	HashTimedQueue * self;
	GeeHashMap* _tmp0_;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue));
#line 2111 "TimedQueue.c"
}


static gboolean
hash_timed_queue_real_contains (TimedQueue* base,
                                gconstpointer item)
{
	HashTimedQueue * self;
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, item);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2130 "TimedQueue.c"
}


static gboolean
hash_timed_queue_real_enqueue (TimedQueue* base,
                               gconstpointer item)
{
	HashTimedQueue * self;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp4_;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item)) {
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 2151 "TimedQueue.c"
	}
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, item)) {
#line 2157 "TimedQueue.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, item);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = ((gint) ((gintptr) _tmp3_)) + 1;
#line 2166 "TimedQueue.c"
	} else {
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = 1;
#line 2170 "TimedQueue.c"
	}
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, item, (gpointer) ((gintptr) _tmp0_));
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2180 "TimedQueue.c"
}


static gboolean
hash_timed_queue_real_enqueue_many (TimedQueue* base,
                                    GeeCollection* items)
{
	HashTimedQueue * self;
	gboolean result = FALSE;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), items)) {
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 2200 "TimedQueue.c"
	}
	{
		GeeIterator* _item_it = NULL;
		GeeIterator* _tmp0_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) items);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_item_it = _tmp0_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 2211 "TimedQueue.c"
			GeeIterator* _tmp1_;
			gpointer item = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gint _tmp4_ = 0;
			GeeHashMap* _tmp5_;
			gconstpointer _tmp6_;
			GeeHashMap* _tmp10_;
			gconstpointer _tmp11_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp1_ = _item_it;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 2227 "TimedQueue.c"
			}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = _item_it;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			item = _tmp3_;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_)) {
#line 2241 "TimedQueue.c"
				GeeHashMap* _tmp7_;
				gconstpointer _tmp8_;
				gpointer _tmp9_;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp7_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp8_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp4_ = ((gint) ((gintptr) _tmp9_)) + 1;
#line 2253 "TimedQueue.c"
			} else {
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp4_ = 1;
#line 2257 "TimedQueue.c"
			}
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, (gpointer) ((gintptr) _tmp4_));
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 2267 "TimedQueue.c"
		}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 2271 "TimedQueue.c"
	}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2277 "TimedQueue.c"
}


static gboolean
hash_timed_queue_real_remove_first (TimedQueue* base,
                                    gconstpointer item)
{
	HashTimedQueue * self;
	gboolean result = FALSE;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->remove_first (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item)) {
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 2295 "TimedQueue.c"
	}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_removed (self, item);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2303 "TimedQueue.c"
}


static void
hash_timed_queue_removed (HashTimedQueue* self,
                          gconstpointer item)
{
	GeeHashMap* _tmp0_;
	gint count = 0;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, item)) {
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 2326 "TimedQueue.c"
	}
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->item_count;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, item);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	count = (gint) ((gintptr) _tmp2_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = count;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_vala_assert (_tmp3_ > 0, "count > 0");
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = count;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	count = _tmp4_ - 1;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = count;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp5_ == 0) {
#line 2346 "TimedQueue.c"
		GeeHashMap* _tmp6_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6_ = self->priv->item_count;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp6_, item, NULL);
#line 2352 "TimedQueue.c"
	} else {
		GeeHashMap* _tmp7_;
		gint _tmp8_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp7_ = self->priv->item_count;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp8_ = count;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, item, (gpointer) ((gintptr) _tmp8_));
#line 2362 "TimedQueue.c"
	}
}


static void
hash_timed_queue_class_init (HashTimedQueueClass * klass)
{
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = hash_timed_queue_finalize;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (HashTimedQueuePrivate));
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_notify_dequeued;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue *)) hash_timed_queue_real_clear;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_contains;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_enqueue;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue *, GeeCollection*)) hash_timed_queue_real_enqueue_many;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_remove_first;
#line 2388 "TimedQueue.c"
}


static void
hash_timed_queue_instance_init (HashTimedQueue * self)
{
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = HASH_TIMED_QUEUE_GET_PRIVATE (self);
#line 2397 "TimedQueue.c"
}


static void
hash_timed_queue_finalize (TimedQueue * obj)
{
	HashTimedQueue * self;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->finalize (obj);
#line 2411 "TimedQueue.c"
}


GType
hash_timed_queue_get_type (void)
{
	static volatile gsize hash_timed_queue_type_id__volatile = 0;
	if (g_once_init_enter (&hash_timed_queue_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HashTimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hash_timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HashTimedQueue), 0, (GInstanceInitFunc) hash_timed_queue_instance_init, NULL };
		GType hash_timed_queue_type_id;
		hash_timed_queue_type_id = g_type_register_static (TYPE_TIMED_QUEUE, "HashTimedQueue", &g_define_type_info, 0);
		g_once_init_leave (&hash_timed_queue_type_id__volatile, hash_timed_queue_type_id);
	}
	return hash_timed_queue_type_id__volatile;
}



