/* VideoTable.c generated by valac 0.39.7, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecVideoRow ParamSpecVideoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_row_parent_class = NULL;
static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
extern sqlite3* database_table_db;

GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self,
                    gint64 id);
gboolean video_id_is_invalid (VideoID *self);
gboolean video_id_is_valid (VideoID *self);
guint video_id_hash (VideoID* a);
guint int64_hash (gint64* n);
gboolean video_id_equal (void* a,
                         void* b);
gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
#define VIDEO_TYPENAME "video"
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_video_row (GValue* value,
                          gpointer v_object);
void value_take_video_row (GValue* value,
                           gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
VideoRow* video_row_new (void);
VideoRow* video_row_construct (GType object_type);
static void video_row_finalize (VideoRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self,
                                          const gchar* data);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VideoTable* video_table_get_instance (void);
GQuark database_error_quark (void);
void video_table_add (VideoTable* self,
                      VideoRow* video_row,
                      VideoID* result,
                      GError** error);
gulong now_sec (void);
void database_table_bind_text (sqlite3_stmt* stmt,
                               gint column,
                               const gchar* data);
void database_table_bind_int (sqlite3_stmt* stmt,
                              gint column,
                              gint data);
void database_table_bind_double (sqlite3_stmt* stmt,
                                 gint column,
                                 gdouble data);
void database_table_bind_int64 (sqlite3_stmt* stmt,
                                gint column,
                                gint64 data);
#define EVENT_ID_INVALID ((gint64) -1)
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
void event_id_init (EventID *self,
                    gint64 id);
gboolean video_table_drop_event (VideoTable* self,
                                 EventID* event_id);
VideoRow* video_table_get_row (VideoTable* self,
                               VideoID* video_id);
GeeArrayList* video_table_get_all (VideoTable* self);
void video_table_set_filepath (VideoTable* self,
                               VideoID* video_id,
                               const gchar* filepath,
                               GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
void video_table_set_title (VideoTable* self,
                            VideoID* video_id,
                            const gchar* new_title,
                            GError** error);
void video_table_set_comment (VideoTable* self,
                              VideoID* video_id,
                              const gchar* new_comment,
                              GError** error);
void video_table_set_exposure_time (VideoTable* self,
                                    VideoID* video_id,
                                    time_t time,
                                    GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
void video_table_set_flags (VideoTable* self,
                            VideoID* video_id,
                            guint64 flags,
                            GError** error);
void video_table_update_backlinks (VideoTable* self,
                                   VideoID* video_id,
                                   const gchar* backlinks,
                                   GError** error);
void video_table_update_is_interpretable (VideoTable* self,
                                          VideoID* video_id,
                                          gboolean is_interpretable,
                                          GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
gboolean video_table_set_event (VideoTable* self,
                                VideoID* video_id,
                                EventID* event_id);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void video_table_remove_by_file (VideoTable* self,
                                 GFile* file,
                                 GError** error);
void video_table_remove (VideoTable* self,
                         VideoID* videoID,
                         GError** error);
gboolean video_table_is_video_stored (VideoTable* self,
                                      GFile* file);
void video_table_get_id (VideoTable* self,
                         GFile* file,
                         VideoID* result);
GeeArrayList* video_table_get_videos (VideoTable* self,
                                      GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self,
                                              GFile* file,
                                              const gchar* md5);
gboolean video_table_has_duplicate (VideoTable* self,
                                    GFile* file,
                                    const gchar* md5);
VideoID* video_table_get_duplicate_ids (VideoTable* self,
                                        GFile* file,
                                        const gchar* md5,
                                        int* result_length1);
static void _vala_array_add137 (VideoID* * array,
                         int* length,
                         int* size,
                         const VideoID* value);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self,
                                                EventID* event_id);
void video_table_set_timestamp (VideoTable* self,
                                VideoID* video_id,
                                time_t timestamp,
                                GError** error);
static void video_table_finalize (DatabaseTable * obj);


void
video_id_init (VideoID *self,
               gint64 id)
{
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	(*self).id = id;
#line 354 "VideoTable.c"
}


gboolean
video_id_is_invalid (VideoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp0_ == VIDEO_ID_INVALID;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 369 "VideoTable.c"
}


gboolean
video_id_is_valid (VideoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp0_ != VIDEO_ID_INVALID;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 384 "VideoTable.c"
}


guint
video_id_hash (VideoID* a)
{
	guint result = 0U;
	gint64 _tmp0_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*a).id;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = int64_hash (&_tmp0_);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 399 "VideoTable.c"
}


gboolean
video_id_equal (void* a,
                void* b)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
	gint64 _tmp1_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*((VideoID*) a)).id;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = (*((VideoID*) b)).id;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp0_ == _tmp1_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 418 "VideoTable.c"
}


gchar*
video_id_upgrade_video_id_to_source_id (VideoID* video_id)
{
	gchar* result = NULL;
	VideoID _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp1_);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp2_;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 441 "VideoTable.c"
}


VideoID*
video_id_dup (const VideoID* self)
{
	VideoID* dup;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return dup;
#line 455 "VideoTable.c"
}


void
video_id_free (VideoID* self)
{
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_free (self);
#line 464 "VideoTable.c"
}


GType
video_id_get_type (void)
{
	static volatile gsize video_id_type_id__volatile = 0;
	if (g_once_init_enter (&video_id_type_id__volatile)) {
		GType video_id_type_id;
		video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
		g_once_init_leave (&video_id_type_id__volatile, video_id_type_id);
	}
	return video_id_type_id__volatile;
}


VideoRow*
video_row_construct (GType object_type)
{
	VideoRow* self = NULL;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = (VideoRow*) g_type_create_instance (object_type);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self;
#line 489 "VideoTable.c"
}


VideoRow*
video_row_new (void)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return video_row_construct (TYPE_VIDEO_ROW);
#line 498 "VideoTable.c"
}


static void
value_video_row_init (GValue* value)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	value->data[0].v_pointer = NULL;
#line 507 "VideoTable.c"
}


static void
value_video_row_free_value (GValue* value)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (value->data[0].v_pointer);
#line 518 "VideoTable.c"
	}
}


static void
value_video_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = video_row_ref (src_value->data[0].v_pointer);
#line 531 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 535 "VideoTable.c"
	}
}


static gpointer
value_video_row_peek_pointer (const GValue* value)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 545 "VideoTable.c"
}


static gchar*
value_video_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (collect_values[0].v_pointer) {
#line 557 "VideoTable.c"
		VideoRow * object;
		object = collect_values[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 564 "VideoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 568 "VideoTable.c"
		}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = video_row_ref (object);
#line 572 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 576 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return NULL;
#line 580 "VideoTable.c"
}


static gchar*
value_video_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	VideoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (!object_p) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 596 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (!value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = NULL;
#line 602 "VideoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 606 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = video_row_ref (value->data[0].v_pointer);
#line 610 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return NULL;
#line 614 "VideoTable.c"
}


GParamSpec*
param_spec_video_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecVideoRow* spec;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_ROW), NULL);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return G_PARAM_SPEC (spec);
#line 634 "VideoTable.c"
}


gpointer
value_get_video_row (const GValue* value)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW), NULL);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 645 "VideoTable.c"
}


void
value_set_video_row (GValue* value,
                     gpointer v_object)
{
	VideoRow * old;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (v_object) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_ref (value->data[0].v_pointer);
#line 668 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 672 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (old) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (old);
#line 678 "VideoTable.c"
	}
}


void
value_take_video_row (GValue* value,
                      gpointer v_object)
{
	VideoRow * old;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (v_object) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 700 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 704 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (old) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (old);
#line 710 "VideoTable.c"
	}
}


static void
video_row_class_init (VideoRowClass * klass)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_row_parent_class = g_type_class_peek_parent (klass);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	((VideoRowClass *) klass)->finalize = video_row_finalize;
#line 722 "VideoTable.c"
}


static void
video_row_instance_init (VideoRow * self)
{
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self->ref_count = 1;
#line 731 "VideoTable.c"
}


static void
video_row_finalize (VideoRow * obj)
{
	VideoRow * self;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_ROW, VideoRow);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_signal_handlers_destroy (self);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->filepath);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->md5);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->title);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->backlinks);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->comment);
#line 753 "VideoTable.c"
}


GType
video_row_get_type (void)
{
	static volatile gsize video_row_type_id__volatile = 0;
	if (g_once_init_enter (&video_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_row_init, value_video_row_free_value, value_video_row_copy_value, value_video_row_peek_pointer, "p", value_video_row_collect_value, "p", value_video_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoRow), 0, (GInstanceInitFunc) video_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_row_type_id;
		video_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_row_type_id__volatile, video_row_type_id);
	}
	return video_row_type_id__volatile;
}


gpointer
video_row_ref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return instance;
#line 782 "VideoTable.c"
}


void
video_row_unref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		VIDEO_ROW_GET_CLASS (self)->finalize (self);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 797 "VideoTable.c"
	}
}


static VideoTable*
video_table_construct (GType object_type)
{
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0, " "comment TEXT " ")");
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = res;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp2_ != SQLITE_DONE) {
#line 828 "VideoTable.c"
		gint _tmp3_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = res;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp3_);
#line 834 "VideoTable.c"
	}
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)");
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp4_;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 850 "VideoTable.c"
		gint _tmp7_;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = res;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp7_);
#line 856 "VideoTable.c"
	}
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "VideoTable");
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self;
#line 864 "VideoTable.c"
}


static VideoTable*
video_table_new (void)
{
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 873 "VideoTable.c"
}


static gpointer
_database_table_ref0 (gpointer self)
{
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 882 "VideoTable.c"
}


VideoTable*
video_table_get_instance (void)
{
	VideoTable* result = NULL;
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 897 "VideoTable.c"
		VideoTable* _tmp1_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 905 "VideoTable.c"
	}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp3_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 915 "VideoTable.c"
}


void
video_table_add (VideoTable* self,
                 VideoRow* video_row,
                 VideoID* result,
                 GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gulong time_created = 0UL;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	gdouble _tmp8_;
	gint _tmp9_ = 0;
	gboolean _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint64 _tmp13_;
	sqlite3_stmt* _tmp14_;
	time_t _tmp15_;
	sqlite3_stmt* _tmp16_;
	time_t _tmp17_;
	sqlite3_stmt* _tmp18_;
	ImportID _tmp19_;
	gint64 _tmp20_;
	sqlite3_stmt* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	gulong _tmp25_;
	sqlite3_stmt* _tmp26_;
	const gchar* _tmp27_;
	sqlite3_stmt* _tmp28_;
	const gchar* _tmp29_;
	gint res = 0;
	sqlite3_stmt* _tmp30_;
	gint _tmp31_;
	sqlite3* _tmp34_;
	gulong _tmp35_;
	VideoID _tmp36_;
	GError * _inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_row != NULL);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	time_created = now_sec ();
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_row->filepath;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp2_);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = video_row->width;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp3_, 2, _tmp4_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = video_row->height;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp5_, 3, _tmp6_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = stmt;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = video_row->clip_duration;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_double (_tmp7_, 4, _tmp8_);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp10_ = video_row->is_interpretable;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp10_) {
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = 1;
#line 1004 "VideoTable.c"
	} else {
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = 0;
#line 1008 "VideoTable.c"
	}
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp11_ = stmt;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp11_, 5, _tmp9_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = video_row->filesize;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp12_, 6, _tmp13_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp15_ = video_row->timestamp;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp14_, 7, (gint64) _tmp15_);
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_ = stmt;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp17_ = video_row->exposure_time;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp16_, 8, (gint64) _tmp17_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp19_ = video_row->import_id;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp20_ = _tmp19_.id;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp18_, 9, _tmp20_);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp21_, 10, EVENT_ID_INVALID);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp23_ = video_row->md5;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp22_, 11, _tmp23_);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp24_ = stmt;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp25_ = time_created;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp24_, 12, (gint64) _tmp25_);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp26_ = stmt;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp27_ = video_row->title;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp26_, 13, _tmp27_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_ = stmt;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp29_ = video_row->comment;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp28_, 14, _tmp29_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp30_ = stmt;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp30_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp31_ = res;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp31_ != SQLITE_DONE) {
#line 1076 "VideoTable.c"
		gint _tmp32_;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp32_ = res;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_tmp32_ != SQLITE_CONSTRAINT) {
#line 1082 "VideoTable.c"
			gint _tmp33_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp33_ = res;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", _tmp33_, &_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					return;
#line 1098 "VideoTable.c"
				} else {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_clear_error (&_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					return;
#line 1108 "VideoTable.c"
				}
			}
		}
	}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_ = database_table_db;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_id_init (&video_row->video_id, sqlite3_last_insert_rowid (_tmp34_));
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	event_id_init (&video_row->event_id, EVENT_ID_INVALID);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp35_ = time_created;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_row->time_created = (time_t) _tmp35_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_row->flags = (guint64) 0;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp36_ = video_row->video_id;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	*result = _tmp36_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return;
#line 1133 "VideoTable.c"
}


gboolean
video_table_drop_event (VideoTable* self,
                        EventID* event_id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	EventID _tmp3_;
	gint64 _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?");
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, EVENT_ID_INVALID);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = *event_id;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, _tmp4_);
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 1179 "VideoTable.c"
		gint _tmp7_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = res;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", _tmp7_);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = FALSE;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 1191 "VideoTable.c"
	}
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = TRUE;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1199 "VideoTable.c"
}


VideoRow*
video_table_get_row (VideoTable* self,
                     VideoID* video_id)
{
	VideoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	sqlite3_stmt* _tmp4_;
	VideoRow* row = NULL;
	VideoRow* _tmp5_;
	VideoRow* _tmp6_;
	VideoID _tmp7_;
	VideoRow* _tmp8_;
	sqlite3_stmt* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	VideoRow* _tmp12_;
	sqlite3_stmt* _tmp13_;
	VideoRow* _tmp14_;
	sqlite3_stmt* _tmp15_;
	VideoRow* _tmp16_;
	sqlite3_stmt* _tmp17_;
	VideoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	VideoRow* _tmp20_;
	sqlite3_stmt* _tmp21_;
	VideoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	VideoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	VideoRow* _tmp26_;
	sqlite3_stmt* _tmp27_;
	VideoRow* _tmp28_;
	sqlite3_stmt* _tmp29_;
	VideoRow* _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	VideoRow* _tmp34_;
	sqlite3_stmt* _tmp35_;
	VideoRow* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	VideoRow* _tmp40_;
	sqlite3_stmt* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	VideoRow* _tmp44_;
	sqlite3_stmt* _tmp45_;
	VideoRow* _tmp46_;
	sqlite3_stmt* _tmp47_;
	VideoRow* _tmp48_;
	sqlite3_stmt* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, title, backlink" \
"s, " "time_reimported, flags, comment FROM VideoTable WHERE id=?");
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (sqlite3_step (_tmp4_) != SQLITE_ROW) {
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = NULL;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 1288 "VideoTable.c"
	}
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = video_row_new ();
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	row = _tmp5_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = row;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = *video_id;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_->video_id = _tmp7_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = row;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_column_text (_tmp9_, 0);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp8_->filepath);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_->filepath = _tmp11_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp12_ = row;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = stmt;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp12_->width = sqlite3_column_int (_tmp13_, 1);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp14_ = row;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp15_ = stmt;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp14_->height = sqlite3_column_int (_tmp15_, 2);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_ = row;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_->clip_duration = sqlite3_column_double (_tmp17_, 3);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp18_ = row;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp19_ = stmt;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp18_->is_interpretable = sqlite3_column_int (_tmp19_, 4) == 1;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp20_ = row;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp20_->filesize = sqlite3_column_int64 (_tmp21_, 5);
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_ = row;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp23_ = stmt;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_->timestamp = (time_t) sqlite3_column_int64 (_tmp23_, 6);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp24_ = row;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp25_ = stmt;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp24_->exposure_time = (time_t) sqlite3_column_int64 (_tmp25_, 7);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp26_ = row;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp27_ = stmt;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp26_->import_id.id = sqlite3_column_int64 (_tmp27_, 8);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_ = row;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp29_ = stmt;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_->event_id.id = sqlite3_column_int64 (_tmp29_, 9);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp30_ = row;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp31_ = stmt;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp32_ = sqlite3_column_text (_tmp31_, 10);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp30_->md5);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp30_->md5 = _tmp33_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_ = row;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp35_ = stmt;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_->time_created = (time_t) sqlite3_column_int64 (_tmp35_, 11);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp36_ = row;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp37_ = stmt;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp38_ = sqlite3_column_text (_tmp37_, 12);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp39_ = g_strdup (_tmp38_);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp36_->title);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp36_->title = _tmp39_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp40_ = row;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp41_ = stmt;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp42_ = sqlite3_column_text (_tmp41_, 13);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp40_->backlinks);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp40_->backlinks = _tmp43_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp44_ = row;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp45_ = stmt;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp44_->time_reimported = (time_t) sqlite3_column_int64 (_tmp45_, 14);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp46_ = row;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp47_ = stmt;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp46_->flags = (guint64) sqlite3_column_int64 (_tmp47_, 15);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp48_ = row;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp49_ = stmt;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp50_ = sqlite3_column_text (_tmp49_, 16);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp51_ = g_strdup (_tmp50_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp48_->comment);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp48_->comment = _tmp51_;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = row;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1438 "VideoTable.c"
}


GeeArrayList*
video_table_get_all (VideoTable* self)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp1_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, titl" \
"e, " "backlinks, time_reimported, flags, comment FROM VideoTable");
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_ref, (GDestroyNotify) video_row_unref, NULL, NULL, NULL);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	all = _tmp1_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	while (TRUE) {
#line 1462 "VideoTable.c"
		sqlite3_stmt* _tmp2_;
		VideoRow* row = NULL;
		VideoRow* _tmp3_;
		VideoRow* _tmp4_;
		sqlite3_stmt* _tmp5_;
		VideoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		VideoRow* _tmp10_;
		sqlite3_stmt* _tmp11_;
		VideoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		VideoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		VideoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		VideoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		VideoRow* _tmp20_;
		sqlite3_stmt* _tmp21_;
		VideoRow* _tmp22_;
		sqlite3_stmt* _tmp23_;
		VideoRow* _tmp24_;
		sqlite3_stmt* _tmp25_;
		VideoRow* _tmp26_;
		sqlite3_stmt* _tmp27_;
		VideoRow* _tmp28_;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		VideoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		VideoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		VideoRow* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		VideoRow* _tmp42_;
		sqlite3_stmt* _tmp43_;
		VideoRow* _tmp44_;
		sqlite3_stmt* _tmp45_;
		VideoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		GeeArrayList* _tmp50_;
		VideoRow* _tmp51_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = stmt;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!(sqlite3_step (_tmp2_) == SQLITE_ROW)) {
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			break;
#line 1520 "VideoTable.c"
		}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = video_row_new ();
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		row = _tmp3_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_ = row;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_->video_id.id = sqlite3_column_int64 (_tmp5_, 0);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = row;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = sqlite3_column_text (_tmp7_, 1);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp6_->filepath);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_->filepath = _tmp9_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp10_ = row;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp11_ = stmt;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp10_->width = sqlite3_column_int (_tmp11_, 2);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_ = row;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_->height = sqlite3_column_int (_tmp13_, 3);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_ = row;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_->clip_duration = sqlite3_column_double (_tmp15_, 4);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp16_ = row;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp16_->is_interpretable = sqlite3_column_int (_tmp17_, 5) == 1;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp18_ = row;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp18_->filesize = sqlite3_column_int64 (_tmp19_, 6);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp20_ = row;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp21_ = stmt;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp20_->timestamp = (time_t) sqlite3_column_int64 (_tmp21_, 7);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp22_ = row;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp23_ = stmt;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp22_->exposure_time = (time_t) sqlite3_column_int64 (_tmp23_, 8);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp24_ = row;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp25_ = stmt;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp24_->import_id.id = sqlite3_column_int64 (_tmp25_, 9);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp26_ = row;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp27_ = stmt;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp26_->event_id.id = sqlite3_column_int64 (_tmp27_, 10);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp28_ = row;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp29_ = stmt;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp30_ = sqlite3_column_text (_tmp29_, 11);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp31_ = g_strdup (_tmp30_);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp28_->md5);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp28_->md5 = _tmp31_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp32_ = row;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp33_ = stmt;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp32_->time_created = (time_t) sqlite3_column_int64 (_tmp33_, 12);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp34_ = row;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp35_ = stmt;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp36_ = sqlite3_column_text (_tmp35_, 13);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp34_->title);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp34_->title = _tmp37_;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp38_ = row;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp39_ = stmt;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp40_ = sqlite3_column_text (_tmp39_, 14);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp38_->backlinks);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp38_->backlinks = _tmp41_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp42_ = row;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp43_ = stmt;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp42_->time_reimported = (time_t) sqlite3_column_int64 (_tmp43_, 15);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp44_ = row;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp45_ = stmt;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp44_->flags = (guint64) sqlite3_column_int64 (_tmp45_, 16);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp46_ = row;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp47_ = stmt;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp48_ = sqlite3_column_text (_tmp47_, 17);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp46_->comment);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp46_->comment = _tmp49_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp50_ = all;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp51_ = row;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_video_row_unref0 (row);
#line 1672 "VideoTable.c"
	}
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = all;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1680 "VideoTable.c"
}


void
video_table_set_filepath (VideoTable* self,
                          VideoID* video_id,
                          const gchar* filepath,
                          GError** error)
{
	VideoID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_, "filename", filepath, &_inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1713 "VideoTable.c"
		} else {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1721 "VideoTable.c"
		}
	}
}


void
video_table_set_title (VideoTable* self,
                       VideoID* video_id,
                       const gchar* new_title,
                       GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	gint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (new_title != NULL) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = new_title;
#line 1745 "VideoTable.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1749 "VideoTable.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp2_, "title", _tmp0_, &_inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1765 "VideoTable.c"
		} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1773 "VideoTable.c"
		}
	}
}


void
video_table_set_comment (VideoTable* self,
                         VideoID* video_id,
                         const gchar* new_comment,
                         GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	gint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (new_comment != NULL) {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = new_comment;
#line 1797 "VideoTable.c"
	} else {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1801 "VideoTable.c"
	}
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp2_, "comment", _tmp0_, &_inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1817 "VideoTable.c"
		} else {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1825 "VideoTable.c"
		}
	}
}


void
video_table_set_exposure_time (VideoTable* self,
                               VideoID* video_id,
                               time_t time,
                               GError** error)
{
	VideoID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "exposure_time", (gint64) time, &_inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1858 "VideoTable.c"
		} else {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1866 "VideoTable.c"
		}
	}
}


void
video_table_set_flags (VideoTable* self,
                       VideoID* video_id,
                       guint64 flags,
                       GError** error)
{
	VideoID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "flags", (gint64) flags, &_inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1899 "VideoTable.c"
		} else {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1907 "VideoTable.c"
		}
	}
}


void
video_table_update_backlinks (VideoTable* self,
                              VideoID* video_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	gint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (backlinks != NULL) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = backlinks;
#line 1931 "VideoTable.c"
	} else {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1935 "VideoTable.c"
	}
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp2_, "backlinks", _tmp0_, &_inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1951 "VideoTable.c"
		} else {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1959 "VideoTable.c"
		}
	}
}


void
video_table_update_is_interpretable (VideoTable* self,
                                     VideoID* video_id,
                                     gboolean is_interpretable,
                                     GError** error)
{
	gint _tmp0_ = 0;
	VideoID _tmp1_;
	gint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (is_interpretable) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 1983 "VideoTable.c"
	} else {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 1987 "VideoTable.c"
	}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int_by_id_2 ((DatabaseTable*) self, _tmp2_, "is_interpretable", _tmp0_, &_inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2003 "VideoTable.c"
		} else {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2011 "VideoTable.c"
		}
	}
}


gboolean
video_table_set_event (VideoTable* self,
                       VideoID* video_id,
                       EventID* event_id)
{
	gboolean result = FALSE;
	VideoID _tmp0_;
	gint64 _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp1_, "event_id", _tmp3_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2045 "VideoTable.c"
}


void
video_table_remove_by_file (VideoTable* self,
                            GFile* file,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE filename=?");
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = g_file_get_path (file);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp3_);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = res;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 2089 "VideoTable.c"
		gint _tmp6_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", _tmp6_, &_inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2105 "VideoTable.c"
			} else {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2115 "VideoTable.c"
			}
		}
	}
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2121 "VideoTable.c"
}


void
video_table_remove (VideoTable* self,
                    VideoID* videoID,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (videoID != NULL);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE id=?");
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *videoID;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = res;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 2163 "VideoTable.c"
		gint _tmp6_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", _tmp6_, &_inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2179 "VideoTable.c"
			} else {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2189 "VideoTable.c"
			}
		}
	}
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2195 "VideoTable.c"
}


gboolean
video_table_is_video_stored (VideoTable* self,
                             GFile* file)
{
	gboolean result = FALSE;
	VideoID _tmp0_ = {0};
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_table_get_id (self, file, &_tmp0_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = video_id_is_valid (&_tmp0_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2215 "VideoTable.c"
}


void
video_table_get_id (VideoTable* self,
                    GFile* file,
                    VideoID* result)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	VideoID _tmp5_ = {0};
	gint _tmp6_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT ID FROM VideoTable WHERE filename=?");
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = g_file_get_path (file);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp3_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp6_ == SQLITE_ROW) {
#line 2259 "VideoTable.c"
		sqlite3_stmt* _tmp7_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp5_, sqlite3_column_int64 (_tmp7_, 0));
#line 2265 "VideoTable.c"
	} else {
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp5_, VIDEO_ID_INVALID);
#line 2269 "VideoTable.c"
	}
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	*result = _tmp5_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return;
#line 2277 "VideoTable.c"
}


GeeArrayList*
video_table_get_videos (VideoTable* self,
                        GError** error)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* video_ids = NULL;
	GeeArrayList* _tmp1_;
	GError * _inner_error_ = NULL;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable");
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, (GDestroyNotify) video_id_free, NULL, NULL, NULL);
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_ids = _tmp1_;
#line 2301 "VideoTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = TRUE;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		while (TRUE) {
#line 2308 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			gint _tmp4_;
			GeeArrayList* _tmp7_;
			sqlite3_stmt* _tmp8_;
			VideoID _tmp9_ = {0};
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (!_tmp2_) {
#line 2317 "VideoTable.c"
			}
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp2_ = FALSE;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp3_ = stmt;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			res = sqlite3_step (_tmp3_);
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp4_ = res;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_tmp4_ == SQLITE_DONE) {
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				break;
#line 2331 "VideoTable.c"
			} else {
				gint _tmp5_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_tmp5_ = res;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_tmp5_ != SQLITE_ROW) {
#line 2338 "VideoTable.c"
					gint _tmp6_;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_tmp6_ = res;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", _tmp6_, &_inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							return NULL;
#line 2356 "VideoTable.c"
						} else {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_clear_error (&_inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							return NULL;
#line 2368 "VideoTable.c"
						}
					}
				}
			}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp7_ = video_ids;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp8_ = stmt;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			video_id_init (&_tmp9_, sqlite3_column_int64 (_tmp8_, 0));
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, &_tmp9_);
#line 2381 "VideoTable.c"
		}
	}
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = video_ids;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2390 "VideoTable.c"
}


static sqlite3_stmt*
video_table_get_duplicate_stmt (VideoTable* self,
                                GFile* file,
                                const gchar* md5)
{
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp1_;
	gboolean first = FALSE;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint col = 0;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (file != NULL) {
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 2414 "VideoTable.c"
	} else {
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = md5 != NULL;
#line 2418 "VideoTable.c"
	}
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_vala_assert (_tmp0_, "file != null || md5 != null");
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	sql = _tmp1_;
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	first = TRUE;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (file != NULL) {
#line 2430 "VideoTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = sql;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = g_strconcat (_tmp2_, " filename=?", NULL);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		sql = _tmp3_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		first = FALSE;
#line 2443 "VideoTable.c"
	}
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2447 "VideoTable.c"
		gboolean _tmp4_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_ = first;
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!_tmp4_) {
#line 2455 "VideoTable.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp5_ = sql;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp6_ = g_strconcat (_tmp5_, " OR ", NULL);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_g_free0 (sql);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			sql = _tmp6_;
#line 2466 "VideoTable.c"
		}
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = sql;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = g_strconcat (_tmp7_, " md5=?", NULL);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		sql = _tmp8_;
#line 2476 "VideoTable.c"
	}
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp9_ = sql;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp10_ = database_table_create_stmt ((DatabaseTable*) self, _tmp9_);
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp10_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	col = 1;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (file != NULL) {
#line 2488 "VideoTable.c"
		sqlite3_stmt* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp11_ = stmt;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_ = col;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		col = _tmp12_ + 1;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp13_ = g_file_get_path (file);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_ = _tmp13_;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_bind_text (_tmp11_, _tmp12_, _tmp14_);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp14_);
#line 2507 "VideoTable.c"
	}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2511 "VideoTable.c"
		sqlite3_stmt* _tmp15_;
		gint _tmp16_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp16_ = col;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		col = _tmp16_ + 1;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_bind_text (_tmp15_, _tmp16_, md5);
#line 2522 "VideoTable.c"
	}
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = stmt;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (sql);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2530 "VideoTable.c"
}


gboolean
video_table_has_duplicate (VideoTable* self,
                           GFile* file,
                           const gchar* md5)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = res;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp2_ == SQLITE_DONE) {
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = FALSE;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 2565 "VideoTable.c"
	} else {
		gint _tmp3_;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = res;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_tmp3_ == SQLITE_ROW) {
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			result = TRUE;
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return result;
#line 2578 "VideoTable.c"
		} else {
			gint _tmp4_;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp4_ = res;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", _tmp4_);
#line 2585 "VideoTable.c"
		}
	}
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = FALSE;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2594 "VideoTable.c"
}


static void
_vala_array_add137 (VideoID* * array,
                    int* length,
                    int* size,
                    const VideoID* value)
{
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2610 "VideoTable.c"
	}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2614 "VideoTable.c"
}


VideoID*
video_table_get_duplicate_ids (VideoTable* self,
                               GFile* file,
                               const gchar* md5,
                               int* result_length1)
{
	VideoID* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	VideoID* ids = NULL;
	VideoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	VideoID* _tmp8_;
	gint _tmp8__length1;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = g_new0 (VideoID, 0);
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	ids = _tmp1_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	ids_length1 = 0;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	while (TRUE) {
#line 2655 "VideoTable.c"
		gint _tmp3_;
		VideoID* _tmp4_;
		gint _tmp4__length1;
		sqlite3_stmt* _tmp5_;
		VideoID _tmp6_ = {0};
		sqlite3_stmt* _tmp7_;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = res;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!(_tmp3_ == SQLITE_ROW)) {
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			break;
#line 2668 "VideoTable.c"
		}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_ = ids;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4__length1 = ids_length1;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp6_, sqlite3_column_int64 (_tmp5_, 0));
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_vala_array_add137 (&ids, &ids_length1, &_ids_size_, &_tmp6_);
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		res = sqlite3_step (_tmp7_);
#line 2684 "VideoTable.c"
	}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = ids;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8__length1 = ids_length1;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (result_length1) {
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*result_length1 = _tmp8__length1;
#line 2694 "VideoTable.c"
	}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp8_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2702 "VideoTable.c"
}


GeeArrayList*
video_table_get_event_source_ids (VideoTable* self,
                                  EventID* event_id)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp4_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable WHERE event_id = ?");
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_result_ = _tmp4_;
#line 2738 "VideoTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = TRUE;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		while (TRUE) {
#line 2745 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp10_;
			sqlite3_stmt* _tmp11_;
			VideoID _tmp12_ = {0};
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (!_tmp5_) {
#line 2756 "VideoTable.c"
			}
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp5_ = FALSE;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp6_ = stmt;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			res = sqlite3_step (_tmp6_);
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp7_ = res;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_tmp7_ == SQLITE_DONE) {
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				break;
#line 2770 "VideoTable.c"
			} else {
				gint _tmp8_;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_tmp8_ = res;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_tmp8_ != SQLITE_ROW) {
#line 2777 "VideoTable.c"
					gint _tmp9_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_tmp9_ = res;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", _tmp9_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					break;
#line 2785 "VideoTable.c"
				}
			}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp10_ = _result_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp11_ = stmt;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			video_id_init (&_tmp12_, sqlite3_column_int64 (_tmp11_, 0));
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp13_ = video_id_upgrade_video_id_to_source_id (&_tmp12_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp14_ = _tmp13_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp14_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_g_free0 (_tmp14_);
#line 2802 "VideoTable.c"
		}
	}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _result_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2811 "VideoTable.c"
}


void
video_table_set_timestamp (VideoTable* self,
                           VideoID* video_id,
                           time_t timestamp,
                           GError** error)
{
	VideoID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "timestamp", (gint64) timestamp, &_inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2842 "VideoTable.c"
		} else {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2850 "VideoTable.c"
		}
	}
}


static void
video_table_class_init (VideoTableClass * klass)
{
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	((DatabaseTableClass *) klass)->finalize = video_table_finalize;
#line 2863 "VideoTable.c"
}


static void
video_table_instance_init (VideoTable * self)
{
}


static void
video_table_finalize (DatabaseTable * obj)
{
	VideoTable * self;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_TABLE, VideoTable);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 2881 "VideoTable.c"
}


GType
video_table_get_type (void)
{
	static volatile gsize video_table_type_id__volatile = 0;
	if (g_once_init_enter (&video_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
		GType video_table_type_id;
		video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
		g_once_init_leave (&video_table_type_id__volatile, video_table_type_id);
	}
	return video_table_type_id__volatile;
}



