/* file.c generated by valac 0.39.7, the Vala compiler
 * generated from file.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);


gboolean claim_file (GFile* file,
                     GError** error);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
glong find_last_offset (const gchar* str,
                        gchar c);
guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
void delete_all_files (GFile* dir,
                       GeeSet* exceptions,
                       ProgressMonitor monitor,
                       void* monitor_target,
                       guint64 file_count,
                       GCancellable* cancellable,
                       GError** error);
time_t query_file_modified (GFile* file,
                            GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir,
                                   GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input,
                  guint64 skip_amount,
                  GError** error);
guint64 count_files_in_directory (GFile* dir,
                                  GError** error);
gboolean file_equal (GFile* a,
                     GFile* b);
guint file_hash (GFile* file);


static gpointer
_g_error_copy0 (gpointer self)
{
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 88 "file.c"
}


gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 101 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 113 "file.c"
			goto __catch545_g_error;
		}
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = TRUE;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 120 "file.c"
	}
	goto __finally545;
	__catch545_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		err = _inner_error_;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = err;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 135 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp5_ = err;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_warning ("file.vala:34: claim_file %s: %s", _tmp4_, _tmp6_);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp4_);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp7_ = err;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = _tmp8_;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 162 "file.c"
			goto __finally545;
		}
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_error_free0 (err);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 171 "file.c"
	}
	__finally545:
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_propagate_error (error, _inner_error_);
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return _tmp9_;
#line 178 "file.c"
}


GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* result = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GError * _inner_error_ = NULL;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	file = _tmp0_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = file;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (file);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return NULL;
#line 221 "file.c"
	}
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp1_) {
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_collision = FALSE;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = file;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (collision) {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			*collision = _vala_collision;
#line 233 "file.c"
		}
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 237 "file.c"
	}
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_vala_collision = TRUE;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (name);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	name = _tmp3_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (ext);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	ext = _tmp4_;
#line 251 "file.c"
	{
		gint ctr = 0;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		ctr = 1;
#line 256 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp5_ = TRUE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			while (TRUE) {
#line 263 "file.c"
				gint _tmp7_;
				gchar* _tmp8_ = NULL;
				const gchar* _tmp9_;
				gchar* new_name = NULL;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GFile* _tmp19_;
				gboolean _tmp20_ = FALSE;
				GFile* _tmp21_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (!_tmp5_) {
#line 275 "file.c"
					gint _tmp6_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp6_ = ctr;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 281 "file.c"
				}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp5_ = FALSE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp7_ = ctr;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (!(_tmp7_ < G_MAXINT)) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					break;
#line 291 "file.c"
				}
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp9_ = ext;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (_tmp9_ != NULL) {
#line 297 "file.c"
					const gchar* _tmp10_;
					gint _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp10_ = name;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp11_ = ctr;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp12_ = ext;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d.%s", _tmp10_, _tmp11_, _tmp12_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp8_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp8_ = _tmp13_;
#line 314 "file.c"
				} else {
					const gchar* _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp14_ = name;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp15_ = ctr;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp16_ = g_strdup_printf ("%s_%d", _tmp14_, _tmp15_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp8_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp8_ = _tmp16_;
#line 329 "file.c"
				}
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp17_ = g_strdup (_tmp8_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				new_name = _tmp17_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp18_ = new_name;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp19_ = g_file_get_child (dir, _tmp18_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_object_unref0 (file);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				file = _tmp19_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp21_ = file;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp20_ = claim_file (_tmp21_, &_inner_error_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					g_propagate_error (error, _inner_error_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (new_name);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp8_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (ext);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (name);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_object_unref0 (file);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					return NULL;
#line 363 "file.c"
				}
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (_tmp20_) {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					result = file;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (new_name);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp8_);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (ext);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (name);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					if (collision) {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
						*collision = _vala_collision;
#line 381 "file.c"
					}
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					return result;
#line 385 "file.c"
				}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_free0 (new_name);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_free0 (_tmp8_);
#line 391 "file.c"
			}
		}
	}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp22_ = g_file_get_path (dir);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp23_ = _tmp22_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_warning ("file.vala:73: generate_unique_filename %s for %s: unable to claim file", _tmp23_, basename);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (_tmp23_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = NULL;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (ext);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (name);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (file);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (collision) {
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*collision = _vala_collision;
#line 415 "file.c"
	}
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 419 "file.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 443 "file.c"
	} else {
		gchar* _tmp2_;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 452 "file.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1347 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 473 "file.c"
	} else {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 477 "file.c"
	}
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1351 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 483 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 493 "file.c"
	}
#line 1356 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 497 "file.c"
		glong _tmp3_;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1358 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 505 "file.c"
	} else {
		glong _tmp4_;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 512 "file.c"
	}
#line 1362 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 516 "file.c"
		glong _tmp5_;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 522 "file.c"
	}
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 534 "file.c"
}


void
disassemble_filename (const gchar* basename,
                      gchar* * name,
                      gchar* * ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
	glong _tmp0_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = offset;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp0_ <= ((glong) 0)) {
#line 555 "file.c"
		gchar* _tmp1_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = g_strdup (basename);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_name = _tmp1_;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_ext = NULL;
#line 567 "file.c"
	} else {
		glong _tmp2_;
		gchar* _tmp3_;
		glong _tmp4_;
		gchar* _tmp5_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = offset;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = string_substring (basename, (glong) 0, _tmp2_);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_name = _tmp3_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = offset;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = string_substring (basename, _tmp4_ + 1, (glong) -1);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_ext = _tmp5_;
#line 589 "file.c"
	}
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (name) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*name = _vala_name;
#line 595 "file.c"
	} else {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 599 "file.c"
	}
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (ext) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*ext = _vala_ext;
#line 605 "file.c"
	} else {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 609 "file.c"
	}
}


guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	guint64 result = 0ULL;
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file_or_dir != NULL, 0ULL);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = type;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp0_ == G_FILE_TYPE_REGULAR) {
#line 634 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp12_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = NULL;
#line 639 "file.c"
		{
			GFileInfo* _tmp1_ = NULL;
			GFileInfo* _tmp2_;
			GFileInfo* _tmp3_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp2_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp1_ = _tmp2_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 650 "file.c"
				goto __catch546_g_error;
			}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp3_ = _tmp1_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp1_ = NULL;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			info = _tmp3_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp1_);
#line 663 "file.c"
		}
		goto __finally546;
		__catch546_g_error:
		{
			GError* err = NULL;
			GError* _tmp4_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			err = _inner_error_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp4_ = err;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 682 "file.c"
				GError* _tmp5_;
				GError* _tmp6_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp5_ = err;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp6_ = _g_error_copy0 (_tmp5_);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_inner_error_ = _tmp6_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_error_free0 (err);
#line 693 "file.c"
				goto __finally546;
			}
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp7_ = g_file_get_path (file_or_dir);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp8_ = _tmp7_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp9_ = err;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp10_ = _tmp9_->message;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_debug ("file.vala:101: Unable to query filesize for %s: %s", _tmp8_, _tmp10_);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp8_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 716 "file.c"
		}
		__finally546:
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 721 "file.c"
			guint64 _tmp11_ = 0ULL;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp11_;
#line 729 "file.c"
		}
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp12_ = info;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp12_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 739 "file.c"
	} else {
		GFileType _tmp13_;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = type;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp13_ != G_FILE_TYPE_DIRECTORY) {
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 750 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp14_ = NULL;
		GFileEnumerator* _tmp15_;
		GFileEnumerator* _tmp16_;
		GFileEnumerator* _tmp17_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp15_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp14_ = _tmp15_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 764 "file.c"
			goto __catch547_g_error;
		}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp16_ = _tmp14_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp14_ = NULL;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		enumerator = _tmp16_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp17_ = enumerator;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp17_ == NULL) {
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp14_);
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 787 "file.c"
		}
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp14_);
#line 791 "file.c"
	}
	goto __finally547;
	__catch547_g_error:
	{
		GError* err = NULL;
		gboolean _tmp18_ = FALSE;
		GError* _tmp19_;
		GError* _tmp21_;
		GError* _tmp22_;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		err = _inner_error_;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp19_ = err;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (g_error_matches (_tmp19_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp18_ = TRUE;
#line 811 "file.c"
		} else {
			GError* _tmp20_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp20_ = err;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp18_ = g_error_matches (_tmp20_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 818 "file.c"
		}
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp18_) {
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 830 "file.c"
		}
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp21_ = err;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp22_ = _g_error_copy0 (_tmp21_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = _tmp22_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_error_free0 (err);
#line 840 "file.c"
		goto __finally547;
	}
	__finally547:
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 846 "file.c"
		guint64 _tmp23_ = 0ULL;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp23_;
#line 854 "file.c"
	}
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	total_bytes = (guint64) 0;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 862 "file.c"
		GFileInfo* _tmp24_ = NULL;
		GFileEnumerator* _tmp25_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp28_;
		GFileInfo* _tmp29_;
		guint64 _tmp30_ = 0ULL;
		GFileInfo* _tmp31_;
		const gchar* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		guint64 _tmp35_;
		guint64 _tmp37_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp25_ = enumerator;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp26_ = g_file_enumerator_next_file (_tmp25_, cancellable, &_inner_error_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp24_ = _tmp26_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 883 "file.c"
			guint64 _tmp27_ = 0ULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp27_;
#line 893 "file.c"
		}
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp28_ = _tmp24_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp24_ = NULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp28_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp29_ = info;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp29_ != NULL)) {
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 911 "file.c"
		}
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp31_ = info;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp32_ = g_file_info_get_name (_tmp31_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp33_ = g_file_get_child (file_or_dir, _tmp32_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp34_ = _tmp33_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp35_ = query_total_file_size (_tmp34_, cancellable, &_inner_error_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp34_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp30_ = _tmp35_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 929 "file.c"
			guint64 _tmp36_ = 0ULL;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp36_;
#line 941 "file.c"
		}
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp37_ = total_bytes;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		total_bytes = _tmp37_ + _tmp30_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp24_);
#line 949 "file.c"
	}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = total_bytes;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 959 "file.c"
}


void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  void* monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp7_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (dir != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = type;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp0_ != G_FILE_TYPE_DIRECTORY) {
#line 987 "file.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = g_file_get_path (dir);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = _tmp1_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = g_strdup_printf ("%s is not a directory", _tmp2_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = _tmp3_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp4_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = _tmp5_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp4_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp2_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = _tmp6_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return;
#line 1016 "file.c"
	}
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp7_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp7_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return;
#line 1028 "file.c"
	}
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	i = (guint64) 0;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 1036 "file.c"
		GFileInfo* _tmp8_ = NULL;
		GFileEnumerator* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		gboolean _tmp26_ = FALSE;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp9_ = enumerator;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp10_ = g_file_enumerator_next_file (_tmp9_, cancellable, &_inner_error_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = _tmp10_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return;
#line 1065 "file.c"
		}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp11_ = _tmp8_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = NULL;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp11_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp12_ = info;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp12_ != NULL)) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1083 "file.c"
		}
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = info;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (g_file_info_get_file_type (_tmp13_) != G_FILE_TYPE_REGULAR) {
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			continue;
#line 1093 "file.c"
		}
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (exceptions != NULL) {
#line 1097 "file.c"
			GFileInfo* _tmp15_;
			const gchar* _tmp16_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp15_ = info;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp16_ = g_file_info_get_name (_tmp15_);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp14_ = gee_collection_contains ((GeeCollection*) exceptions, _tmp16_);
#line 1106 "file.c"
		} else {
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp14_ = FALSE;
#line 1110 "file.c"
		}
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp14_) {
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			continue;
#line 1118 "file.c"
		}
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp17_ = info;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp18_ = g_file_info_get_name (_tmp17_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp19_ = g_file_get_child (dir, _tmp18_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		file = _tmp19_;
#line 1128 "file.c"
		{
			GFile* _tmp20_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp20_ = file;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_file_delete (_tmp20_, cancellable, &_inner_error_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1137 "file.c"
				goto __catch548_g_error;
			}
		}
		goto __finally548;
		__catch548_g_error:
		{
			GError* err = NULL;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			err = _inner_error_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = NULL;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp21_ = file;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp22_ = g_file_get_path (_tmp21_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp23_ = _tmp22_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp24_ = err;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp25_ = _tmp24_->message;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_warning ("file.vala:159: Unable to delete file %s: %s", _tmp23_, _tmp25_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp23_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 1170 "file.c"
		}
		__finally548:
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (file);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return;
#line 1187 "file.c"
		}
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (monitor != NULL) {
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp26_ = file_count > ((guint64) 0);
#line 1193 "file.c"
		} else {
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp26_ = FALSE;
#line 1197 "file.c"
		}
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp26_) {
#line 1201 "file.c"
			guint64 _tmp27_;
			guint64 _tmp28_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp27_ = i;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			i = _tmp27_ + 1;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp28_ = i;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			monitor (file_count, _tmp28_, TRUE, monitor_target);
#line 1212 "file.c"
		}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (file);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp8_);
#line 1218 "file.c"
	}
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1224 "file.c"
}


time_t
query_file_modified (GFile* file,
                     GError** error)
{
	time_t result = 0;
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GTimeVal _tmp2_ = {0};
	glong _tmp3_;
	GError * _inner_error_ = NULL;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = _tmp0_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1246 "file.c"
		time_t _tmp1_ = 0;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp1_;
#line 1252 "file.c"
	}
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = _tmp2_.tv_sec;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = (time_t) _tmp3_;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1264 "file.c"
}


gboolean
query_is_directory (GFile* file)
{
	gboolean result = FALSE;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1278 "file.c"
}


gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	gboolean result = FALSE;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError * _inner_error_ = NULL;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1302 "file.c"
	}
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp0_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1310 "file.c"
		gboolean _tmp1_ = FALSE;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp1_;
#line 1316 "file.c"
	}
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = enumerator;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1328 "file.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = enumerator;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1338 "file.c"
		gboolean _tmp6_ = FALSE;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp6_;
#line 1346 "file.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp3_ == NULL;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1356 "file.c"
}


gchar*
get_display_pathname (GFile* file)
{
	gchar* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	path = _tmp0_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	home = _tmp2_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = path;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = home;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1391 "file.c"
		gchar* _tmp5_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp5_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (home);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (path);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1403 "file.c"
	}
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp6_ = path;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp7_ = home;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1411 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = path;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp9_ = home;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp13_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp15_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (home);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (path);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1446 "file.c"
	}
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = path;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (home);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1454 "file.c"
}


gchar*
strip_pretty_path (const gchar* path)
{
	gchar* result = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1471 "file.c"
		gchar* _tmp0_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp0_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1479 "file.c"
	}
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (_tmp3_);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp5_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1497 "file.c"
}


gchar*
get_file_info_id (GFileInfo* info)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp1_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1517 "file.c"
}


void
skip_uint64 (GInputStream* input,
             guint64 skip_amount,
             GError** error)
{
	GError * _inner_error_ = NULL;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (input != NULL);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(skip_amount > ((guint64) 0))) {
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1535 "file.c"
		}
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (skip_amount >= ((guint64) G_MAXSSIZE)) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				g_propagate_error (error, _inner_error_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				return;
#line 1547 "file.c"
			}
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			skip_amount = skip_amount - G_MAXSSIZE;
#line 1551 "file.c"
		} else {
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				g_propagate_error (error, _inner_error_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				return;
#line 1561 "file.c"
			}
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			skip_amount = (guint64) 0;
#line 1565 "file.c"
		}
	}
}


guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 result = 0ULL;
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError * _inner_error_ = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, 0ULL);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = (guint64) 0;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1589 "file.c"
	}
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	count = (guint64) 0;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp0_;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1599 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp1_;
#line 1605 "file.c"
	}
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 1611 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = enumerator;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1626 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp5_;
#line 1636 "file.c"
		}
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = NULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp6_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp7_ = info;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1654 "file.c"
		}
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = count;
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		count = _tmp8_ + 1;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1662 "file.c"
	}
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = count;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1672 "file.c"
}


gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (a != NULL) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1687 "file.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = FALSE;
#line 1691 "file.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp1_) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1697 "file.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = FALSE;
#line 1701 "file.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp0_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1707 "file.c"
}


guint
file_hash (GFile* file)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (file != NULL) {
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1720 "file.c"
	} else {
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1724 "file.c"
	}
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp0_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1730 "file.c"
}



