/* MetadataWriter.c generated by valac 0.39.7, the Vala compiler
 * generated from MetadataWriter.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* MetadataWriter tracks LibraryPhotos for alterations to their metadata and commits those changes*/
/* in a timely manner to their backing files.  Because only the MetadataWriter knows when the*/
/* metadata has been properly committed, it is also responsible for updating the metadata-dirty*/
/* flag in Photo.  Thus, MetadataWriter should *always* be running, even if the user has turned off*/
/* the feature, so if they turn it on MetadataWriter can properly go out and update the backing*/
/* files.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gio/gio.h>
#include <time.h>
#include <glib/gi18n-lib.h>
#include "config.h"


#define TYPE_METADATA_WRITER (metadata_writer_get_type ())
#define METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_WRITER, MetadataWriter))
#define METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_WRITER, MetadataWriterClass))
#define IS_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_WRITER))
#define IS_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_WRITER))
#define METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_WRITER, MetadataWriterClass))

typedef struct _MetadataWriter MetadataWriter;
typedef struct _MetadataWriterClass MetadataWriterClass;
typedef struct _MetadataWriterPrivate MetadataWriterPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define METADATA_WRITER_TYPE_COMMIT_JOB (metadata_writer_commit_job_get_type ())
#define METADATA_WRITER_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob))
#define METADATA_WRITER_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))
#define METADATA_WRITER_IS_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_IS_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_COMMIT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))

typedef struct _MetadataWriterCommitJob MetadataWriterCommitJob;
typedef struct _MetadataWriterCommitJobClass MetadataWriterCommitJobClass;
enum  {
	METADATA_WRITER_0_PROPERTY,
	METADATA_WRITER_NUM_PROPERTIES
};
static GParamSpec* metadata_writer_properties[METADATA_WRITER_NUM_PROPERTIES];

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;

#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _timed_queue_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _MetadataWriterCommitJobPrivate MetadataWriterCommitJobPrivate;

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())
enum  {
	METADATA_WRITER_PROGRESS_SIGNAL,
	METADATA_WRITER_NUM_SIGNALS
};
static guint metadata_writer_signals[METADATA_WRITER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MetadataWriter {
	GObject parent_instance;
	MetadataWriterPrivate * priv;
};

struct _MetadataWriterClass {
	GObjectClass parent_class;
};

struct _MetadataWriterPrivate {
	Workers* workers;
	gboolean enabled;
	HashTimedQueue* dirty;
	GeeHashMap* pending;
	GeeHashSet* interested_photo_details;
	LibraryPhoto* ignore_photo_alteration;
	guint outstanding_total;
	guint outstanding_completed;
	gboolean closed;
	gint pause_count;
	GeeHashSet* importing_photos;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _MetadataWriterCommitJob {
	BackgroundJob parent_instance;
	MetadataWriterCommitJobPrivate * priv;
	LibraryPhoto* photo;
	GeeSet* current_keywords;
	PhotoReimportMasterState* reimport_master_state;
	PhotoReimportEditableState* reimport_editable_state;
	GError* err;
};

struct _MetadataWriterCommitJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


static gpointer metadata_writer_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
extern TagSourceCollection* tag_global;
static MetadataWriter* metadata_writer_instance;
static MetadataWriter* metadata_writer_instance = NULL;
static gpointer metadata_writer_commit_job_parent_class = NULL;

GType metadata_writer_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_timed_queue (GValue* value,
                            gpointer v_object);
void value_take_timed_queue (GValue* value,
                             gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType photo_source_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType library_photo_get_type (void) G_GNUC_CONST;
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_background_job (GValue* value,
                               gpointer v_object);
void value_take_background_job (GValue* value,
                                gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
static GType metadata_writer_commit_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define METADATA_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_WRITER, MetadataWriterPrivate))
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
static void metadata_writer_on_config_changed (MetadataWriter* self);
static void _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed (ConfigurationFacade* _sender,
                                                                                                 gpointer self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_importing_photos (MetadataWriter* self,
                                          GeeCollection* media_sources);
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender,
                                                                                         GeeCollection* media,
                                                                                         gpointer self);
static void metadata_writer_on_photos_imported (MetadataWriter* self,
                                         GeeCollection* media_sources);
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender,
                                                                                         GeeCollection* media,
                                                                                         gpointer self);
static void metadata_writer_on_photos_added_removed (MetadataWriter* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                                GeeIterable* added,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_photos_altered (MetadataWriter* self,
                                        GeeMap* items);
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                       GeeMap* items,
                                                                       gpointer self);
static void metadata_writer_on_collection_frozen (MetadataWriter* self);
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender,
                                                                   gpointer self);
static void metadata_writer_on_collection_thawed (MetadataWriter* self);
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender,
                                                                   gpointer self);
static void metadata_writer_on_photos_destroyed (MetadataWriter* self,
                                          GeeCollection* destroyed);
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                             GeeCollection* destroyed,
                                                                             gpointer self);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tags_altered (MetadataWriter* self,
                                      GeeMap* map);
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                                     GeeMap* items,
                                                                     gpointer self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self,
                                              ContainerSource* container,
                                              GeeCollection* added,
                                              gboolean relinking,
                                              GeeCollection* removed,
                                              gboolean unlinking);
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                                      ContainerSource* container,
                                                                                                      GeeCollection* added,
                                                                                                      gboolean relinked,
                                                                                                      GeeCollection* removed,
                                                                                                      gboolean unlinked,
                                                                                                      gpointer self);
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self,
                                              ContainerSource* container,
                                              GeeCollection* sources);
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender,
                                                                                                         ContainerSource* container,
                                                                                                         GeeCollection* sources,
                                                                                                         gpointer self);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
static void metadata_writer_on_application_exiting (MetadataWriter* self);
static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender,
                                                                  gboolean panicked,
                                                                  gpointer self);
gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void value_set_library_monitor_pool (GValue* value,
                                     gpointer v_object);
void value_take_library_monitor_pool (GValue* value,
                                      gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
LibraryMonitorPool* library_monitor_pool_get_instance (void);
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_monitor_installed (MetadataWriter* self,
                                           LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender,
                                                                                   LibraryMonitor* monitor,
                                                                                   gpointer self);
static void metadata_writer_on_monitor_destroyed (MetadataWriter* self,
                                           LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender,
                                                                                   LibraryMonitor* monitor,
                                                                                   gpointer self);
Workers* workers_new (gint max_threads,
                      gboolean exclusive);
Workers* workers_construct (GType object_type,
                            gint max_threads,
                            gboolean exclusive);
#define METADATA_WRITER_COMMIT_DELAY_MSEC ((guint) 3000)
#define METADATA_WRITER_COMMIT_SPACING_MSEC ((guint) 50)
static MetadataWriter* metadata_writer_new (void);
static MetadataWriter* metadata_writer_construct (GType object_type);
static void metadata_writer_on_photo_dequeued (MetadataWriter* self,
                                        LibraryPhoto* photo);
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item,
                                                           gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      guint hold_msec,
                                      DequeuedCallback callback,
                                      void* callback_target,
                                      GeeHashDataFunc hash_func,
                                      void* hash_func_target,
                                      GDestroyNotify hash_func_target_destroy_notify,
                                      GeeEqualDataFunc equal_func,
                                      void* equal_func_target,
                                      GDestroyNotify equal_func_target_destroy_notify,
                                      gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            guint hold_msec,
                                            DequeuedCallback callback,
                                            void* callback_target,
                                            GeeHashDataFunc hash_func,
                                            void* hash_func_target,
                                            GDestroyNotify hash_func_target_destroy_notify,
                                            GeeEqualDataFunc equal_func,
                                            void* equal_func_target,
                                            GDestroyNotify equal_func_target_destroy_notify,
                                            gint priority);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self,
                                           guint msec);
void metadata_writer_pause (MetadataWriter* self);
gboolean configuration_facade_get_commit_metadata_to_masters (ConfigurationFacade* self);
void metadata_writer_force_rescan (MetadataWriter* self);
void metadata_writer_init (void);
void metadata_writer_terminate (void);
void metadata_writer_close (MetadataWriter* self);
MetadataWriter* metadata_writer_get_instance (void);
static void metadata_writer_schedule_if_dirty (MetadataWriter* self,
                                        GeeIterable* media_sources,
                                        const gchar* reason);
GeeCollection* data_collection_get_all (DataCollection* self);
void timed_queue_pause (TimedQueue* self);
void metadata_writer_unpause (MetadataWriter* self);
void timed_queue_unpause (TimedQueue* self);
static void metadata_writer_cancel_all (MetadataWriter* self,
                                 gboolean wait);
static void metadata_writer_on_discovery_completed (MetadataWriter* self);
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender,
                                                                                    gpointer self);
static gboolean metadata_writer_cancel_job (MetadataWriter* self,
                                     LibraryPhoto* photo);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self,
                                       const gchar* subject);
static void metadata_writer_photos_are_dirty (MetadataWriter* self,
                                       GeeCollection* photos,
                                       const gchar* reason,
                                       gboolean already_marked);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* tag_get_sources (Tag* self);
gchar* data_object_to_string (DataObject* self);
static void metadata_writer_count_enqueued_work (MetadataWriter* self,
                                          gint count,
                                          gboolean report);
static void metadata_writer_count_cancelled_work (MetadataWriter* self,
                                           gint count,
                                           gboolean report);
static void metadata_writer_count_completed_work (MetadataWriter* self,
                                           gint count,
                                           gboolean report);
gboolean photo_is_master_metadata_dirty (Photo* self);
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
void transaction_controller_begin (TransactionController* self);
GQuark database_error_quark (void);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void transaction_controller_commit (TransactionController* self);
void app_window_database_error (GError* err);
gboolean timed_queue_enqueue (TimedQueue* self,
                              gconstpointer item);
void timed_queue_clear (TimedQueue* self);
void background_job_cancel (BackgroundJob* self);
void workers_wait_for_empty_queue (Workers* self);
gboolean timed_queue_contains (TimedQueue* self,
                               gconstpointer item);
gboolean timed_queue_remove_first (TimedQueue* self,
                                   gconstpointer item);
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
gchar* data_object_get_name (DataObject* self);
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner,
                                                         LibraryPhoto* photo,
                                                         GeeSet* keywords);
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type,
                                                               MetadataWriter* owner,
                                                               LibraryPhoto* photo,
                                                               GeeSet* keywords);
void workers_enqueue (Workers* self,
                      BackgroundJob* job);
static void metadata_writer_on_update_completed (MetadataWriter* self,
                                          BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
static void metadata_writer_on_update_cancelled (MetadataWriter* self,
                                          BackgroundJob* j);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job,
                                                               gpointer self);
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job,
                                                                 gpointer self);
gpointer abstract_semaphore_ref (gpointer instance);
void abstract_semaphore_unref (gpointer instance);
GParamSpec* param_spec_abstract_semaphore (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_abstract_semaphore (GValue* value,
                                   gpointer v_object);
void value_take_abstract_semaphore (GValue* value,
                                    gpointer v_object);
gpointer value_get_abstract_semaphore (const GValue* value);
GType abstract_semaphore_get_type (void) G_GNUC_CONST;
BackgroundJob* background_job_construct (GType object_type,
                                         GObject* owner,
                                         CompletionCallback callback,
                                         void* callback_target,
                                         GCancellable* cancellable,
                                         CancellationCallback cancellation,
                                         void* cancellation_target,
                                         AbstractSemaphore* completion_semaphore);
static void metadata_writer_commit_job_real_execute (BackgroundJob* base);
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self,
                                               GError** error);
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self,
                                                 GError** error);
gboolean photo_has_editable (Photo* self);
GType photo_file_format_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_get_master_file_format (Photo* self);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self,
                                                     PhotoMetadata* metadata,
                                                     gboolean skip_orientation);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
GFile* media_source_get_master_file (MediaSource* self);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState* * state,
                                        GError** error);
void library_monitor_unblacklist_file (GFile* file);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
GFile* photo_get_editable_file (Photo* self);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState* * state,
                                          GError** error);
gchar* media_source_get_title (MediaSource* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment);
time_t media_source_get_exposure_time (MediaSource* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
Tag* tag_for_path (const gchar* name);
gchar* tag_get_user_visible_name (Tag* self);
gboolean equal_sets (GeeSet* a,
                     GeeSet* b);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     void* compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_get_orientation (Photo* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE _ ("Photos")
#define RESOURCES_APP_VERSION _VERSION
static void metadata_writer_commit_job_finalize (BackgroundJob * obj);
static void metadata_writer_finalize (GObject * obj);

static const gchar* METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS[3] = {"name", "comment", "exposure-time"};

static void
_metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed (ConfigurationFacade* _sender,
                                                                                            gpointer self)
{
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_config_changed ((MetadataWriter*) self);
#line 1059 "MetadataWriter.c"
}


static void
_metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender,
                                                                                    GeeCollection* media,
                                                                                    gpointer self)
{
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_importing_photos ((MetadataWriter*) self, media);
#line 1070 "MetadataWriter.c"
}


static void
_metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender,
                                                                                    GeeCollection* media,
                                                                                    gpointer self)
{
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_photos_imported ((MetadataWriter*) self, media);
#line 1081 "MetadataWriter.c"
}


static void
_metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                           GeeIterable* added,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_photos_added_removed ((MetadataWriter*) self, added, removed);
#line 1093 "MetadataWriter.c"
}


static void
_metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                  GeeMap* items,
                                                                  gpointer self)
{
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_photos_altered ((MetadataWriter*) self, items);
#line 1104 "MetadataWriter.c"
}


static void
_metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender,
                                                              gpointer self)
{
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_collection_frozen ((MetadataWriter*) self);
#line 1114 "MetadataWriter.c"
}


static void
_metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender,
                                                              gpointer self)
{
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_collection_thawed ((MetadataWriter*) self);
#line 1124 "MetadataWriter.c"
}


static void
_metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                        GeeCollection* destroyed,
                                                                        gpointer self)
{
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_photos_destroyed ((MetadataWriter*) self, destroyed);
#line 1135 "MetadataWriter.c"
}


static void
_metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                                GeeMap* items,
                                                                gpointer self)
{
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_tags_altered ((MetadataWriter*) self, items);
#line 1146 "MetadataWriter.c"
}


static void
_metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                                 ContainerSource* container,
                                                                                                 GeeCollection* added,
                                                                                                 gboolean relinked,
                                                                                                 GeeCollection* removed,
                                                                                                 gboolean unlinked,
                                                                                                 gpointer self)
{
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_tag_contents_altered ((MetadataWriter*) self, container, added, relinked, removed, unlinked);
#line 1161 "MetadataWriter.c"
}


static void
_metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender,
                                                                                                    ContainerSource* container,
                                                                                                    GeeCollection* sources,
                                                                                                    gpointer self)
{
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_tag_backlink_removed ((MetadataWriter*) self, container, sources);
#line 1173 "MetadataWriter.c"
}


static void
_metadata_writer_on_application_exiting_application_exiting (Application* _sender,
                                                             gboolean panicked,
                                                             gpointer self)
{
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_application_exiting ((MetadataWriter*) self);
#line 1184 "MetadataWriter.c"
}


static void
_metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender,
                                                                              LibraryMonitor* monitor,
                                                                              gpointer self)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_monitor_installed ((MetadataWriter*) self, monitor);
#line 1195 "MetadataWriter.c"
}


static void
_metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender,
                                                                              LibraryMonitor* monitor,
                                                                              gpointer self)
{
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_monitor_destroyed ((MetadataWriter*) self, monitor);
#line 1206 "MetadataWriter.c"
}


static void
_metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item,
                                                      gpointer self)
{
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_photo_dequeued ((MetadataWriter*) self, (LibraryPhoto*) item);
#line 1216 "MetadataWriter.c"
}


static MetadataWriter*
metadata_writer_construct (GType object_type)
{
	MetadataWriter * self = NULL;
	HashTimedQueue* _tmp0_;
	HashTimedQueue* _tmp1_;
	ConfigFacade* _tmp5_;
	ConfigFacade* _tmp6_;
	ConfigFacade* _tmp7_;
	ConfigFacade* _tmp8_;
	LibraryPhotoSourceCollection* _tmp9_;
	LibraryPhotoSourceCollection* _tmp10_;
	LibraryPhotoSourceCollection* _tmp11_;
	LibraryPhotoSourceCollection* _tmp12_;
	LibraryPhotoSourceCollection* _tmp13_;
	LibraryPhotoSourceCollection* _tmp14_;
	LibraryPhotoSourceCollection* _tmp15_;
	TagSourceCollection* _tmp16_;
	TagSourceCollection* _tmp17_;
	TagSourceCollection* _tmp18_;
	TagSourceCollection* _tmp19_;
	TagSourceCollection* _tmp20_;
	Application* _tmp21_;
	Application* _tmp22_;
	LibraryMonitorPool* _tmp23_;
	LibraryMonitorPool* _tmp24_;
	LibraryMonitorPool* _tmp25_;
	LibraryMonitorPool* _tmp26_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self = (MetadataWriter*) g_object_new (object_type, NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = hash_timed_queue_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, METADATA_WRITER_COMMIT_DELAY_MSEC, _metadata_writer_on_photo_dequeued_dequeued_callback, self, NULL, NULL, NULL, NULL, NULL, NULL, G_PRIORITY_DEFAULT);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->dirty = _tmp0_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	timed_queue_set_dequeue_spacing_msec ((TimedQueue*) _tmp1_, METADATA_WRITER_COMMIT_SPACING_MSEC);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 1262 "MetadataWriter.c"
	{
		const gchar** detail_collection = NULL;
		gint detail_collection_length1 = 0;
		gint _detail_collection_size_ = 0;
		gint detail_it = 0;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		detail_collection = METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		detail_collection_length1 = G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		for (detail_it = 0; detail_it < G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS); detail_it = detail_it + 1) {
#line 1274 "MetadataWriter.c"
			gchar* _tmp2_;
			gchar* detail = NULL;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp2_ = g_strdup (detail_collection[detail_it]);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			detail = _tmp2_;
#line 1281 "MetadataWriter.c"
			{
				GeeHashSet* _tmp3_;
				const gchar* _tmp4_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp3_ = self->priv->interested_photo_details;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp4_ = detail;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_free0 (detail);
#line 1293 "MetadataWriter.c"
			}
		}
	}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = config_facade_get_instance ();
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp6_ = _tmp5_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->enabled = configuration_facade_get_commit_metadata_to_masters ((ConfigurationFacade*) _tmp6_);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp6_);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp7_ = config_facade_get_instance ();
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp8_ = _tmp7_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((ConfigurationFacade*) _tmp8_, "commit-metadata-to-masters-changed", (GCallback) _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed, self, 0);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp8_);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_force_rescan (self);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp9_ = library_photo_global;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((MediaSourceCollection*) _tmp9_, "media-import-starting", (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self, 0);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp10_ = library_photo_global;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((MediaSourceCollection*) _tmp10_, "media-import-completed", (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self, 0);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp11_, "contents-altered", (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self, 0);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp12_ = library_photo_global;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp12_, "items-altered", (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self, 0);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp13_, "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = library_photo_global;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp14_, "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((SourceCollection*) _tmp15_, "items-destroyed", (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self, 0);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp16_ = tag_global;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp16_, "items-altered", (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self, 0);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((ContainerSourceCollection*) _tmp17_, "container-contents-altered", (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp18_ = tag_global;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((ContainerSourceCollection*) _tmp18_, "backlink-to-container-removed", (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self, 0);
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp19_, "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp20_ = tag_global;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp20_, "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp21_ = application_get_instance ();
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp22_ = _tmp21_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp22_, "exiting", (GCallback) _metadata_writer_on_application_exiting_application_exiting, self, 0);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp22_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp23_ = library_monitor_pool_get_instance ();
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp24_ = _tmp23_;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp24_, "monitor-installed", (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self, 0);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp24_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp25_ = library_monitor_pool_get_instance ();
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp26_ = _tmp25_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp26_, "monitor-destroyed", (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self, 0);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp26_);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return self;
#line 1389 "MetadataWriter.c"
}


static MetadataWriter*
metadata_writer_new (void)
{
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return metadata_writer_construct (TYPE_METADATA_WRITER);
#line 1398 "MetadataWriter.c"
}


void
metadata_writer_init (void)
{
	MetadataWriter* _tmp0_;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_new ();
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_instance = _tmp0_;
#line 1412 "MetadataWriter.c"
}


void
metadata_writer_terminate (void)
{
	MetadataWriter* _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_ != NULL) {
#line 1424 "MetadataWriter.c"
		MetadataWriter* _tmp1_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = metadata_writer_instance;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_close (_tmp1_);
#line 1430 "MetadataWriter.c"
	}
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_instance = NULL;
#line 1436 "MetadataWriter.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return self ? g_object_ref (self) : NULL;
#line 1445 "MetadataWriter.c"
}


MetadataWriter*
metadata_writer_get_instance (void)
{
	MetadataWriter* result = NULL;
	MetadataWriter* _tmp0_;
	MetadataWriter* _tmp1_;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	result = _tmp1_;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return result;
#line 1463 "MetadataWriter.c"
}


void
metadata_writer_force_rescan (MetadataWriter* self)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = library_photo_global;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = data_collection_get_all ((DataCollection*) _tmp0_);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_schedule_if_dirty (self, (GeeIterable*) _tmp2_, "force rescan");
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp2_);
#line 1485 "MetadataWriter.c"
}


void
metadata_writer_pause (MetadataWriter* self)
{
	gint _tmp0_;
	HashTimedQueue* _tmp1_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pause_count;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->pause_count = _tmp0_ + 1;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_ != 0) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 1504 "MetadataWriter.c"
	}
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	timed_queue_pause ((TimedQueue*) _tmp1_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, (guint) 0, (guint) 0);
#line 1512 "MetadataWriter.c"
}


void
metadata_writer_unpause (MetadataWriter* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	HashTimedQueue* _tmp4_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->priv->pause_count;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp1_ == 0) {
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 1530 "MetadataWriter.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = self->priv->pause_count;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->pause_count = _tmp2_ - 1;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = self->priv->pause_count;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = _tmp3_ != 0;
#line 1542 "MetadataWriter.c"
	}
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 1548 "MetadataWriter.c"
	}
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = self->priv->dirty;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	timed_queue_unpause ((TimedQueue*) _tmp4_);
#line 1554 "MetadataWriter.c"
}


void
metadata_writer_close (MetadataWriter* self)
{
	gboolean _tmp0_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->closed;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 1570 "MetadataWriter.c"
	}
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_cancel_all (self, TRUE);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->closed = TRUE;
#line 1576 "MetadataWriter.c"
}


static void
metadata_writer_on_config_changed (MetadataWriter* self)
{
	gboolean value = FALSE;
	ConfigFacade* _tmp0_;
	ConfigFacade* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = config_facade_get_instance ();
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = configuration_facade_get_commit_metadata_to_masters ((ConfigurationFacade*) _tmp1_);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	value = _tmp2_;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = self->priv->enabled;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = value;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp3_ == _tmp4_) {
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 1611 "MetadataWriter.c"
	}
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = value;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->enabled = _tmp5_;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp6_ = self->priv->enabled;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp6_) {
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_force_rescan (self);
#line 1623 "MetadataWriter.c"
	} else {
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_cancel_all (self, FALSE);
#line 1627 "MetadataWriter.c"
	}
}


static void
metadata_writer_on_application_exiting (MetadataWriter* self)
{
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_close (self);
#line 1639 "MetadataWriter.c"
}


static void
_metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender,
                                                                               gpointer self)
{
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_discovery_completed ((MetadataWriter*) self);
#line 1649 "MetadataWriter.c"
}


static void
metadata_writer_on_monitor_installed (MetadataWriter* self,
                                      LibraryMonitor* monitor)
{
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (monitor != NULL);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_connect_object ((DirectoryMonitor*) monitor, "discovery-completed", (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self, 0);
#line 1663 "MetadataWriter.c"
}


static void
metadata_writer_on_monitor_destroyed (MetadataWriter* self,
                                      LibraryMonitor* monitor)
{
	guint _tmp0_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (monitor != NULL);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("discovery-completed", TYPE_DIRECTORY_MONITOR, &_tmp0_, NULL, FALSE);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DirectoryMonitor*) monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self);
#line 1680 "MetadataWriter.c"
}


static void
metadata_writer_on_discovery_completed (MetadataWriter* self)
{
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1691 "MetadataWriter.c"
}


static void
metadata_writer_on_collection_frozen (MetadataWriter* self)
{
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 1702 "MetadataWriter.c"
}


static void
metadata_writer_on_collection_thawed (MetadataWriter* self)
{
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1713 "MetadataWriter.c"
}


static void
metadata_writer_on_importing_photos (MetadataWriter* self,
                                     GeeCollection* media_sources)
{
	GeeHashSet* _tmp0_;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 324 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 324 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_COLLECTION, GeeCollection));
#line 1730 "MetadataWriter.c"
}


static void
metadata_writer_on_photos_imported (MetadataWriter* self,
                                    GeeCollection* media_sources)
{
	GeeHashSet* _tmp0_;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_COLLECTION, GeeCollection));
#line 1747 "MetadataWriter.c"
}


static void
metadata_writer_on_photos_added_removed (MetadataWriter* self,
                                         GeeIterable* added,
                                         GeeIterable* removed)
{
	gboolean _tmp0_ = FALSE;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (added != NULL) {
#line 1761 "MetadataWriter.c"
		gboolean _tmp1_;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = self->priv->enabled;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = _tmp1_;
#line 1767 "MetadataWriter.c"
	} else {
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 1771 "MetadataWriter.c"
	}
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_schedule_if_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable), "added to LibraryPhoto.global");
#line 1777 "MetadataWriter.c"
	}
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (removed != NULL) {
#line 1781 "MetadataWriter.c"
		gboolean cancelled = FALSE;
		gboolean _tmp9_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		cancelled = FALSE;
#line 1786 "MetadataWriter.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp2_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp2_ = gee_iterable_iterator (removed);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_object_it = _tmp2_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			while (TRUE) {
#line 1796 "MetadataWriter.c"
				GeeIterator* _tmp3_;
				DataObject* object = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				gboolean _tmp6_ = FALSE;
				DataObject* _tmp7_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp3_ = _object_it;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					break;
#line 1809 "MetadataWriter.c"
				}
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp4_ = _object_it;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				object = (DataObject*) _tmp5_;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp7_ = object;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (metadata_writer_cancel_job (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto))) {
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp6_ = TRUE;
#line 1823 "MetadataWriter.c"
				} else {
					gboolean _tmp8_;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp8_ = cancelled;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp6_ = _tmp8_;
#line 1830 "MetadataWriter.c"
				}
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				cancelled = _tmp6_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 1836 "MetadataWriter.c"
			}
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_object_it);
#line 1840 "MetadataWriter.c"
		}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp9_ = cancelled;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (_tmp9_) {
#line 1846 "MetadataWriter.c"
			guint _tmp10_;
			guint _tmp11_;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp10_ = self->priv->outstanding_completed;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp11_ = self->priv->outstanding_total;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, _tmp10_, _tmp11_);
#line 1855 "MetadataWriter.c"
		}
	}
}


static void
metadata_writer_on_photos_altered (MetadataWriter* self,
                                   GeeMap* items)
{
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp33_;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (items != NULL);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	photos = NULL;
#line 1873 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = _tmp0_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp2_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_object_it = _tmp4_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 1897 "MetadataWriter.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp8_;
			LibraryPhoto* _tmp9_;
			LibraryPhoto* _tmp10_;
			LibraryPhoto* _tmp11_;
			Alteration* alteration = NULL;
			DataObject* _tmp12_;
			gpointer _tmp13_;
			Alteration* _tmp14_;
			GeeCollection* details = NULL;
			Alteration* _tmp19_;
			GeeCollection* _tmp20_;
			GeeCollection* _tmp21_;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = _object_it;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 1921 "MetadataWriter.c"
			}
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			object = (DataObject*) _tmp7_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = object;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = _tmp9_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp11_ = self->priv->ignore_photo_alteration;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp10_ == _tmp11_) {
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 1947 "MetadataWriter.c"
			}
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp12_ = object;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp13_ = gee_map_get (items, _tmp12_);
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			alteration = (Alteration*) _tmp13_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp14_ = alteration;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (alteration_has_detail (_tmp14_, "image", "orientation")) {
#line 1959 "MetadataWriter.c"
				GeeHashSet* _tmp15_;
				GeeHashSet* _tmp17_;
				LibraryPhoto* _tmp18_;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp15_ = photos;
#line 362 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (_tmp15_ == NULL) {
#line 1967 "MetadataWriter.c"
					GeeHashSet* _tmp16_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp16_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					photos = _tmp16_;
#line 1975 "MetadataWriter.c"
				}
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp17_ = photos;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp18_ = photo;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 1991 "MetadataWriter.c"
			}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp19_ = alteration;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp20_ = alteration_get_details (_tmp19_, "metadata");
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			details = _tmp20_;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp21_ = details;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp21_ == NULL) {
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (details);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 2013 "MetadataWriter.c"
			}
			{
				GeeIterator* _detail_it = NULL;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp22_ = details;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_detail_it = _tmp23_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				while (TRUE) {
#line 2027 "MetadataWriter.c"
					GeeIterator* _tmp24_;
					gchar* detail = NULL;
					GeeIterator* _tmp25_;
					gpointer _tmp26_;
					GeeHashSet* _tmp27_;
					const gchar* _tmp28_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp24_ = _detail_it;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp24_)) {
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						break;
#line 2040 "MetadataWriter.c"
					}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp25_ = _detail_it;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp26_ = gee_iterator_get (_tmp25_);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					detail = (gchar*) _tmp26_;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp27_ = self->priv->interested_photo_details;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp28_ = detail;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp27_, _tmp28_)) {
#line 2054 "MetadataWriter.c"
						GeeHashSet* _tmp29_;
						GeeHashSet* _tmp31_;
						LibraryPhoto* _tmp32_;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp29_ = photos;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						if (_tmp29_ == NULL) {
#line 2062 "MetadataWriter.c"
							GeeHashSet* _tmp30_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
							_tmp30_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
							_g_object_unref0 (photos);
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
							photos = _tmp30_;
#line 2070 "MetadataWriter.c"
						}
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp31_ = photos;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp32_ = photo;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_g_free0 (detail);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						break;
#line 2082 "MetadataWriter.c"
					}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_free0 (detail);
#line 2086 "MetadataWriter.c"
				}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (_detail_it);
#line 2090 "MetadataWriter.c"
			}
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (details);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_alteration_unref0 (alteration);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 2100 "MetadataWriter.c"
		}
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 2104 "MetadataWriter.c"
	}
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp33_ = photos;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp33_ != NULL) {
#line 2110 "MetadataWriter.c"
		GeeHashSet* _tmp34_;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp34_ = photos;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp34_, "alteration", FALSE);
#line 2116 "MetadataWriter.c"
	}
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2120 "MetadataWriter.c"
}


static void
metadata_writer_on_photos_destroyed (MetadataWriter* self,
                                     GeeCollection* destroyed)
{
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (destroyed != NULL);
#line 2132 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) destroyed);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_source_it = _tmp0_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 2142 "MetadataWriter.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp4_;
			LibraryPhoto* _tmp5_;
			LibraryPhoto* _tmp6_;
			GeeHashSet* _tmp7_;
			LibraryPhoto* _tmp8_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp1_ = _source_it;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 2159 "MetadataWriter.c"
			}
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			source = (DataSource*) _tmp3_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp4_ = source;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = _tmp5_;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp6_);
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = self->priv->importing_photos;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 2187 "MetadataWriter.c"
		}
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 2191 "MetadataWriter.c"
	}
}


static void
metadata_writer_on_tags_altered (MetadataWriter* self,
                                 GeeMap* map)
{
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp27_;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (map != NULL);
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	photos = NULL;
#line 2208 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = _tmp0_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp2_);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_object_it = _tmp4_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 2232 "MetadataWriter.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			Alteration* _tmp10_;
			gboolean _tmp11_;
			GeeHashSet* _tmp12_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = _object_it;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 2248 "MetadataWriter.c"
			}
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			object = (DataObject*) _tmp7_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = object;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = gee_map_get (map, _tmp8_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp10_ = (Alteration*) _tmp9_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp11_ = !alteration_has_detail (_tmp10_, "metadata", "name");
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_alteration_unref0 (_tmp10_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp11_) {
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 2272 "MetadataWriter.c"
			}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp12_ = photos;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp12_ == NULL) {
#line 2278 "MetadataWriter.c"
				GeeHashSet* _tmp13_;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp13_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photos);
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				photos = _tmp13_;
#line 2286 "MetadataWriter.c"
			}
			{
				GeeIterator* _media_it = NULL;
				DataObject* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				GeeIterator* _tmp17_;
				GeeIterator* _tmp18_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp14_ = object;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp15_ = tag_get_sources (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_TAG, Tag));
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp16_ = _tmp15_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp18_ = _tmp17_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (_tmp16_);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_media_it = _tmp18_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				while (TRUE) {
#line 2311 "MetadataWriter.c"
					GeeIterator* _tmp19_;
					MediaSource* media = NULL;
					GeeIterator* _tmp20_;
					gpointer _tmp21_;
					LibraryPhoto* photo = NULL;
					MediaSource* _tmp22_;
					LibraryPhoto* _tmp23_;
					LibraryPhoto* _tmp24_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp19_ = _media_it;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp19_)) {
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						break;
#line 2326 "MetadataWriter.c"
					}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp20_ = _media_it;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp21_ = gee_iterator_get (_tmp20_);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					media = (MediaSource*) _tmp21_;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp22_ = media;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp23_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp22_) : NULL);
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					photo = _tmp23_;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp24_ = photo;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (_tmp24_ != NULL) {
#line 2344 "MetadataWriter.c"
						GeeHashSet* _tmp25_;
						LibraryPhoto* _tmp26_;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp25_ = photos;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp26_ = photo;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 2353 "MetadataWriter.c"
					}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_object_unref0 (media);
#line 2359 "MetadataWriter.c"
				}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (_media_it);
#line 2363 "MetadataWriter.c"
			}
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 2367 "MetadataWriter.c"
		}
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 2371 "MetadataWriter.c"
	}
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp27_ = photos;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp27_ != NULL) {
#line 2377 "MetadataWriter.c"
		GeeHashSet* _tmp28_;
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp28_ = photos;
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp28_, "tag renamed", FALSE);
#line 2383 "MetadataWriter.c"
	}
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2387 "MetadataWriter.c"
}


static void
metadata_writer_on_tag_contents_altered (MetadataWriter* self,
                                         ContainerSource* container,
                                         GeeCollection* added,
                                         gboolean relinking,
                                         GeeCollection* removed,
                                         gboolean unlinking)
{
	Tag* tag = NULL;
	Tag* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp21_ = FALSE;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (container != NULL);
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (container, TYPE_TAG, Tag));
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	tag = _tmp0_;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (added != NULL) {
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = !relinking;
#line 2415 "MetadataWriter.c"
	} else {
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = FALSE;
#line 2419 "MetadataWriter.c"
	}
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp1_) {
#line 2423 "MetadataWriter.c"
		GeeArrayList* added_photos = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp15_;
		Tag* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		added_photos = _tmp2_;
#line 2436 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp3_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp3_ = gee_iterable_iterator ((GeeIterable*) added);
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_source_it = _tmp3_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			while (TRUE) {
#line 2446 "MetadataWriter.c"
				GeeIterator* _tmp4_;
				DataSource* source = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp7_;
				LibraryPhoto* _tmp8_;
				gboolean _tmp9_ = FALSE;
				LibraryPhoto* _tmp10_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp4_ = _source_it;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					break;
#line 2462 "MetadataWriter.c"
				}
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp5_ = _source_it;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				source = (DataSource*) _tmp6_;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp7_ = source;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp7_) : NULL);
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				photo = _tmp8_;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp10_ = photo;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (_tmp10_ != NULL) {
#line 2480 "MetadataWriter.c"
					GeeHashSet* _tmp11_;
					LibraryPhoto* _tmp12_;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp11_ = self->priv->importing_photos;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp12_ = photo;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp9_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 2489 "MetadataWriter.c"
				} else {
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp9_ = FALSE;
#line 2493 "MetadataWriter.c"
				}
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (_tmp9_) {
#line 2497 "MetadataWriter.c"
					GeeArrayList* _tmp13_;
					LibraryPhoto* _tmp14_;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp13_ = added_photos;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp14_ = photo;
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 2506 "MetadataWriter.c"
				}
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2512 "MetadataWriter.c"
			}
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2516 "MetadataWriter.c"
		}
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp15_ = added_photos;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp16_ = tag;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp17_ = data_object_to_string ((DataObject*) _tmp16_);
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp18_ = _tmp17_;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp19_ = g_strdup_printf ("added to %s", _tmp18_);
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp20_ = _tmp19_;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp15_, _tmp20_, FALSE);
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp20_);
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp18_);
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (added_photos);
#line 2538 "MetadataWriter.c"
	}
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (removed != NULL) {
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp21_ = !unlinking;
#line 2544 "MetadataWriter.c"
	} else {
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp21_ = FALSE;
#line 2548 "MetadataWriter.c"
	}
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp21_) {
#line 2552 "MetadataWriter.c"
		GeeArrayList* removed_photos = NULL;
		GeeArrayList* _tmp22_;
		GeeArrayList* _tmp32_;
		Tag* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp22_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		removed_photos = _tmp22_;
#line 2565 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp23_;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_source_it = _tmp23_;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			while (TRUE) {
#line 2575 "MetadataWriter.c"
				GeeIterator* _tmp24_;
				DataSource* source = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp27_;
				LibraryPhoto* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp24_ = _source_it;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					break;
#line 2590 "MetadataWriter.c"
				}
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp25_ = _source_it;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				source = (DataSource*) _tmp26_;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp27_ = source;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp28_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp27_) : NULL);
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				photo = _tmp28_;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp29_ = photo;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (_tmp29_ != NULL) {
#line 2608 "MetadataWriter.c"
					GeeArrayList* _tmp30_;
					LibraryPhoto* _tmp31_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp30_ = removed_photos;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp31_ = photo;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 2617 "MetadataWriter.c"
				}
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2623 "MetadataWriter.c"
			}
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2627 "MetadataWriter.c"
		}
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp32_ = removed_photos;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp33_ = tag;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp34_ = data_object_to_string ((DataObject*) _tmp33_);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp35_ = _tmp34_;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp36_ = g_strdup_printf ("removed from %s", _tmp35_);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp37_ = _tmp36_;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp32_, _tmp37_, FALSE);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp37_);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp35_);
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (removed_photos);
#line 2649 "MetadataWriter.c"
	}
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (tag);
#line 2653 "MetadataWriter.c"
}


static void
metadata_writer_on_tag_backlink_removed (MetadataWriter* self,
                                         ContainerSource* container,
                                         GeeCollection* sources)
{
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (container != NULL);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (sources != NULL);
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	photos = _tmp0_;
#line 2679 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp1_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) sources);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_source_it = _tmp1_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 2689 "MetadataWriter.c"
			GeeIterator* _tmp2_;
			DataSource* source = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			LibraryPhoto* _tmp7_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 2704 "MetadataWriter.c"
			}
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp3_ = _source_it;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			source = (DataSource*) _tmp4_;
#line 450 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = source;
#line 450 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp5_) : NULL);
#line 450 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = _tmp6_;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = photo;
#line 451 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp7_ != NULL) {
#line 2722 "MetadataWriter.c"
				GeeArrayList* _tmp8_;
				LibraryPhoto* _tmp9_;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp8_ = photos;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp9_ = photo;
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 2731 "MetadataWriter.c"
			}
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 2737 "MetadataWriter.c"
		}
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 2741 "MetadataWriter.c"
	}
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp10_ = photos;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp11_ = data_object_to_string ((DataObject*) container);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp12_ = _tmp11_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp13_ = g_strdup_printf ("backlink removed from %s", _tmp12_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = _tmp13_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp10_, _tmp14_, FALSE);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (_tmp14_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (_tmp12_);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2761 "MetadataWriter.c"
}


static void
metadata_writer_count_enqueued_work (MetadataWriter* self,
                                     gint count,
                                     gboolean report)
{
	guint _tmp0_;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_total;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_ + count;
#line 465 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (report) {
#line 2779 "MetadataWriter.c"
		guint _tmp1_;
		guint _tmp2_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = self->priv->outstanding_completed;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = self->priv->outstanding_total;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, _tmp1_, _tmp2_);
#line 2788 "MetadataWriter.c"
	}
}


static void
metadata_writer_count_cancelled_work (MetadataWriter* self,
                                      gint count,
                                      gboolean report)
{
	guint _tmp0_ = 0U;
	guint _tmp1_;
	guint _tmp3_;
	guint _tmp4_;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->priv->outstanding_total;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp1_ >= ((guint) count)) {
#line 2808 "MetadataWriter.c"
		guint _tmp2_;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = self->priv->outstanding_total;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = _tmp2_ - count;
#line 2814 "MetadataWriter.c"
	} else {
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = (guint) 0;
#line 2818 "MetadataWriter.c"
	}
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_;
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = self->priv->outstanding_completed;
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = self->priv->outstanding_total;
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp3_ >= _tmp4_) {
#line 472 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2832 "MetadataWriter.c"
	}
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (report) {
#line 2836 "MetadataWriter.c"
		guint _tmp5_;
		guint _tmp6_;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp5_ = self->priv->outstanding_completed;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = self->priv->outstanding_total;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, _tmp5_, _tmp6_);
#line 2845 "MetadataWriter.c"
	}
}


static void
metadata_writer_count_completed_work (MetadataWriter* self,
                                      gint count,
                                      gboolean report)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_completed;
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->outstanding_completed = _tmp0_ + count;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->priv->outstanding_completed;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = self->priv->outstanding_total;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp1_ >= _tmp2_) {
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2874 "MetadataWriter.c"
	}
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (report) {
#line 2878 "MetadataWriter.c"
		guint _tmp3_;
		guint _tmp4_;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = self->priv->outstanding_completed;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = self->priv->outstanding_total;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, _tmp3_, _tmp4_);
#line 2887 "MetadataWriter.c"
	}
}


static void
metadata_writer_schedule_if_dirty (MetadataWriter* self,
                                   GeeIterable* media_sources,
                                   const gchar* reason)
{
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp14_;
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	photos = NULL;
#line 2907 "MetadataWriter.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp0_;
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = gee_iterable_iterator (media_sources);
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_media_it = _tmp0_;
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 2917 "MetadataWriter.c"
			GeeIterator* _tmp1_;
			MediaSource* media = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp4_;
			LibraryPhoto* _tmp5_;
			LibraryPhoto* _tmp6_;
			GeeHashSet* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* _tmp9_;
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp1_ = _media_it;
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 2935 "MetadataWriter.c"
			}
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp2_ = _media_it;
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			media = (MediaSource*) _tmp3_;
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp4_ = media;
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp4_) : NULL);
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = _tmp5_;
#line 503 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 503 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp6_ == NULL) {
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 2959 "MetadataWriter.c"
			}
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = self->priv->importing_photos;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_)) {
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				continue;
#line 2973 "MetadataWriter.c"
			}
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (photo_is_master_metadata_dirty ((Photo*) _tmp9_)) {
#line 2979 "MetadataWriter.c"
				GeeArrayList* _tmp10_;
				GeeArrayList* _tmp12_;
				LibraryPhoto* _tmp13_;
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp10_ = photos;
#line 511 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (_tmp10_ == NULL) {
#line 2987 "MetadataWriter.c"
					GeeArrayList* _tmp11_;
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp11_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					photos = _tmp11_;
#line 2995 "MetadataWriter.c"
				}
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp12_ = photos;
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp13_ = photo;
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 3003 "MetadataWriter.c"
			}
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (media);
#line 3009 "MetadataWriter.c"
		}
#line 501 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_media_it);
#line 3013 "MetadataWriter.c"
	}
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = photos;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp14_ != NULL) {
#line 3019 "MetadataWriter.c"
		GeeArrayList* _tmp15_;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp15_ = photos;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp15_, reason, TRUE);
#line 3025 "MetadataWriter.c"
	}
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 3029 "MetadataWriter.c"
}


static void
metadata_writer_photos_are_dirty (MetadataWriter* self,
                                  GeeCollection* photos,
                                  const gchar* reason,
                                  gboolean already_marked)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_;
	gint _tmp32_;
	gint _tmp33_;
	GError * _inner_error_ = NULL;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (photos != NULL);
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = gee_collection_get_size (photos);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp1_ == 0) {
#line 525 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 3060 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeIterator* _tmp2_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_photo_it = _tmp2_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 3071 "MetadataWriter.c"
			GeeIterator* _tmp3_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			LibraryPhoto* _tmp6_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp3_ = _photo_it;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 3083 "MetadataWriter.c"
			}
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp4_ = _photo_it;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp5_;
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp6_);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 3097 "MetadataWriter.c"
		}
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 3101 "MetadataWriter.c"
	}
#line 532 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (!already_marked) {
#line 3105 "MetadataWriter.c"
		{
			LibraryPhotoSourceCollection* _tmp7_;
			TransactionController* _tmp8_;
			TransactionController* _tmp9_;
			LibraryPhotoSourceCollection* _tmp15_;
			TransactionController* _tmp16_;
			TransactionController* _tmp17_;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = library_photo_global;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp7_);
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = _tmp8_;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			transaction_controller_begin (_tmp9_);
#line 3121 "MetadataWriter.c"
			{
				GeeIterator* _photo_it = NULL;
				GeeIterator* _tmp10_;
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp10_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_photo_it = _tmp10_;
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				while (TRUE) {
#line 3131 "MetadataWriter.c"
					GeeIterator* _tmp11_;
					LibraryPhoto* photo = NULL;
					GeeIterator* _tmp12_;
					gpointer _tmp13_;
					LibraryPhoto* _tmp14_;
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp11_ = _photo_it;
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp11_)) {
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						break;
#line 3143 "MetadataWriter.c"
					}
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp12_ = _photo_it;
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp13_ = gee_iterator_get (_tmp12_);
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					photo = (LibraryPhoto*) _tmp13_;
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_tmp14_ = photo;
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					photo_set_master_metadata_dirty ((Photo*) _tmp14_, TRUE, &_inner_error_);
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_g_object_unref0 (photo);
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_g_object_unref0 (_photo_it);
#line 3161 "MetadataWriter.c"
						goto __catch84_g_error;
					}
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 3166 "MetadataWriter.c"
				}
#line 536 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (_photo_it);
#line 3170 "MetadataWriter.c"
			}
#line 539 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp15_ = library_photo_global;
#line 539 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp16_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp15_);
#line 539 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp17_ = _tmp16_;
#line 539 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			transaction_controller_commit (_tmp17_);
#line 3180 "MetadataWriter.c"
		}
		goto __finally84;
		__catch84_g_error:
		{
			GError* err = NULL;
			GError* _tmp18_;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			err = _inner_error_;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp18_ = err;
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp18_->domain == DATABASE_ERROR) {
#line 3195 "MetadataWriter.c"
				GError* _tmp19_;
#line 542 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp19_ = err;
#line 542 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				app_window_database_error ((GError*) _tmp19_);
#line 3201 "MetadataWriter.c"
			} else {
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 544 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp20_ = err;
#line 544 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp21_ = _tmp20_->message;
#line 544 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				g_error ("MetadataWriter.vala:544: Unable to mark metadata as dirty: %s", _tmp21_);
#line 3211 "MetadataWriter.c"
			}
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 3215 "MetadataWriter.c"
		}
		__finally84:
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			return;
#line 3226 "MetadataWriter.c"
		}
	}
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp23_ = self->priv->closed;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp23_) {
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp22_ = TRUE;
#line 3235 "MetadataWriter.c"
	} else {
		gboolean _tmp24_;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp24_ = self->priv->enabled;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp22_ = !_tmp24_;
#line 3242 "MetadataWriter.c"
	}
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp22_) {
#line 551 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 3248 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeIterator* _tmp25_;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp25_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_photo_it = _tmp25_;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 3259 "MetadataWriter.c"
			GeeIterator* _tmp26_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp27_;
			gpointer _tmp28_;
			gboolean enqueued = FALSE;
			HashTimedQueue* _tmp29_;
			LibraryPhoto* _tmp30_;
			gboolean _tmp31_;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp26_ = _photo_it;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp26_)) {
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 3274 "MetadataWriter.c"
			}
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp27_ = _photo_it;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp28_ = gee_iterator_get (_tmp27_);
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp28_;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp29_ = self->priv->dirty;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp30_ = photo;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			enqueued = timed_queue_enqueue ((TimedQueue*) _tmp29_, _tmp30_);
#line 559 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp31_ = enqueued;
#line 559 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_vala_assert (_tmp31_, "enqueued");
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 3294 "MetadataWriter.c"
		}
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 3298 "MetadataWriter.c"
	}
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp32_ = gee_collection_get_size (photos);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp33_ = _tmp32_;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_count_enqueued_work (self, _tmp33_, TRUE);
#line 3306 "MetadataWriter.c"
}


static void
metadata_writer_cancel_all (MetadataWriter* self,
                            gboolean wait)
{
	HashTimedQueue* _tmp0_;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->dirty;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	timed_queue_clear ((TimedQueue*) _tmp0_);
#line 3321 "MetadataWriter.c"
	{
		GeeIterator* _job_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp4_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_job_it = _tmp6_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		while (TRUE) {
#line 3348 "MetadataWriter.c"
			GeeIterator* _tmp7_;
			MetadataWriterCommitJob* job = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MetadataWriterCommitJob* _tmp10_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp7_ = _job_it;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				break;
#line 3360 "MetadataWriter.c"
			}
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp8_ = _job_it;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			job = (MetadataWriterCommitJob*) _tmp9_;
#line 569 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp10_ = job;
#line 569 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			background_job_cancel ((BackgroundJob*) _tmp10_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 3374 "MetadataWriter.c"
		}
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_job_it);
#line 3378 "MetadataWriter.c"
	}
#line 571 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (wait) {
#line 3382 "MetadataWriter.c"
		Workers* _tmp11_;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp11_ = self->priv->workers;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		workers_wait_for_empty_queue (_tmp11_);
#line 3388 "MetadataWriter.c"
	}
#line 574 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, G_MAXINT, TRUE);
#line 3392 "MetadataWriter.c"
}


static gboolean
metadata_writer_cancel_job (MetadataWriter* self,
                            LibraryPhoto* photo)
{
	gboolean result = FALSE;
	gboolean cancelled = FALSE;
	GeeHashMap* _tmp0_;
	HashTimedQueue* _tmp4_;
#line 577 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 577 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (photo != NULL, FALSE);
#line 578 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	cancelled = FALSE;
#line 580 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 580 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, photo)) {
#line 3414 "MetadataWriter.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
		MetadataWriterCommitJob* _tmp3_;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, photo);
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = (MetadataWriterCommitJob*) _tmp2_;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		background_job_cancel ((BackgroundJob*) _tmp3_);
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_background_job_unref0 (_tmp3_);
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3430 "MetadataWriter.c"
	}
#line 585 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = self->priv->dirty;
#line 585 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (timed_queue_contains ((TimedQueue*) _tmp4_, photo)) {
#line 3436 "MetadataWriter.c"
		gboolean removed = FALSE;
		HashTimedQueue* _tmp5_;
		gboolean _tmp6_;
		HashTimedQueue* _tmp7_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp5_ = self->priv->dirty;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		removed = timed_queue_remove_first ((TimedQueue*) _tmp5_, photo);
#line 587 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = removed;
#line 587 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_vala_assert (_tmp6_, "removed");
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp7_ = self->priv->dirty;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_vala_assert (!timed_queue_contains ((TimedQueue*) _tmp7_, photo), "!dirty.contains (photo)");
#line 591 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, FALSE);
#line 592 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3457 "MetadataWriter.c"
	}
#line 595 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	result = cancelled;
#line 595 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return result;
#line 3463 "MetadataWriter.c"
}


static void
metadata_writer_on_photo_dequeued (MetadataWriter* self,
                                   LibraryPhoto* photo)
{
	gboolean _tmp0_;
	GeeSet* keywords = NULL;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeCollection* _tmp3_;
	MetadataWriterCommitJob* job = NULL;
	GeeSet* _tmp14_;
	MetadataWriterCommitJob* _tmp15_;
	GeeHashMap* _tmp16_;
	MetadataWriterCommitJob* _tmp17_;
	Workers* _tmp18_;
	MetadataWriterCommitJob* _tmp19_;
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (photo != NULL);
#line 599 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->enabled;
#line 599 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (!_tmp0_) {
#line 600 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 3496 "MetadataWriter.c"
	}
#line 605 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	keywords = NULL;
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = tag_global;
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = tag_source_collection_fetch_for_source (_tmp1_, (MediaSource*) photo);
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	tags = (GeeCollection*) _tmp2_;
#line 607 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = tags;
#line 607 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp3_ != NULL) {
#line 3510 "MetadataWriter.c"
		GeeHashSet* _tmp4_;
#line 608 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 608 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (keywords);
#line 608 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		keywords = (GeeSet*) _tmp4_;
#line 3518 "MetadataWriter.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp5_ = tags;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tag_it = _tmp6_;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			while (TRUE) {
#line 3531 "MetadataWriter.c"
				GeeIterator* _tmp7_;
				Tag* tag = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				GeeSet* _tmp10_;
				Tag* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp7_ = _tag_it;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					break;
#line 3546 "MetadataWriter.c"
				}
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp8_ = _tag_it;
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				tag = (Tag*) _tmp9_;
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp10_ = keywords;
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp11_ = tag;
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp12_ = data_object_get_name ((DataObject*) _tmp11_);
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp13_ = _tmp12_;
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_collection_add ((GeeCollection*) _tmp10_, _tmp13_);
#line 610 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_free0 (_tmp13_);
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 3568 "MetadataWriter.c"
			}
#line 609 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_tag_it);
#line 3572 "MetadataWriter.c"
		}
	}
#line 613 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = keywords;
#line 613 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp15_ = metadata_writer_commit_job_new (self, photo, _tmp14_);
#line 613 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	job = _tmp15_;
#line 614 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp16_ = self->priv->pending;
#line 614 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp17_ = job;
#line 614 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, photo, _tmp17_);
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp18_ = self->priv->workers;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp19_ = job;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	workers_enqueue (_tmp18_, (BackgroundJob*) _tmp19_);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (tags);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (keywords);
#line 3599 "MetadataWriter.c"
}


static gpointer
_background_job_ref0 (gpointer self)
{
#line 624 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return self ? background_job_ref (self) : NULL;
#line 3608 "MetadataWriter.c"
}


static void
metadata_writer_on_update_completed (MetadataWriter* self,
                                     BackgroundJob* j)
{
	MetadataWriterCommitJob* job = NULL;
	MetadataWriterCommitJob* _tmp0_;
	MetadataWriterCommitJob* _tmp1_;
	GError* _tmp2_;
	gboolean removed = FALSE;
	GeeHashMap* _tmp14_;
	MetadataWriterCommitJob* _tmp15_;
	LibraryPhoto* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	LibraryPhotoSourceCollection* _tmp19_;
	TransactionController* _tmp20_;
	TransactionController* _tmp21_;
	gboolean _tmp22_ = FALSE;
	MetadataWriterCommitJob* _tmp23_;
	PhotoReimportMasterState* _tmp24_;
	LibraryPhotoSourceCollection* _tmp56_;
	TransactionController* _tmp57_;
	TransactionController* _tmp58_;
	GError * _inner_error_ = NULL;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (j != NULL);
#line 624 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob));
#line 624 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	job = _tmp0_;
#line 626 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = job;
#line 626 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = _tmp1_->err;
#line 626 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp2_ != NULL) {
#line 3650 "MetadataWriter.c"
		MetadataWriterCommitJob* _tmp3_;
		LibraryPhoto* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		MetadataWriterCommitJob* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = job;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_->photo;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp5_ = data_object_to_string ((DataObject*) _tmp4_);
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp7_ = job;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp8_ = _tmp7_->err;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp9_ = _tmp8_->message;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_warning ("MetadataWriter.vala:627: Unable to update metadata for %s: %s", _tmp6_, _tmp9_);
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp6_);
#line 3676 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp10_;
		LibraryPhoto* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp10_ = job;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp11_ = _tmp10_->photo;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp12_ = data_object_to_string ((DataObject*) _tmp11_);
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp13_ = _tmp12_;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_message ("MetadataWriter.vala:629: Completed writing metadata for %s", _tmp13_);
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp13_);
#line 3694 "MetadataWriter.c"
	}
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = self->priv->pending;
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp15_ = job;
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp16_ = _tmp15_->photo;
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp17_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp14_, _tmp16_, NULL);
#line 631 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	removed = _tmp17_;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp18_ = removed;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_vala_assert (_tmp18_, "removed");
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp19_ = library_photo_global;
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp20_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp19_);
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp21_ = _tmp20_;
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	transaction_controller_begin (_tmp21_);
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp23_ = job;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp24_ = _tmp23_->reimport_master_state;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp24_ != NULL) {
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp22_ = TRUE;
#line 3726 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp25_;
		PhotoReimportEditableState* _tmp26_;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp25_ = job;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp26_ = _tmp25_->reimport_editable_state;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp22_ = _tmp26_ != NULL;
#line 3736 "MetadataWriter.c"
	}
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp22_) {
#line 3740 "MetadataWriter.c"
		LibraryPhoto* _tmp27_;
		MetadataWriterCommitJob* _tmp28_;
		LibraryPhoto* _tmp29_;
		LibraryPhoto* _tmp30_;
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp27_ = self->priv->ignore_photo_alteration;
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_vala_assert (_tmp27_ == NULL, "ignore_photo_alteration == null");
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp28_ = job;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp29_ = _tmp28_->photo;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->priv->ignore_photo_alteration = _tmp30_;
#line 3759 "MetadataWriter.c"
		{
			MetadataWriterCommitJob* _tmp31_;
			PhotoReimportMasterState* _tmp32_;
			MetadataWriterCommitJob* _tmp40_;
			PhotoReimportEditableState* _tmp41_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp31_ = job;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp32_ = _tmp31_->reimport_master_state;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp32_ != NULL) {
#line 3771 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp33_;
				LibraryPhoto* _tmp34_;
				MetadataWriterCommitJob* _tmp35_;
				PhotoReimportMasterState* _tmp36_;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp33_ = job;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp34_ = _tmp33_->photo;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp35_ = job;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp36_ = _tmp35_->reimport_master_state;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				photo_finish_update_master_metadata ((Photo*) _tmp34_, _tmp36_, &_inner_error_);
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3790 "MetadataWriter.c"
						goto __catch85_database_error;
					}
					{
						LibraryPhoto* _tmp37_;
						MetadataWriterCommitJob* _tmp38_;
						LibraryPhoto* _tmp39_;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp37_ = self->priv->ignore_photo_alteration;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp38_ = job;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp39_ = _tmp38_->photo;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_vala_assert (_tmp37_ == _tmp39_, "ignore_photo_alteration == job.photo");
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3809 "MetadataWriter.c"
					}
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					return;
#line 3819 "MetadataWriter.c"
				}
			}
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp40_ = job;
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp41_ = _tmp40_->reimport_editable_state;
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_tmp41_ != NULL) {
#line 3828 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp42_;
				LibraryPhoto* _tmp43_;
				MetadataWriterCommitJob* _tmp44_;
				PhotoReimportEditableState* _tmp45_;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp42_ = job;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp43_ = _tmp42_->photo;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp44_ = job;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp45_ = _tmp44_->reimport_editable_state;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				photo_finish_update_editable_metadata ((Photo*) _tmp43_, _tmp45_, &_inner_error_);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3847 "MetadataWriter.c"
						goto __catch85_database_error;
					}
					{
						LibraryPhoto* _tmp46_;
						MetadataWriterCommitJob* _tmp47_;
						LibraryPhoto* _tmp48_;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp46_ = self->priv->ignore_photo_alteration;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp47_ = job;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_tmp48_ = _tmp47_->photo;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_vala_assert (_tmp46_ == _tmp48_, "ignore_photo_alteration == job.photo");
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3866 "MetadataWriter.c"
					}
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					return;
#line 3876 "MetadataWriter.c"
				}
			}
		}
		goto __finally85;
		__catch85_database_error:
		{
			GError* err = NULL;
			GError* _tmp49_;
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			err = _inner_error_;
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp49_ = err;
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			app_window_database_error (_tmp49_);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 3895 "MetadataWriter.c"
		}
		__finally85:
		{
			LibraryPhoto* _tmp50_;
			MetadataWriterCommitJob* _tmp51_;
			LibraryPhoto* _tmp52_;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp50_ = self->priv->ignore_photo_alteration;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp51_ = job;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp52_ = _tmp51_->photo;
#line 653 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_vala_assert (_tmp50_ == _tmp52_, "ignore_photo_alteration == job.photo");
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			self->priv->ignore_photo_alteration = NULL;
#line 3914 "MetadataWriter.c"
		}
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			return;
#line 3926 "MetadataWriter.c"
		}
	} else {
	}
	{
		MetadataWriterCommitJob* _tmp53_;
		LibraryPhoto* _tmp54_;
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp53_ = job;
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp54_ = _tmp53_->photo;
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_set_master_metadata_dirty ((Photo*) _tmp54_, FALSE, &_inner_error_);
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 3943 "MetadataWriter.c"
				goto __catch86_database_error;
			}
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 664 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			return;
#line 3954 "MetadataWriter.c"
		}
	}
	goto __finally86;
	__catch86_database_error:
	{
		GError* err = NULL;
		GError* _tmp55_;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		err = _inner_error_;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 666 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp55_ = err;
#line 666 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		app_window_database_error (_tmp55_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 3972 "MetadataWriter.c"
	}
	__finally86:
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_background_job_unref0 (job);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 3985 "MetadataWriter.c"
	}
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp56_ = library_photo_global;
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp57_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp56_);
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp58_ = _tmp57_;
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	transaction_controller_commit (_tmp58_);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_count_completed_work (self, 1, TRUE);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 3999 "MetadataWriter.c"
}


static void
metadata_writer_on_update_cancelled (MetadataWriter* self,
                                     BackgroundJob* j)
{
	gboolean removed = FALSE;
	GeeHashMap* _tmp0_;
	LibraryPhoto* _tmp1_;
	gboolean _tmp2_;
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (j != NULL);
#line 675 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 675 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (j, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob)->photo;
#line 675 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp1_, NULL);
#line 675 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	removed = _tmp2_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_vala_assert (removed, "removed");
#line 678 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 4027 "MetadataWriter.c"
}


static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		data1 = closure->data;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		data2 = param_values->data[0].v_pointer;
#line 4053 "MetadataWriter.c"
	} else {
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		data2 = closure->data;
#line 4059 "MetadataWriter.c"
	}
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 4065 "MetadataWriter.c"
}


static void
_metadata_writer_on_update_completed_completion_callback (BackgroundJob* job,
                                                          gpointer self)
{
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_update_completed ((MetadataWriter*) self, job);
#line 4075 "MetadataWriter.c"
}


static void
_metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job,
                                                            gpointer self)
{
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_on_update_cancelled ((MetadataWriter*) self, job);
#line 4085 "MetadataWriter.c"
}


static MetadataWriterCommitJob*
metadata_writer_commit_job_construct (GType object_type,
                                      MetadataWriter* owner,
                                      LibraryPhoto* photo,
                                      GeeSet* keywords)
{
	MetadataWriterCommitJob* self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeSet* _tmp3_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = g_cancellable_new ();
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) background_job_construct (object_type, (GObject*) owner, _metadata_writer_on_update_completed_completion_callback, owner, _tmp1_, _metadata_writer_on_update_cancelled_cancellation_callback, owner, NULL);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = _g_object_ref0 (photo);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->photo = _tmp2_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = _g_object_ref0 (keywords);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->current_keywords = _tmp3_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return self;
#line 4126 "MetadataWriter.c"
}


static MetadataWriterCommitJob*
metadata_writer_commit_job_new (MetadataWriter* owner,
                                LibraryPhoto* photo,
                                GeeSet* keywords)
{
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return metadata_writer_commit_job_construct (METADATA_WRITER_TYPE_COMMIT_JOB, owner, photo, keywords);
#line 4137 "MetadataWriter.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return self ? g_error_copy (self) : NULL;
#line 4146 "MetadataWriter.c"
}


static void
metadata_writer_commit_job_real_execute (BackgroundJob* base)
{
	MetadataWriterCommitJob * self;
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) base;
#line 4157 "MetadataWriter.c"
	{
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_master (self, &_inner_error_);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4163 "MetadataWriter.c"
			goto __catch87_g_error;
		}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_editable (self, &_inner_error_);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4170 "MetadataWriter.c"
			goto __catch87_g_error;
		}
	}
	goto __finally87;
	__catch87_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		err = _inner_error_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = err;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp1_ = _g_error_copy0 (_tmp0_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_error_free0 (self->err);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		self->err = _tmp1_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 4194 "MetadataWriter.c"
	}
	__finally87:
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 4205 "MetadataWriter.c"
	}
}


static void
metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self,
                                          GError** error)
{
	gboolean skip_orientation = FALSE;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	skip_orientation = photo_has_editable ((Photo*) _tmp0_);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (!photo_file_format_can_write_metadata (photo_get_master_file_format ((Photo*) _tmp1_))) {
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 4235 "MetadataWriter.c"
	}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = self->photo;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = photo_get_master_metadata ((Photo*) _tmp2_, &_inner_error_);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata = _tmp3_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 4249 "MetadataWriter.c"
	}
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = metadata;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = skip_orientation;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, _tmp4_, _tmp5_)) {
#line 4257 "MetadataWriter.c"
		LibraryPhoto* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = self->photo;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp7_ = media_source_get_master_file ((MediaSource*) _tmp6_);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp8_ = _tmp7_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp8_, "MetadataWriter.commit_master");
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp8_);
#line 4271 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp9_;
			PhotoMetadata* _tmp10_;
			PhotoReimportMasterState* _tmp11_ = NULL;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp9_ = self->photo;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp10_ = metadata;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo_persist_master_metadata ((Photo*) _tmp9_, _tmp10_, &_tmp11_, &_inner_error_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			self->reimport_master_state = _tmp11_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4288 "MetadataWriter.c"
				goto __finally88;
			}
		}
		__finally88:
		{
			LibraryPhoto* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp12_ = self->photo;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp13_ = media_source_get_master_file ((MediaSource*) _tmp12_);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp14_ = _tmp13_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp14_);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp14_);
#line 4307 "MetadataWriter.c"
		}
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			return;
#line 4317 "MetadataWriter.c"
		}
	}
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4322 "MetadataWriter.c"
}


static void
metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self,
                                            GError** error)
{
	gboolean _tmp0_ = FALSE;
	LibraryPhoto* _tmp1_;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	GError * _inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (!photo_has_editable ((Photo*) _tmp1_)) {
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 4346 "MetadataWriter.c"
	} else {
		LibraryPhoto* _tmp2_;
		PhotoFileFormat* _tmp3_;
		PhotoFileFormat* _tmp4_;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp2_ = self->photo;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp3_ = photo_get_editable_file_format ((Photo*) _tmp2_);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp0_ = !photo_file_format_can_write_metadata (*_tmp4_);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_free0 (_tmp4_);
#line 4361 "MetadataWriter.c"
	}
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 4367 "MetadataWriter.c"
	}
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = self->photo;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp6_ = photo_get_editable_metadata ((Photo*) _tmp5_, &_inner_error_);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata = _tmp6_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		return;
#line 4381 "MetadataWriter.c"
	}
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp7_ = metadata;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_vala_assert (_tmp7_ != NULL, "metadata != null");
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp8_ = metadata;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, _tmp8_, FALSE)) {
#line 4391 "MetadataWriter.c"
		LibraryPhoto* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp9_ = self->photo;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp11_ = _tmp10_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp11_, "MetadataWriter.commit_editable");
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp11_);
#line 4405 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp12_;
			PhotoMetadata* _tmp13_;
			PhotoReimportEditableState* _tmp14_ = NULL;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp12_ = self->photo;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp13_ = metadata;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo_persist_editable_metadata ((Photo*) _tmp12_, _tmp13_, &_tmp14_, &_inner_error_);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			self->reimport_editable_state = _tmp14_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4422 "MetadataWriter.c"
				goto __finally89;
			}
		}
		__finally89:
		{
			LibraryPhoto* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp15_ = self->photo;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp16_ = photo_get_editable_file ((Photo*) _tmp15_);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp17_ = _tmp16_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp17_);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp17_);
#line 4441 "MetadataWriter.c"
		}
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			return;
#line 4451 "MetadataWriter.c"
		}
	}
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4456 "MetadataWriter.c"
}


static gboolean
metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self,
                                            PhotoMetadata* metadata,
                                            gboolean skip_orientation)
{
	gboolean result = FALSE;
	gboolean changed = FALSE;
	gchar* current_title = NULL;
	LibraryPhoto* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gchar* current_comment = NULL;
	LibraryPhoto* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	time_t current_exposure_time = 0;
	LibraryPhoto* _tmp14_;
	time_t metadata_exposure_time = 0;
	MetadataDateTime* metadata_exposure_date_time = NULL;
	MetadataDateTime* _tmp15_;
	MetadataDateTime* _tmp16_;
	time_t _tmp18_;
	time_t _tmp19_;
	GeeSet* safe_keywords = NULL;
	GeeHashSet* _tmp24_;
	GeeSet* _tmp25_;
	GeeSet* _tmp37_;
	GeeSet* _tmp38_;
	GeeSet* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp45_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	changed = FALSE;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = media_source_get_title ((MediaSource*) _tmp0_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	current_title = _tmp1_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = current_title;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = media_metadata_get_title ((MediaMetadata*) metadata);
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp4_ = _tmp3_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = g_strcmp0 (_tmp2_, _tmp4_) != 0;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (_tmp4_);
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp5_) {
#line 4521 "MetadataWriter.c"
		const gchar* _tmp6_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp6_ = current_title;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_metadata_set_title (metadata, _tmp6_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		changed = TRUE;
#line 4529 "MetadataWriter.c"
	}
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp7_ = self->photo;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp8_ = media_source_get_comment ((MediaSource*) _tmp7_);
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	current_comment = _tmp8_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp9_ = current_comment;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp10_ = media_metadata_get_comment ((MediaMetadata*) metadata);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp11_ = _tmp10_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp12_ = g_strcmp0 (_tmp9_, _tmp11_) != 0;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (_tmp11_);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp12_) {
#line 4549 "MetadataWriter.c"
		const gchar* _tmp13_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp13_ = current_comment;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_metadata_set_comment (metadata, _tmp13_);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		changed = TRUE;
#line 4557 "MetadataWriter.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp14_ = self->photo;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	current_exposure_time = media_source_get_exposure_time ((MediaSource*) _tmp14_);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_exposure_time = (time_t) 0;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp15_ = photo_metadata_get_exposure_date_time (metadata);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_exposure_date_time = _tmp15_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp16_ = metadata_exposure_date_time;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp16_ != NULL) {
#line 4573 "MetadataWriter.c"
		MetadataDateTime* _tmp17_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp17_ = metadata_exposure_date_time;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		metadata_exposure_time = metadata_date_time_get_timestamp (_tmp17_);
#line 4579 "MetadataWriter.c"
	}
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp18_ = current_exposure_time;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp19_ = metadata_exposure_time;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp18_ != _tmp19_) {
#line 4587 "MetadataWriter.c"
		MetadataDateTime* _tmp20_ = NULL;
		time_t _tmp21_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp21_ = current_exposure_time;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (_tmp21_ != ((time_t) 0)) {
#line 4594 "MetadataWriter.c"
			time_t _tmp22_;
			MetadataDateTime* _tmp23_;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp22_ = current_exposure_time;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp23_ = metadata_date_time_new (_tmp22_);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp20_);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp20_ = _tmp23_;
#line 4605 "MetadataWriter.c"
		} else {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp20_);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp20_ = NULL;
#line 4611 "MetadataWriter.c"
		}
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_metadata_set_exposure_date_time (metadata, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		changed = TRUE;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_metadata_date_time_unref0 (_tmp20_);
#line 4619 "MetadataWriter.c"
	}
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp24_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	safe_keywords = (GeeSet*) _tmp24_;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp25_ = self->current_keywords;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp25_ != NULL) {
#line 4629 "MetadataWriter.c"
		{
			GeeIterator* _tmp_it = NULL;
			GeeSet* _tmp26_;
			GeeIterator* _tmp27_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp26_ = self->current_keywords;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp_it = _tmp27_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			while (TRUE) {
#line 4642 "MetadataWriter.c"
				GeeIterator* _tmp28_;
				gchar* tmp = NULL;
				GeeIterator* _tmp29_;
				gpointer _tmp30_;
				Tag* tag = NULL;
				const gchar* _tmp31_;
				Tag* _tmp32_;
				GeeSet* _tmp33_;
				Tag* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp28_ = _tmp_it;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp28_)) {
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
					break;
#line 4660 "MetadataWriter.c"
				}
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp29_ = _tmp_it;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp30_ = gee_iterator_get (_tmp29_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				tmp = (gchar*) _tmp30_;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp31_ = tmp;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp32_ = tag_for_path (_tmp31_);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				tag = _tmp32_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp33_ = safe_keywords;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp34_ = tag;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp35_ = tag_get_user_visible_name (_tmp34_);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_tmp36_ = _tmp35_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				gee_collection_add ((GeeCollection*) _tmp33_, _tmp36_);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_free0 (_tmp36_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
				_g_free0 (tmp);
#line 4690 "MetadataWriter.c"
			}
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp_it);
#line 4694 "MetadataWriter.c"
		}
	}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp37_ = safe_keywords;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp38_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp39_ = _tmp38_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp40_ = !equal_sets (_tmp37_, _tmp39_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp39_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp40_) {
#line 4709 "MetadataWriter.c"
		GeeSet* _tmp41_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp41_ = self->current_keywords;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_metadata_set_keywords (metadata, (GeeCollection*) _tmp41_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		changed = TRUE;
#line 4717 "MetadataWriter.c"
	}
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (!skip_orientation) {
#line 4721 "MetadataWriter.c"
		Orientation current_orientation = 0;
		LibraryPhoto* _tmp42_;
		Orientation _tmp43_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp42_ = self->photo;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		current_orientation = photo_get_orientation ((Photo*) _tmp42_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		_tmp43_ = current_orientation;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		if (_tmp43_ != photo_metadata_get_orientation (metadata)) {
#line 4733 "MetadataWriter.c"
			Orientation _tmp44_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			_tmp44_ = current_orientation;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			photo_metadata_set_orientation (metadata, _tmp44_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
			changed = TRUE;
#line 4741 "MetadataWriter.c"
		}
	}
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp45_ = changed;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	if (_tmp45_) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
		photo_metadata_set_software (metadata, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 4750 "MetadataWriter.c"
	}
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	result = changed;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (safe_keywords);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_metadata_date_time_unref0 (metadata_exposure_date_time);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (current_comment);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_free0 (current_title);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	return result;
#line 4764 "MetadataWriter.c"
}


static void
metadata_writer_commit_job_class_init (MetadataWriterCommitJobClass * klass)
{
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_commit_job_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->finalize = metadata_writer_commit_job_finalize;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob *)) metadata_writer_commit_job_real_execute;
#line 4777 "MetadataWriter.c"
}


static void
metadata_writer_commit_job_instance_init (MetadataWriterCommitJob * self)
{
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->reimport_master_state = NULL;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->reimport_editable_state = NULL;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->err = NULL;
#line 4790 "MetadataWriter.c"
}


static void
metadata_writer_commit_job_finalize (BackgroundJob * obj)
{
	MetadataWriterCommitJob * self;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_error_free0 (self->err);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (metadata_writer_commit_job_parent_class)->finalize (obj);
#line 4812 "MetadataWriter.c"
}


static GType
metadata_writer_commit_job_get_type (void)
{
	static volatile gsize metadata_writer_commit_job_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_commit_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterCommitJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_commit_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriterCommitJob), 0, (GInstanceInitFunc) metadata_writer_commit_job_instance_init, NULL };
		GType metadata_writer_commit_job_type_id;
		metadata_writer_commit_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "MetadataWriterCommitJob", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_commit_job_type_id__volatile, metadata_writer_commit_job_type_id);
	}
	return metadata_writer_commit_job_type_id__volatile;
}


static void
metadata_writer_class_init (MetadataWriterClass * klass)
{
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_type_class_add_private (klass, sizeof (MetadataWriterPrivate));
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	G_OBJECT_CLASS (klass)->finalize = metadata_writer_finalize;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL] = g_signal_new ("progress", TYPE_METADATA_WRITER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 4841 "MetadataWriter.c"
}


static void
metadata_writer_instance_init (MetadataWriter * self)
{
	Workers* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv = METADATA_WRITER_GET_PRIVATE (self);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = workers_new (1, FALSE);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->workers = _tmp0_;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->enabled = FALSE;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, METADATA_WRITER_TYPE_COMMIT_JOB, (GBoxedCopyFunc) background_job_ref, (GDestroyNotify) background_job_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->pending = _tmp1_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->interested_photo_details = _tmp2_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->ignore_photo_alteration = NULL;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->outstanding_total = (guint) 0;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->outstanding_completed = (guint) 0;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->closed = FALSE;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->pause_count = 0;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self->priv->importing_photos = _tmp3_;
#line 4882 "MetadataWriter.c"
}


static void
metadata_writer_finalize (GObject * obj)
{
	MetadataWriter * self;
	ConfigFacade* _tmp0_;
	ConfigFacade* _tmp1_;
	guint _tmp2_;
	LibraryPhotoSourceCollection* _tmp3_;
	guint _tmp4_;
	LibraryPhotoSourceCollection* _tmp5_;
	guint _tmp6_;
	LibraryPhotoSourceCollection* _tmp7_;
	guint _tmp8_;
	LibraryPhotoSourceCollection* _tmp9_;
	guint _tmp10_;
	LibraryPhotoSourceCollection* _tmp11_;
	guint _tmp12_;
	LibraryPhotoSourceCollection* _tmp13_;
	guint _tmp14_;
	LibraryPhotoSourceCollection* _tmp15_;
	guint _tmp16_;
	TagSourceCollection* _tmp17_;
	guint _tmp18_;
	TagSourceCollection* _tmp19_;
	guint _tmp20_;
	TagSourceCollection* _tmp21_;
	guint _tmp22_;
	TagSourceCollection* _tmp23_;
	guint _tmp24_;
	TagSourceCollection* _tmp25_;
	guint _tmp26_;
	Application* _tmp27_;
	Application* _tmp28_;
	guint _tmp29_;
	LibraryMonitorPool* _tmp30_;
	LibraryMonitorPool* _tmp31_;
	guint _tmp32_;
	LibraryMonitorPool* _tmp33_;
	LibraryMonitorPool* _tmp34_;
	guint _tmp35_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_WRITER, MetadataWriter);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp0_ = config_facade_get_instance ();
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("commit-metadata-to-masters-changed", TYPE_CONFIGURATION_FACADE, &_tmp2_, NULL, FALSE);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((ConfigurationFacade*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _metadata_writer_on_config_changed_configuration_facade_commit_metadata_to_masters_changed, self);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp3_ = library_photo_global;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp4_, NULL, FALSE);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((MediaSourceCollection*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp5_ = library_photo_global;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((MediaSourceCollection*) _tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp7_ = library_photo_global;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp9_ = library_photo_global;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp10_, NULL, FALSE);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp12_, NULL, FALSE);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp14_, NULL, FALSE);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp16_, NULL, FALSE);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((SourceCollection*) _tmp15_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp18_, NULL, FALSE);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp17_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp20_, NULL, FALSE);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((ContainerSourceCollection*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp21_ = tag_global;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp22_, NULL, FALSE);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((ContainerSourceCollection*) _tmp21_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, 0, NULL, (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp23_ = tag_global;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp24_, NULL, FALSE);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp23_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp25_ = tag_global;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp26_, NULL, FALSE);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp25_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp27_ = application_get_instance ();
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp28_ = _tmp27_;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("exiting", TYPE_APPLICATION, &_tmp29_, NULL, FALSE);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp28_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp29_, 0, NULL, (GCallback) _metadata_writer_on_application_exiting_application_exiting, self);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp28_);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp30_ = library_monitor_pool_get_instance ();
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp31_ = _tmp30_;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-installed", TYPE_LIBRARY_MONITOR_POOL, &_tmp32_, NULL, FALSE);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp31_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp32_, 0, NULL, (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp31_);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp33_ = library_monitor_pool_get_instance ();
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_tmp34_ = _tmp33_;
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-destroyed", TYPE_LIBRARY_MONITOR_POOL, &_tmp35_, NULL, FALSE);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp34_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp35_, 0, NULL, (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp34_);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_workers_unref0 (self->priv->workers);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->pending);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->interested_photo_details);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->importing_photos);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/MetadataWriter.vala"
	G_OBJECT_CLASS (metadata_writer_parent_class)->finalize (obj);
#line 5054 "MetadataWriter.c"
}


GType
metadata_writer_get_type (void)
{
	static volatile gsize metadata_writer_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriter), 0, (GInstanceInitFunc) metadata_writer_instance_init, NULL };
		GType metadata_writer_type_id;
		metadata_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "MetadataWriter", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_type_id__volatile, metadata_writer_type_id);
	}
	return metadata_writer_type_id__volatile;
}



