/* Photo.c generated by valac 0.39.7, the Vala compiler
 * generated from Photo.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	gboolean enhanced;
	GeeHashMap* original_transforms;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	GeeHashMap* original_transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gboolean enhanced;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_pixel_transformer (GValue* value,
                                  gpointer v_object);
void value_take_pixel_transformer (GValue* value,
                                   gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value,
                                            gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value,
                                             gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type,
                        PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_key_value_map (GValue* value,
                              gpointer v_object);
void value_take_key_value_map (GValue* value,
                               gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
static void photo_internal_remove_all_transformations (Photo* self,
                                                gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              GError** error);
void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
void photo_set_raw_developer (Photo* self,
                              RawDeveloper d);
void photo_populate_prefetched (Photo* self,
                                GError** error);
void photo_revert_to_master (Photo* self,
                             gboolean notify);
gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
gboolean photo_discard_prefetched (Photo* self,
                                   gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add91 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add92 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add93 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     void* compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation* * detected,
                                                GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState* * reimport_state,
                                            GError** error);
static void _vala_array_add94 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add95 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add96 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add97 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add98 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add99 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add100 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
Alteration* alteration_new_from_array (gchar** array,
                                       int array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow* * backing,
                                         DetectedPhotoInformation* * detected,
                                         GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState* * state,
                                              GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void media_source_set_title (MediaSource* self,
                             const gchar* title);
gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState* * state,
                                                     GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   int extensions_length1);
gboolean photo_can_write_file (Photo* self);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self,
                            GFile* file);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add101 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add102 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add103 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add104 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void photo_set_editable_file (Photo* self,
                              GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add105 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add106 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add107 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
gboolean photo_is_enhanced (Photo* self);
void photo_set_enhanced (Photo* self,
                         gboolean enhanced);
gboolean photo_table_set_enhanced (PhotoTable* self,
                                   PhotoID* photo_id,
                                   gboolean enhanced);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_set_import_id (Photo* self,
                          ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base,
                                   time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
void photo_set_exposure_time_persistent (Photo* self,
                                         time_t time,
                                         GError** error);
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self,
                                       KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type,
                                      const gchar* group);
static KeyValueMap* photo_get_color_adjustments_map (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void value_set_pixel_transformation (GValue* value,
                                     gpointer v_object);
void value_take_pixel_transformation (GValue* value,
                                      gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self,
                                                                     PixelTransformationType type);
void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self,
                                               const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self,
                                               PixelTransformation* old_trans,
                                               PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState* * state,
                                        GError** error);
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState* * state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments,
                                                                              GeeHashMap* original_transformations,
                                                                              gboolean enhanced);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments,
                                                                                    GeeHashMap* original_transformations,
                                                                                    gboolean enhanced);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations,
                                               GeeHashMap* original_transforms,
                                               gboolean enhanced);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self,
                   Rotation rotation);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
static gboolean photo_set_original_transforms (Photo* self,
                                        KeyValueMap* trans);
gboolean photo_table_set_original_transforms (PhotoTable* self,
                                              PhotoID* photo_id,
                                              KeyValueMap* map);
static gboolean photo_clear_original_transforms (Photo* self);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
gint key_value_map_get_int (KeyValueMap* self,
                            const gchar* key,
                            gint def);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
void key_value_map_set_int (KeyValueMap* self,
                            const gchar* key,
                            gint value);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self,
                                  const gchar* key,
                                  gdouble def);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
void key_value_map_set_double (KeyValueMap* self,
                               const gchar* key,
                               gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            int* result_length1);
void key_value_map_get_point (KeyValueMap* self,
                              const gchar* key,
                              GdkPoint* def,
                              GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self,
                              const gchar* key,
                              GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self,
                                         GdkPixbuf* pixbuf,
                                         GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE _ ("Photos")
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              const gchar* commandline,
                              GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self,
                                          const gchar* external_editor,
                                          GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
void configuration_facade_set_external_raw_app (ConfigurationFacade* self,
                                                const gchar* external_raw_app);
void photo_open_with_external_editor (Photo* self,
                                      const gchar* external_editor,
                                      GError** error);
GFile* photo_get_modified_file (Photo* self,
                                GError** error);
void configuration_facade_set_external_photo_app (ConfigurationFacade* self,
                                                  const gchar* external_photo_app);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
void photo_reimport_editable (Photo* self,
                              GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add108 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add109 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add110 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add111 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add112 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add113 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
void photo_set_crop (Photo* self,
                     Box* crop);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
gboolean photo_unenhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static gchar** _vala_array_dup6 (gchar** self,
                          int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static void photo_finalize (GObject * obj);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      void* check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      void* get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            void* check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            void* get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self,
                      GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
gint utf8_ci_compare (void* a,
                      void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor,
                         void* monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto* * photo);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                void* progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self,
                   MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
void tag_attach (Tag* self,
                 MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
static void library_photo_finalize (GObject * obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       void* check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             void* check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             void* get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 3877 "Photo.c"
}


static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 3886 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->file = _tmp0_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *import_id;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->import_id = _tmp2_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 3959 "Photo.c"
}


PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 3975 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->file = _tmp0_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *import_id;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->import_id = _tmp1_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->exif_md5 = NULL;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->full_md5 = NULL;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnails = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 4023 "Photo.c"
}


PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 4033 "Photo.c"
}


static void
value_photo_import_params_init (GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 4042 "Photo.c"
}


static void
value_photo_import_params_free_value (GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 4053 "Photo.c"
	}
}


static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 4066 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4070 "Photo.c"
	}
}


static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 4080 "Photo.c"
}


static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4092 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4099 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4103 "Photo.c"
		}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4107 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4111 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 4115 "Photo.c"
}


static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4131 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 4137 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4141 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4145 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 4149 "Photo.c"
}


GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4169 "Photo.c"
}


gpointer
value_get_photo_import_params (const GValue* value)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 4180 "Photo.c"
}


void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4203 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4207 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (old);
#line 4213 "Photo.c"
	}
}


void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4235 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4239 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (old);
#line 4245 "Photo.c"
	}
}


static void
photo_import_params_class_init (PhotoImportParamsClass * klass)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4257 "Photo.c"
}


static void
photo_import_params_instance_init (PhotoImportParams * self)
{
	PhotoRow* _tmp0_;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->final_associated_file = NULL;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->keywords = NULL;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 4275 "Photo.c"
}


static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4303 "Photo.c"
}


GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 4332 "Photo.c"
}


void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4347 "Photo.c"
	}
}


PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 4360 "Photo.c"
}


gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 4377 "Photo.c"
}


static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4386 "Photo.c"
}


static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass)
{
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4403 "Photo.c"
}


static void
photo_transformation_state_instance_init (PhotoTransformationState * self)
{
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4414 "Photo.c"
}


static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4426 "Photo.c"
}


GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result = FALSE;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (self & exception) != 0;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 4453 "Photo.c"
}


gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result = FALSE;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (self & exception) == 0;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 4466 "Photo.c"
}


GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer
_photo_row_ref0 (gpointer self)
{
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4489 "Photo.c"
}


static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4498 "Photo.c"
}


Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	PhotoFileFormat _tmp11_;
	BackingPhotoRow* _tmp12_;
	const gchar* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp21_;
	BackingPhotoID _tmp25_;
	gint64 _tmp26_;
	BackingPhotoRow* _tmp41_;
	PhotoFileFormat _tmp42_;
	gboolean _tmp57_ = FALSE;
	BackingPhotoRow* _tmp58_;
	PhotoFileFormat _tmp59_;
	PhotoBackingReaders* _tmp71_;
	PhotoFileReader* _tmp72_;
	PhotoRow* _tmp88_;
	time_t _tmp89_;
	GError * _inner_error_ = NULL;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->row;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->row;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = self->row;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->row;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = row->master;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_->file_format;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = row->master;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_->filepath;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_file_format_create_reader (_tmp11_, _tmp13_);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_->master = _tmp14_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = row->master;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = string_sliced_at_last_char (_tmp16_, (gunichar) G_DIR_SEPARATOR, 0);
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	basename = _tmp17_;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = basename;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 4602 "Photo.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = basename;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = string_sliced_at (_tmp19_, 1);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 4613 "Photo.c"
	}
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = self->priv->file_title;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (is_string_empty (_tmp21_)) {
#line 4619 "Photo.c"
		BackingPhotoRow* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = row->master;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_->filepath;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 4633 "Photo.c"
	}
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = row->editable_id;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_.id;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp26_ != BACKING_PHOTO_ID_INVALID) {
#line 4641 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp27_;
		BackingPhotoRow* _tmp28_;
		BackingPhotoRow* _tmp29_;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = row->editable_id;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = photo_get_backing_row (self, &_tmp27_);
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _tmp28_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = e;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp29_ != NULL) {
#line 4656 "Photo.c"
			BackingPhotoRow* _tmp30_;
			BackingPhotoRow* _tmp31_;
			PhotoBackingReaders* _tmp32_;
			BackingPhotoRow* _tmp33_;
			PhotoFileFormat _tmp34_;
			BackingPhotoRow* _tmp35_;
			const gchar* _tmp36_;
			PhotoFileReader* _tmp37_;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = e;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = _backing_photo_row_ref0 (_tmp30_);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->editable = _tmp31_;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = self->priv->readers;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = _tmp33_->file_format;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = _tmp35_->filepath;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = photo_file_format_create_reader (_tmp34_, _tmp36_);
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp32_->editable);
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_->editable = _tmp37_;
#line 4689 "Photo.c"
		} else {
			{
				PhotoTable* _tmp38_;
				PhotoTable* _tmp39_;
				PhotoRow* _tmp40_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = photo_table_get_instance ();
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = _tmp38_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = self->row;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_detach_editable (_tmp39_, _tmp40_, &_inner_error_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp39_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 4709 "Photo.c"
						goto __catch112_database_error;
					}
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (basename);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return NULL;
#line 4722 "Photo.c"
				}
			}
			goto __finally112;
			__catch112_database_error:
			{
				GError* err = NULL;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 4735 "Photo.c"
			}
			__finally112:
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (basename);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 4750 "Photo.c"
			}
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 4754 "Photo.c"
		}
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 4758 "Photo.c"
	}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = row->master;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = _tmp41_->file_format;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp42_ == PHOTO_FILE_FORMAT_RAW) {
#line 4766 "Photo.c"
		GeeHashMap* _tmp43_;
		gint _tmp44_;
		RawDeveloper* _tmp45_;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->developments = _tmp43_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = raw_developer_as_array (&_tmp44_);
#line 4778 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = _tmp45_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection_length1 = _tmp44_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (d_it = 0; d_it < _tmp44_; d_it = d_it + 1) {
#line 4790 "Photo.c"
				RawDeveloper d = 0;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				d = d_collection[d_it];
#line 4794 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp46_;
					gint _tmp46__length1;
					RawDeveloper _tmp47_;
					BackingPhotoID _tmp48_;
					BackingPhotoID _tmp49_;
					gint64 _tmp50_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46_ = row->development_ids;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46__length1 = row->development_ids_length1;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp47_ = d;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp48_ = _tmp46_[_tmp47_];
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					id = _tmp48_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp49_ = id;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = _tmp49_.id;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp50_ != BACKING_PHOTO_ID_INVALID) {
#line 4819 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp51_;
						BackingPhotoRow* _tmp52_;
						BackingPhotoRow* _tmp53_;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp51_ = id;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp52_ = photo_get_backing_row (self, &_tmp51_);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						bpr = _tmp52_;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp53_ = bpr;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp53_ != NULL) {
#line 4834 "Photo.c"
							GeeHashMap* _tmp54_;
							RawDeveloper _tmp55_;
							BackingPhotoRow* _tmp56_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp54_ = self->priv->developments;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp55_ = d;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp56_ = bpr;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, (gpointer) ((gintptr) _tmp55_), _tmp56_);
#line 4846 "Photo.c"
						}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 4850 "Photo.c"
					}
				}
			}
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4856 "Photo.c"
		}
	}
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp58_ = row->master;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp59_ = _tmp58_->file_format;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp59_ == PHOTO_FILE_FORMAT_RAW) {
#line 4865 "Photo.c"
		GeeHashMap* _tmp60_;
		RawDeveloper _tmp61_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = self->priv->developments;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = row->developer;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp60_, (gpointer) ((gintptr) _tmp61_));
#line 4874 "Photo.c"
	} else {
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = FALSE;
#line 4878 "Photo.c"
	}
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp57_) {
#line 4882 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp62_;
		RawDeveloper _tmp63_;
		gpointer _tmp64_;
		PhotoBackingReaders* _tmp65_;
		BackingPhotoRow* _tmp66_;
		PhotoFileFormat _tmp67_;
		BackingPhotoRow* _tmp68_;
		const gchar* _tmp69_;
		PhotoFileReader* _tmp70_;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = self->priv->developments;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = row->developer;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp62_, (gpointer) ((gintptr) _tmp63_));
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp64_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = self->priv->readers;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = r;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = _tmp66_->file_format;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp68_ = r;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = _tmp68_->filepath;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = photo_file_format_create_reader (_tmp67_, _tmp69_);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp65_->developer);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_->developer = _tmp70_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 4919 "Photo.c"
	}
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp71_ = self->priv->readers;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp72_ = _tmp71_->editable;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp72_ != NULL) {
#line 4927 "Photo.c"
		BackingPhotoRow* _tmp73_;
		BackingPhotoRow* _tmp74_;
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = self->priv->editable;
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = _backing_photo_row_ref0 (_tmp73_);
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->backing_photo_row = _tmp74_;
#line 4938 "Photo.c"
	} else {
		BackingPhotoRow* _tmp75_;
		PhotoFileFormat _tmp76_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = row->master;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = _tmp75_->file_format;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp76_ != PHOTO_FILE_FORMAT_RAW) {
#line 4948 "Photo.c"
			PhotoRow* _tmp77_;
			BackingPhotoRow* _tmp78_;
			BackingPhotoRow* _tmp79_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = self->row;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp78_ = _tmp77_->master;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->backing_photo_row = _tmp79_;
#line 4962 "Photo.c"
		} else {
			GeeHashMap* _tmp80_;
			RawDeveloper _tmp81_;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp80_ = self->priv->developments;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp81_ = row->developer;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp80_, (gpointer) ((gintptr) _tmp81_))) {
#line 4972 "Photo.c"
				GeeHashMap* _tmp82_;
				RawDeveloper _tmp83_;
				gpointer _tmp84_;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp82_ = self->priv->developments;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp83_ = row->developer;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp84_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp82_, (gpointer) ((gintptr) _tmp83_));
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp84_;
#line 4986 "Photo.c"
			} else {
				PhotoRow* _tmp85_;
				BackingPhotoRow* _tmp86_;
				BackingPhotoRow* _tmp87_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp85_ = self->row;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp86_ = _tmp85_->master;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp87_ = _backing_photo_row_ref0 (_tmp86_);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->backing_photo_row = _tmp87_;
#line 5001 "Photo.c"
			}
		}
	}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = self->row;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = _tmp88_->exposure_time;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->cached_exposure_time = _tmp89_;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (basename);
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 5015 "Photo.c"
}


static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 5026 "Photo.c"
}


void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 5039 "Photo.c"
}


static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 5048 "Photo.c"
}


void
photo_notify_raw_development_modified (Photo* self)
{
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 5059 "Photo.c"
}


static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 5068 "Photo.c"
}


void
photo_notify_baseline_replaced (Photo* self)
{
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 5079 "Photo.c"
}


static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5089 "Photo.c"
}


void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 5101 "Photo.c"
}


static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5111 "Photo.c"
}


void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 5123 "Photo.c"
}


static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5133 "Photo.c"
}


void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 5145 "Photo.c"
}


static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5155 "Photo.c"
}


void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 5167 "Photo.c"
}


static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = TRUE;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = NULL;
#line 5188 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5195 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5205 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				file = _tmp5_;
#line 5219 "Photo.c"
			}
		}
		__finally113:
		{
			PhotoBackingReaders* _tmp6_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5229 "Photo.c"
		}
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5233 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp7_;
#line 5241 "Photo.c"
		}
	}
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5248 "Photo.c"
		gint _tmp8_;
		RawDeveloper* _tmp9_;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5253 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = _tmp9_;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 5265 "Photo.c"
				RawDeveloper d = 0;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				d = d_collection[d_it];
#line 5269 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = d;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 5276 "Photo.c"
				}
			}
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5281 "Photo.c"
		}
	}
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_delete_original_file ((MediaSource*) self);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_inner_error_);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5290 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp13_;
#line 5298 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_) {
#line 5302 "Photo.c"
		gboolean _tmp14_;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = ret;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp14_;
#line 5308 "Photo.c"
	} else {
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = FALSE;
#line 5312 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp11_;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 5320 "Photo.c"
}


static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp13_;
	GError * _inner_error_ = NULL;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *id;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 5348 "Photo.c"
	}
#line 465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_row = NULL;
#line 5352 "Photo.c"
	{
		BackingPhotoRow* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		BackingPhotoID _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
		BackingPhotoRow* _tmp8_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = *id;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = backing_photo_table_fetch (_tmp4_, &_tmp5_, &_inner_error_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp7_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 5379 "Photo.c"
				goto __catch114_database_error;
			}
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 5390 "Photo.c"
		}
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp2_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = NULL;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_row = _tmp8_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp2_);
#line 5402 "Photo.c"
	}
	goto __finally114;
	__catch114_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = data_object_to_string ((DataObject*) self);
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = err;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:469: Unable to fetch backing state for %s: %s", _tmp10_, _tmp12_);
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 5430 "Photo.c"
	}
	__finally114:
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 5443 "Photo.c"
	}
#line 472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = backing_row;
#line 472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 5449 "Photo.c"
		{
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoID _tmp16_;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = *id;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_remove (_tmp15_, &_tmp16_, &_inner_error_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 5468 "Photo.c"
					goto __catch115_database_error;
				}
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 5479 "Photo.c"
			}
		}
		goto __finally115;
		__catch115_database_error:
		{
			GError* err = NULL;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 5492 "Photo.c"
		}
		__finally115:
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 5505 "Photo.c"
		}
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 5513 "Photo.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = backing_row;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 5519 "Photo.c"
}


gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5531 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5539 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d))) {
#line 5547 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 5564 "Photo.c"
			} else {
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 5568 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 5572 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5579 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 5583 "Photo.c"
		}
		__finally116:
		{
			GeeHashMap* _tmp8_;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5592 "Photo.c"
		}
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp9_;
#line 5600 "Photo.c"
	}
}


gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5613 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5620 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 5629 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5636 "Photo.c"
				}
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 5640 "Photo.c"
			}
		}
		__finally117:
		{
			GeeHashMap* _tmp3_;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5650 "Photo.c"
		}
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5654 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp4_;
#line 5662 "Photo.c"
		}
	}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (d) {
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5669 "Photo.c"
		{
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = TRUE;
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 5675 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5679 "Photo.c"
		{
#line 505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = FALSE;
#line 505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 5685 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5689 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
				guint _tmp7_;
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error_);
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp5_;
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5703 "Photo.c"
					goto __catch118_g_error;
				}
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = meta;
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = num_previews;
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp7_ > ((guint) 0)) {
#line 5714 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp8_;
					guint _tmp9_;
					PhotoPreview* _tmp10_;
					PhotoPreview* _tmp11_;
					Dimensions dims = {0};
					PhotoPreview* _tmp12_;
					Dimensions _tmp13_ = {0};
					gint _tmp14_ = 0;
					Dimensions _tmp15_;
					gint _tmp16_;
					Dimensions _tmp17_;
					gint _tmp18_;
					gint preview_major_axis = 0;
					gint _tmp23_;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = meta;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = num_previews;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = photo_metadata_get_preview (_tmp8_, _tmp9_ - 1);
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					prev = _tmp10_;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = prev;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp11_ == NULL) {
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						result = FALSE;
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return result;
#line 5750 "Photo.c"
					}
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = prev;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp12_, &_tmp13_);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					dims = _tmp13_;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = _tmp15_.width;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = _tmp17_.height;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp16_ > _tmp18_) {
#line 5768 "Photo.c"
						Dimensions _tmp19_;
						gint _tmp20_;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp19_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = _tmp19_.width;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = _tmp20_;
#line 5777 "Photo.c"
					} else {
						Dimensions _tmp21_;
						gint _tmp22_;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp21_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp22_ = _tmp21_.height;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = _tmp22_;
#line 5787 "Photo.c"
					}
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					preview_major_axis = _tmp14_;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = preview_major_axis;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp23_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						result = FALSE;
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return result;
#line 5803 "Photo.c"
					}
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 5813 "Photo.c"
				}
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 5821 "Photo.c"
			}
			goto __finally118;
			__catch118_g_error:
			{
				GError* e = NULL;
				GError* _tmp24_;
				const gchar* _tmp25_;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = e;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _tmp24_->message;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:533: Error accessing embedded preview. Message: %s", _tmp25_);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 5841 "Photo.c"
			}
			__finally118:
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5846 "Photo.c"
				gboolean _tmp26_ = FALSE;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp26_;
#line 5854 "Photo.c"
			}
#line 535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = FALSE;
#line 535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 5860 "Photo.c"
		}
		default:
		{
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_assert_not_reached ();
#line 5866 "Photo.c"
		}
	}
}


void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	Alteration* _tmp4_;
	Alteration* _tmp5_;
	GError * _inner_error_ = NULL;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error_);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 5896 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5904 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d), bpr);
#line 5911 "Photo.c"
		}
		__finally119:
		{
			GeeHashMap* _tmp3_;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5920 "Photo.c"
		}
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 5928 "Photo.c"
		}
	}
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = alteration_new ("image", "developer");
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp5_);
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp5_);
#line 5939 "Photo.c"
}


void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp4_;
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp6_;
	PhotoFileInterrogator* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	Dimensions _tmp12_;
	GFileInfo* _tmp13_;
	GTimeVal _tmp14_;
	glong _tmp15_;
	Orientation _tmp16_ = 0;
	DetectedPhotoInformation* _tmp17_;
	PhotoMetadata* _tmp18_;
	BackingPhotoTable* _tmp21_;
	BackingPhotoTable* _tmp22_;
	PhotoTable* _tmp23_;
	PhotoTable* _tmp24_;
	BackingPhotoID _tmp25_;
	GError * _inner_error_ = NULL;
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (row != NULL);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp1_;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = _tmp3_;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 6003 "Photo.c"
	}
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = info;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp4_, &_tmp5_);
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp5_;
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = file;
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_file_interrogator_new (_tmp6_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp7_;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = interrogator;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp8_, &_inner_error_);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 6033 "Photo.c"
	}
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = interrogator;
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_file_interrogator_get_detected_photo_information (_tmp9_);
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp10_;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = detected;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_->image_dim;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bpr->dim = _tmp12_;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = info;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp13_);
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = timestamp;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_.tv_sec;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bpr->timestamp = (time_t) _tmp15_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = detected;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_->metadata;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 6063 "Photo.c"
		DetectedPhotoInformation* _tmp19_;
		PhotoMetadata* _tmp20_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = detected;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_->metadata;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = photo_metadata_get_orientation (_tmp20_);
#line 6072 "Photo.c"
	} else {
#line 569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = ORIENTATION_TOP_LEFT;
#line 6076 "Photo.c"
	}
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bpr->original_orientation = _tmp16_;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = backing_photo_table_get_instance ();
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = _tmp21_;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_photo_table_add (_tmp22_, bpr, &_inner_error_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp22_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 6102 "Photo.c"
	}
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_table_get_instance ();
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp23_;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = bpr->id;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_update_raw_development (_tmp24_, row, d, &_tmp25_, &_inner_error_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp24_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 6128 "Photo.c"
	}
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 6138 "Photo.c"
}


static void
photo_develop_photo (Photo* self,
                     RawDeveloper d)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError * _inner_error_ = NULL;
#line 578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bps = NULL;
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (d) {
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6159 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp12_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp17_;
				const gchar* _tmp18_;
				PhotoFileWriter* _tmp19_;
				PhotoFileWriter* _tmp20_;
				GdkPixbuf* _tmp21_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp22_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp23_;
				const gchar* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_;
				PhotoMetadata* _tmp27_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = self->row;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error_);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6196 "Photo.c"
					goto __catch120_g_error;
				}
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp0_ = NULL;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				bps = _tmp5_;
#line 587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				pix = NULL;
#line 6209 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6216 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error_);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6230 "Photo.c"
							goto __finally121;
						}
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp7_ = NULL;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (pix);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						pix = _tmp10_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6243 "Photo.c"
					}
					__finally121:
					{
						PhotoBackingReaders* _tmp11_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6252 "Photo.c"
					}
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (pix);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6260 "Photo.c"
						goto __catch120_g_error;
					}
				}
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = pix;
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:597: Could not get preview pixbuf");
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6274 "Photo.c"
					{
						gboolean _tmp13_;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp13_) {
#line 6281 "Photo.c"
							{
								BackingPhotoRow* _tmp14_;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp14_ = bps;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp14_, &_inner_error_);
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6290 "Photo.c"
									goto __catch122_g_error;
								}
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6295 "Photo.c"
							}
							goto __finally122;
							__catch122_g_error:
							{
								GError* e = NULL;
								GError* _tmp15_;
								const gchar* _tmp16_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp15_ = e;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp16_ = _tmp15_->message;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp16_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 6315 "Photo.c"
							}
							__finally122:
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6320 "Photo.c"
								goto __catch120_g_error;
							}
						}
					}
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6329 "Photo.c"
				}
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = bps;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_->filepath;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp18_, &_inner_error_);
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				writer = _tmp19_;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6345 "Photo.c"
					goto __catch120_g_error;
				}
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = writer;
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = pix;
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_writer_write (_tmp20_, _tmp21_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6362 "Photo.c"
					goto __catch120_g_error;
				}
#line 611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = photo_get_master_metadata (self, &_inner_error_);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp22_;
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6379 "Photo.c"
					goto __catch120_g_error;
				}
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = bps;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = _tmp23_->filepath;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp24_, &_inner_error_);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				mwriter = _tmp25_;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6400 "Photo.c"
					goto __catch120_g_error;
				}
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = mwriter;
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = meta;
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp26_, _tmp27_, &_inner_error_);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6421 "Photo.c"
					goto __catch120_g_error;
				}
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (pix);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 6434 "Photo.c"
			}
			goto __finally120;
			__catch120_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = err;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:620: Error developing photo: %s", _tmp29_);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 6454 "Photo.c"
			}
			__finally120:
			{
				gboolean _tmp30_;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp30_) {
#line 6463 "Photo.c"
					{
						BackingPhotoRow* _tmp31_;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp31_ = bps;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp31_, &_inner_error_);
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6472 "Photo.c"
							goto __catch123_g_error;
						}
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6477 "Photo.c"
					}
					goto __finally123;
					__catch123_g_error:
					{
						GError* e = NULL;
						GError* _tmp32_;
						const gchar* _tmp33_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						e = _inner_error_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp32_ = e;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp33_ = _tmp32_->message;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp33_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_error_free0 (e);
#line 6497 "Photo.c"
					}
					__finally123:
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 6510 "Photo.c"
					}
				}
			}
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 6524 "Photo.c"
			}
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 6528 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6532 "Photo.c"
		{
#line 639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 6536 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6540 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp34_;
				guint c = 0U;
				PhotoMetadata* _tmp35_;
				guint _tmp36_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp41_;
				guint _tmp42_;
				PhotoPreview* _tmp43_;
				PhotoPreview* _tmp44_;
				GdkPixbuf* pix = NULL;
				PhotoPreview* _tmp49_;
				GdkPixbuf* _tmp50_;
				GdkPixbuf* _tmp51_;
				BackingPhotoRow* _tmp56_ = NULL;
				PhotoRow* _tmp57_;
				BackingPhotoRow* _tmp58_;
				const gchar* _tmp59_;
				BackingPhotoRow* _tmp60_;
				BackingPhotoRow* _tmp61_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp62_;
				const gchar* _tmp63_;
				PhotoFileWriter* _tmp64_;
				PhotoFileWriter* _tmp65_;
				GdkPixbuf* _tmp66_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp67_;
				const gchar* _tmp68_;
				PhotoFileMetadataWriter* _tmp69_;
				PhotoFileMetadataWriter* _tmp70_;
				PhotoMetadata* _tmp71_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = photo_get_master_metadata (self, &_inner_error_);
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp34_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6581 "Photo.c"
					goto __catch124_g_error;
				}
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = meta;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp35_);
#line 646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = c;
#line 646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp36_ <= ((guint) 0)) {
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6594 "Photo.c"
					{
						gboolean _tmp37_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp37_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp37_) {
#line 6601 "Photo.c"
							{
								BackingPhotoRow* _tmp38_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp38_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp38_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6610 "Photo.c"
									goto __catch125_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6615 "Photo.c"
							}
							goto __finally125;
							__catch125_g_error:
							{
								GError* e = NULL;
								GError* _tmp39_;
								const gchar* _tmp40_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp39_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp40_ = _tmp39_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp40_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 6635 "Photo.c"
							}
							__finally125:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6640 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6649 "Photo.c"
				}
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = meta;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = c;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = photo_metadata_get_preview (_tmp41_, _tmp42_ - 1);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				prev = _tmp43_;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = prev;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp44_ == NULL) {
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:650: Could not get preview from metadata");
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6669 "Photo.c"
					{
						gboolean _tmp45_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp45_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp45_) {
#line 6676 "Photo.c"
							{
								BackingPhotoRow* _tmp46_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp46_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp46_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6685 "Photo.c"
									goto __catch126_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6690 "Photo.c"
							}
							goto __finally126;
							__catch126_g_error:
							{
								GError* e = NULL;
								GError* _tmp47_;
								const gchar* _tmp48_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp47_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp48_ = _tmp47_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp48_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 6710 "Photo.c"
							}
							__finally126:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6715 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6724 "Photo.c"
				}
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = prev;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp50_ = photo_preview_get_pixbuf (_tmp49_, &_inner_error_);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				pix = _tmp50_;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6738 "Photo.c"
					goto __catch124_g_error;
				}
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp51_ = pix;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp51_ == NULL) {
#line 656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:656: Could not get preview pixbuf");
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6753 "Photo.c"
					{
						gboolean _tmp52_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp52_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp52_) {
#line 6760 "Photo.c"
							{
								BackingPhotoRow* _tmp53_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp53_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp53_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6769 "Photo.c"
									goto __catch127_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6774 "Photo.c"
							}
							goto __finally127;
							__catch127_g_error:
							{
								GError* e = NULL;
								GError* _tmp54_;
								const gchar* _tmp55_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp54_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp55_ = _tmp54_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp55_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 6794 "Photo.c"
							}
							__finally127:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6799 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6808 "Photo.c"
				}
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = self->row;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = _tmp57_->master;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = _tmp58_->filepath;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = raw_developer_create_backing_row_for_development (d, _tmp59_, NULL, &_inner_error_);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = _tmp60_;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6828 "Photo.c"
					goto __catch124_g_error;
				}
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp61_ = _tmp56_;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = NULL;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				bps = _tmp61_;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp62_ = bps;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp63_ = _tmp62_->filepath;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp63_, &_inner_error_);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				writer = _tmp64_;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6857 "Photo.c"
					goto __catch124_g_error;
				}
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = writer;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = pix;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_writer_write (_tmp65_, _tmp66_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6878 "Photo.c"
					goto __catch124_g_error;
				}
#line 667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = bps;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp68_ = _tmp67_->filepath;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp69_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp68_, &_inner_error_);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				mwriter = _tmp69_;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6903 "Photo.c"
					goto __catch124_g_error;
				}
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp70_ = mwriter;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp71_ = meta;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp70_, _tmp71_, &_inner_error_);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6926 "Photo.c"
					goto __catch124_g_error;
				}
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp56_);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (pix);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 6941 "Photo.c"
			}
			goto __finally124;
			__catch124_g_error:
			{
				GError* e = NULL;
				GError* _tmp72_;
				const gchar* _tmp73_;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp72_ = e;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp73_ = _tmp72_->message;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:673: Error accessing embedded preview. Message: %s", _tmp73_);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 6961 "Photo.c"
				{
					gboolean _tmp74_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp74_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp74_) {
#line 6968 "Photo.c"
						{
							BackingPhotoRow* _tmp75_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp75_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp75_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6977 "Photo.c"
								goto __catch128_g_error;
							}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 6982 "Photo.c"
						}
						goto __finally128;
						__catch128_g_error:
						{
							GError* e = NULL;
							GError* _tmp76_;
							const gchar* _tmp77_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp76_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp77_ = _tmp76_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp77_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_error_free0 (e);
#line 7002 "Photo.c"
						}
						__finally128:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 7009 "Photo.c"
						}
					}
				}
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 7017 "Photo.c"
			}
			__finally124:
			{
				gboolean _tmp78_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp78_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp78_) {
#line 7026 "Photo.c"
					{
						BackingPhotoRow* _tmp79_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp79_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp79_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7035 "Photo.c"
							goto __catch129_g_error;
						}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7040 "Photo.c"
					}
					goto __finally129;
					__catch129_g_error:
					{
						GError* e = NULL;
						GError* _tmp80_;
						const gchar* _tmp81_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp80_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp81_ = _tmp80_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp81_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_error_free0 (e);
#line 7060 "Photo.c"
					}
					__finally129:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 7073 "Photo.c"
					}
				}
			}
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 7087 "Photo.c"
			}
#line 688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 7091 "Photo.c"
		}
		default:
		{
#line 691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_assert_not_reached ();
#line 7097 "Photo.c"
		}
	}
#line 578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 7102 "Photo.c"
}


void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError * _inner_error_ = NULL;
#line 696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 7113 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7120 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_->developer = d;
#line 7127 "Photo.c"
		}
		__finally130:
		{
			PhotoRow* _tmp2_;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7136 "Photo.c"
		}
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 7146 "Photo.c"
		}
	}
}


void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d)
{
	gboolean _tmp0_ = FALSE;
	Alteration* _tmp34_;
	Alteration* _tmp35_;
	GError * _inner_error_ = NULL;
#line 703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 704 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 7166 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7172 "Photo.c"
	} else {
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 7176 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7182 "Photo.c"
	}
#line 715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7188 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7196 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp2_;
			RawDeveloper _tmp3_;
			GeeHashMap* _tmp6_;
			PhotoRow* _tmp8_;
			GeeHashMap* _tmp9_;
			gpointer _tmp10_;
			PhotoBackingReaders* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoFileFormat _tmp13_;
			BackingPhotoRow* _tmp14_;
			const gchar* _tmp15_;
			PhotoFileReader* _tmp16_;
			BackingPhotoRow* _tmp17_;
			Orientation _tmp18_;
			gboolean _tmp27_ = FALSE;
			RawDeveloper _tmp28_;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->developer;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			stale_raw_developer = _tmp3_;
#line 722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_develop_photo (self, d);
#line 7225 "Photo.c"
				{
#line 725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7231 "Photo.c"
						goto __catch132_g_error;
					}
				}
				goto __finally132;
				__catch132_g_error:
				{
					GError* e = NULL;
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 7245 "Photo.c"
					{
						GeeHashMap* _tmp4_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7252 "Photo.c"
					}
#line 728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 7256 "Photo.c"
				}
				__finally132:
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7261 "Photo.c"
					{
						GeeHashMap* _tmp5_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7268 "Photo.c"
					}
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 7276 "Photo.c"
				}
			}
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->developments;
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) d))) {
#line 7283 "Photo.c"
				{
					GeeHashMap* _tmp7_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7290 "Photo.c"
				}
#line 732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 7294 "Photo.c"
			}
#line 735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_->developer = d;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->priv->developments;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) d));
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp10_;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->priv->readers;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = _tmp12_->file_format;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_->filepath;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = photo_file_format_create_reader (_tmp13_, _tmp15_);
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp11_->developer);
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_->developer = _tmp16_;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->backing_photo_row;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = _tmp17_->original_orientation;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_orientation (self, _tmp18_);
#line 7332 "Photo.c"
			{
				PhotoTable* _tmp19_;
				PhotoTable* _tmp20_;
				PhotoRow* _tmp21_;
				BackingPhotoRow* _tmp22_;
				BackingPhotoID _tmp23_;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = photo_table_get_instance ();
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = _tmp19_;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = self->row;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = self->backing_photo_row;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = _tmp22_->id;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_update_raw_development (_tmp20_, _tmp21_, d, &_tmp23_, &_inner_error_);
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp20_);
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7355 "Photo.c"
					goto __catch133_g_error;
				}
			}
			goto __finally133;
			__catch133_g_error:
			{
				GError* e = NULL;
				GError* _tmp24_;
				const gchar* _tmp25_;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = e;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _tmp24_->message;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:747: Error updating database: %s", _tmp25_);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 7377 "Photo.c"
			}
			__finally133:
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7382 "Photo.c"
				{
					GeeHashMap* _tmp26_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7389 "Photo.c"
				}
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 7397 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = stale_raw_developer;
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp28_ != RAW_DEVELOPER_CAMERA) {
#line 7403 "Photo.c"
				RawDeveloper _tmp29_;
				PhotoRow* _tmp30_;
				RawDeveloper _tmp31_;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = stale_raw_developer;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = self->row;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tmp30_->developer;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp29_ != _tmp31_;
#line 7415 "Photo.c"
			} else {
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = FALSE;
#line 7419 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp27_) {
#line 7423 "Photo.c"
				RawDeveloper _tmp32_;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = stale_raw_developer;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_delete_raw_development (self, _tmp32_);
#line 7429 "Photo.c"
			}
		}
		__finally131:
		{
			GeeHashMap* _tmp33_;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7439 "Photo.c"
		}
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 7449 "Photo.c"
		}
	}
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = alteration_new ("image", "developer");
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp35_);
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp35_);
#line 766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 7462 "Photo.c"
}


RawDeveloper
photo_get_raw_developer (Photo* self)
{
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 7482 "Photo.c"
}


static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError * _inner_error_ = NULL;
#line 775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = FALSE;
#line 7497 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7504 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp33_;
			gboolean _tmp34_;
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 7524 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7531 "Photo.c"
				}
#line 780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7535 "Photo.c"
			}
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = data_object_to_string ((DataObject*) self);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_debug ("Photo.vala:784: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp4_);
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) d));
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = bpr;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 7563 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = bpr;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = _tmp13_;
#line 7576 "Photo.c"
				{
#line 789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 7580 "Photo.c"
						GFile* _tmp14_;
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = f;
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error_);
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7588 "Photo.c"
							goto __catch135_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = f;
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error_);
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7599 "Photo.c"
							goto __catch135_g_error;
						}
					}
				}
				goto __finally135;
				__catch135_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = bpr;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = e;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_warning ("Photo.vala:794: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 7628 "Photo.c"
				}
				__finally135:
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7633 "Photo.c"
					gboolean _tmp21_ = FALSE;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 7643 "Photo.c"
					{
						GeeHashMap* _tmp20_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7650 "Photo.c"
					}
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return _tmp21_;
#line 7658 "Photo.c"
				}
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 7662 "Photo.c"
			}
			{
				PhotoTable* _tmp22_;
				PhotoTable* _tmp23_;
				PhotoRow* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoTable* _tmp26_;
				BackingPhotoRow* _tmp27_;
				BackingPhotoID _tmp28_;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = photo_table_get_instance ();
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = _tmp22_;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = self->row;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_remove_development (_tmp23_, _tmp24_, d, &_inner_error_);
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp23_);
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7684 "Photo.c"
					goto __catch136_g_error;
				}
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = backing_photo_table_get_instance ();
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = _tmp25_;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = bpr;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = _tmp27_->id;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_remove (_tmp26_, &_tmp28_, &_inner_error_);
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp26_);
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7701 "Photo.c"
					goto __catch136_g_error;
				}
			}
			goto __finally136;
			__catch136_g_error:
			{
				GError* e = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = e;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = _tmp29_->message;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:803: Database error while deleting RAW development: %s", _tmp30_);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 7723 "Photo.c"
			}
			__finally136:
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7728 "Photo.c"
				gboolean _tmp32_ = FALSE;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 7734 "Photo.c"
				{
					GeeHashMap* _tmp31_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7741 "Photo.c"
				}
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp32_;
#line 7749 "Photo.c"
			}
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = self->priv->developments;
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) d), NULL);
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			ret = _tmp34_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 7759 "Photo.c"
		}
		__finally134:
		{
			GeeHashMap* _tmp35_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7768 "Photo.c"
		}
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 7772 "Photo.c"
			gboolean _tmp36_ = FALSE;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp36_;
#line 7780 "Photo.c"
		}
	}
#line 809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = ret;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 7789 "Photo.c"
}


void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError * _inner_error_ = NULL;
#line 814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 7800 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7807 "Photo.c"
		{
			RawDeveloper dev = 0;
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
#line 816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dev = d;
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = dev;
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == RAW_DEVELOPER_CAMERA) {
#line 819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 7822 "Photo.c"
			}
#line 821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = dev;
#line 821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_raw_developer (self, _tmp2_);
#line 7828 "Photo.c"
		}
		__finally137:
		{
			GeeHashMap* _tmp3_;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7837 "Photo.c"
		}
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 7847 "Photo.c"
		}
	}
}


static void
_vala_array_add91 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7865 "Photo.c"
	}
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7871 "Photo.c"
}


static void
_vala_array_add92 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7887 "Photo.c"
	}
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7893 "Photo.c"
}


static void
_vala_array_add93 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7909 "Photo.c"
	}
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7915 "Photo.c"
}


static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    int* result_length1)
{
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp24_;
	gint _tmp24__length1;
	GError * _inner_error_ = NULL;
#line 825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp0_;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_length1 = 0;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 7942 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7949 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = backing;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add91 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_has_editable (self)) {
#line 7976 "Photo.c"
				BackingFileState** _tmp8_;
				gint _tmp8__length1;
				BackingPhotoRow* _tmp9_;
				BackingFileState* _tmp10_;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = backing;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8__length1 = backing_length1;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->editable;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = backing_file_state_new_from_photo_row (_tmp9_, NULL);
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_array_add92 (&backing, &backing_length1, &_backing_size_, _tmp10_);
#line 7991 "Photo.c"
			}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_is_developed (self)) {
#line 7995 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = photo_get_raw_development_photo_rows (self);
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dev_rows = _tmp11_;
#line 834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = dev_rows;
#line 834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp12_ != NULL) {
#line 8007 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = dev_rows;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_r_it = _tmp14_;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 8020 "Photo.c"
							GeeIterator* _tmp15_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp16_;
							gpointer _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							BackingFileState** _tmp20_;
							gint _tmp20__length1;
							BackingPhotoRow* _tmp21_;
							BackingFileState* _tmp22_;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_ = _r_it;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp15_)) {
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 8037 "Photo.c"
							}
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_ = _r_it;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = gee_iterator_get (_tmp16_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp17_;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = r;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = _tmp18_->filepath;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_debug ("Photo.vala:836: adding: %s", _tmp19_);
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = backing;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20__length1 = backing_length1;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = r;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = backing_file_state_new_from_photo_row (_tmp21_, NULL);
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_vala_array_add93 (&backing, &backing_length1, &_backing_size_, _tmp22_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 8063 "Photo.c"
						}
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 8067 "Photo.c"
					}
				}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 8072 "Photo.c"
			}
		}
		__finally138:
		{
			PhotoRow* _tmp23_;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = self->row;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8082 "Photo.c"
		}
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 8094 "Photo.c"
		}
	}
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = backing;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24__length1 = backing_length1;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp24__length1;
#line 8105 "Photo.c"
	}
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp24_;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8111 "Photo.c"
}


static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result = NULL;
#line 846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (mode) {
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 8126 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp0_;
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8135 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 8139 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8148 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 8152 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8161 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8165 "Photo.c"
		{
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8169 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp3_;
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8177 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp4_;
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8186 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:864: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8196 "Photo.c"
		}
	}
}


static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8207 "Photo.c"
}


static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8218 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8225 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 8238 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8245 "Photo.c"
			}
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8249 "Photo.c"
		}
		__finally139:
		{
			PhotoBackingReaders* _tmp5_;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8258 "Photo.c"
		}
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8266 "Photo.c"
	}
}


PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8278 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8285 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 8298 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8305 "Photo.c"
			}
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8309 "Photo.c"
		}
		__finally140:
		{
			PhotoBackingReaders* _tmp5_;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8318 "Photo.c"
		}
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8326 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8338 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8345 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8360 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp5_;
#line 8372 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8379 "Photo.c"
				}
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8383 "Photo.c"
			}
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8391 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp11_;
#line 8403 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8410 "Photo.c"
				}
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8414 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp15_;
#line 8424 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8431 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8435 "Photo.c"
		}
		__finally141:
		{
			PhotoBackingReaders* _tmp17_;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8444 "Photo.c"
		}
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8452 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8464 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8471 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8486 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp5_;
#line 8498 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8505 "Photo.c"
				}
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8509 "Photo.c"
			}
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8517 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp11_;
#line 8529 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8536 "Photo.c"
				}
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8540 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp15_;
#line 8550 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8557 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8561 "Photo.c"
		}
		__finally142:
		{
			PhotoBackingReaders* _tmp17_;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8570 "Photo.c"
		}
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8578 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8590 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8597 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 8610 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8617 "Photo.c"
			}
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8621 "Photo.c"
		}
		__finally143:
		{
			PhotoBackingReaders* _tmp5_;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8630 "Photo.c"
		}
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8638 "Photo.c"
	}
}


gboolean
photo_is_developed (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8650 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8658 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8668 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8675 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8679 "Photo.c"
		}
		__finally144:
		{
			PhotoBackingReaders* _tmp4_;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8688 "Photo.c"
		}
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 8696 "Photo.c"
	}
}


gboolean
photo_has_editable (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8708 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8716 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8726 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8733 "Photo.c"
			}
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8737 "Photo.c"
		}
		__finally145:
		{
			PhotoBackingReaders* _tmp4_;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8746 "Photo.c"
		}
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 8754 "Photo.c"
	}
}


gboolean
photo_does_master_exist (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8766 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8774 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp2_);
#line 8784 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8791 "Photo.c"
			}
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8795 "Photo.c"
		}
		__finally146:
		{
			PhotoBackingReaders* _tmp4_;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8804 "Photo.c"
		}
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 8812 "Photo.c"
	}
}


gboolean
photo_does_editable_exist (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 932 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8824 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8832 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 8843 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp5_);
#line 8852 "Photo.c"
			} else {
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 8856 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 8860 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8867 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8871 "Photo.c"
		}
		__finally147:
		{
			PhotoBackingReaders* _tmp7_;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8880 "Photo.c"
		}
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp8_;
#line 8888 "Photo.c"
	}
}


gboolean
photo_is_master_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8900 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8908 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 8918 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8925 "Photo.c"
			}
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8929 "Photo.c"
		}
		__finally148:
		{
			PhotoBackingReaders* _tmp4_;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8938 "Photo.c"
		}
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 8946 "Photo.c"
	}
}


gboolean
photo_is_master_source (Photo* self)
{
	gboolean result = FALSE;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = !photo_has_editable (self);
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8961 "Photo.c"
}


gboolean
photo_is_editable_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8972 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8980 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8990 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8997 "Photo.c"
			}
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9001 "Photo.c"
		}
		__finally149:
		{
			PhotoBackingReaders* _tmp4_;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9010 "Photo.c"
		}
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 9018 "Photo.c"
	}
}


gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result = FALSE;
#line 954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_has_editable (self);
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 9033 "Photo.c"
}


BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9044 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9051 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 9064 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9071 "Photo.c"
			}
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9075 "Photo.c"
		}
		__finally150:
		{
			PhotoRow* _tmp5_;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9084 "Photo.c"
		}
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 9092 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9104 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9111 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 9118 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp3_;
#line 9127 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp4_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9134 "Photo.c"
				}
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 9138 "Photo.c"
			} else {
#line 970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = NULL;
#line 9142 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp5_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9149 "Photo.c"
				}
#line 970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 9153 "Photo.c"
			}
		}
		__finally151:
		{
			PhotoRow* _tmp6_;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9163 "Photo.c"
		}
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 9171 "Photo.c"
	}
}


GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GeeCollection* result = NULL;
	GError * _inner_error_ = NULL;
#line 974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9183 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9190 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9198 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9212 "Photo.c"
			} else {
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 9218 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 9222 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9229 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9233 "Photo.c"
		}
		__finally152:
		{
			PhotoRow* _tmp7_;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9242 "Photo.c"
		}
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 9250 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9263 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9270 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9278 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9289 "Photo.c"
			} else {
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 9295 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 9299 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9306 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9310 "Photo.c"
		}
		__finally153:
		{
			PhotoRow* _tmp6_;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9319 "Photo.c"
		}
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 9327 "Photo.c"
	}
}


static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return dup;
#line 9342 "Photo.c"
}


static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9351 "Photo.c"
}


PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
#line 986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = reader;
#line 988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9381 "Photo.c"
	}
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 9395 "Photo.c"
}


PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *params;
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp1_) {
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 9421 "Photo.c"
		{
#line 1000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 9427 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 9431 "Photo.c"
		{
#line 1004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 9437 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 9441 "Photo.c"
		{
			ExportFormatParameters _tmp2_;
			PhotoFileFormat _tmp3_;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = *params;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_.specified_format;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp3_;
#line 1009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 9453 "Photo.c"
		}
		default:
		{
#line 1012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:1012: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 9459 "Photo.c"
		}
	}
#line 1015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _result_;
#line 1015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 9466 "Photo.c"
}


gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_result_ = NULL;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *params;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp1_) {
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 9493 "Photo.c"
		{
			GFile* _tmp2_;
			GFile* _tmp3_;
			gchar* _tmp4_;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_result_);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp4_;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1024 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 9512 "Photo.c"
		}
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 9518 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
			gchar* _tmp7_;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = *params;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp7_;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_result_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9535 "Photo.c"
		}
		default:
		{
#line 1031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:1031: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 9541 "Photo.c"
		}
	}
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _result_;
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _result_;
#line 1035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 9552 "Photo.c"
}


ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	ImportResult result = 0;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp23_;
	PhotoFileSnifferOptions _tmp24_;
	PhotoFileInterrogator* _tmp25_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp32_;
	DetectedPhotoInformation* _tmp33_;
	DetectedPhotoInformation* _tmp34_;
	PhotoFileSnifferOptions _tmp35_;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp45_;
	gchar* comment = NULL;
	gchar* _tmp46_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	DetectedPhotoInformation* _tmp67_;
	GdkColorspace _tmp68_;
	PhotoRow* _tmp76_;
	PhotoRow* _tmp77_;
	BackingPhotoRow* _tmp78_;
	GFile* _tmp79_;
	gchar* _tmp80_;
	PhotoRow* _tmp81_;
	BackingPhotoRow* _tmp82_;
	DetectedPhotoInformation* _tmp83_;
	Dimensions _tmp84_;
	PhotoRow* _tmp85_;
	BackingPhotoRow* _tmp86_;
	GFileInfo* _tmp87_;
	PhotoRow* _tmp88_;
	BackingPhotoRow* _tmp89_;
	GTimeVal _tmp90_;
	glong _tmp91_;
	PhotoRow* _tmp92_;
	time_t _tmp93_;
	PhotoRow* _tmp94_;
	Orientation _tmp95_;
	PhotoRow* _tmp96_;
	BackingPhotoRow* _tmp97_;
	Orientation _tmp98_;
	PhotoRow* _tmp99_;
	ImportID _tmp100_;
	PhotoRow* _tmp101_;
	PhotoRow* _tmp102_;
	PhotoRow* _tmp103_;
	DetectedPhotoInformation* _tmp104_;
	const gchar* _tmp105_;
	gchar* _tmp106_;
	PhotoRow* _tmp107_;
	DetectedPhotoInformation* _tmp108_;
	const gchar* _tmp109_;
	gchar* _tmp110_;
	PhotoRow* _tmp111_;
	DetectedPhotoInformation* _tmp112_;
	const gchar* _tmp113_;
	gchar* _tmp114_;
	PhotoRow* _tmp115_;
	PhotoRow* _tmp116_;
	PhotoRow* _tmp117_;
	BackingPhotoRow* _tmp118_;
	DetectedPhotoInformation* _tmp119_;
	PhotoFileFormat _tmp120_;
	PhotoRow* _tmp121_;
	const gchar* _tmp122_;
	gchar* _tmp123_;
	PhotoRow* _tmp124_;
	const gchar* _tmp125_;
	gchar* _tmp126_;
	Thumbnails* _tmp127_;
	GError * _inner_error_ = NULL;
#line 1050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = params->file;
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp1_;
#line 1056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 9657 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = file;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9671 "Photo.c"
			goto __catch154_g_error;
		}
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = NULL;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp5_;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 9684 "Photo.c"
	}
	goto __finally154;
	__catch154_g_error:
	{
		GError* err = NULL;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9704 "Photo.c"
	}
	__finally154:
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 9719 "Photo.c"
	}
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = info;
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9733 "Photo.c"
	}
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = file;
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 9739 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = file;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1068: Not importing %s: Not an image file", _tmp10_);
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9761 "Photo.c"
	}
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = file;
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 9767 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = file;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1074: Not importing %s: Unsupported extension", _tmp14_);
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9789 "Photo.c"
	}
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = info;
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp16_;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = params->exif_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 9801 "Photo.c"
		const gchar* _tmp20_;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = params->thumbnail_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp20_ != NULL;
#line 9807 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = FALSE;
#line 9811 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 9815 "Photo.c"
		const gchar* _tmp21_;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = params->full_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp21_ != NULL;
#line 9821 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = FALSE;
#line 9825 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_) {
#line 9829 "Photo.c"
		PhotoFileSnifferOptions _tmp22_;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = params->sniffer_options;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		params->sniffer_options = _tmp22_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 9835 "Photo.c"
	}
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = file;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = params->sniffer_options;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = photo_file_interrogator_new (_tmp23_, _tmp24_);
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp25_;
#line 9845 "Photo.c"
	{
		PhotoFileInterrogator* _tmp26_;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = interrogator;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp26_, &_inner_error_);
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9854 "Photo.c"
			goto __catch155_g_error;
		}
	}
	goto __finally155;
	__catch155_g_error:
	{
		GError* err = NULL;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = file;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = err;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = _tmp30_->message;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1090: Unable to interrogate photo file %s: %s", _tmp29_, _tmp31_);
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp29_);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9897 "Photo.c"
	}
	__finally155:
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 9914 "Photo.c"
	}
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = interrogator;
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = photo_file_interrogator_get_detected_photo_information (_tmp32_);
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp33_;
#line 1097 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = detected;
#line 1097 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp34_ == NULL) {
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9938 "Photo.c"
	}
#line 1101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = params->sniffer_options;
#line 1101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp35_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 9944 "Photo.c"
		DetectedPhotoInformation* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		DetectedPhotoInformation* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		DetectedPhotoInformation* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = detected;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = params->exif_md5;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp36_->exif_md5);
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_->exif_md5 = _tmp38_;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = detected;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = params->thumbnail_md5;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp39_->thumbnail_md5);
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_->thumbnail_md5 = _tmp41_;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = detected;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = params->full_md5;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp42_->md5);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_->md5 = _tmp44_;
#line 9984 "Photo.c"
	}
#line 1107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = g_strdup ("");
#line 1109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	title = _tmp45_;
#line 1110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = g_strdup ("");
#line 1110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	comment = _tmp46_;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = detected;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 10004 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		MetadataDateTime* _tmp52_;
		DetectedPhotoInformation* _tmp54_;
		PhotoMetadata* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoMetadata* _tmp57_;
		gchar* _tmp58_;
		DetectedPhotoInformation* _tmp59_;
		PhotoMetadata* _tmp60_;
		gchar* _tmp61_;
		DetectedPhotoInformation* _tmp62_;
		PhotoMetadata* _tmp63_;
		GeeSet* _tmp64_;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = detected;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp51_;
#line 1119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = date_time;
#line 1119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp52_ != NULL) {
#line 10033 "Photo.c"
			MetadataDateTime* _tmp53_;
#line 1120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = date_time;
#line 1120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp53_);
#line 10039 "Photo.c"
		}
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = detected;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = _tmp54_->metadata;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp55_);
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = detected;
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = _tmp56_->metadata;
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = media_metadata_get_title ((MediaMetadata*) _tmp57_);
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		title = _tmp58_;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = detected;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = _tmp59_->metadata;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = media_metadata_get_comment ((MediaMetadata*) _tmp60_);
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		comment = _tmp61_;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = detected;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = _tmp62_->metadata;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = photo_metadata_get_keywords (_tmp63_, NULL, NULL, NULL);
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		params->keywords = (GeeCollection*) _tmp64_;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10079 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp67_ = detected;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp68_ = _tmp67_->colorspace;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp68_ != GDK_COLORSPACE_RGB) {
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = TRUE;
#line 10089 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp69_;
		gint _tmp70_;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = detected;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = _tmp69_->channels;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = _tmp70_ < 3;
#line 10099 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp66_) {
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = TRUE;
#line 10105 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp71_;
		gint _tmp72_;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = detected;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = _tmp71_->bits_per_channel;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = _tmp72_ != 8;
#line 10115 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp65_) {
#line 10119 "Photo.c"
		GFile* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = file;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = g_file_get_path (_tmp73_);
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1132: Not importing %s: Unsupported color format", _tmp75_);
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp75_);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10149 "Photo.c"
	}
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp76_ = params->row;
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp76_->photo_id, PHOTO_ID_INVALID);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp77_ = params->row;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_ = _tmp77_->master;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp79_ = file;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp80_ = g_file_get_path (_tmp79_);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp78_->filepath);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_->filepath = _tmp80_;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_ = params->row;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = _tmp81_->master;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp83_ = detected;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = _tmp83_->image_dim;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_->dim = _tmp84_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = params->row;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_ = _tmp85_->master;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = info;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_->filesize = g_file_info_get_size (_tmp87_);
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = params->row;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = _tmp88_->master;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = timestamp;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp91_ = _tmp90_.tv_sec;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_->timestamp = (time_t) _tmp91_;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_ = params->row;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = exposure_time;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_->exposure_time = _tmp93_;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = params->row;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp95_ = orientation;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_->orientation = _tmp95_;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96_ = params->row;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_ = _tmp96_->master;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp98_ = orientation;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_->original_orientation = _tmp98_;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp99_ = params->row;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp100_ = params->import_id;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp99_->import_id = _tmp100_;
#line 1149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp101_ = params->row;
#line 1149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	event_id_init (&_tmp101_->event_id, EVENT_ID_INVALID);
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp102_ = params->row;
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp102_->transformations);
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp102_->transformations = NULL;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp103_ = params->row;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp104_ = detected;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp105_ = _tmp104_->md5;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp106_ = g_strdup (_tmp105_);
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp103_->md5);
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp103_->md5 = _tmp106_;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp107_ = params->row;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp108_ = detected;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp109_ = _tmp108_->thumbnail_md5;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp110_ = g_strdup (_tmp109_);
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp107_->thumbnail_md5);
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp107_->thumbnail_md5 = _tmp110_;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp111_ = params->row;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112_ = detected;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp113_ = _tmp112_->exif_md5;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp114_ = g_strdup (_tmp113_);
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp111_->exif_md5);
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp111_->exif_md5 = _tmp114_;
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp115_ = params->row;
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp115_->time_created = (time_t) 0;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp116_ = params->row;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp116_->flags = (guint64) 0;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp117_ = params->row;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp118_ = _tmp117_->master;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp119_ = detected;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp120_ = _tmp119_->file_format;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp118_->file_format = _tmp120_;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp121_ = params->row;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp122_ = title;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp123_ = g_strdup (_tmp122_);
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp121_->title);
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp121_->title = _tmp123_;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp124_ = params->row;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp125_ = comment;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp126_ = g_strdup (_tmp125_);
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp124_->comment);
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp124_->comment = _tmp126_;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp127_ = params->thumbnails;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp127_ != NULL) {
#line 10309 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp128_;
		BackingPhotoRow* _tmp129_;
		PhotoFileFormat _tmp130_;
		PhotoRow* _tmp131_;
		BackingPhotoRow* _tmp132_;
		const gchar* _tmp133_;
		PhotoFileReader* _tmp134_;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp128_ = params->row;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp129_ = _tmp128_->master;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp130_ = _tmp129_->file_format;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp131_ = params->row;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp132_ = _tmp131_->master;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp133_ = _tmp132_->filepath;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp134_ = photo_file_format_create_reader (_tmp130_, _tmp133_);
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		reader = _tmp134_;
#line 10334 "Photo.c"
		{
			Thumbnails* _tmp135_;
			PhotoFileReader* _tmp136_;
			PhotoRow* _tmp137_;
			Orientation _tmp138_;
			PhotoRow* _tmp139_;
			BackingPhotoRow* _tmp140_;
			Dimensions _tmp141_;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp135_ = params->thumbnails;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp136_ = reader;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp137_ = params->row;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp138_ = _tmp137_->orientation;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp139_ = params->row;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp140_ = _tmp139_->master;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp141_ = _tmp140_->dim;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp135_, _tmp136_, _tmp138_, &_tmp141_, &_inner_error_);
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10361 "Photo.c"
				goto __catch156_g_error;
			}
		}
		goto __finally156;
		__catch156_g_error:
		{
			GError* err = NULL;
			GError* _tmp142_;
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp142_ = err;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = import_result_convert_error (_tmp142_, IMPORT_RESULT_FILE_ERROR);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 10396 "Photo.c"
		}
		__finally156:
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return 0;
#line 10421 "Photo.c"
		}
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 10425 "Photo.c"
	}
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (comment);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (title);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 10443 "Photo.c"
}


void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp29_;
	PhotoFileSnifferOptions _tmp30_;
	PhotoFileInterrogator* _tmp31_;
	GError * _inner_error_ = NULL;
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (params != NULL);
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = params->file;
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp1_;
#line 1179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = params->row;
#line 1179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = params->row;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = params->row;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = params->row;
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = params->row;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_->timestamp = (time_t) 0;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = params->row;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_->exposure_time = (time_t) 0;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = params->row;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = params->row;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = params->row;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = params->row;
#line 1188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = params->row;
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = params->row;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = params->row;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = params->row;
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = params->row;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_->time_created = (time_t) 0;
#line 1194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = params->row;
#line 1194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = params->row;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = params->row;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_->title = NULL;
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = params->row;
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp28_->comment);
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_->comment = NULL;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = params->file;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = params->sniffer_options;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = photo_file_interrogator_new (_tmp29_, _tmp30_);
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp31_;
#line 10607 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp32_;
		DetectedPhotoInformation* _tmp33_;
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10616 "Photo.c"
			goto __catch157_g_error;
		}
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		detected = _tmp32_;
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = detected;
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp33_ != NULL) {
#line 10627 "Photo.c"
			PhotoRow* _tmp34_;
			BackingPhotoRow* _tmp35_;
			DetectedPhotoInformation* _tmp36_;
			PhotoFileFormat _tmp37_;
			MetadataDateTime* date_time = NULL;
			DetectedPhotoInformation* _tmp38_;
			PhotoMetadata* _tmp39_;
			MetadataDateTime* _tmp40_;
			MetadataDateTime* _tmp41_;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = params->row;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = _tmp34_->master;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = detected;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp36_->file_format;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_->file_format = _tmp37_;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = detected;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = _tmp38_->metadata;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = photo_metadata_get_exposure_date_time (_tmp39_);
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			date_time = _tmp40_;
#line 1206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = date_time;
#line 1206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp41_ != NULL) {
#line 10659 "Photo.c"
				PhotoRow* _tmp42_;
				MetadataDateTime* _tmp43_;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = params->row;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = date_time;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_->exposure_time = metadata_date_time_get_timestamp (_tmp43_);
#line 10668 "Photo.c"
			}
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 10672 "Photo.c"
		}
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 10676 "Photo.c"
	}
	goto __finally157;
	__catch157_g_error:
	{
		GError* err = NULL;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = g_file_get_path (file);
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = err;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = _tmp46_->message;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_debug ("Photo.vala:1210: Unable to interrogate photo file %s: %s", _tmp45_, _tmp47_);
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp45_);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 10704 "Photo.c"
	}
	__finally157:
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 10719 "Photo.c"
	}
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 10725 "Photo.c"
}


BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation* * detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	DetectedPhotoInformation* _tmp12_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	BackingPhotoRow* _tmp17_;
	gchar* _tmp18_;
	BackingPhotoRow* _tmp19_;
	GTimeVal _tmp20_;
	glong _tmp21_;
	BackingPhotoRow* _tmp22_;
	GFileInfo* _tmp23_;
	BackingPhotoRow* _tmp24_;
	DetectedPhotoInformation* _tmp25_;
	PhotoFileFormat _tmp26_;
	BackingPhotoRow* _tmp27_;
	DetectedPhotoInformation* _tmp28_;
	Dimensions _tmp29_;
	Orientation _tmp30_ = 0;
	DetectedPhotoInformation* _tmp31_;
	PhotoMetadata* _tmp32_;
	BackingPhotoRow* _tmp35_;
	GError * _inner_error_ = NULL;
#line 1214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = NULL;
#line 1218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp0_;
#line 1220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 10782 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10793 "Photo.c"
			goto __catch158_g_error;
		}
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp3_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 10806 "Photo.c"
	}
	goto __finally158;
	__catch158_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = err;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:1225: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 10844 "Photo.c"
		} else {
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10848 "Photo.c"
		}
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10852 "Photo.c"
	}
	__finally158:
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 10865 "Photo.c"
	}
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp8_;
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = interrogator;
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error_);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 10887 "Photo.c"
	}
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = interrogator;
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _vala_detected;
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 10901 "Photo.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = data_object_to_string ((DataObject*) self);
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:1235: Photo update: %s no longer a recognized image", _tmp14_);
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 10924 "Photo.c"
		} else {
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10928 "Photo.c"
		}
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10932 "Photo.c"
	}
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = info;
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification_time = _tmp16_;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = backing;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = g_file_get_path (file);
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp17_->filepath);
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_->filepath = _tmp18_;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = backing;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = modification_time;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_.tv_sec;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_->timestamp = (time_t) _tmp21_;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = backing;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = info;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_->filesize = g_file_info_get_size (_tmp23_);
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = backing;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = _vala_detected;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_->file_format;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_->file_format = _tmp26_;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = backing;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _vala_detected;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = _tmp28_->image_dim;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_->dim = _tmp29_;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _vala_detected;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_->metadata;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 10984 "Photo.c"
		DetectedPhotoInformation* _tmp33_;
		PhotoMetadata* _tmp34_;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = _vala_detected;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = _tmp33_->metadata;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = photo_metadata_get_orientation (_tmp34_);
#line 10993 "Photo.c"
	} else {
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = ORIENTATION_TOP_LEFT;
#line 10997 "Photo.c"
	}
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = backing;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_->original_orientation = _tmp30_;
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = backing;
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (detected) {
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*detected = _vala_detected;
#line 11013 "Photo.c"
	} else {
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11017 "Photo.c"
	}
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 11021 "Photo.c"
}


static void
_vala_array_add94 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11037 "Photo.c"
	}
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11043 "Photo.c"
}


static void
_vala_array_add95 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11059 "Photo.c"
	}
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11065 "Photo.c"
}


static void
_vala_array_add96 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11081 "Photo.c"
	}
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11087 "Photo.c"
}


static void
_vala_array_add97 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11103 "Photo.c"
	}
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11109 "Photo.c"
}


static void
_vala_array_add98 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11125 "Photo.c"
	}
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11131 "Photo.c"
}


static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 11140 "Photo.c"
}


gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState* * reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	GdkColorspace _tmp15_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp23_;
	gchar** list = NULL;
	gchar** _tmp29_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow* _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	BackingPhotoRow* _tmp39_;
	Orientation _tmp40_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	PhotoRow* _tmp77_;
	BackingPhotoRow* _tmp78_;
	BackingPhotoRow* _tmp79_;
	PhotoRow* _tmp80_;
	DetectedPhotoInformation* _tmp81_;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	PhotoRow* _tmp84_;
	DetectedPhotoInformation* _tmp85_;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	PhotoRow* _tmp88_;
	DetectedPhotoInformation* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp92_;
	PhotoMetadata* _tmp93_;
	PhotoRow* _tmp115_;
	PhotoMetadata* _tmp116_;
	gchar** _tmp117_;
	gint _tmp117__length1;
	PhotoReimportMasterStateImpl* _tmp118_;
	GError * _inner_error_ = NULL;
#line 1314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = file;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error_);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp5_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp6_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11237 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 11247 "Photo.c"
	}
#line 1322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = backing;
#line 1322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 11253 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = file;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1323: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (reimport_state) {
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11279 "Photo.c"
		} else {
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11283 "Photo.c"
		}
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11287 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = detected;
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = TRUE;
#line 11297 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
		gint _tmp17_;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = detected;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_->channels;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp17_ < 3;
#line 11307 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_) {
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = TRUE;
#line 11313 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_;
		gint _tmp19_;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = detected;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp19_ != 8;
#line 11323 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_) {
#line 11327 "Photo.c"
		GFile* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = file;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1331: Not re-importing %s: Unsupported color format", _tmp22_);
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp22_);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (reimport_state) {
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11353 "Photo.c"
		} else {
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11357 "Photo.c"
		}
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11361 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_row_new ();
#line 1337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	updated_row = _tmp23_;
#line 11367 "Photo.c"
	{
		PhotoRow* _tmp24_;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = self->row;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11374 "Photo.c"
		{
			PhotoRow* _tmp25_;
			PhotoRow* _tmp26_;
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = self->row;
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = _photo_row_ref0 (_tmp25_);
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			updated_row = _tmp26_;
#line 11386 "Photo.c"
		}
		__finally159:
		{
			PhotoRow* _tmp27_;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = self->row;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11395 "Photo.c"
		}
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11399 "Photo.c"
			gboolean _tmp28_ = FALSE;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp28_;
#line 11413 "Photo.c"
		}
	}
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp29_;
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list_length1 = 0;
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_list_size_ = list_length1;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = updated_row;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = detected;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 11434 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = list;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add94 (&list, &list_length1, &_list_size_, _tmp35_);
#line 11446 "Photo.c"
	}
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = updated_row;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = backing;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 11460 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		PhotoRow* _tmp43_;
		BackingPhotoRow* _tmp44_;
		BackingPhotoRow* _tmp45_;
		Orientation _tmp46_;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = list;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add95 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = updated_row;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = backing;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 11486 "Photo.c"
	}
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = detected;
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 11494 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_;
		PhotoRow* _tmp59_;
		const gchar* _tmp60_;
		DetectedPhotoInformation* _tmp61_;
		PhotoMetadata* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gboolean _tmp65_;
		PhotoRow* _tmp68_;
		const gchar* _tmp69_;
		DetectedPhotoInformation* _tmp70_;
		PhotoMetadata* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		gboolean _tmp74_;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = detected;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp51_;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = date_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 11527 "Photo.c"
			PhotoRow* _tmp54_;
			time_t _tmp55_;
			MetadataDateTime* _tmp56_;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = updated_row;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = date_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = _tmp55_ != metadata_date_time_get_timestamp (_tmp56_);
#line 11539 "Photo.c"
		} else {
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = FALSE;
#line 11543 "Photo.c"
		}
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp52_) {
#line 11547 "Photo.c"
			gchar** _tmp57_;
			gint _tmp57__length1;
			gchar* _tmp58_;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57_ = list;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57__length1 = list_length1;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58_ = g_strdup ("metadata:exposure-time");
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add96 (&list, &list_length1, &_list_size_, _tmp58_);
#line 11559 "Photo.c"
		}
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = updated_row;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = _tmp59_->title;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = detected;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = _tmp61_->metadata;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = media_metadata_get_title ((MediaMetadata*) _tmp62_);
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = g_strcmp0 (_tmp60_, _tmp64_) != 0;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp64_);
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp65_) {
#line 11579 "Photo.c"
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar* _tmp67_;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp66_ = list;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp66__length1 = list_length1;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = g_strdup ("metadata:name");
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add97 (&list, &list_length1, &_list_size_, _tmp67_);
#line 11591 "Photo.c"
		}
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp68_ = updated_row;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = _tmp68_->comment;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = detected;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = _tmp70_->metadata;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = media_metadata_get_comment ((MediaMetadata*) _tmp71_);
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = g_strcmp0 (_tmp69_, _tmp73_) != 0;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp73_);
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp74_) {
#line 11611 "Photo.c"
			gchar** _tmp75_;
			gint _tmp75__length1;
			gchar* _tmp76_;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp75_ = list;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp75__length1 = list_length1;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = g_strdup ("metadata:comment");
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add98 (&list, &list_length1, &_list_size_, _tmp76_);
#line 11623 "Photo.c"
		}
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11627 "Photo.c"
	}
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp77_ = updated_row;
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_ = backing;
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp77_->master);
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp77_->master = _tmp79_;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp80_ = updated_row;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_ = detected;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = _tmp81_->md5;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp83_ = g_strdup (_tmp82_);
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp80_->md5);
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp80_->md5 = _tmp83_;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = updated_row;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = detected;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_ = _tmp85_->exif_md5;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = g_strdup (_tmp86_);
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp84_->exif_md5);
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_->exif_md5 = _tmp87_;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = updated_row;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = detected;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = _tmp89_->thumbnail_md5;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp91_ = g_strdup (_tmp90_);
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp88_->thumbnail_md5);
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_->thumbnail_md5 = _tmp91_;
#line 1370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = NULL;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_ = detected;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = _tmp92_->metadata;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp93_ != NULL) {
#line 11683 "Photo.c"
		DetectedPhotoInformation* _tmp94_;
		PhotoMetadata* _tmp95_;
		PhotoMetadata* _tmp96_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp97_;
		PhotoMetadata* _tmp98_;
		MetadataDateTime* _tmp99_;
		MetadataDateTime* _tmp100_;
		PhotoRow* _tmp103_;
		DetectedPhotoInformation* _tmp104_;
		PhotoMetadata* _tmp105_;
		gchar* _tmp106_;
		PhotoRow* _tmp107_;
		DetectedPhotoInformation* _tmp108_;
		PhotoMetadata* _tmp109_;
		gchar* _tmp110_;
		PhotoRow* _tmp111_;
		DetectedPhotoInformation* _tmp112_;
		PhotoMetadata* _tmp113_;
		gchar* _tmp114_;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp94_ = detected;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp95_ = _tmp94_->metadata;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp96_ = _media_metadata_ref0 (_tmp95_);
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp96_;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp97_ = detected;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98_ = _tmp97_->metadata;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp99_ = photo_metadata_get_exposure_date_time (_tmp98_);
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp99_;
#line 1375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = date_time;
#line 1375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp100_ != NULL) {
#line 11726 "Photo.c"
			PhotoRow* _tmp101_;
			MetadataDateTime* _tmp102_;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp101_ = updated_row;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp102_ = date_time;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp101_->exposure_time = metadata_date_time_get_timestamp (_tmp102_);
#line 11735 "Photo.c"
		}
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp103_ = updated_row;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp104_ = detected;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_ = _tmp104_->metadata;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp106_ = media_metadata_get_title ((MediaMetadata*) _tmp105_);
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp103_->title);
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp103_->title = _tmp106_;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp107_ = updated_row;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp108_ = detected;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp109_ = _tmp108_->metadata;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp110_ = media_metadata_get_comment ((MediaMetadata*) _tmp109_);
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp107_->comment);
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp107_->comment = _tmp110_;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp111_ = updated_row;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp112_ = detected;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp113_ = _tmp112_->metadata;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp114_ = media_metadata_get_comment ((MediaMetadata*) _tmp113_);
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp111_->comment);
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp111_->comment = _tmp114_;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11775 "Photo.c"
	}
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp115_ = updated_row;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp116_ = metadata;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp117_ = list;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp117__length1 = list_length1;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp118_ = photo_reimport_master_state_impl_new (_tmp115_, _tmp116_, _tmp117_, _tmp117__length1);
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_reimport_state = (PhotoReimportMasterState*) _tmp118_;
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (reimport_state) {
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 11809 "Photo.c"
	} else {
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11813 "Photo.c"
	}
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 11817 "Photo.c"
}


static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 11829 "Photo.c"
}


void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 11841 "Photo.c"
}


static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 11850 "Photo.c"
}


static void
_vala_array_add99 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11866 "Photo.c"
	}
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11872 "Photo.c"
}


static void
_vala_array_add100 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11888 "Photo.c"
	}
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11894 "Photo.c"
}


void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp19_;
	gboolean _tmp21_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	PhotoMetadata* _tmp30_;
	GError * _inner_error_ = NULL;
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp0_;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 11942 "Photo.c"
		} else {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 11952 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->row;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11961 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
			gboolean _tmp17_;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original_master = _tmp7_;
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->row = _tmp9_;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->row;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = original_master;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = reimport_state->metadata_only;
#line 1402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp17_) {
#line 1403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 12019 "Photo.c"
			}
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 12023 "Photo.c"
		}
		__finally160:
		{
			PhotoRow* _tmp18_;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = self->row;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12032 "Photo.c"
		}
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12044 "Photo.c"
			} else {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12054 "Photo.c"
			}
		}
	}
#line 1406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = reimport_state->metadata;
#line 1406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 12062 "Photo.c"
		PhotoMetadata* _tmp20_;
#line 1407 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = reimport_state->metadata;
#line 1407 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp20_);
#line 12068 "Photo.c"
	}
#line 1409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = reimport_state->metadata_only;
#line 1409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp21_) {
#line 12074 "Photo.c"
		gchar** _tmp22_;
		gint _tmp22__length1;
		gchar* _tmp23_;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = reimport_state->alterations;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22__length1 = reimport_state->alterations_length1;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = g_strdup ("image:master");
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add99 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp23_);
#line 1411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 12088 "Photo.c"
			gchar** _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp25_;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = reimport_state->alterations;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24__length1 = reimport_state->alterations_length1;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = g_strdup ("image:baseline");
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add100 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp25_);
#line 12100 "Photo.c"
		}
	}
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = reimport_state->alterations;
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26__length1 = reimport_state->alterations_length1;
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp26__length1 > 0) {
#line 12109 "Photo.c"
		gchar** _tmp27_;
		gint _tmp27__length1;
		Alteration* _tmp28_;
		Alteration* _tmp29_;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = reimport_state->alterations;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27__length1 = reimport_state->alterations_length1;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = alteration_new_from_array (_tmp27_, _tmp27__length1);
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp29_);
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp29_);
#line 12126 "Photo.c"
	}
#line 1418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = reimport_state->metadata;
#line 1418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp30_);
#line 1420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 12134 "Photo.c"
		PhotoMetadata* _tmp31_;
#line 1421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = reimport_state->metadata;
#line 1421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp31_);
#line 12140 "Photo.c"
	}
#line 1423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 12144 "Photo.c"
		PhotoMetadata* _tmp32_;
#line 1424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = reimport_state->metadata;
#line 1424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp32_);
#line 12150 "Photo.c"
	}
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 12154 "Photo.c"
}


static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow* * backing,
                                DetectedPhotoInformation* * detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GdkColorspace _tmp9_;
	GError * _inner_error_ = NULL;
#line 1428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error_);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12192 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp3_;
#line 12198 "Photo.c"
	}
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (backing) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*backing = _vala_backing;
#line 12220 "Photo.c"
		} else {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12224 "Photo.c"
		}
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 12230 "Photo.c"
		} else {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12234 "Photo.c"
		}
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12238 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_->colorspace;
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ != GDK_COLORSPACE_RGB) {
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = TRUE;
#line 12248 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
		gint _tmp11_;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_->channels;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp11_ < 3;
#line 12258 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_) {
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = TRUE;
#line 12264 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_;
		gint _tmp13_;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp13_ != 8;
#line 12274 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 12278 "Photo.c"
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = g_file_get_path (file);
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1440: Not re-importing %s: Unsupported color format", _tmp15_);
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp15_);
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (backing) {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*backing = _vala_backing;
#line 12297 "Photo.c"
		} else {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12301 "Photo.c"
		}
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 12307 "Photo.c"
		} else {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12311 "Photo.c"
		}
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12315 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (backing) {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*backing = _vala_backing;
#line 12325 "Photo.c"
	} else {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 12329 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (detected) {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*detected = _vala_detected;
#line 12335 "Photo.c"
	} else {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 12339 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12343 "Photo.c"
}


gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* * state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError * _inner_error_ = NULL;
#line 1449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 1452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp0_;
#line 1453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 1453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 12391 "Photo.c"
		} else {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 12395 "Photo.c"
		}
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12399 "Photo.c"
	}
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp4_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp5_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12417 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 12429 "Photo.c"
	}
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp2_) {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 12445 "Photo.c"
		} else {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 12449 "Photo.c"
		}
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12453 "Photo.c"
	}
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = backing;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = detected;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = (PhotoReimportEditableState*) _tmp11_;
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 12479 "Photo.c"
	} else {
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 12483 "Photo.c"
	}
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12487 "Photo.c"
}


static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 12496 "Photo.c"
}


void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	gboolean _tmp3_;
	PhotoReimportEditableStateImpl* _tmp19_;
	PhotoMetadata* _tmp20_;
	gchar* list = NULL;
	gchar* _tmp31_;
	PhotoReimportEditableStateImpl* _tmp32_;
	gboolean _tmp33_;
	const gchar* _tmp36_;
	Alteration* _tmp37_;
	Alteration* _tmp38_;
	PhotoReimportEditableStateImpl* _tmp39_;
	PhotoMetadata* _tmp40_;
	GError * _inner_error_ = NULL;
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_id = _tmp0_;
#line 1469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 12535 "Photo.c"
	}
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_->metadata_only;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 12547 "Photo.c"
		BackingPhotoTable* _tmp4_;
		BackingPhotoTable* _tmp5_;
		PhotoReimportEditableStateImpl* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = backing_photo_table_get_instance ();
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = reimport_state;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_->backing_state;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_table_update (_tmp5_, _tmp7_, &_inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp5_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12574 "Photo.c"
			} else {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12584 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp8_;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 12593 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp9_;
				BackingPhotoRow* _tmp10_;
				BackingPhotoRow* _tmp11_;
				PhotoReimportEditableStateImpl* _tmp12_;
				BackingPhotoRow* _tmp13_;
				Orientation _tmp14_;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = reimport_state;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->backing_state;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _backing_photo_row_ref0 (_tmp10_);
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->editable = _tmp11_;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = reimport_state;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_->backing_state;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = _tmp13_->original_orientation;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_set_orientation (self, _tmp14_);
#line 1480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 12621 "Photo.c"
			}
			__finally161:
			{
				PhotoRow* _tmp15_;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->row;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12630 "Photo.c"
			}
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 12642 "Photo.c"
				} else {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 12652 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp16_;
		BackingPhotoRow* _tmp17_;
		Orientation _tmp18_;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = reimport_state;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_->backing_state;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp17_->original_orientation;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_orientation (self, _tmp18_);
#line 12668 "Photo.c"
	}
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = reimport_state;
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _tmp19_->metadata;
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 12676 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp21_;
		PhotoMetadata* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		PhotoReimportEditableStateImpl* _tmp25_;
		PhotoMetadata* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		PhotoReimportEditableStateImpl* _tmp29_;
		PhotoMetadata* _tmp30_;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = reimport_state;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp21_->metadata;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = media_metadata_get_title ((MediaMetadata*) _tmp22_);
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp24_);
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp24_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = reimport_state;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = media_metadata_get_comment ((MediaMetadata*) _tmp26_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp28_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp28_);
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = reimport_state;
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = _tmp29_->metadata;
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp30_);
#line 12717 "Photo.c"
	}
#line 1492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp31_;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = reimport_state;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_->metadata_only;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp33_) {
#line 12729 "Photo.c"
		const gchar* _tmp34_;
		gchar* _tmp35_;
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = list;
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = g_strconcat (_tmp34_, "image:editable,image:baseline", NULL);
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (list);
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		list = _tmp35_;
#line 12740 "Photo.c"
	}
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = list;
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = alteration_new_from_list (_tmp36_);
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_;
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp38_);
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp38_);
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = reimport_state;
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_->metadata;
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp40_);
#line 1500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 12760 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp41_;
		PhotoMetadata* _tmp42_;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = reimport_state;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = _tmp41_->metadata;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp42_);
#line 12769 "Photo.c"
	}
#line 1503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 12773 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp43_;
		PhotoMetadata* _tmp44_;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = reimport_state;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_->metadata;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp44_);
#line 12782 "Photo.c"
	}
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (list);
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 12788 "Photo.c"
}


static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 12797 "Photo.c"
}


gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* * state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError * _inner_error_ = NULL;
#line 1508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 1511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = _tmp0_;
#line 1512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = files;
#line 1512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (files);
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 12839 "Photo.c"
		} else {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12843 "Photo.c"
		}
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12847 "Photo.c"
	}
#line 1515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12853 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = files;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_file_it = _tmp4_;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 12866 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 12888 "Photo.c"
			}
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _file_it;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = file;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error_);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = _tmp10_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			detected = _tmp11_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12912 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (files);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp13_;
#line 12930 "Photo.c"
			}
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp8_) {
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				continue;
#line 12942 "Photo.c"
			}
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = backing;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = detected;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 12960 "Photo.c"
		}
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 12964 "Photo.c"
	}
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 ((PhotoReimportRawDevelopmentState*) _tmp18_);
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp19_;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (files);
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 12986 "Photo.c"
	} else {
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12990 "Photo.c"
	}
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12994 "Photo.c"
}


void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp29_;
	PhotoReimportRawDevelopmentStateImpl* _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp34_;
	Alteration* _tmp35_;
	Alteration* _tmp36_;
	GError * _inner_error_ = NULL;
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 13021 "Photo.c"
	}
#line 1535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp0_;
#line 13027 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_dev_it = _tmp3_;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 13043 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
			gboolean _tmp8_;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 13056 "Photo.c"
			}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->metadata_only;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp8_) {
#line 13070 "Photo.c"
				BackingPhotoTable* _tmp9_;
				BackingPhotoTable* _tmp10_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = backing_photo_table_get_instance ();
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = dev;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->backing;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_update (_tmp10_, _tmp12_, &_inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 13101 "Photo.c"
					} else {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 13115 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp13_;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = self->row;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 13124 "Photo.c"
					{
						gint _tmp14_;
						RawDeveloper* _tmp15_;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = raw_developer_as_array (&_tmp14_);
#line 13130 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection = _tmp15_;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection_length1 = _tmp14_;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							for (d_it = 0; d_it < _tmp14_; d_it = d_it + 1) {
#line 13142 "Photo.c"
								RawDeveloper d = 0;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								d = d_collection[d_it];
#line 13146 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp16_;
									BackingPhotoID* _tmp17_;
									gint _tmp17__length1;
									RawDeveloper _tmp18_;
									BackingPhotoID _tmp19_;
									BackingPhotoID _tmp20_;
									gint64 _tmp21_;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp16_ = self->row;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp17_ = _tmp16_->development_ids;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp17__length1 = _tmp16_->development_ids_length1;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp18_ = d;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp19_ = _tmp17_[_tmp18_];
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									id = _tmp19_;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp20_ = id;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp21_ = _tmp20_.id;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									if (_tmp21_ != BACKING_PHOTO_ID_INVALID) {
#line 13174 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp22_;
										BackingPhotoRow* _tmp23_;
										BackingPhotoRow* _tmp24_;
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp22_ = id;
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp23_ = photo_get_backing_row (self, &_tmp22_);
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										bpr = _tmp23_;
#line 1547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp24_ = bpr;
#line 1547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										if (_tmp24_ != NULL) {
#line 13189 "Photo.c"
											GeeHashMap* _tmp25_;
											RawDeveloper _tmp26_;
											BackingPhotoRow* _tmp27_;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp25_ = self->priv->developments;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp26_ = d;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp27_ = bpr;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, (gpointer) ((gintptr) _tmp26_), _tmp27_);
#line 13201 "Photo.c"
										}
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 13205 "Photo.c"
									}
								}
							}
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 13211 "Photo.c"
						}
					}
					__finally162:
					{
						PhotoRow* _tmp28_;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = self->row;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13221 "Photo.c"
					}
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_propagate_error (error, _inner_error_);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							return;
#line 13237 "Photo.c"
						} else {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_clear_error (&_inner_error_);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							return;
#line 13251 "Photo.c"
						}
					}
				}
			}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 13258 "Photo.c"
		}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 13262 "Photo.c"
	}
#line 1555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp29_;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = reimport_state;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_->metadata_only;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp31_) {
#line 13274 "Photo.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = list;
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = g_strconcat (_tmp32_, "image:editable,image:baseline", NULL);
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (list);
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		list = _tmp33_;
#line 13285 "Photo.c"
	}
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = list;
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = alteration_new_from_list (_tmp34_);
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp36_);
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp36_);
#line 1561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (list);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 13303 "Photo.c"
}


static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13321 "Photo.c"
}


static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13342 "Photo.c"
}


static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_source_get_typename ((DataSource*) self);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id ((DataSource*) self));
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13371 "Photo.c"
}


void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	GError * _inner_error_ = NULL;
#line 1580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification = _tmp0_;
#line 13390 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13398 "Photo.c"
			{
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				time_t _tmp4_;
				GTimeVal _tmp5_;
				glong _tmp6_;
				PhotoTable* _tmp8_;
				PhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				PhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				PhotoRow* _tmp14_;
				BackingPhotoRow* _tmp15_;
				GTimeVal _tmp16_;
				glong _tmp17_;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = self->row;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->timestamp;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = modification;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_.tv_sec;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp4_ == ((time_t) _tmp6_)) {
#line 13427 "Photo.c"
					{
						PhotoRow* _tmp7_;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp7_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13434 "Photo.c"
					}
#line 1586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 13438 "Photo.c"
				}
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->row;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_->photo_id;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = modification;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error_);
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13458 "Photo.c"
					goto __finally164;
				}
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp14_->master;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = modification;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = _tmp16_.tv_sec;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_->timestamp = (time_t) _tmp17_;
#line 13471 "Photo.c"
			}
			__finally164:
			{
				PhotoRow* _tmp18_;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13480 "Photo.c"
			}
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13486 "Photo.c"
					goto __catch163_database_error;
				}
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 13495 "Photo.c"
			}
		}
	}
	goto __finally163;
	__catch163_database_error:
	{
		GError* err = NULL;
		GError* _tmp19_;
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = err;
#line 1592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp19_);
#line 1594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 13516 "Photo.c"
	}
	__finally163:
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 13527 "Photo.c"
	}
#line 1597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 13531 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp21_);
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 13542 "Photo.c"
	} else {
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = alteration_new ("metadata", "master-timestamp");
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp23_);
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 13554 "Photo.c"
	}
}


void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered = FALSE;
	gboolean _tmp18_;
	GError * _inner_error_ = NULL;
#line 1604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification = _tmp0_;
#line 1607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 13579 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13586 "Photo.c"
		{
			gboolean _tmp2_ = FALSE;
			PhotoRow* _tmp3_;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp3_->editable_id)) {
#line 13594 "Photo.c"
				BackingPhotoRow* _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->editable;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = modification;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp5_ != ((time_t) _tmp7_);
#line 13609 "Photo.c"
			} else {
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = FALSE;
#line 13613 "Photo.c"
			}
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_) {
#line 13617 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				BackingPhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				BackingPhotoRow* _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->row;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_->editable_id;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = modification;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error_);
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13645 "Photo.c"
					goto __finally165;
				}
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->priv->editable;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = modification;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_->timestamp = (time_t) _tmp16_;
#line 1613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered = TRUE;
#line 13658 "Photo.c"
			}
		}
		__finally165:
		{
			PhotoRow* _tmp17_;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->row;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13668 "Photo.c"
		}
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 13678 "Photo.c"
			} else {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 13686 "Photo.c"
			}
		}
	}
#line 1617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = altered;
#line 1617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 13694 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp20_);
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 13705 "Photo.c"
	}
}


void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError * _inner_error_ = NULL;
#line 1622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 13719 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp4_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 13743 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 13758 "Photo.c"
			}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 13790 "Photo.c"
				} else {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 13802 "Photo.c"
				}
			}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 13807 "Photo.c"
		}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 13811 "Photo.c"
	}
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 13823 "Photo.c"
		} else {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 13831 "Photo.c"
		}
	}
}


static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
#line 1630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 13849 "Photo.c"
	} else {
#line 1632 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 13853 "Photo.c"
	}
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13859 "Photo.c"
}


static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 1635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf ((PhotoSource*) self, &_tmp1_, &_inner_error_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 13889 "Photo.c"
	}
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13901 "Photo.c"
}


gboolean
photo_is_file_image (GFile* file)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 13916 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp2_);
#line 13928 "Photo.c"
	}
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13934 "Photo.c"
}


gboolean
photo_can_write_file (Photo* self)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* file_info = NULL;
	GFileInfo* _tmp11_;
	GError * _inner_error_ = NULL;
#line 1647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->master;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_->filepath;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 13962 "Photo.c"
	{
		GFileInfo* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = file;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp6_;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13976 "Photo.c"
			goto __catch166_g_error;
		}
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp4_;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = NULL;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		file_info = _tmp7_;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 13989 "Photo.c"
	}
	goto __finally166;
	__catch166_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _inner_error_;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = e;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1653: Error while testing if file is writeable: %s\n", _tmp9_);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (e);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 14017 "Photo.c"
	}
	__finally166:
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 14022 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 14034 "Photo.c"
	}
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = file_info;
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = g_file_info_get_attribute_boolean (_tmp11_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file_info);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14046 "Photo.c"
}


static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          int extensions_length1)
{
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 1660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name = _tmp0_;
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp1_;
#line 1663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = ext;
#line 1663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (name);
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 14087 "Photo.c"
	}
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = ext;
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp4_;
#line 14097 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		extension_collection = extensions;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		for (extension_it = 0; extension_it < extensions_length1; extension_it = extension_it + 1) {
#line 14109 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			extension = _tmp5_;
#line 14116 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = ext;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = extension;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (extension);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (ext);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (name);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 14136 "Photo.c"
				}
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (extension);
#line 14140 "Photo.c"
			}
		}
	}
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14152 "Photo.c"
}


gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14178 "Photo.c"
}


PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         int* result_length1)
{
	PhotoID* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 14218 "Photo.c"
	}
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp5_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14224 "Photo.c"
}


gint64
photo_get_photo_key (DataSource* source)
{
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, 0LL);
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), &_tmp0_);
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14244 "Photo.c"
}


static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14273 "Photo.c"
}


static void
_vala_array_add101 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14289 "Photo.c"
	}
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14295 "Photo.c"
}


static void
_vala_array_add102 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14311 "Photo.c"
	}
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14317 "Photo.c"
}


static void
_vala_array_add103 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14333 "Photo.c"
	}
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14339 "Photo.c"
}


static void
_vala_array_add104 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14355 "Photo.c"
	}
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14361 "Photo.c"
}


void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp33_;
	GError * _inner_error_ = NULL;
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filepath = _tmp0_;
#line 1728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 1729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_baseline = FALSE;
#line 1730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_source = FALSE;
#line 1731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name_changed = FALSE;
#line 1732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_file = NULL;
#line 14396 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14404 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14412 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						old_file = _tmp5_;
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp6_ = old_file;
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 14432 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							PhotoFileFormat _tmp19_;
							const gchar* _tmp20_;
							PhotoFileReader* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PhotoRow* _tmp23_;
							const gchar* _tmp24_;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp10_ = filepath;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 14465 "Photo.c"
								goto __finally169;
							}
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp11_ = self->row;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp13_ = filepath;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = self->row;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = _tmp18_->file_format;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = filepath;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = photo_file_format_create_reader (_tmp19_, _tmp20_);
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_->master = _tmp21_;
#line 1744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							altered = TRUE;
#line 1745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = self->row;
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = _tmp23_->title;
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (is_string_empty (_tmp24_)) {
#line 14514 "Photo.c"
								GFile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp25_ = old_file;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp26_ = g_file_get_basename (_tmp25_);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp27_ = _tmp26_;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp28_ = g_file_get_basename (file);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp29_ = _tmp28_;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp22_ = g_strcmp0 (_tmp27_, _tmp29_) != 0;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_free0 (_tmp29_);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_free0 (_tmp27_);
#line 14536 "Photo.c"
							} else {
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp22_ = FALSE;
#line 14540 "Photo.c"
							}
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							name_changed = _tmp22_;
#line 14544 "Photo.c"
						}
					}
					__finally169:
					{
						PhotoBackingReaders* _tmp30_;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14554 "Photo.c"
					}
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 14558 "Photo.c"
						goto __finally168;
					}
				}
			}
			__finally168:
			{
				PhotoRow* _tmp31_;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = self->row;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14570 "Photo.c"
			}
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 14576 "Photo.c"
					goto __catch167_database_error;
				}
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (filepath);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 14589 "Photo.c"
			}
		}
	}
	goto __finally167;
	__catch167_database_error:
	{
		GError* err = NULL;
		GError* _tmp32_;
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = err;
#line 1753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp32_);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 14608 "Photo.c"
	}
	__finally167:
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (filepath);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 14623 "Photo.c"
	}
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = altered;
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp33_) {
#line 14629 "Photo.c"
		GFile* _tmp34_;
		gboolean _tmp35_;
		gchar** alteration_list = NULL;
		gchar** _tmp36_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		gchar* _tmp38_;
		gboolean _tmp39_;
		gboolean _tmp42_;
		gboolean _tmp45_;
		gchar** _tmp48_;
		gint _tmp48__length1;
		Alteration* _tmp49_;
		Alteration* _tmp50_;
#line 1757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = old_file;
#line 1757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_notify_master_replaced ((MediaSource*) self, _tmp34_, file);
#line 1759 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1759 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp35_) {
#line 1760 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14656 "Photo.c"
		}
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = g_new0 (gchar*, 0 + 1);
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = _tmp36_;
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = alteration_list;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37__length1 = alteration_list_length1;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = g_strdup ("backing:master");
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 1767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = name_changed;
#line 1767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp39_) {
#line 14678 "Photo.c"
			gchar** _tmp40_;
			gint _tmp40__length1;
			gchar* _tmp41_;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = alteration_list;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40__length1 = alteration_list_length1;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = g_strdup ("metadata:name");
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp41_);
#line 14690 "Photo.c"
		}
#line 1770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = is_source;
#line 1770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp42_) {
#line 14696 "Photo.c"
			gchar** _tmp43_;
			gint _tmp43__length1;
			gchar* _tmp44_;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = alteration_list;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43__length1 = alteration_list_length1;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = g_strdup ("backing:source");
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp44_);
#line 14708 "Photo.c"
		}
#line 1773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = is_baseline;
#line 1773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp45_) {
#line 14714 "Photo.c"
			gchar** _tmp46_;
			gint _tmp46__length1;
			gchar* _tmp47_;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp46_ = alteration_list;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp46__length1 = alteration_list_length1;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp47_ = g_strdup ("backing:baseline");
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
#line 14726 "Photo.c"
		}
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = alteration_list;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48__length1 = alteration_list_length1;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = alteration_new_from_array (_tmp48_, _tmp48__length1);
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp49_;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp50_);
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp50_);
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14742 "Photo.c"
	}
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (filepath);
#line 14748 "Photo.c"
}


static void
_vala_array_add105 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14764 "Photo.c"
	}
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14770 "Photo.c"
}


static void
_vala_array_add106 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14786 "Photo.c"
	}
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14792 "Photo.c"
}


static void
_vala_array_add107 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14808 "Photo.c"
	}
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14814 "Photo.c"
}


void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp29_;
	GError * _inner_error_ = NULL;
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filepath = _tmp0_;
#line 1785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 1786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_baseline = FALSE;
#line 1787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_source = FALSE;
#line 1788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_file = NULL;
#line 14846 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14854 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14862 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 14876 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp7_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 14890 "Photo.c"
						} else {
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp3_ = NULL;
#line 14896 "Photo.c"
						}
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						old_file = _tmp9_;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp11_ = old_file;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 14908 "Photo.c"
							GFile* _tmp12_;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp12_ = old_file;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 14914 "Photo.c"
						} else {
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp10_ = FALSE;
#line 14918 "Photo.c"
						}
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp10_) {
#line 14922 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_ = self->row;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = filepath;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error_);
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 14954 "Photo.c"
								goto __finally172;
							}
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = filepath;
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = filepath;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_->editable = _tmp25_;
#line 1799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							altered = TRUE;
#line 1800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 14987 "Photo.c"
						}
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 14991 "Photo.c"
					}
					__finally172:
					{
						PhotoBackingReaders* _tmp26_;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15000 "Photo.c"
					}
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 15004 "Photo.c"
						goto __finally171;
					}
				}
			}
			__finally171:
			{
				PhotoRow* _tmp27_;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = self->row;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15016 "Photo.c"
			}
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 15022 "Photo.c"
					goto __catch170_database_error;
				}
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (filepath);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 15035 "Photo.c"
			}
		}
	}
	goto __finally170;
	__catch170_database_error:
	{
		GError* err = NULL;
		GError* _tmp28_;
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = err;
#line 1806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp28_);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 15054 "Photo.c"
	}
	__finally170:
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (filepath);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15069 "Photo.c"
	}
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = altered;
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp29_) {
#line 15075 "Photo.c"
		GFile* _tmp30_;
		gboolean _tmp31_;
		gchar** alteration_list = NULL;
		gchar** _tmp32_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gboolean _tmp35_;
		gboolean _tmp38_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		Alteration* _tmp42_;
		Alteration* _tmp43_;
#line 1810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = old_file;
#line 1810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, file);
#line 1812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = is_baseline;
#line 1812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp31_) {
#line 1813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15101 "Photo.c"
		}
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = g_new0 (gchar*, 0 + 1);
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = _tmp32_;
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = alteration_list;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33__length1 = alteration_list_length1;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = g_strdup ("backing:editable");
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 1818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp35_) {
#line 15123 "Photo.c"
			gchar** _tmp36_;
			gint _tmp36__length1;
			gchar* _tmp37_;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = alteration_list;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36__length1 = alteration_list_length1;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = g_strdup ("backing:baseline");
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 15135 "Photo.c"
		}
#line 1821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = is_source;
#line 1821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp38_) {
#line 15141 "Photo.c"
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar* _tmp40_;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = alteration_list;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39__length1 = alteration_list_length1;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = g_strdup ("backing:source");
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 15153 "Photo.c"
		}
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = alteration_list;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41__length1 = alteration_list_length1;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = alteration_new_from_array (_tmp41_, _tmp41__length1);
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp43_);
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp43_);
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15169 "Photo.c"
	}
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (filepath);
#line 15175 "Photo.c"
}


void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError * _inner_error_ = NULL;
#line 1829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 1832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map_iter = _tmp0_;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	while (TRUE) {
#line 15196 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = map_iter;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 15210 "Photo.c"
		}
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = map_iter;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = map_iter;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 15230 "Photo.c"
	}
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15244 "Photo.c"
		} else {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15254 "Photo.c"
		}
	}
#line 1829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 15259 "Photo.c"
}


GFile*
photo_get_actual_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15287 "Photo.c"
}


static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15316 "Photo.c"
}


GFile*
photo_get_editable_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 15338 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = reader;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp3_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 15349 "Photo.c"
	} else {
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 15355 "Photo.c"
	}
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15363 "Photo.c"
}


GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError * _inner_error_ = NULL;
#line 1855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1856 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 15382 "Photo.c"
	}
#line 1859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = _tmp0_;
#line 15388 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15395 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_row_it = _tmp7_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				while (TRUE) {
#line 15423 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = _row_it;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						break;
#line 15439 "Photo.c"
					}
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = ret;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = row;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 15463 "Photo.c"
				}
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 15467 "Photo.c"
			}
		}
		__finally173:
		{
			PhotoRow* _tmp16_;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = self->row;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15477 "Photo.c"
		}
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 15489 "Photo.c"
		}
	}
#line 1865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (GeeCollection*) ret;
#line 1865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15496 "Photo.c"
}


GFile*
photo_get_source_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15524 "Photo.c"
}


PhotoFileFormat
photo_get_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15535 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15542 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 15552 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15559 "Photo.c"
			}
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15563 "Photo.c"
		}
		__finally174:
		{
			PhotoRow* _tmp4_;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15572 "Photo.c"
		}
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 15580 "Photo.c"
	}
}


PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_;
#line 1878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1879 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file_format;
#line 1880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write (_tmp0_)) {
#line 1881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 15601 "Photo.c"
	}
#line 1883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = file_format;
#line 1883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15607 "Photo.c"
}


PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15618 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15625 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 15635 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15642 "Photo.c"
			}
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15646 "Photo.c"
		}
		__finally175:
		{
			PhotoRow* _tmp4_;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15655 "Photo.c"
		}
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 15663 "Photo.c"
	}
}


static time_t
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 15676 "Photo.c"
	{
		PhotoRow* _tmp0_;
		time_t _tmp5_ = 0;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15684 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			time_t _tmp2_;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 15694 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15701 "Photo.c"
			}
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15705 "Photo.c"
		}
		__finally176:
		{
			PhotoRow* _tmp4_;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15714 "Photo.c"
		}
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 15722 "Photo.c"
	}
}


void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError * _inner_error_ = NULL;
#line 1898 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 15734 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15741 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15751 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15758 "Photo.c"
			}
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15762 "Photo.c"
		}
		__finally177:
		{
			PhotoRow* _tmp4_;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15771 "Photo.c"
		}
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15779 "Photo.c"
	}
}


static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1905 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp1_;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 15801 "Photo.c"
}


inline gint64
photo_get_raw_event_id (Photo* self)
{
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 1910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15824 "Photo.c"
}


static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 15836 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15843 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15853 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15860 "Photo.c"
			}
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15864 "Photo.c"
		}
		__finally178:
		{
			PhotoRow* _tmp4_;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15873 "Photo.c"
		}
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15881 "Photo.c"
	}
}


void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError * _inner_error_ = NULL;
#line 1920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 15893 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15900 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15910 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15917 "Photo.c"
			}
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15921 "Photo.c"
		}
		__finally179:
		{
			PhotoRow* _tmp4_;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15930 "Photo.c"
		}
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15938 "Photo.c"
	}
}


static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 15951 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15958 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 15971 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15978 "Photo.c"
			}
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15982 "Photo.c"
		}
		__finally180:
		{
			PhotoRow* _tmp5_;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15991 "Photo.c"
		}
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 15999 "Photo.c"
	}
}


guint64
photo_get_flags (Photo* self)
{
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 16011 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16019 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 16029 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16036 "Photo.c"
			}
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16040 "Photo.c"
		}
		__finally181:
		{
			PhotoRow* _tmp4_;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16049 "Photo.c"
		}
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 16057 "Photo.c"
	}
}


static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 1940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration = _tmp0_;
#line 1942 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (additional_alteration != NULL) {
#line 16077 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = alteration;
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration = _tmp2_;
#line 16088 "Photo.c"
	}
#line 1945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = alteration;
#line 1945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp3_);
#line 1940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 16096 "Photo.c"
}


guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 1948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 16111 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16118 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			gboolean _tmp4_;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = committed;
#line 1952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_) {
#line 16138 "Photo.c"
				PhotoRow* _tmp5_;
#line 1953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 1953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_->flags = flags;
#line 16144 "Photo.c"
			}
		}
		__finally182:
		{
			PhotoRow* _tmp6_;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16154 "Photo.c"
		}
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16158 "Photo.c"
			guint64 _tmp7_ = 0ULL;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp7_;
#line 16166 "Photo.c"
		}
	}
#line 1956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = committed;
#line 1956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 1957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16175 "Photo.c"
	}
#line 1959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 1959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16181 "Photo.c"
}


gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16193 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16201 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp2_, mask);
#line 16211 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16218 "Photo.c"
			}
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16222 "Photo.c"
		}
		__finally183:
		{
			PhotoRow* _tmp4_;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16231 "Photo.c"
		}
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 16239 "Photo.c"
	}
}


guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 1968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 1971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16260 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16267 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp2_, mask);
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = flags;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 16288 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = flags;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = committed;
#line 1976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 16310 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = flags;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 16319 "Photo.c"
				}
			}
		}
		__finally184:
		{
			PhotoRow* _tmp13_;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16330 "Photo.c"
		}
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16334 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 16342 "Photo.c"
		}
	}
#line 1981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = committed;
#line 1981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 1982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16351 "Photo.c"
	}
#line 1984 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 1984 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16357 "Photo.c"
}


guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 1987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 1990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16377 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16384 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp2_, mask);
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = flags;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 16405 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = flags;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = committed;
#line 1995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 16427 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = flags;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 16436 "Photo.c"
				}
			}
		}
		__finally185:
		{
			PhotoRow* _tmp13_;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16447 "Photo.c"
		}
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16451 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 16459 "Photo.c"
		}
	}
#line 2000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = committed;
#line 2000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 2001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16468 "Photo.c"
	}
#line 2003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16474 "Photo.c"
}


guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 2006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2007 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 2009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16495 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16502 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = (_tmp2_ | add) & (~remove);
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = flags;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 16523 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = flags;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = committed;
#line 2014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 16545 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = flags;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 16554 "Photo.c"
				}
			}
		}
		__finally186:
		{
			PhotoRow* _tmp13_;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16565 "Photo.c"
		}
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16569 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 16577 "Photo.c"
		}
	}
#line 2019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = committed;
#line 2019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 2020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16586 "Photo.c"
	}
#line 2022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16592 "Photo.c"
}


void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError * _inner_error_ = NULL;
#line 2028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 2030 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (add != NULL) {
#line 16610 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) add);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_it = _tmp0_;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 16620 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 16632 "Photo.c"
				}
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 16646 "Photo.c"
			}
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16650 "Photo.c"
		}
	}
#line 2035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (remove != NULL) {
#line 16655 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) remove);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_it = _tmp5_;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 16665 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 16677 "Photo.c"
				}
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 16691 "Photo.c"
			}
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16695 "Photo.c"
		}
	}
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16708 "Photo.c"
		} else {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16716 "Photo.c"
		}
	}
}


guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 2043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 2046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16738 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16745 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = _tmp2_ ^ mask;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = flags;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 16766 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = flags;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = committed;
#line 2051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 16788 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = flags;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 16797 "Photo.c"
				}
			}
		}
		__finally187:
		{
			PhotoRow* _tmp13_;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16808 "Photo.c"
		}
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16812 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 16820 "Photo.c"
		}
	}
#line 2056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = committed;
#line 2056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 2057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16829 "Photo.c"
	}
#line 2059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16835 "Photo.c"
}


gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16846 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16854 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 16864 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16871 "Photo.c"
			}
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16875 "Photo.c"
		}
		__finally188:
		{
			PhotoRow* _tmp4_;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16884 "Photo.c"
		}
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 16892 "Photo.c"
	}
}


void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 2068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2069 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16909 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16916 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != dirty) {
#line 16926 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
				PhotoRow* _tmp6_;
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp4_, &_tmp5_, dirty, &_inner_error_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16943 "Photo.c"
					goto __finally189;
				}
#line 2073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_->metadata_dirty = dirty;
#line 2074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = TRUE;
#line 16952 "Photo.c"
			}
		}
		__finally189:
		{
			PhotoRow* _tmp7_;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16962 "Photo.c"
		}
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 16972 "Photo.c"
			} else {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 16980 "Photo.c"
			}
		}
	}
#line 2078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = committed;
#line 2078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 16988 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "master-dirty");
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp10_);
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 16999 "Photo.c"
	}
}


gboolean
photo_is_enhanced (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 17011 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17019 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 17029 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17036 "Photo.c"
			}
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17040 "Photo.c"
		}
		__finally190:
		{
			PhotoRow* _tmp4_;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17049 "Photo.c"
		}
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 17057 "Photo.c"
	}
}


void
photo_set_enhanced (Photo* self,
                    gboolean enhanced)
{
	gboolean committed = FALSE;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
#line 2088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 17073 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17080 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != enhanced) {
#line 17090 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
				gboolean _tmp6_;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_set_enhanced (_tmp4_, &_tmp5_, enhanced);
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = committed;
#line 2093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp6_) {
#line 17109 "Photo.c"
					PhotoRow* _tmp7_;
#line 2094 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = self->row;
#line 2094 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_->enhanced = enhanced;
#line 17115 "Photo.c"
				}
			}
		}
		__finally191:
		{
			PhotoRow* _tmp8_;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17126 "Photo.c"
		}
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 17136 "Photo.c"
		}
	}
#line 2098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = committed;
#line 2098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_) {
#line 17143 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = alteration_new ("metadata", "enhanced");
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp11_);
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 17154 "Photo.c"
	}
}


static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17168 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 17187 "Photo.c"
				goto __catch192_database_error;
			}
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 17196 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 17204 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 17216 "Photo.c"
			}
			__finally193:
			{
				PhotoRow* _tmp6_;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17225 "Photo.c"
			}
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 17231 "Photo.c"
					goto __catch192_database_error;
				}
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 17240 "Photo.c"
			}
		}
	}
	goto __finally192;
	__catch192_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = data_object_to_string ((DataObject*) self);
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = err;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2112: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 17270 "Photo.c"
	}
	__finally192:
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17281 "Photo.c"
	}
}


static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 17297 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17305 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp6_;
#line 2124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = committed;
#line 2124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp7_) {
#line 17335 "Photo.c"
				PhotoRow* _tmp8_;
				EventID _tmp9_;
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = *event_id;
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_->event_id = _tmp9_;
#line 17344 "Photo.c"
			}
#line 2127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = committed;
#line 17348 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17355 "Photo.c"
			}
#line 2127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17359 "Photo.c"
		}
		__finally194:
		{
			PhotoRow* _tmp11_;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17368 "Photo.c"
		}
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp12_;
#line 17376 "Photo.c"
	}
}


static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gint64 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 2131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 17401 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 17433 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 17442 "Photo.c"
	}
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_.id;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp10_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = photo_get_master_reader (self);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp14_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = g_strdup_printf ("[%s] %s%s", _tmp12_, _tmp16_, _tmp0_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp16_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp14_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp12_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp18_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 17476 "Photo.c"
}


static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 2136 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_PHOTO) ? ((Photo*) source) : NULL);
#line 2138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp0_;
#line 2139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo;
#line 2139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 17499 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_id = _tmp2_;
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo;
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (self != _tmp6_) {
#line 17521 "Photo.c"
			PhotoID _tmp7_;
			gint64 _tmp8_;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo_id;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_.id;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp8_ != PHOTO_ID_INVALID;
#line 17530 "Photo.c"
		} else {
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = FALSE;
#line 17534 "Photo.c"
		}
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp5_) {
#line 17538 "Photo.c"
			PhotoID _tmp9_;
			gint64 _tmp10_;
			PhotoID _tmp11_;
			gint64 _tmp12_;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_.id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = other_photo_id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_assert (_tmp10_ != _tmp12_, "photo_id.id != other_photo_id.id");
#line 17553 "Photo.c"
		}
	}
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), source);
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 17562 "Photo.c"
}


static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_;
	DetectedPhotoInformation* _tmp15_;
	gboolean success = FALSE;
	gboolean _tmp33_;
	GError * _inner_error_ = NULL;
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_get_file ((MediaSource*) self);
#line 2153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp0_;
#line 2155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 17591 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17602 "Photo.c"
			goto __catch195_g_error;
		}
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp3_;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 17615 "Photo.c"
	}
	goto __finally195;
	__catch195_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = data_object_to_string ((DataObject*) self);
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = err->message;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_error ("Photo.vala:2160: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 17640 "Photo.c"
	}
	__finally195:
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17655 "Photo.c"
	}
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = info;
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp8_;
#line 2166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp9_;
#line 17667 "Photo.c"
	{
#line 2168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 2168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17673 "Photo.c"
			goto __catch196_g_error;
		}
	}
	goto __finally196;
	__catch196_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = err;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2170: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 17703 "Photo.c"
	}
	__finally196:
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17720 "Photo.c"
	}
#line 2173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp14_;
#line 2174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = detected;
#line 2174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 17730 "Photo.c"
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:2175: file_exif_updated: %s no longer an image", _tmp17_);
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17751 "Photo.c"
	}
	{
		PhotoRow* _tmp18_;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = self->row;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17759 "Photo.c"
		{
			PhotoTable* _tmp19_;
			PhotoTable* _tmp20_;
			PhotoID _tmp21_ = {0};
			GFileInfo* _tmp22_;
			GTimeVal _tmp23_;
			glong _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			PhotoRow* _tmp31_;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = photo_table_get_instance ();
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_get_photo_id (self, &_tmp21_);
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = info;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = timestamp;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = _tmp23_.tv_sec;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = self->row;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp20_, &_tmp21_, g_file_info_get_size (_tmp22_), _tmp24_, _tmp26_, _tmp28_, _tmp30_, _tmp31_);
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 17804 "Photo.c"
		}
		__finally197:
		{
			PhotoRow* _tmp32_;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = self->row;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17813 "Photo.c"
		}
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 17831 "Photo.c"
		}
	}
#line 2186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = success;
#line 2186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp33_) {
#line 17838 "Photo.c"
		Alteration* _tmp34_;
		Alteration* _tmp35_;
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = _tmp34_;
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp35_);
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp35_);
#line 17849 "Photo.c"
	}
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 17859 "Photo.c"
}


static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17871 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17879 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17889 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17896 "Photo.c"
			}
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17900 "Photo.c"
		}
		__finally198:
		{
			PhotoRow* _tmp4_;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17909 "Photo.c"
		}
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 17917 "Photo.c"
	}
}


static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17930 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp6_ = 0ULL;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17938 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			gint64 _tmp3_;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 17951 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17958 "Photo.c"
			}
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17962 "Photo.c"
		}
		__finally199:
		{
			PhotoRow* _tmp5_;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17971 "Photo.c"
		}
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 17979 "Photo.c"
	}
}


guint64
photo_get_editable_filesize (Photo* self)
{
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 17991 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17999 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 18009 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18016 "Photo.c"
			}
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 18020 "Photo.c"
		}
		__finally200:
		{
			PhotoRow* _tmp4_;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18029 "Photo.c"
		}
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 18037 "Photo.c"
	}
}


static time_t
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	time_t result = 0;
	time_t _tmp0_;
#line 2210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 18056 "Photo.c"
}


static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 18068 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18075 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 18085 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18092 "Photo.c"
			}
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 18096 "Photo.c"
		}
		__finally201:
		{
			PhotoRow* _tmp4_;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18105 "Photo.c"
		}
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 18113 "Photo.c"
	}
}


static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 18126 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18133 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 18146 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18153 "Photo.c"
			}
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 18157 "Photo.c"
		}
		__finally202:
		{
			PhotoRow* _tmp5_;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18166 "Photo.c"
		}
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 18174 "Photo.c"
	}
}


static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 18187 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18194 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 18207 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18214 "Photo.c"
			}
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 18218 "Photo.c"
		}
		__finally203:
		{
			PhotoRow* _tmp5_;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18227 "Photo.c"
		}
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 18235 "Photo.c"
	}
}


static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 2232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_title = _tmp0_;
#line 2235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 18258 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18265 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = new_title;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 18284 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp5_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18291 "Photo.c"
				}
#line 2238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (new_title);
#line 2238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 18297 "Photo.c"
			}
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = new_title;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = committed;
#line 2241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp11_) {
#line 18317 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->row;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = new_title;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp12_->title);
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_->title = _tmp14_;
#line 18331 "Photo.c"
			}
		}
		__finally204:
		{
			PhotoRow* _tmp15_;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18341 "Photo.c"
		}
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (new_title);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 18353 "Photo.c"
		}
	}
#line 2245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = committed;
#line 2245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp16_) {
#line 18360 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = alteration_new ("metadata", "name");
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp18_);
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 18371 "Photo.c"
	}
#line 2232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (new_title);
#line 18375 "Photo.c"
}


static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_comment = _tmp0_;
#line 2252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 18398 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18405 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = new_comment;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 18426 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp5_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18433 "Photo.c"
				}
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (new_comment);
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 18439 "Photo.c"
			}
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = new_comment;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = committed;
#line 2258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp11_) {
#line 18459 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->row;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = new_comment;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp12_->comment);
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_->comment = _tmp14_;
#line 18473 "Photo.c"
			}
		}
		__finally205:
		{
			PhotoRow* _tmp15_;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18483 "Photo.c"
		}
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18487 "Photo.c"
			gboolean _tmp16_ = FALSE;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (new_comment);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp16_;
#line 18497 "Photo.c"
		}
	}
#line 2262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = committed;
#line 2262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_) {
#line 18504 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "comment");
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp19_);
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 18515 "Photo.c"
	}
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (new_comment);
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 18523 "Photo.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 18532 "Photo.c"
}


void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp13_;
	GError * _inner_error_ = NULL;
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dberr = NULL;
#line 18549 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18556 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 18584 "Photo.c"
						goto __catch207_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp6_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18593 "Photo.c"
					}
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 18603 "Photo.c"
				}
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->row;
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 18611 "Photo.c"
			}
			goto __finally207;
			__catch207_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = err;
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dberr = _tmp10_;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 18633 "Photo.c"
			}
			__finally207:
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18638 "Photo.c"
				{
					PhotoRow* _tmp11_;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18645 "Photo.c"
				}
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 18655 "Photo.c"
			}
		}
		__finally206:
		{
			PhotoRow* _tmp12_;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18665 "Photo.c"
		}
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 18677 "Photo.c"
		}
	}
#line 2279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = dberr;
#line 2279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 18684 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 18695 "Photo.c"
	} else {
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = dberr;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2282: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 18713 "Photo.c"
	}
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_error_free0 (dberr);
#line 18717 "Photo.c"
}


void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError * _inner_error_ = NULL;
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 18750 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = source;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2290: No photo file writer available for %s", _tmp4_);
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, title);
#line 2294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18770 "Photo.c"
	}
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = source;
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error_);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp6_;
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18786 "Photo.c"
	}
#line 2298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = metadata;
#line 2298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = source;
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error_);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp9_;
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18808 "Photo.c"
	}
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = source;
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 18820 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = writer;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = metadata;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error_);
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18832 "Photo.c"
			goto __finally208;
		}
	}
	__finally208:
	{
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = source;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 18851 "Photo.c"
	}
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18865 "Photo.c"
	}
#line 2308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_set_title ((MediaSource*) self, title);
#line 2310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18877 "Photo.c"
}


void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError * _inner_error_ = NULL;
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 18910 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = source;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2318: No photo file writer available for %s", _tmp4_);
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, comment);
#line 2322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18930 "Photo.c"
	}
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = source;
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error_);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp6_;
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18946 "Photo.c"
	}
#line 2326 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = metadata;
#line 2326 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = source;
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error_);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp9_;
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18968 "Photo.c"
	}
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = source;
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 18980 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = writer;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = metadata;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error_);
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18992 "Photo.c"
			goto __finally209;
		}
	}
	__finally209:
	{
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = source;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19011 "Photo.c"
	}
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19025 "Photo.c"
	}
#line 2336 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_set_comment ((MediaSource*) self, comment);
#line 2338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19037 "Photo.c"
}


static void
photo_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 2341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 19051 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19058 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = committed;
#line 2345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp5_) {
#line 19081 "Photo.c"
				PhotoRow* _tmp6_;
#line 2346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_->exposure_time = time;
#line 2347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 19089 "Photo.c"
			}
		}
		__finally210:
		{
			PhotoRow* _tmp7_;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19099 "Photo.c"
		}
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 19109 "Photo.c"
		}
	}
#line 2351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = committed;
#line 2351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 19116 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "exposure-time");
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp10_);
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 19127 "Photo.c"
	}
}


void
photo_set_exposure_time_persistent (Photo* self,
                                    time_t time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError * _inner_error_ = NULL;
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 19163 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = source;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2360: No photo file writer available for %s", _tmp4_);
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dateable_set_exposure_time ((Dateable*) self, time);
#line 2364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19183 "Photo.c"
	}
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = source;
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error_);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp6_;
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19199 "Photo.c"
	}
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = metadata;
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = source;
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp11_;
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19227 "Photo.c"
	}
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = source;
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp12_);
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 19239 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = writer;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = metadata;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error_);
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19251 "Photo.c"
			goto __finally211;
		}
	}
	__finally211:
	{
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = source;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp17_);
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 19270 "Photo.c"
	}
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19284 "Photo.c"
	}
#line 2378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dateable_set_exposure_time ((Dateable*) self, time);
#line 2380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19296 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options ()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 19329 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp1_;
#line 2402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = ori_tmp;
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		switch (_tmp1_) {
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 19346 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp2_;
				gint _tmp3_;
				Dimensions _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _tmp2_.width;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				width_tmp = _tmp3_;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = returned_dims;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_.height;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				returned_dims.width = _tmp5_;
#line 2414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = width_tmp;
#line 2414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				returned_dims.height = _tmp6_;
#line 2415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 19372 "Photo.c"
			}
			default:
			{
#line 2419 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 19378 "Photo.c"
			}
		}
	}
#line 2424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 19384 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp7_ = 0.0;
		Dimensions _tmp8_;
		gint _tmp9_;
		Dimensions _tmp10_;
		gint _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_;
		gdouble _tmp16_;
#line 2426 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		angle = 0.0;
#line 2428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_straighten (self, &_tmp7_);
#line 2428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		angle = _tmp7_;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = returned_dims;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_.width;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = returned_dims;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_.height;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = angle;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp9_, (gdouble) _tmp11_, _tmp12_, &_tmp13_, &_tmp14_);
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		x_size = _tmp13_;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_size = _tmp14_;
#line 2432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = x_size;
#line 2432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		returned_dims.width = (gint) _tmp15_;
#line 2433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = y_size;
#line 2433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		returned_dims.height = (gint) _tmp16_;
#line 19428 "Photo.c"
	}
#line 2437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 19432 "Photo.c"
		Box crop = {0};
		Box _tmp17_ = {0};
		gboolean _tmp18_;
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = photo_get_crop (self, &_tmp17_, disallowed_steps);
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		crop = _tmp17_;
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp18_) {
#line 19442 "Photo.c"
			Dimensions _tmp19_ = {0};
#line 2440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 2440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			returned_dims = _tmp19_;
#line 19448 "Photo.c"
		}
	}
#line 2443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = returned_dims;
#line 2443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 19455 "Photo.c"
}


static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp1_;
#line 2451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 19484 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 19490 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = map;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 19500 "Photo.c"
	}
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19512 "Photo.c"
}


PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 2460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19523 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19530 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19541 "Photo.c"
			}
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 19549 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19556 "Photo.c"
			}
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 19560 "Photo.c"
		}
		__finally212:
		{
			PhotoRow* _tmp5_;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19569 "Photo.c"
		}
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19577 "Photo.c"
	}
}


static PixelTransformationBundle*
photo_locked_original_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* original_adjustments = NULL;
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	PhotoRow* _tmp1_;
	GeeHashMap* _tmp2_;
	KeyValueMap* _tmp10_;
#line 2470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	original_adjustments = _tmp0_;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->row;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_->original_transforms;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19604 "Photo.c"
		PhotoRow* _tmp3_;
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
		KeyValueMap* _tmp6_;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->row;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_->original_transforms;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "adjustments");
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = (KeyValueMap*) _tmp5_;
#line 2476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = map;
#line 2476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 19623 "Photo.c"
			KeyValueMap* _tmp7_;
			KeyValueMap* _tmp8_;
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = map;
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = key_value_map_copy (_tmp7_);
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			map = _tmp8_;
#line 19634 "Photo.c"
		}
	} else {
		KeyValueMap* _tmp9_;
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = key_value_map_new ("adjustments");
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = _tmp9_;
#line 19644 "Photo.c"
	}
#line 2481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = map;
#line 2481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 19650 "Photo.c"
		PixelTransformationBundle* _tmp11_;
#line 2482 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = original_adjustments;
#line 2482 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp11_);
#line 19656 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp12_;
		KeyValueMap* _tmp13_;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = original_adjustments;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = map;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp12_, _tmp13_);
#line 19666 "Photo.c"
	}
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = original_adjustments;
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19674 "Photo.c"
}


static KeyValueMap*
photo_get_color_adjustments_map (Photo* self)
{
	KeyValueMap* result = NULL;
	GError * _inner_error_ = NULL;
#line 2491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19685 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19692 "Photo.c"
		{
			KeyValueMap* map = NULL;
			KeyValueMap* _tmp1_;
			KeyValueMap* _tmp2_;
#line 2493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			map = _tmp1_;
#line 2494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = map;
#line 2494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 19705 "Photo.c"
				KeyValueMap* _tmp3_;
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = key_value_map_new ("adjustments");
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				map = _tmp3_;
#line 19713 "Photo.c"
			}
#line 2496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = map;
#line 19717 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19724 "Photo.c"
			}
#line 2496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 19728 "Photo.c"
		}
		__finally213:
		{
			PhotoRow* _tmp5_;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19737 "Photo.c"
		}
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19745 "Photo.c"
	}
}


PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 2500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19757 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19764 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19775 "Photo.c"
			}
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 19783 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19790 "Photo.c"
			}
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 19794 "Photo.c"
		}
		__finally214:
		{
			PhotoRow* _tmp5_;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19803 "Photo.c"
		}
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19811 "Photo.c"
	}
}


gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result = FALSE;
#line 2509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19826 "Photo.c"
}


PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
#line 2513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19855 "Photo.c"
}


void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp5_;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError * _inner_error_ = NULL;
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (new_adjustments != NULL);
#line 2520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_enhanced (self, FALSE);
#line 2521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 19876 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp2_;
		{
			PhotoRow* _tmp0_;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp0_ = self->row;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 19885 "Photo.c"
			{
#line 2524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = NULL;
#line 19897 "Photo.c"
			}
			__finally215:
			{
				PhotoRow* _tmp1_;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = self->row;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19906 "Photo.c"
			}
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 19916 "Photo.c"
			}
		}
#line 2529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _result_;
#line 2529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp2_) {
#line 19923 "Photo.c"
			Alteration* _tmp3_;
			Alteration* _tmp4_;
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = alteration_new ("image", "color-adjustments");
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			data_object_notify_altered ((DataObject*) self, _tmp4_);
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_alteration_unref0 (_tmp4_);
#line 19934 "Photo.c"
		}
#line 2532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19938 "Photo.c"
	}
#line 2536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp5_;
#line 19944 "Photo.c"
	{
		PhotoRow* _tmp6_;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = self->row;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19951 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
			PixelTransformer* _tmp8_;
			KeyValueMap* _tmp26_;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->priv->transformer;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ == NULL) {
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = TRUE;
#line 19962 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp9_;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->adjustments;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp9_ == NULL;
#line 19969 "Photo.c"
			}
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp7_) {
#line 19973 "Photo.c"
				PixelTransformationBundle* _tmp10_;
				PixelTransformer* _tmp11_;
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp10_;
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = _tmp11_;
#line 19988 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp25_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp12_;
					GeeIterable* _tmp13_;
					GeeIterator* _tmp14_;
					GeeIterator* _tmp15_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = gee_iterable_iterator (_tmp13_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_transformation_it = _tmp15_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 20011 "Photo.c"
						GeeIterator* _tmp16_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp17_;
						gpointer _tmp18_;
						PixelTransformer* _tmp19_;
						PixelTransformationBundle* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
						PixelTransformation* _tmp24_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!gee_iterator_next (_tmp16_)) {
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 20028 "Photo.c"
						}
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp17_ = _transformation_it;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp18_;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp19_ = self->priv->transformer;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = self->priv->adjustments;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp21_ = transformation;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp22_ = pixel_transformation_bundle_get_transformation (_tmp20_, pixel_transformation_get_transformation_type (_tmp21_));
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp23_ = _tmp22_;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp24_ = transformation;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp19_, _tmp23_, _tmp24_);
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp23_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 20054 "Photo.c"
					}
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 20058 "Photo.c"
				}
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp25_;
#line 20066 "Photo.c"
			}
#line 2555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = map;
#line 2555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_set_transformation (self, _tmp26_);
#line 20072 "Photo.c"
		}
		__finally216:
		{
			PhotoRow* _tmp27_;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = self->row;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20081 "Photo.c"
		}
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20093 "Photo.c"
		}
	}
#line 2558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = committed;
#line 2558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28_) {
#line 20100 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = alteration_new ("image", "color-adjustments");
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp30_);
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 20111 "Photo.c"
	}
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20115 "Photo.c"
}


static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 2563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 20127 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20149 "Photo.c"
			goto __catch217_g_error;
		}
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp5_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20162 "Photo.c"
	}
	goto __finally217;
	__catch217_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = err;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2567: Unable to load metadata: %s", _tmp7_);
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20186 "Photo.c"
	}
	__finally217:
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 20195 "Photo.c"
}


PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError * _inner_error_ = NULL;
#line 2573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 20231 "Photo.c"
	}
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp5_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 20243 "Photo.c"
}


PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError * _inner_error_ = NULL;
#line 2577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 20267 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = reader;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 20288 "Photo.c"
		}
	} else {
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 20295 "Photo.c"
	}
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 20303 "Photo.c"
}


gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState* * state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError * _inner_error_ = NULL;
#line 2586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 2590 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2590 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	master_reader = _tmp0_;
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20350 "Photo.c"
		} else {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20354 "Photo.c"
		}
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20358 "Photo.c"
	}
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = master_reader;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20368 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 20376 "Photo.c"
	}
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20382 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 20392 "Photo.c"
	}
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp8_;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20404 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 20414 "Photo.c"
	}
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp7_) {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20428 "Photo.c"
		} else {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20432 "Photo.c"
		}
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20436 "Photo.c"
	}
#line 2600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 20452 "Photo.c"
	} else {
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 20456 "Photo.c"
	}
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 20460 "Photo.c"
}


void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError * _inner_error_ = NULL;
#line 2605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20484 "Photo.c"
		} else {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20492 "Photo.c"
		}
	}
}


gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState* * state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError * _inner_error_ = NULL;
#line 2609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 2613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2614 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2614 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20542 "Photo.c"
		} else {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20546 "Photo.c"
		}
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20550 "Photo.c"
	}
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_))) {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20564 "Photo.c"
		} else {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20568 "Photo.c"
		}
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20572 "Photo.c"
	}
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20582 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 20590 "Photo.c"
	}
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20596 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 20606 "Photo.c"
	}
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp9_;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20618 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp11_;
#line 20628 "Photo.c"
	}
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp8_) {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20642 "Photo.c"
		} else {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20646 "Photo.c"
		}
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20650 "Photo.c"
	}
#line 2625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 20666 "Photo.c"
	} else {
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 20670 "Photo.c"
	}
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 20674 "Photo.c"
}


void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError * _inner_error_ = NULL;
#line 2630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20698 "Photo.c"
		} else {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20706 "Photo.c"
		}
	}
}


void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError * _inner_error_ = NULL;
#line 2636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 20719 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20726 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 20736 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20743 "Photo.c"
			}
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20747 "Photo.c"
		}
		__finally218:
		{
			PhotoRow* _tmp4_;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20756 "Photo.c"
		}
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 20764 "Photo.c"
	}
}


gboolean
photo_has_transformations (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20776 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp10_ = FALSE;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20784 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = TRUE;
#line 20803 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 20813 "Photo.c"
			}
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 20817 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20824 "Photo.c"
			}
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20828 "Photo.c"
		}
		__finally219:
		{
			PhotoRow* _tmp9_;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20837 "Photo.c"
		}
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 20845 "Photo.c"
	}
}


gboolean
photo_only_metadata_changed (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError * _inner_error_ = NULL;
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	date_time = NULL;
#line 2653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp0_;
#line 2654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 2654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20871 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = metadata;
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp3_;
#line 20882 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp20_ = FALSE;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20891 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 20902 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->row;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = TRUE;
#line 20920 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = date_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 20928 "Photo.c"
						PhotoRow* _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = self->row;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp17_ = date_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = _tmp16_ != metadata_date_time_get_timestamp (_tmp17_);
#line 20940 "Photo.c"
					} else {
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = FALSE;
#line 20944 "Photo.c"
					}
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 20948 "Photo.c"
				}
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20952 "Photo.c"
			} else {
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = FALSE;
#line 20956 "Photo.c"
			}
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp5_;
#line 20960 "Photo.c"
			{
				PhotoRow* _tmp18_;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20967 "Photo.c"
			}
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20975 "Photo.c"
		}
		__finally220:
		{
			PhotoRow* _tmp19_;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20984 "Photo.c"
		}
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp20_;
#line 20996 "Photo.c"
	}
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 21002 "Photo.c"
}


gboolean
photo_has_alterations (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError * _inner_error_ = NULL;
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	date_time = NULL;
#line 2666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	title = NULL;
#line 2667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	comment = NULL;
#line 2669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp0_;
#line 2670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 2670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21034 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = metadata;
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp3_;
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = metadata;
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = media_metadata_get_title ((MediaMetadata*) _tmp4_);
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		title = _tmp5_;
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = metadata;
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = media_metadata_get_comment ((MediaMetadata*) _tmp6_);
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		comment = _tmp7_;
#line 21065 "Photo.c"
	}
#line 2677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = date_time;
#line 2677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 21071 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 21078 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				time_t _tmp11_;
				PhotoRow* _tmp12_;
				time_t _tmp13_;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->row;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 21096 "Photo.c"
					{
						PhotoRow* _tmp14_;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21103 "Photo.c"
					}
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (comment);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (title);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 21115 "Photo.c"
				}
			}
			__finally221:
			{
				PhotoRow* _tmp15_;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21125 "Photo.c"
			}
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 21129 "Photo.c"
				gboolean _tmp16_ = FALSE;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (comment);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (title);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp16_;
#line 21145 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp17_;
		gboolean _tmp41_ = FALSE;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21156 "Photo.c"
		{
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			PhotoRow* _tmp22_;
			GeeHashMap* _tmp23_;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = self->row;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = _tmp22_->transformations;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp23_ != NULL) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = TRUE;
#line 21172 "Photo.c"
			} else {
				PhotoRow* _tmp24_;
				Orientation _tmp25_;
				BackingPhotoRow* _tmp26_;
				Orientation _tmp27_;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = self->row;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _tmp24_->orientation;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = self->backing_photo_row;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_->original_orientation;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = _tmp25_ != _tmp27_;
#line 21188 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp21_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = TRUE;
#line 21194 "Photo.c"
			} else {
				gboolean _tmp28_ = FALSE;
				MetadataDateTime* _tmp29_;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = date_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 21202 "Photo.c"
					PhotoRow* _tmp30_;
					time_t _tmp31_;
					MetadataDateTime* _tmp32_;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = self->row;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = _tmp30_->exposure_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp32_ = date_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = _tmp31_ != metadata_date_time_get_timestamp (_tmp32_);
#line 21214 "Photo.c"
				} else {
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = FALSE;
#line 21218 "Photo.c"
				}
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = _tmp28_;
#line 21222 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp20_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = TRUE;
#line 21228 "Photo.c"
			} else {
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = media_source_get_comment ((MediaSource*) self);
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = comment;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp34_);
#line 21243 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp19_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = TRUE;
#line 21249 "Photo.c"
			} else {
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = media_source_get_title ((MediaSource*) self);
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = title;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp37_);
#line 21264 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp18_;
#line 21268 "Photo.c"
			{
				PhotoRow* _tmp39_;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21275 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21287 "Photo.c"
		}
		__finally222:
		{
			PhotoRow* _tmp40_;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21296 "Photo.c"
		}
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp41_;
#line 21312 "Photo.c"
	}
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (comment);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (title);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 21322 "Photo.c"
}


PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21333 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21340 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PhotoRow* _tmp13_;
			GeeHashMap* _tmp14_;
			PhotoRow* _tmp15_;
			gboolean _tmp16_;
			PhotoPhotoTransformationStateImpl* _tmp17_;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21359 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 21370 "Photo.c"
			} else {
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 21376 "Photo.c"
			}
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 21382 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21393 "Photo.c"
			} else {
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = NULL;
#line 21399 "Photo.c"
			}
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->original_transforms;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_->enhanced;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_, _tmp14_, _tmp16_);
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (PhotoTransformationState*) _tmp17_;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 21425 "Photo.c"
			{
				PhotoRow* _tmp18_;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21432 "Photo.c"
			}
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21436 "Photo.c"
		}
		__finally223:
		{
			PhotoRow* _tmp19_;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21445 "Photo.c"
		}
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 21453 "Photo.c"
	}
}


static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 21463 "Photo.c"
}


static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 21472 "Photo.c"
}


gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	gboolean saved_enhanced = FALSE;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* saved_original_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp6_;
	GeeHashMap* _tmp7_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp8_;
	PixelTransformer* _tmp9_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp10_;
	PixelTransformationBundle* _tmp11_;
	gboolean committed = FALSE;
	gboolean _tmp38_;
	GError * _inner_error_ = NULL;
#line 2708 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2708 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 2709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (state, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	state_impl = _tmp0_;
#line 2710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = state_impl;
#line 2710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 21521 "Photo.c"
	}
#line 2713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_enhanced = photo_photo_transformation_state_impl_get_enhanced (_tmp3_);
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = state_impl;
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_photo_transformation_state_impl_get_transformations (_tmp4_);
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_transformations = _tmp5_;
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = state_impl;
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_photo_transformation_state_impl_get_original_transformations (_tmp6_);
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_original_transformations = _tmp7_;
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = state_impl;
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_photo_transformation_state_impl_get_transformer (_tmp8_);
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_transformer = _tmp9_;
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = state_impl;
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp10_);
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_adjustments = _tmp11_;
#line 21555 "Photo.c"
	{
		PhotoRow* _tmp12_;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = self->row;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21562 "Photo.c"
		{
			PhotoTable* _tmp13_;
			PhotoTable* _tmp14_;
			PhotoRow* _tmp15_;
			PhotoID _tmp16_;
			Orientation _tmp17_;
			GeeHashMap* _tmp18_;
			GeeHashMap* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp21_;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_table_get_instance ();
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_->photo_id;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = saved_orientation;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = saved_transformations;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = saved_transformations;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = saved_enhanced;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp14_, &_tmp16_, _tmp17_, _tmp18_, _tmp19_, _tmp20_);
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 2724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = committed;
#line 2724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp21_) {
#line 21597 "Photo.c"
				PhotoRow* _tmp22_;
				Orientation _tmp23_;
				PhotoRow* _tmp24_;
				GeeHashMap* _tmp25_;
				GeeHashMap* _tmp26_;
				PhotoRow* _tmp27_;
				GeeHashMap* _tmp28_;
				GeeHashMap* _tmp29_;
				PhotoRow* _tmp30_;
				gboolean _tmp31_;
				PixelTransformer* _tmp32_;
				PixelTransformer* _tmp33_;
				PixelTransformationBundle* _tmp34_;
				PixelTransformationBundle* _tmp35_;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = self->row;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = saved_orientation;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_->orientation = _tmp23_;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = self->row;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = saved_transformations;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp24_->transformations);
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_->transformations = _tmp26_;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = self->row;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = saved_original_transformations;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp27_->original_transforms);
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_->original_transforms = _tmp29_;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = self->row;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = saved_enhanced;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_->enhanced = _tmp31_;
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = saved_transformer;
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _pixel_transformer_ref0 (_tmp32_);
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = _tmp33_;
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = saved_adjustments;
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _pixel_transformation_bundle_ref0 (_tmp34_);
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp35_;
#line 21660 "Photo.c"
			}
		}
		__finally224:
		{
			PhotoRow* _tmp36_;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = self->row;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21670 "Photo.c"
		}
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 21674 "Photo.c"
			gboolean _tmp37_ = FALSE;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (saved_original_transformations);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp37_;
#line 21692 "Photo.c"
		}
	}
#line 2734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = committed;
#line 2734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_) {
#line 21699 "Photo.c"
		Alteration* _tmp39_;
		Alteration* _tmp40_;
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = alteration_new ("image", "transformation-state");
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp40_);
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp40_);
#line 21710 "Photo.c"
	}
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (saved_original_transformations);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 21726 "Photo.c"
}


void
photo_remove_all_transformations (Photo* self)
{
#line 2740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 21737 "Photo.c"
}


static void
photo_internal_remove_all_transformations (Photo* self,
                                           gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_;
	GError * _inner_error_ = NULL;
#line 2744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_altered = FALSE;
#line 21753 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21760 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			PhotoRow* _tmp7_;
			Orientation _tmp8_;
			BackingPhotoRow* _tmp9_;
			Orientation _tmp10_;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 2749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_->enhanced = FALSE;
#line 2750 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2750 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->orientation;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->backing_photo_row;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->original_orientation;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ != _tmp10_) {
#line 21812 "Photo.c"
				PhotoTable* _tmp11_;
				PhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				PhotoID _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
				PhotoRow* _tmp17_;
				BackingPhotoRow* _tmp18_;
				Orientation _tmp19_;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = photo_table_get_instance ();
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = self->row;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = _tmp13_->photo_id;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->backing_photo_row;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_orientation (_tmp12_, &_tmp14_, _tmp16_);
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = self->row;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->backing_photo_row;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = _tmp18_->original_orientation;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_->orientation = _tmp19_;
#line 2757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				is_altered = TRUE;
#line 21848 "Photo.c"
			}
		}
		__finally225:
		{
			PhotoRow* _tmp20_;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = self->row;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21858 "Photo.c"
		}
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 21868 "Photo.c"
		}
	}
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = is_altered;
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_) {
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = notify;
#line 21877 "Photo.c"
	} else {
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = FALSE;
#line 21881 "Photo.c"
	}
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_) {
#line 21885 "Photo.c"
		Alteration* _tmp23_;
		Alteration* _tmp24_;
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = alteration_new ("image", "revert");
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp24_);
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp24_);
#line 21896 "Photo.c"
	}
}


Orientation
photo_get_original_orientation (Photo* self)
{
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21908 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21915 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 21925 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21932 "Photo.c"
			}
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21936 "Photo.c"
		}
		__finally226:
		{
			PhotoRow* _tmp4_;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21945 "Photo.c"
		}
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 21953 "Photo.c"
	}
}


Orientation
photo_get_orientation (Photo* self)
{
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21965 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21972 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 21982 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21989 "Photo.c"
			}
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21993 "Photo.c"
		}
		__finally227:
		{
			PhotoRow* _tmp4_;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22002 "Photo.c"
		}
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 22010 "Photo.c"
	}
}


gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean result = FALSE;
	gboolean committed = FALSE;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 2777 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 22027 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22034 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != orientation) {
#line 22044 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoRow* _tmp5_;
				PhotoID _tmp6_;
				gboolean _tmp7_;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_->photo_id;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = photo_table_set_orientation (_tmp4_, &_tmp6_, orientation);
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = committed;
#line 2782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp7_) {
#line 22066 "Photo.c"
					PhotoRow* _tmp8_;
#line 2783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = self->row;
#line 2783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_->orientation = orientation;
#line 22072 "Photo.c"
				}
			}
		}
		__finally228:
		{
			PhotoRow* _tmp9_;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22083 "Photo.c"
		}
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 22087 "Photo.c"
			gboolean _tmp10_ = FALSE;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp10_;
#line 22095 "Photo.c"
		}
	}
#line 2787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = committed;
#line 2787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 22102 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = alteration_new ("image", "orientation");
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp13_);
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 22113 "Photo.c"
	}
#line 2790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22119 "Photo.c"
}


gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 2793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22136 "Photo.c"
}


static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError * _inner_error_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22151 "Photo.c"
		{
#line 2799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 22155 "Photo.c"
		}
		__finally229:
		{
			PhotoRow* _tmp1_;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22164 "Photo.c"
		}
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 22174 "Photo.c"
		}
	}
}


void
photo_rotate (Photo* self,
              Rotation rotation)
{
#line 2797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 22188 "Photo.c"
}


static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22202 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22210 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 22221 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, name);
#line 22230 "Photo.c"
			} else {
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 22234 "Photo.c"
			}
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 22238 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22245 "Photo.c"
			}
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22249 "Photo.c"
		}
		__finally230:
		{
			PhotoRow* _tmp7_;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22258 "Photo.c"
		}
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp8_;
#line 22266 "Photo.c"
	}
}


static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError * _inner_error_ = NULL;
#line 2812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = NULL;
#line 22284 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22291 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22301 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, name);
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = map;
#line 2817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 22320 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = map;
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					map = _tmp8_;
#line 22331 "Photo.c"
				}
			}
		}
		__finally231:
		{
			PhotoRow* _tmp9_;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22342 "Photo.c"
		}
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 22354 "Photo.c"
		}
	}
#line 2822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = map;
#line 2822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22361 "Photo.c"
}


static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 22375 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22383 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22402 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 22413 "Photo.c"
			}
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp13_;
#line 22441 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22448 "Photo.c"
			}
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22452 "Photo.c"
		}
		__finally232:
		{
			PhotoRow* _tmp15_;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22461 "Photo.c"
		}
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp16_;
#line 22469 "Photo.c"
	}
}


static gboolean
photo_set_original_transforms (Photo* self,
                               KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 22484 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22492 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22511 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 22522 "Photo.c"
			}
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->original_transforms;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_table_set_original_transforms (_tmp10_, &_tmp12_, trans);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp13_;
#line 22550 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22557 "Photo.c"
			}
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22561 "Photo.c"
		}
		__finally233:
		{
			PhotoRow* _tmp15_;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22570 "Photo.c"
		}
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp16_;
#line 22578 "Photo.c"
	}
}


static gboolean
photo_clear_original_transforms (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22590 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22598 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp5_;
			PhotoTable* _tmp6_;
			PhotoRow* _tmp7_;
			PhotoID _tmp8_;
			gboolean _tmp9_;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22613 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 22624 "Photo.c"
			}
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_table_get_instance ();
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->photo_id;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_table_set_original_transforms (_tmp6_, &_tmp8_, NULL);
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp6_);
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp9_;
#line 22640 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22647 "Photo.c"
			}
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22651 "Photo.c"
		}
		__finally234:
		{
			PhotoRow* _tmp11_;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22660 "Photo.c"
		}
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp12_;
#line 22668 "Photo.c"
	}
}


static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
	GError * _inner_error_ = NULL;
#line 2855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22687 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22694 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp11_;
			PhotoTable* _tmp12_;
			PhotoRow* _tmp13_;
			PhotoID _tmp14_;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22708 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gboolean _tmp5_;
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, name, NULL);
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered_cache = _tmp5_;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp7_);
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp9_ == 0) {
#line 22734 "Photo.c"
					PhotoRow* _tmp10_;
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->row;
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp10_->transformations);
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_->transformations = NULL;
#line 22742 "Photo.c"
				}
			} else {
#line 2863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered_cache = FALSE;
#line 22747 "Photo.c"
			}
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->photo_id;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp12_, &_tmp14_, name);
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 22761 "Photo.c"
		}
		__finally235:
		{
			PhotoRow* _tmp15_;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22770 "Photo.c"
		}
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 22774 "Photo.c"
			gboolean _tmp16_ = FALSE;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp16_;
#line 22782 "Photo.c"
		}
	}
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = altered_cache;
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = TRUE;
#line 22791 "Photo.c"
	} else {
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = altered_persistent;
#line 22795 "Photo.c"
	}
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp17_;
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22801 "Photo.c"
}


gboolean
photo_has_crop (Photo* self)
{
	gboolean result = FALSE;
#line 2873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22815 "Photo.c"
}


gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 2878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2879 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 22864 "Photo.c"
		}
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22868 "Photo.c"
	}
#line 2885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = map;
#line 2886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 2887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 2888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = map;
#line 2888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = left;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ == -1) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = TRUE;
#line 22892 "Photo.c"
	} else {
		gint _tmp10_;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = top;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp10_ == -1;
#line 22899 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = TRUE;
#line 22905 "Photo.c"
	} else {
		gint _tmp11_;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = right;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp11_ == -1;
#line 22912 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = TRUE;
#line 22918 "Photo.c"
	} else {
		gint _tmp12_;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = bottom;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp12_ == -1;
#line 22925 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 22937 "Photo.c"
		}
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22941 "Photo.c"
	}
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = left;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = top;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = right;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = bottom;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	box_init (&_vala_crop, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (crop) {
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*crop = _vala_crop;
#line 22961 "Photo.c"
	}
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22965 "Photo.c"
}


static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *crop;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = *crop;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = map;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = *crop;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = map;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = *crop;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = map;
#line 2906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_set_transformation (self, _tmp13_)) {
#line 23032 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = alteration_new ("image", "crop");
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 23043 "Photo.c"
	}
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23047 "Photo.c"
}


static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 2910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_angle = 0.0;
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (angle) {
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*angle = _vala_angle;
#line 23081 "Photo.c"
		}
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23085 "Photo.c"
	}
#line 2918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (angle) {
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*angle = _vala_angle;
#line 23099 "Photo.c"
	}
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23103 "Photo.c"
}


static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 2923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 2927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 23129 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp4_);
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 23140 "Photo.c"
	}
#line 2923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23144 "Photo.c"
}


static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                int* result_length1)
{
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	EditingToolsRedeyeInstance* res = NULL;
	gint _tmp6_;
	EditingToolsRedeyeInstance* _tmp7_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp8_ = {0};
	EditingToolsRedeyeInstance* _tmp45_;
	gint _tmp45__length1;
#line 2933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23178 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (result_length1) {
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 23192 "Photo.c"
		}
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp3_;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23200 "Photo.c"
	}
#line 2938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = num_points;
#line 2939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp5_ > 0, "num_points > 0");
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = num_points;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = g_new0 (EditingToolsRedeyeInstance, _tmp6_);
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	res = _tmp7_;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	res_length1 = _tmp6_;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_res_size_ = res_length1;
#line 2943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_.x = 0;
#line 2943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point = _tmp8_;
#line 2944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point.x = -1;
#line 2945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point.y = -1;
#line 23228 "Photo.c"
	{
		gint i = 0;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		i = 0;
#line 23233 "Photo.c"
		{
			gboolean _tmp9_ = FALSE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = TRUE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 23240 "Photo.c"
				gint _tmp11_;
				gint _tmp12_;
				gchar* center_key = NULL;
				gint _tmp13_;
				gchar* _tmp14_;
				gchar* radius_key = NULL;
				gint _tmp15_;
				gchar* _tmp16_;
				EditingToolsRedeyeInstance* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				KeyValueMap* _tmp19_;
				const gchar* _tmp20_;
				GdkPoint _tmp21_;
				GdkPoint _tmp22_ = {0};
				EditingToolsRedeyeInstance* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				EditingToolsRedeyeInstance _tmp25_;
				GdkPoint _tmp26_;
				gint _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				EditingToolsRedeyeInstance* _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				EditingToolsRedeyeInstance _tmp32_;
				GdkPoint _tmp33_;
				gint _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				EditingToolsRedeyeInstance* _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_;
				KeyValueMap* _tmp39_;
				const gchar* _tmp40_;
				EditingToolsRedeyeInstance* _tmp41_;
				gint _tmp41__length1;
				gint _tmp42_;
				EditingToolsRedeyeInstance _tmp43_;
				gint _tmp44_;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp9_) {
#line 23284 "Photo.c"
					gint _tmp10_;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = i;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					i = _tmp10_ + 1;
#line 23290 "Photo.c"
				}
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = FALSE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = i;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = num_points;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp11_ < _tmp12_)) {
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 23302 "Photo.c"
				}
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = i;
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = g_strdup_printf ("center%d", _tmp13_);
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				center_key = _tmp14_;
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = i;
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = g_strdup_printf ("radius%d", _tmp15_);
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				radius_key = _tmp16_;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = res;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17__length1 = res_length1;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = i;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = map;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = center_key;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = default_point;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				key_value_map_get_point (_tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_[_tmp18_].center = _tmp22_;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = res;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23__length1 = res_length1;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = i;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _tmp23_[_tmp24_];
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = _tmp25_.center;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_.x;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = default_point;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp27_ != _tmp29_, "res[i].center.x != default_point.x");
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = res;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30__length1 = res_length1;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = i;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tmp30_[_tmp31_];
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tmp32_.center;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tmp33_.y;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = default_point;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp34_ != _tmp36_, "res[i].center.y != default_point.y");
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = res;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37__length1 = res_length1;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = i;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = map;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = radius_key;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_[_tmp38_].radius = key_value_map_get_int (_tmp39_, _tmp40_, -1);
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = res;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41__length1 = res_length1;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = i;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = _tmp41_[_tmp42_];
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = _tmp43_.radius;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp44_ != -1, "res[i].radius != -1");
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (radius_key);
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (center_key);
#line 23396 "Photo.c"
			}
		}
	}
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = res;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45__length1 = res_length1;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp45__length1;
#line 23408 "Photo.c"
	}
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp45_;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23416 "Photo.c"
}


gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result = FALSE;
#line 2962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 2963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23430 "Photo.c"
}


void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* radius_key = NULL;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* center_key = NULL;
	gint _tmp9_;
	gchar* _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	gint _tmp14_;
	KeyValueMap* _tmp15_;
	const gchar* _tmp16_;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	KeyValueMap* _tmp19_;
	gint _tmp20_;
	KeyValueMap* _tmp21_;
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23474 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = _tmp2_;
#line 2971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = map;
#line 2971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 23487 "Photo.c"
	}
#line 2974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = num_points;
#line 2975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp5_ >= 0, "num_points >= 0");
#line 2977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = num_points;
#line 2977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = _tmp6_ + 1;
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = num_points;
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = g_strdup_printf ("radius%d", _tmp7_ - 1);
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	radius_key = _tmp8_;
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = num_points;
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = g_strdup_printf ("center%d", _tmp9_ - 1);
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	center_key = _tmp10_;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = map;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = radius_key;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = *redeye;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = _tmp13_.radius;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp11_, _tmp12_, _tmp14_);
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = map;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = center_key;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = *redeye;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_point (_tmp15_, _tmp16_, &_tmp18_);
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = map;
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = num_points;
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp19_, "num_points", _tmp20_);
#line 2987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = map;
#line 2987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_set_transformation (self, _tmp21_)) {
#line 23543 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = alteration_new ("image", "redeye");
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp23_);
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 23554 "Photo.c"
	}
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (center_key);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (radius_key);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23562 "Photo.c"
}


static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23581 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23589 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp4_;
#line 23605 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23612 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (scaled_image) {
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23618 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (scaled_to_viewport) {
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23624 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 23628 "Photo.c"
		}
		__finally236:
		{
			PhotoRow* _tmp6_;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23637 "Photo.c"
		}
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 23645 "Photo.c"
	}
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_image) {
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23651 "Photo.c"
	}
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23657 "Photo.c"
	}
}


static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp36_ = FALSE;
	Dimensions _tmp37_;
	gint _tmp38_;
	Dimensions _tmp39_;
	gint _tmp40_;
#line 3012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw = _tmp0_;
#line 3016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 23690 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = raw;
#line 3017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = raw;
#line 3018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_image) {
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23707 "Photo.c"
		}
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23713 "Photo.c"
		}
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23717 "Photo.c"
	}
#line 3023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3029 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 23727 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		crop = _tmp3_;
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp4_) {
#line 23737 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			Box _tmp15_ = {0};
			Dimensions _tmp16_ = {0};
			gboolean _tmp17_ = FALSE;
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
#line 3036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = raw;
#line 3036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23755 "Photo.c"
				Orientation _tmp6_;
				Dimensions _tmp7_;
				Box _tmp8_;
				Box _tmp9_ = {0};
				Orientation _tmp10_;
				Dimensions _tmp11_;
				Dimensions _tmp12_ = {0};
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = orientation;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = raw;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = crop;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				crop = _tmp9_;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = orientation;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = raw;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_rotate_dimensions (_tmp10_, &_tmp11_, &_tmp12_);
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				rotated_raw = _tmp12_;
#line 23781 "Photo.c"
			}
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp13_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp13_, &_tmp14_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_scaled (&crop, &_tmp14_, &_tmp15_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_crop = _tmp15_;
#line 3046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp16_);
#line 3046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp16_;
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 23799 "Photo.c"
			} else {
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = FALSE;
#line 23803 "Photo.c"
			}
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp17_) {
#line 23807 "Photo.c"
				Dimensions _tmp18_;
				Dimensions _tmp19_ = {0};
#line 3051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = raw;
#line 3051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_image = _tmp18_;
#line 3052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp19_);
#line 3052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp19_;
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (scaled_image) {
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23824 "Photo.c"
				}
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (scaled_to_viewport) {
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23830 "Photo.c"
				}
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 23834 "Photo.c"
			}
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp20_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp21_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp20_, &_tmp21_, &_tmp22_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp22_;
#line 3063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23846 "Photo.c"
				Orientation _tmp23_;
				Dimensions _tmp24_;
				Dimensions _tmp25_ = {0};
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = orientation;
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = _vala_scaled_image;
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_derotate_dimensions (_tmp23_, &_tmp24_, &_tmp25_);
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_image = _tmp25_;
#line 23858 "Photo.c"
			}
		}
	}
#line 3069 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 23864 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp26_;
		Dimensions _tmp30_;
		Dimensions _tmp31_ = {0};
		Dimensions _tmp32_;
#line 3071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = raw;
#line 3071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		rotated_raw = _tmp26_;
#line 3072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23876 "Photo.c"
			Orientation _tmp27_;
			Dimensions _tmp28_;
			Dimensions _tmp29_ = {0};
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = orientation;
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = raw;
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation_rotate_dimensions (_tmp27_, &_tmp28_, &_tmp29_);
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			rotated_raw = _tmp29_;
#line 23888 "Photo.c"
		}
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = rotated_raw;
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp30_, &_tmp31_);
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp31_;
#line 3076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = _vala_scaled_image;
#line 3076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp32_;
#line 3079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23902 "Photo.c"
			Orientation _tmp33_;
			Dimensions _tmp34_;
			Dimensions _tmp35_ = {0};
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = orientation;
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = _vala_scaled_image;
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation_derotate_dimensions (_tmp33_, &_tmp34_, &_tmp35_);
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp35_;
#line 23914 "Photo.c"
		}
	}
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _vala_scaled_image;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_.width;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = raw;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_.width;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_ >= _tmp40_) {
#line 23927 "Photo.c"
		Dimensions _tmp41_;
		gint _tmp42_;
		Dimensions _tmp43_;
		gint _tmp44_;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _vala_scaled_image;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = _tmp41_.height;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = raw;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_.height;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = _tmp42_ >= _tmp44_;
#line 23942 "Photo.c"
	} else {
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = FALSE;
#line 23946 "Photo.c"
	}
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp36_) {
#line 23950 "Photo.c"
		Dimensions _tmp45_;
#line 3085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = raw;
#line 3085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp45_;
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_image) {
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23962 "Photo.c"
		}
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23968 "Photo.c"
		}
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23972 "Photo.c"
	}
#line 3090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area ()");
#line 3091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area ()");
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_image) {
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23984 "Photo.c"
	}
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23990 "Photo.c"
	}
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23994 "Photo.c"
}


static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean _tmp9_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp14_;
	Dimensions _tmp15_ = {0};
	Dimensions _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
	Dimensions _tmp19_ = {0};
	GError * _inner_error_ = NULL;
#line 3099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	loader = _tmp0_;
#line 3105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24034 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = loader;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 24053 "Photo.c"
		}
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp4_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 24067 "Photo.c"
	}
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = *scaling;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaled_image = _tmp6_;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_scaled = _tmp8_;
#line 3117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = is_scaled;
#line 3117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp9_) {
#line 24083 "Photo.c"
		GdkPixbuf* _tmp10_ = NULL;
		PhotoFileReader* _tmp11_;
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = loader;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = photo_file_reader_unscaled_read (_tmp11_, &_inner_error_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp12_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 24102 "Photo.c"
		}
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp10_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = NULL;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp13_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp10_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 24116 "Photo.c"
	}
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = loader;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp15_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = scaled_image;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo_file_reader_scaled_read (_tmp14_, &_tmp15_, &_tmp16_, &_inner_error_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp17_;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24136 "Photo.c"
	}
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = pixbuf;
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_for_pixbuf (_tmp18_, &_tmp19_);
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp19_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24150 "Photo.c"
}


GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24182 "Photo.c"
	}
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24194 "Photo.c"
}


GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24226 "Photo.c"
	}
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24238 "Photo.c"
}


static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError * _inner_error_ = NULL;
#line 3150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 24261 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24268 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_image = _tmp2_;
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 24283 "Photo.c"
		}
		__finally237:
		{
			PhotoRow* _tmp4_;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24292 "Photo.c"
		}
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 24300 "Photo.c"
		}
	}
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = *scaling;
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error_);
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp6_;
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24315 "Photo.c"
	}
#line 3177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (rotate) {
#line 24319 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp8_;
#line 24330 "Photo.c"
	}
#line 3187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24336 "Photo.c"
}


static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 3190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24368 "Photo.c"
	}
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24380 "Photo.c"
}


/**
     * @brief Populates the cached version of the unmodified image.
     */
void
photo_populate_prefetched (Photo* self,
                           GError** error)
{
	GError * _inner_error_ = NULL;
#line 3197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 24394 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24401 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 24408 "Photo.c"
				GdkPixbuf* _tmp2_ = NULL;
				Scaling _tmp3_ = {0};
				GdkPixbuf* _tmp4_;
				GdkPixbuf* _tmp5_;
				GTimer* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				scaling_for_original (&_tmp3_);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_load_raw_pixbuf (self, &_tmp3_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp4_;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 24424 "Photo.c"
					goto __finally238;
				}
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp2_;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = NULL;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->unmodified_precached = _tmp5_;
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = g_timer_new ();
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->secs_since_access = _tmp6_;
#line 3203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:3204: spawning new precache timeout for %s", _tmp8_);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp2_);
#line 24453 "Photo.c"
			}
		}
		__finally238:
		{
			GdkPixbuf* _tmp9_;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24463 "Photo.c"
		}
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 24471 "Photo.c"
		}
	}
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self)
{
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 3214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24489 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24496 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 3216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 24505 "Photo.c"
				{
#line 3218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 3218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 24511 "Photo.c"
						goto __catch240_g_error;
					}
				}
				goto __finally240;
				__catch240_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_;
					gchar* _tmp3_;
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = data_object_to_string ((DataObject*) self);
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_warning ("Photo.vala:3220: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = NULL;
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 24537 "Photo.c"
					{
						GdkPixbuf* _tmp4_;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24544 "Photo.c"
					}
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 24548 "Photo.c"
				}
				__finally240:
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 24553 "Photo.c"
					{
						GdkPixbuf* _tmp5_;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24560 "Photo.c"
					}
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return NULL;
#line 24568 "Photo.c"
				}
			}
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp7_;
#line 24577 "Photo.c"
			{
				GdkPixbuf* _tmp8_;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24584 "Photo.c"
			}
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 24588 "Photo.c"
		}
		__finally239:
		{
			GdkPixbuf* _tmp9_;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24597 "Photo.c"
		}
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24605 "Photo.c"
	}
}


/**
     * @brief Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean
photo_discard_prefetched (Photo* self,
                          gboolean immed)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24623 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24631 "Photo.c"
		{
			GTimer* _tmp1_;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_;
#line 3236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 24645 "Photo.c"
				{
					GdkPixbuf* _tmp2_;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24652 "Photo.c"
				}
#line 3237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 24656 "Photo.c"
			}
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = TRUE;
#line 24668 "Photo.c"
			} else {
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = immed;
#line 24672 "Photo.c"
			}
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_) {
#line 24676 "Photo.c"
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp8_);
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 24697 "Photo.c"
				{
					GdkPixbuf* _tmp9_;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24704 "Photo.c"
				}
#line 3246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 24708 "Photo.c"
			}
#line 3249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = TRUE;
#line 24712 "Photo.c"
			{
				GdkPixbuf* _tmp10_;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24719 "Photo.c"
			}
#line 3249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 24723 "Photo.c"
		}
		__finally241:
		{
			GdkPixbuf* _tmp11_;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24732 "Photo.c"
		}
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp12_;
#line 24740 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	GTimer* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GdkPixbuf* _tmp26_;
	gboolean _tmp68_;
	gboolean _tmp78_ = FALSE;
	gboolean _tmp79_;
	GError * _inner_error_ = NULL;
#line 3264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 3278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 24804 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = FALSE;
#line 24808 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 24812 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = TRUE;
#line 24819 "Photo.c"
		} else {
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 24823 "Photo.c"
		}
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp6_) {
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = TRUE;
#line 24829 "Photo.c"
		} else {
#line 3280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 24833 "Photo.c"
		}
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 24837 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 24841 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 24847 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 24851 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 3282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self));
#line 24857 "Photo.c"
	}
#line 3287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances = NULL;
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformer = NULL;
#line 24871 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = self->row;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24878 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original = _tmp8_;
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, exceptions, &_tmp9_);
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled = _tmp10_;
#line 3298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = scaled;
#line 3298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = scaled;
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop = _tmp16_;
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_cropped = _tmp17_;
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_straightened = _tmp19_;
#line 3308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 24936 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				transformer = _tmp20_;
#line 24944 "Photo.c"
			}
#line 3311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 24948 "Photo.c"
		}
		__finally242:
		{
			PhotoRow* _tmp21_;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = self->row;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24957 "Photo.c"
		}
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 24969 "Photo.c"
		}
	}
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error_);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24984 "Photo.c"
	}
#line 3319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self);
#line 3319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp22_;
#line 3322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = self->priv->secs_since_access;
#line 3322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_timer_start (_tmp23_);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = data_object_to_string ((DataObject*) self);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3323: pipeline being run against %s, timer restarted.", _tmp25_);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 3325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = pixbuf;
#line 3325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp26_ != NULL, "pixbuf != null");
#line 3332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 25008 "Photo.c"
		EditingToolsRedeyeInstance* _tmp27_;
		gint _tmp27__length1;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = redeye_instances;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27__length1 = redeye_instances_length1;
#line 25015 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			instance_collection = _tmp27_;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			instance_collection_length1 = _tmp27__length1;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp27__length1; instance_it = instance_it + 1) {
#line 25027 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 25031 "Photo.c"
				{
					GdkPixbuf* _tmp28_;
					EditingToolsRedeyeInstance _tmp29_;
					GdkPixbuf* _tmp30_;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = pixbuf;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = instance;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = photo_do_redeye (self, _tmp28_, &_tmp29_);
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					pixbuf = _tmp30_;
#line 25046 "Photo.c"
				}
			}
		}
	}
#line 3346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 25053 "Photo.c"
		gboolean _tmp31_;
#line 3350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = is_straightened;
#line 3350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp31_) {
#line 25059 "Photo.c"
			GdkPixbuf* _tmp32_;
			gdouble _tmp33_;
			GdkPixbuf* _tmp34_;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = pixbuf;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = straightening_angle;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = rotate_arb (_tmp32_, _tmp33_);
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixbuf = _tmp34_;
#line 25073 "Photo.c"
		}
	}
#line 3360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 25078 "Photo.c"
		gboolean _tmp35_;
#line 3364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = is_cropped;
#line 3364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp35_) {
#line 25084 "Photo.c"
			Box _tmp36_;
			gint _tmp37_;
			GdkPixbuf* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			Box _tmp41_;
			gint _tmp42_;
			GdkPixbuf* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			Box _tmp46_;
			gint _tmp47_;
			Box _tmp48_;
			gint _tmp49_;
			GdkPixbuf* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			Box _tmp53_;
			gint _tmp54_;
			Box _tmp55_;
			gint _tmp56_;
			GdkPixbuf* _tmp57_;
			gint _tmp58_;
			gint _tmp59_;
			GdkPixbuf* _tmp60_;
			Box _tmp61_;
			gint _tmp62_;
			Box _tmp63_;
			gint _tmp64_;
			GdkPixbuf* _tmp65_;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = crop;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp36_.left;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = pixbuf;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = gdk_pixbuf_get_width (_tmp38_);
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.left = CLAMP (_tmp37_, 0, _tmp40_ - 2);
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = crop;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = _tmp41_.top;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = pixbuf;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = gdk_pixbuf_get_height (_tmp43_);
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.top = CLAMP (_tmp42_, 0, _tmp45_ - 2);
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp46_ = crop;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp47_ = _tmp46_.right;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp48_ = crop;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49_ = _tmp48_.left;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp50_ = pixbuf;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp51_ = gdk_pixbuf_get_width (_tmp50_);
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = _tmp51_;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.right = CLAMP (_tmp47_, _tmp49_ + 1, _tmp52_ - 1);
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = crop;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = _tmp53_.bottom;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = crop;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = _tmp55_.top;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57_ = pixbuf;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58_ = gdk_pixbuf_get_height (_tmp57_);
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp59_ = _tmp58_;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.bottom = CLAMP (_tmp54_, _tmp56_ + 1, _tmp59_ - 1);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp60_ = pixbuf;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp61_ = crop;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp62_ = _tmp61_.left;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp63_ = crop;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp64_ = _tmp63_.top;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp65_ = gdk_pixbuf_new_subpixbuf (_tmp60_, _tmp62_, _tmp64_, box_get_width (&crop), box_get_height (&crop));
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixbuf = _tmp65_;
#line 25187 "Photo.c"
		}
	}
#line 3385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 25192 "Photo.c"
		GdkPixbuf* _tmp66_;
		GdkPixbuf* _tmp67_;
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = pixbuf;
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = orientation_rotate_pixbuf (orientation, _tmp66_);
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp67_;
#line 25203 "Photo.c"
	}
#line 3402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp68_ = is_scaled;
#line 3402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp68_) {
#line 25209 "Photo.c"
		GdkPixbuf* _tmp69_;
		Dimensions _tmp70_;
		gint _tmp71_;
		Dimensions _tmp72_;
		gint _tmp73_;
		GdkPixbuf* _tmp74_;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = pixbuf;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = scaled_to_viewport;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = _tmp70_.width;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = scaled_to_viewport;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = _tmp72_.height;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = gdk_pixbuf_scale_simple (_tmp69_, _tmp71_, _tmp73_, GDK_INTERP_BILINEAR);
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp74_;
#line 25232 "Photo.c"
	}
#line 3408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 25236 "Photo.c"
		PixelTransformer* _tmp75_;
#line 3412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = transformer;
#line 3412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp75_ != NULL) {
#line 25242 "Photo.c"
			PixelTransformer* _tmp76_;
			GdkPixbuf* _tmp77_;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = transformer;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = pixbuf;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp76_, _tmp77_, NULL);
#line 25251 "Photo.c"
		}
	}
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp79_ = is_scaled;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp79_) {
#line 25258 "Photo.c"
		gboolean _tmp80_;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp80_ = is_straightened;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = !_tmp80_;
#line 25264 "Photo.c"
	} else {
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = FALSE;
#line 25268 "Photo.c"
	}
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp78_) {
#line 25272 "Photo.c"
		GdkPixbuf* _tmp81_;
		Dimensions _tmp82_ = {0};
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = pixbuf;
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dimensions_for_pixbuf (_tmp81_, &_tmp82_);
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp82_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 25281 "Photo.c"
	}
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 25291 "Photo.c"
}


static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return _tmp0_;
#line 25303 "Photo.c"
}


gboolean
photo_has_user_generated_metadata (Photo* self)
{
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 25314 "Photo.c"
}


static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 25326 "Photo.c"
}


void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 25338 "Photo.c"
}


gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result = NULL;
#line 3444 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (file_format != NULL) {
#line 25351 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp7_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 25386 "Photo.c"
	} else {
#line 3448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 25390 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = media_source_get_master_file ((MediaSource*) self);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp15_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 25425 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = media_source_get_master_file ((MediaSource*) self);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp23_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 25461 "Photo.c"
		}
	}
}


static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp56_;
	PhotoMetadata* _tmp57_;
	PhotoMetadata* _tmp59_;
	PhotoFileMetadataWriter* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	PhotoFileMetadataWriter* _tmp82_;
	PhotoMetadata* _tmp83_;
	GError * _inner_error_ = NULL;
#line 3458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	export_reader = NULL;
#line 3462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_master = TRUE;
#line 25522 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 25529 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25540 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp5_));
#line 25549 "Photo.c"
			} else {
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 25553 "Photo.c"
			}
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_) {
#line 25557 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				export_reader = _tmp8_;
#line 3466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				is_master = FALSE;
#line 25573 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 25584 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp13_));
#line 25593 "Photo.c"
				} else {
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = FALSE;
#line 25597 "Photo.c"
				}
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp9_) {
#line 25601 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					export_reader = _tmp16_;
#line 3469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					is_master = FALSE;
#line 25617 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp18_))) {
#line 25627 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						export_reader = _tmp21_;
#line 25641 "Photo.c"
					}
				}
			}
		}
		__finally243:
		{
			PhotoBackingReaders* _tmp22_;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25653 "Photo.c"
		}
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25657 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp23_;
#line 25665 "Photo.c"
		}
	}
#line 3475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = export_reader;
#line 3475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 25678 "Photo.c"
	}
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = export_reader;
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp25_));
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	format_properties = _tmp26_;
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = format_properties;
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dest_file = _tmp28_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = export_reader;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = dest_file;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp29_), _tmp32_, &_inner_error_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp34_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25710 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp35_;
#line 25722 "Photo.c"
	}
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = data_object_to_string ((DataObject*) self);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = writer;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp38_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3487: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = export_reader;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp41_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = dest_file;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25754 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp45_;
#line 25768 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 25772 "Photo.c"
		gboolean _tmp51_;
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = is_master;
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp51_;
#line 25778 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = FALSE;
#line 25782 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp50_) {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 25788 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = FALSE;
#line 25792 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp49_) {
#line 25796 "Photo.c"
		gchar* _tmp52_;
		gchar* _tmp53_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = media_source_get_title ((MediaSource*) self);
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp53_ == NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp53_);
#line 25807 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = FALSE;
#line 25811 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp48_) {
#line 25815 "Photo.c"
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = media_source_get_comment ((MediaSource*) self);
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = _tmp54_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = _tmp55_ == NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp55_);
#line 25826 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = FALSE;
#line 25830 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp47_) {
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = export_metadata;
#line 25836 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = FALSE;
#line 25840 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp46_) {
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 25856 "Photo.c"
	}
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp56_ = export_reader;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp57_ = photo_file_reader_read_metadata (_tmp56_, &_inner_error_);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp57_;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25866 "Photo.c"
		gboolean _tmp58_ = FALSE;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp58_;
#line 25880 "Photo.c"
	}
#line 3500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp59_ = metadata;
#line 3500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp59_ == NULL) {
#line 25886 "Photo.c"
		PhotoFileReader* _tmp60_;
		PhotoMetadata* _tmp61_;
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = export_reader;
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp60_));
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp61_;
#line 25897 "Photo.c"
	}
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp62_ = writer;
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp63_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp62_);
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp64_ = _tmp63_;
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3503: Updating metadata of %s", _tmp64_);
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp64_);
#line 3505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (media_source_get_exposure_time ((MediaSource*) self) != ((time_t) 0)) {
#line 25911 "Photo.c"
		PhotoMetadata* _tmp65_;
		MetadataDateTime* _tmp66_;
		MetadataDateTime* _tmp67_;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = metadata;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = _tmp66_;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp65_, _tmp67_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp67_);
#line 25925 "Photo.c"
	} else {
		PhotoMetadata* _tmp68_;
#line 3508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp68_ = metadata;
#line 3508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp68_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25932 "Photo.c"
	}
#line 3510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (export_metadata) {
#line 25936 "Photo.c"
		PhotoMetadata* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		PhotoMetadata* _tmp72_;
		gchar* _tmp73_;
		gchar* _tmp74_;
		PhotoMetadata* _tmp75_;
		Dimensions _tmp76_ = {0};
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp78_;
		PhotoMetadata* _tmp80_;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = metadata;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = media_source_get_title ((MediaSource*) self);
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_title (_tmp69_, _tmp71_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp71_);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = metadata;
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = media_source_get_comment ((MediaSource*) self);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = _tmp73_;
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_comment (_tmp72_, _tmp74_);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp74_);
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = metadata;
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp76_);
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp75_, &_tmp76_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp77_ = metadata;
#line 3515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp77_, photo_get_orientation (self));
#line 3516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = metadata;
#line 3516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_software (_tmp78_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3518 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 25984 "Photo.c"
			PhotoMetadata* _tmp79_;
#line 3519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp79_ = metadata;
#line 3519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp79_);
#line 25990 "Photo.c"
		}
#line 3521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp80_ = metadata;
#line 3521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp80_);
#line 25996 "Photo.c"
	} else {
		PhotoMetadata* _tmp81_;
#line 3524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = metadata;
#line 3524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_clear (_tmp81_);
#line 26003 "Photo.c"
	}
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = writer;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp83_ = metadata;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp82_, _tmp83_, &_inner_error_);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26013 "Photo.c"
		gboolean _tmp84_ = FALSE;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp84_;
#line 26029 "Photo.c"
	}
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 26045 "Photo.c"
}


gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 3534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = TRUE;
#line 26066 "Photo.c"
	} else {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 26070 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = TRUE;
#line 26076 "Photo.c"
	} else {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 26080 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 26086 "Photo.c"
	} else {
#line 3536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 26090 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 26096 "Photo.c"
}


void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError * _inner_error_ = NULL;
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (dest_file != NULL);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (direct_copy_unmodified) {
#line 26150 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26167 "Photo.c"
		}
#line 3547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26171 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 26175 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = TRUE;
#line 26181 "Photo.c"
		} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 26185 "Photo.c"
		}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 26189 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = FALSE;
#line 26193 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 26199 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = FALSE;
#line 26203 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_) {
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 26209 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = FALSE;
#line 26213 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 26217 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error_);
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26227 "Photo.c"
		}
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp6_) {
#line 3557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26233 "Photo.c"
		}
	}
#line 3563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_source_get_metadata ((PhotoSource*) self);
#line 3563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp7_;
#line 3564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = metadata;
#line 3564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 26244 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp9_;
#line 26252 "Photo.c"
	}
#line 3567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 26258 "Photo.c"
	}
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp13_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26280 "Photo.c"
	}
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = data_object_to_string ((DataObject*) self);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = writer;
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp16_);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3572: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = TRUE;
#line 26304 "Photo.c"
	} else {
#line 3580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26308 "Photo.c"
	}
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp20_) {
#line 26312 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = *scaling;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26335 "Photo.c"
		}
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = NULL;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp24_;
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 26347 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = *scaling;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26371 "Photo.c"
		}
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = NULL;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp28_;
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 26383 "Photo.c"
	}
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = writer;
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error_);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26403 "Photo.c"
	}
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = writer;
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp31_);
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3591: Setting EXIF for %s", _tmp33_);
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (export_metadata) {
#line 26417 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = metadata;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = media_source_get_title ((MediaSource*) self);
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = metadata;
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = media_source_get_comment ((MediaSource*) self);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = metadata;
#line 3598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_software (_tmp40_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (media_source_get_exposure_time ((MediaSource*) self) != ((time_t) 0)) {
#line 26454 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = metadata;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 26468 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = metadata;
#line 3603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26475 "Photo.c"
		}
#line 3605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = metadata;
#line 3605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = metadata;
#line 3606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = metadata;
#line 3607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 26491 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp48_ = metadata;
#line 3610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 26497 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = metadata;
#line 3613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 26505 "Photo.c"
	}
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = TRUE;
#line 26511 "Photo.c"
	} else {
#line 3621 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26515 "Photo.c"
	}
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp50_) {
#line 26519 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = metadata;
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = metadata;
#line 3623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 26533 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = metadata;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = metadata;
#line 3627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 26551 "Photo.c"
	}
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26577 "Photo.c"
	}
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp63_ = metadata;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26597 "Photo.c"
	}
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26607 "Photo.c"
}


static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp3_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* editable_basename = NULL;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean collision = FALSE;
	GFile* _tmp21_ = NULL;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GError * _inner_error_ = NULL;
#line 3633 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26643 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 26650 "Photo.c"
		{
			GFile* _tmp1_;
#line 3636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = media_source_get_file ((MediaSource*) self);
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = _tmp1_;
#line 26661 "Photo.c"
		}
		__finally244:
		{
			PhotoRow* _tmp2_;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 26670 "Photo.c"
		}
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 26680 "Photo.c"
		}
	}
#line 3640 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _vala_file_format;
#line 3640 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_file_format_can_write (_tmp3_)) {
#line 3641 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 26689 "Photo.c"
	}
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_file_get_basename (backing);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	disassemble_filename (_tmp5_, &_tmp6_, &_tmp7_);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name = _tmp6_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp7_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp5_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = ext;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ == NULL) {
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = TRUE;
#line 26713 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_;
		PhotoFileFormatProperties* _tmp11_;
		PhotoFileFormatProperties* _tmp12_;
		const gchar* _tmp13_;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _vala_file_format;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = photo_file_format_get_properties (_tmp10_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = ext;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = !photo_file_format_properties_is_recognized_extension (_tmp12_, _tmp13_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp12_);
#line 26731 "Photo.c"
	}
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 26735 "Photo.c"
		PhotoFileFormat _tmp14_;
		PhotoFileFormatProperties* _tmp15_;
		PhotoFileFormatProperties* _tmp16_;
		gchar* _tmp17_;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _vala_file_format;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = photo_file_format_get_properties (_tmp14_);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_get_default_extension (_tmp16_);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ext = _tmp17_;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp16_);
#line 26754 "Photo.c"
	}
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = name;
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = ext;
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = g_strdup_printf ("%s_%s.%s", _tmp18_, _ ("modified"), _tmp19_);
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_basename = _tmp20_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = g_file_get_parent (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = generate_unique_file (_tmp23_, editable_basename, &_tmp24_, &_inner_error_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	collision = _tmp24_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp23_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp26_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (name);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 26792 "Photo.c"
	}
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = _tmp21_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = NULL;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp27_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp21_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (file_format) {
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*file_format = _vala_file_format;
#line 26814 "Photo.c"
	}
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 26818 "Photo.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 26827 "Photo.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 26836 "Photo.c"
}


static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     const gchar* commandline,
                     GError** error)
{
	gboolean result = FALSE;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp4_;
	GAppInfo* _tmp5_;
	gchar** argv = NULL;
	gchar** _tmp10_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GPid child_pid = 0;
	gboolean _tmp17_ = FALSE;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GPid _tmp19_ = 0;
	gboolean _tmp20_;
	GError * _inner_error_ = NULL;
#line 3655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (commandline != NULL, FALSE);
#line 3657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (is_string_empty (commandline)) {
#line 3658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 26880 "Photo.c"
	}
	{
		GAppInfo* _tmp0_ = NULL;
		GAppInfo* _tmp1_;
		GAppInfo* _tmp2_;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = g_app_info_create_from_commandline (commandline, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp1_;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26892 "Photo.c"
			goto __catch245_g_error;
		}
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp0_;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app = _tmp2_;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 26905 "Photo.c"
	}
	goto __finally245;
	__catch245_g_error:
	{
		GError* er = NULL;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		er = _inner_error_;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 3665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app = NULL;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (er);
#line 26921 "Photo.c"
	}
	__finally245:
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26926 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp3_;
#line 26934 "Photo.c"
	}
#line 3668 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = NULL;
#line 3669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (file);
#line 3669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = g_list_insert (files, _tmp4_, -1);
#line 3671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = app;
#line 3671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 26946 "Photo.c"
		gboolean _tmp6_ = FALSE;
		GAppInfo* _tmp7_;
		GList* _tmp8_;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = app;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = files;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_app_info_launch (_tmp7_, _tmp8_, NULL, &_inner_error_);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26958 "Photo.c"
			gboolean _tmp9_ = FALSE;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp9_;
#line 26968 "Photo.c"
		}
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp6_;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 26978 "Photo.c"
	}
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv = _tmp10_;
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv_length1 = 2;
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = argv;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11__length1 = argv_length1;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = g_strdup (commandline);
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp11_[0]);
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_[0] = _tmp12_;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp11_[0];
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = argv;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14__length1 = argv_length1;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = g_file_get_path (file);
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp14_[1]);
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_[1] = _tmp15_;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp14_[1];
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = argv;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18__length1 = argv_length1;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = g_spawn_async ("/", _tmp18_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp19_, &_inner_error_);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	child_pid = _tmp19_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp20_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27024 "Photo.c"
		gboolean _tmp21_ = FALSE;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp21_;
#line 27036 "Photo.c"
	}
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp17_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 27048 "Photo.c"
}


void
photo_open_with_raw_external_editor (Photo* self,
                                     const gchar* external_editor,
                                     GError** error)
{
	ConfigFacade* _tmp0_;
	ConfigFacade* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = config_facade_get_instance ();
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	configuration_facade_set_external_raw_app ((ConfigurationFacade*) _tmp1_, external_editor);
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_launch_editor (_tmp3_, photo_get_master_file_format (self), external_editor, &_inner_error_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp3_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27088 "Photo.c"
	}
}


void
photo_open_with_external_editor (Photo* self,
                                 const gchar* external_editor,
                                 GError** error)
{
	GFile* modified_file = NULL;
	GFile* _tmp0_;
	ConfigFacade* _tmp1_;
	ConfigFacade* _tmp2_;
	GFile* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_modified_file (self, &_inner_error_);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modified_file = _tmp0_;
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27118 "Photo.c"
	}
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = config_facade_get_instance ();
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	configuration_facade_set_external_photo_app ((ConfigurationFacade*) _tmp2_, external_editor);
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp2_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = modified_file;
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_launch_editor (_tmp3_, photo_get_file_format (self), external_editor, &_inner_error_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (modified_file);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27140 "Photo.c"
	}
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (modified_file);
#line 27144 "Photo.c"
}


GFile*
photo_get_modified_file (Photo* self,
                         GError** error)
{
	GFile* result = NULL;
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GFile* _tmp23_;
	GFile* _tmp40_;
	GFileMonitor* _tmp41_;
	GError * _inner_error_ = NULL;
#line 3705 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	current_editable_file = NULL;
#line 3707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	create_editable_file = NULL;
#line 27170 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27177 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27188 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 27202 "Photo.c"
			}
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 27208 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error_);
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27221 "Photo.c"
					goto __finally246;
				}
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = NULL;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 27234 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp12_);
#line 27244 "Photo.c"
			}
		}
		__finally246:
		{
			PhotoBackingReaders* _tmp13_;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27254 "Photo.c"
		}
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27266 "Photo.c"
		}
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 27273 "Photo.c"
		GFile* _tmp17_;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 27279 "Photo.c"
	} else {
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = FALSE;
#line 27283 "Photo.c"
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 27287 "Photo.c"
		gboolean _tmp18_ = FALSE;
		GFile* _tmp19_;
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = current_editable_file;
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = TRUE;
#line 27296 "Photo.c"
		} else {
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = photo_has_transformations (self);
#line 27300 "Photo.c"
		}
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp18_;
#line 27304 "Photo.c"
	} else {
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = FALSE;
#line 27308 "Photo.c"
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp14_) {
#line 27312 "Photo.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		create_editable_file = _tmp21_;
#line 27323 "Photo.c"
	}
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = create_editable_file;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 27329 "Photo.c"
		PhotoFileFormat _tmp24_;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = editable_file_format;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = photo_file_format_can_write (_tmp24_);
#line 27335 "Photo.c"
	} else {
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = FALSE;
#line 27339 "Photo.c"
	}
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_) {
#line 27343 "Photo.c"
		PhotoFileFormat _tmp36_;
		GFile* _tmp37_;
		GFile* _tmp38_;
		GFile* _tmp39_;
#line 3727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27350 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
			PhotoFileFormat _tmp27_;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = editable_file_format;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, _tmp27_, FALSE, TRUE, &_inner_error_);
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27365 "Photo.c"
				goto __catch247_g_error;
			}
		}
		goto __finally247;
		__catch247_g_error:
		{
			GError* err = NULL;
			GError* _tmp34_;
			GError* _tmp35_;
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 27379 "Photo.c"
			{
				GFile* _tmp28_;
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_file_delete (_tmp28_, NULL, &_inner_error_);
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27388 "Photo.c"
					goto __catch248_g_error;
				}
			}
			goto __finally248;
			__catch248_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GError* _tmp32_;
				const gchar* _tmp33_;
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				delete_err = _inner_error_;
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = create_editable_file;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = g_file_get_path (_tmp29_);
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = delete_err;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tmp32_->message;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:3738: Unable to delete editable file %s after export error:" \
" %s", _tmp31_, _tmp33_);
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp31_);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27421 "Photo.c"
			}
			__finally248:
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 27440 "Photo.c"
			}
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = err;
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = _g_error_copy0 (_tmp34_);
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = _tmp35_;
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 27450 "Photo.c"
			goto __finally247;
		}
		__finally247:
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27464 "Photo.c"
		}
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = editable_file_format;
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = create_editable_file;
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_attach_editable (self, _tmp36_, _tmp37_, &_inner_error_);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27482 "Photo.c"
		}
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = create_editable_file;
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = _g_object_ref0 (_tmp38_);
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		current_editable_file = _tmp39_;
#line 27492 "Photo.c"
	}
#line 3751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = current_editable_file;
#line 3751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp40_ != NULL, "current_editable_file != null");
#line 3754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = self->priv->editable_monitor;
#line 3754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp41_ == NULL) {
#line 27502 "Photo.c"
		GFile* _tmp42_;
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = current_editable_file;
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp42_, &_inner_error_);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27518 "Photo.c"
		}
	}
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = current_editable_file;
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 27527 "Photo.c"
}


void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3760 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 27539 "Photo.c"
}


static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 27552 "Photo.c"
}


static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27584 "Photo.c"
	}
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 27600 "Photo.c"
}


static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27622 "Photo.c"
	}
#line 3779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp1_;
#line 3780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 3780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 27632 "Photo.c"
		GFile* _tmp3_;
#line 3781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = file;
#line 3781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 27638 "Photo.c"
	}
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 27656 "Photo.c"
}


static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27697 "Photo.c"
	}
}


static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError * _inner_error_ = NULL;
#line 3797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27717 "Photo.c"
	}
}


void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError * _inner_error_ = NULL;
#line 3801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27737 "Photo.c"
	}
}


static void
_vala_array_add108 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27754 "Photo.c"
	}
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27760 "Photo.c"
}


static void
_vala_array_add109 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27776 "Photo.c"
	}
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27782 "Photo.c"
}


static void
_vala_array_add110 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27798 "Photo.c"
	}
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27804 "Photo.c"
}


static void
_vala_array_add111 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27820 "Photo.c"
	}
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27826 "Photo.c"
}


static void
_vala_array_add112 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27842 "Photo.c"
	}
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27848 "Photo.c"
}


static void
_vala_array_add113 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27864 "Photo.c"
	}
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27870 "Photo.c"
}


static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp87_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp96_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp97_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	GError * _inner_error_ = NULL;
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (only_attributes) {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 27918 "Photo.c"
	} else {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 27922 "Photo.c"
	}
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 27928 "Photo.c"
	} else {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 27932 "Photo.c"
	}
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes  &&new_reader == null) || (!only_attributes)");
#line 3811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_reader = _tmp2_;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = new_reader;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 27944 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = old_reader;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 27950 "Photo.c"
	}
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp5_;
#line 3814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = reader;
#line 3814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27968 "Photo.c"
	}
#line 3820 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filesize_changed = FALSE;
#line 3822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_new_editable = FALSE;
#line 3824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_id = _tmp7_;
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = reader;
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp8_);
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp9_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = file;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error_);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp11_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp12_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 28010 "Photo.c"
	}
#line 3832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 28014 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = backing;
#line 3834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 28020 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = backing;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28050 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = self->row;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28058 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
					Orientation _tmp28_;
#line 3837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					filesize_changed = TRUE;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = self->row;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = backing;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error_);
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28091 "Photo.c"
						goto __finally249;
					}
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = backing;
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = _tmp27_->original_orientation;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_orientation (self, _tmp28_);
#line 28116 "Photo.c"
				}
				__finally249:
				{
					PhotoRow* _tmp29_;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = self->row;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28125 "Photo.c"
				}
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (file);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28143 "Photo.c"
				}
			}
		}
#line 3846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		is_new_editable = TRUE;
#line 28149 "Photo.c"
	}
#line 3849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (only_attributes) {
#line 28153 "Photo.c"
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp38_;
		GTimeVal _tmp39_ = {0};
		BackingPhotoTable* _tmp40_;
		BackingPhotoTable* _tmp41_;
		BackingPhotoID _tmp42_;
		GTimeVal _tmp43_;
		glong _tmp44_;
		GFileInfo* _tmp45_;
#line 3851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid ()");
#line 28166 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = file;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28180 "Photo.c"
				goto __catch250_g_error;
			}
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = NULL;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			info = _tmp33_;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 28193 "Photo.c"
		}
		goto __finally250;
		__catch250_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = data_object_to_string ((DataObject*) self);
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = err;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3857: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp35_);
#line 3858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28237 "Photo.c"
		}
		__finally250:
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28258 "Photo.c"
		}
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = info;
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_file_info_get_modification_time (_tmp38_, &_tmp39_);
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		timestamp = _tmp39_;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = backing_photo_table_get_instance ();
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = editable_id;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = timestamp;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_.tv_sec;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = info;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp41_, &_tmp42_, (time_t) _tmp44_, g_file_info_get_size (_tmp45_), &_inner_error_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp41_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28300 "Photo.c"
		}
		{
			PhotoRow* _tmp46_;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp46_ = self->row;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 28308 "Photo.c"
			{
				BackingPhotoRow* _tmp47_;
				time_t _tmp48_;
				GTimeVal _tmp49_;
				glong _tmp50_;
				BackingPhotoRow* _tmp51_;
				gint64 _tmp52_;
				GFileInfo* _tmp53_;
				BackingPhotoRow* _tmp54_;
				GTimeVal _tmp55_;
				glong _tmp56_;
				BackingPhotoRow* _tmp57_;
				GFileInfo* _tmp58_;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = self->priv->editable;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = _tmp47_->timestamp;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = timestamp;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp50_ = _tmp49_.tv_sec;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				timestamp_changed = _tmp48_ != ((time_t) _tmp50_);
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp51_ = self->priv->editable;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp52_ = _tmp51_->filesize;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = info;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				filesize_changed = _tmp52_ != g_file_info_get_size (_tmp53_);
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_ = self->priv->editable;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = timestamp;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = _tmp55_.tv_sec;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_->timestamp = (time_t) _tmp56_;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = self->priv->editable;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = info;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_->filesize = g_file_info_get_size (_tmp58_);
#line 28354 "Photo.c"
			}
			__finally251:
			{
				PhotoRow* _tmp59_;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = self->row;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28363 "Photo.c"
			}
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (info);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28383 "Photo.c"
			}
		}
#line 3849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 28388 "Photo.c"
	} else {
		gboolean _tmp60_ = FALSE;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 28393 "Photo.c"
			gboolean _tmp61_;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp61_ = is_new_editable;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp60_ = !_tmp61_;
#line 28399 "Photo.c"
		} else {
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp60_ = FALSE;
#line 28403 "Photo.c"
		}
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp60_) {
#line 28407 "Photo.c"
			BackingPhotoRow* _tmp62_;
			BackingPhotoID _tmp63_;
			BackingPhotoTable* _tmp64_;
			BackingPhotoTable* _tmp65_;
			BackingPhotoRow* _tmp66_;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp62_ = backing;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp63_ = editable_id;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp62_->id = _tmp63_;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp64_ = backing_photo_table_get_instance ();
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp65_ = _tmp64_;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp66_ = backing;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_update (_tmp65_, _tmp66_, &_inner_error_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp65_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28445 "Photo.c"
			}
			{
				PhotoRow* _tmp67_;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = self->row;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28453 "Photo.c"
				{
					BackingPhotoRow* _tmp68_;
					time_t _tmp69_;
					BackingPhotoRow* _tmp70_;
					time_t _tmp71_;
					BackingPhotoRow* _tmp72_;
					gint64 _tmp73_;
					BackingPhotoRow* _tmp74_;
					gint64 _tmp75_;
					BackingPhotoRow* _tmp76_;
					BackingPhotoRow* _tmp77_;
					BackingPhotoRow* _tmp78_;
					BackingPhotoRow* _tmp79_;
					BackingPhotoRow* _tmp80_;
					Orientation _tmp81_;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp68_ = self->priv->editable;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp69_ = _tmp68_->timestamp;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp70_ = backing;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp71_ = _tmp70_->timestamp;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					timestamp_changed = _tmp69_ != _tmp71_;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp72_ = self->priv->editable;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp73_ = _tmp72_->filesize;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp74_ = backing;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp75_ = _tmp74_->filesize;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					filesize_changed = _tmp73_ != _tmp75_;
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp76_ = backing;
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp77_ = _backing_photo_row_ref0 (_tmp76_);
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->editable = _tmp77_;
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp78_ = self->priv->editable;
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp79_;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp80_ = self->backing_photo_row;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp81_ = _tmp80_->original_orientation;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_orientation (self, _tmp81_);
#line 28511 "Photo.c"
				}
				__finally252:
				{
					PhotoRow* _tmp82_;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp82_ = self->row;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28520 "Photo.c"
				}
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (file);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28538 "Photo.c"
				}
			}
		}
	}
#line 3895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (new_reader != NULL) {
#line 28545 "Photo.c"
		{
			PhotoBackingReaders* _tmp83_;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp83_ = self->priv->readers;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28552 "Photo.c"
			{
				PhotoBackingReaders* _tmp84_;
				PhotoFileReader* _tmp85_;
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp84_ = self->priv->readers;
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp85_ = _photo_file_adapter_ref0 (new_reader);
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp84_->editable);
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp84_->editable = _tmp85_;
#line 28564 "Photo.c"
			}
			__finally253:
			{
				PhotoBackingReaders* _tmp86_;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp86_ = self->priv->readers;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28573 "Photo.c"
			}
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28591 "Photo.c"
			}
		}
	}
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!only_attributes) {
#line 28597 "Photo.c"
		PhotoFileReader* _tmp88_;
		PhotoFileReader* _tmp89_;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp88_ = reader;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp89_ = old_reader;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = _tmp88_ != _tmp89_;
#line 28606 "Photo.c"
	} else {
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = FALSE;
#line 28610 "Photo.c"
	}
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp87_) {
#line 28614 "Photo.c"
		GFile* _tmp90_ = NULL;
		PhotoFileReader* _tmp91_;
		GFile* _tmp94_ = NULL;
#line 3902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp91_ = old_reader;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp91_ != NULL) {
#line 28624 "Photo.c"
			PhotoFileReader* _tmp92_;
			GFile* _tmp93_;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp92_ = old_reader;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp93_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp92_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp90_ = _tmp93_;
#line 28635 "Photo.c"
		} else {
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp90_ = NULL;
#line 28641 "Photo.c"
		}
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (new_reader != NULL) {
#line 28645 "Photo.c"
			GFile* _tmp95_;
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp95_ = photo_file_adapter_get_file ((PhotoFileAdapter*) new_reader);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp94_ = _tmp95_;
#line 28653 "Photo.c"
		} else {
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp94_ = NULL;
#line 28659 "Photo.c"
		}
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp90_, _tmp94_);
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp94_);
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp90_);
#line 28667 "Photo.c"
	}
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96_ = g_new0 (gchar*, 0 + 1);
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list = _tmp96_;
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list_length1 = 0;
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 3908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_ = timestamp_changed;
#line 3908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp97_) {
#line 28681 "Photo.c"
		gchar** _tmp98_;
		gint _tmp98__length1;
		gchar* _tmp99_;
		gchar** _tmp100_;
		gint _tmp100__length1;
		gchar* _tmp101_;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98_ = alteration_list;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98__length1 = alteration_list_length1;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp99_ = g_strdup ("metadata:editable-timestamp");
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp99_);
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = alteration_list;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100__length1 = alteration_list_length1;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp101_ = g_strdup ("metadata:baseline-timestamp");
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add109 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp101_);
#line 3912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 28706 "Photo.c"
			gchar** _tmp102_;
			gint _tmp102__length1;
			gchar* _tmp103_;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp102_ = alteration_list;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp102__length1 = alteration_list_length1;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp103_ = g_strdup ("metadata:source-timestamp");
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add110 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp103_);
#line 28718 "Photo.c"
		}
	}
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp105_ = filesize_changed;
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp105_) {
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp104_ = TRUE;
#line 28727 "Photo.c"
	} else {
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp104_ = new_reader != NULL;
#line 28731 "Photo.c"
	}
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp104_) {
#line 28735 "Photo.c"
		gchar** _tmp106_;
		gint _tmp106__length1;
		gchar* _tmp107_;
		gchar** _tmp108_;
		gint _tmp108__length1;
		gchar* _tmp109_;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp106_ = alteration_list;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp106__length1 = alteration_list_length1;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp107_ = g_strdup ("image:editable");
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add111 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp107_);
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp108_ = alteration_list;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp108__length1 = alteration_list_length1;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp109_ = g_strdup ("image:baseline");
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add112 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp109_);
#line 3920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 28760 "Photo.c"
			gchar** _tmp110_;
			gint _tmp110__length1;
			gchar* _tmp111_;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp110_ = alteration_list;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp110__length1 = alteration_list_length1;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp111_ = g_strdup ("image:source");
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add113 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp111_);
#line 28772 "Photo.c"
		}
	}
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112_ = alteration_list;
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112__length1 = alteration_list_length1;
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp112__length1 > 0) {
#line 28781 "Photo.c"
		gchar** _tmp113_;
		gint _tmp113__length1;
		Alteration* _tmp114_;
		Alteration* _tmp115_;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp113_ = alteration_list;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp113__length1 = alteration_list_length1;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp114_ = alteration_new_from_array (_tmp113_, _tmp113__length1);
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp115_ = _tmp114_;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp115_);
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp115_);
#line 28798 "Photo.c"
	}
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 28812 "Photo.c"
}


static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp8_;
	gboolean _tmp26_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_;
	GError * _inner_error_ = NULL;
#line 3928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	has_editable = FALSE;
#line 3932 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_file = NULL;
#line 28839 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28846 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28856 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file = _tmp5_;
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 3937 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				has_editable = TRUE;
#line 28879 "Photo.c"
			}
		}
		__finally254:
		{
			PhotoBackingReaders* _tmp7_;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28889 "Photo.c"
		}
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28901 "Photo.c"
		}
	}
#line 3941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = has_editable;
#line 3941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 28908 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3942 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 28912 "Photo.c"
		{
			{
				PhotoRow* _tmp9_;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->row;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28920 "Photo.c"
				{
					PhotoRow* _tmp10_;
					BackingPhotoID _tmp11_;
					PhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
					BackingPhotoRow* _tmp17_;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->row;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					editable_id = _tmp11_;
#line 3946 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 28935 "Photo.c"
						PhotoTable* _tmp12_;
						PhotoTable* _tmp13_;
						PhotoRow* _tmp14_;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = photo_table_get_instance ();
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = self->row;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_table_detach_editable (_tmp13_, _tmp14_, &_inner_error_);
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_database_table_unref0 (_tmp13_);
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28951 "Photo.c"
							goto __finally256;
						}
					}
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = self->row;
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = _tmp15_->master;
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = _backing_photo_row_ref0 (_tmp16_);
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp17_;
#line 28965 "Photo.c"
				}
				__finally256:
				{
					PhotoRow* _tmp18_;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = self->row;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28974 "Photo.c"
				}
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28980 "Photo.c"
						goto __catch255_database_error;
					}
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28991 "Photo.c"
				}
			}
		}
		goto __finally255;
		__catch255_database_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = err;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3951: Unable to remove editable from PhotoTable: %s", _tmp20_);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 29013 "Photo.c"
		}
		__finally255:
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29026 "Photo.c"
		}
		{
#line 3955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 29031 "Photo.c"
				BackingPhotoTable* _tmp21_;
				BackingPhotoTable* _tmp22_;
				BackingPhotoID _tmp23_;
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = backing_photo_table_get_instance ();
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = editable_id;
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_remove (_tmp22_, &_tmp23_, &_inner_error_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 29049 "Photo.c"
						goto __catch257_database_error;
					}
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 29060 "Photo.c"
				}
			}
		}
		goto __finally257;
		__catch257_database_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = err;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = _tmp24_->message;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3958: Unable to remove editable from BackingPhotoTable: %s", _tmp25_);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 29082 "Photo.c"
		}
		__finally257:
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29095 "Photo.c"
		}
	}
#line 3962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (remove_transformations) {
#line 3963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 29102 "Photo.c"
	}
#line 3965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = has_editable;
#line 3965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp26_) {
#line 29108 "Photo.c"
		GFile* _tmp27_;
#line 3966 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = editable_file;
#line 3967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp27_, NULL);
#line 29116 "Photo.c"
	}
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (delete_editable) {
#line 29120 "Photo.c"
		GFile* _tmp29_;
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = editable_file;
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp29_ != NULL;
#line 29126 "Photo.c"
	} else {
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = FALSE;
#line 29130 "Photo.c"
	}
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28_) {
#line 29134 "Photo.c"
		{
			GFile* _tmp30_;
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = editable_file;
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_file_trash (_tmp30_, NULL, &_inner_error_);
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29143 "Photo.c"
				goto __catch258_g_error;
			}
		}
		goto __finally258;
		__catch258_g_error:
		{
			GError* err = NULL;
			GFile* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = editable_file;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = g_file_get_path (_tmp31_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = data_object_to_string ((DataObject*) self);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = err;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3974: Unable to trash editable %s for %s: %s", _tmp33_, _tmp35_, _tmp37_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp35_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp33_);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 29184 "Photo.c"
		}
		__finally258:
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29197 "Photo.c"
		}
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = has_editable;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp40_) {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = TRUE;
#line 29206 "Photo.c"
	} else {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = remove_transformations;
#line 29210 "Photo.c"
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp39_) {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = notify;
#line 29216 "Photo.c"
	} else {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = FALSE;
#line 29220 "Photo.c"
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_) {
#line 29224 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = alteration_new ("image", "revert");
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp42_);
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 29235 "Photo.c"
	}
#line 3928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29239 "Photo.c"
}


static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 29248 "Photo.c"
}


static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 29257 "Photo.c"
}


static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 29266 "Photo.c"
}


static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError * _inner_error_ = NULL;
#line 3983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 29284 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29291 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 29302 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp5_);
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = g_file_equal (file, _tmp7_);
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 29319 "Photo.c"
			} else {
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 29323 "Photo.c"
			}
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_assert (_tmp1_, "readers.editable != null && file.equal (readers.editable.get_file ())");
#line 29327 "Photo.c"
		}
		__finally259:
		{
			PhotoBackingReaders* _tmp8_;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29336 "Photo.c"
		}
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29346 "Photo.c"
		}
	}
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = g_file_get_path (file);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3989: EDITABLE %s: %s", (_tmp9_ != NULL) ? _tmp9_->value_name : NULL, _tmp11_);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (event) {
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29365 "Photo.c"
		{
			OneShotScheduler* _tmp12_;
			OneShotScheduler* _tmp14_;
#line 3994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->priv->reimport_editable_scheduler;
#line 3994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 29373 "Photo.c"
				OneShotScheduler* _tmp13_;
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp13_;
#line 29381 "Photo.c"
			}
#line 3999 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = self->priv->reimport_editable_scheduler;
#line 3999 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp14_, (guint) 1000, TRUE);
#line 4000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29389 "Photo.c"
		}
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29393 "Photo.c"
		{
			OneShotScheduler* _tmp15_;
			OneShotScheduler* _tmp17_;
#line 4003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->priv->update_editable_attributes_scheduler;
#line 4003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp15_ == NULL) {
#line 29401 "Photo.c"
				OneShotScheduler* _tmp16_;
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp16_;
#line 29409 "Photo.c"
			}
#line 4008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->update_editable_attributes_scheduler;
#line 4008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp17_, (guint) 1000, TRUE);
#line 4009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29417 "Photo.c"
		}
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29421 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 4012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = self->priv->remove_editable_scheduler;
#line 4012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 29429 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp19_;
#line 29437 "Photo.c"
			}
#line 4017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = self->priv->remove_editable_scheduler;
#line 4017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 3000, TRUE);
#line 4018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29445 "Photo.c"
		}
		default:
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29450 "Photo.c"
		{
#line 4023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29454 "Photo.c"
		}
	}
#line 4028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 29459 "Photo.c"
}


static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4035: Reimporting editable for %s", _tmp1_);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29481 "Photo.c"
	{
#line 4037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 4037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29487 "Photo.c"
			goto __catch260_g_error;
		}
	}
	goto __finally260;
	__catch260_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4039: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 29517 "Photo.c"
	}
	__finally260:
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29528 "Photo.c"
	}
}


static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4045: Updating editable attributes for %s", _tmp1_);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29549 "Photo.c"
	{
#line 4047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 4047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29555 "Photo.c"
			goto __catch261_g_error;
		}
	}
	goto __finally261;
	__catch261_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = err;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4049: Unable to update editable attributes: %s", _tmp3_);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 29577 "Photo.c"
	}
	__finally261:
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29588 "Photo.c"
	}
}


static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 4055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = reader;
#line 4055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29619 "Photo.c"
	}
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp2_);
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 4059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = file;
#line 4059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 29631 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = data_object_to_string ((DataObject*) self);
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_debug ("Photo.vala:4060: Not removing editable for %s: file exists", _tmp6_);
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29648 "Photo.c"
	}
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = data_object_to_string ((DataObject*) self);
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4065: Removing editable for %s: file no longer exists", _tmp8_);
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4066 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 29664 "Photo.c"
}


void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp0_;
#line 4076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = dim;
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp2_;
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 29693 "Photo.c"
}


void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp1_;
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 29713 "Photo.c"
}


gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
#line 4087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw = _tmp0_;
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 4090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 29746 "Photo.c"
		}
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 29750 "Photo.c"
	}
#line 4095 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4095 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp2_;
#line 4096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 29760 "Photo.c"
		Orientation _tmp3_;
		Dimensions _tmp4_;
		Box _tmp5_;
		Box _tmp6_ = {0};
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = orientation;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = dim;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = raw;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		orientation_rotate_box (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_crop = _tmp6_;
#line 29775 "Photo.c"
	} else {
		Box _tmp7_;
#line 4101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = raw;
#line 4101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_crop = _tmp7_;
#line 29782 "Photo.c"
	}
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (crop) {
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*crop = _vala_crop;
#line 29790 "Photo.c"
	}
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 29794 "Photo.c"
}


void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	gint _tmp5_;
	Dimensions _tmp6_;
	gint _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	Box _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	Box _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	Box _tmp18_;
	gint _tmp19_;
	Box _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Box _tmp24_;
#line 4107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp0_;
#line 4109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = dim;
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *crop;
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated = _tmp3_;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = derotated;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_.left;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = dim;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_.width;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.left = CLAMP (_tmp5_, 0, _tmp7_ - 2);
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = derotated;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = derotated;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_.left;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = dim;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_.width;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.right = CLAMP (_tmp9_, _tmp11_, _tmp13_ - 1);
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = derotated;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_.top;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = dim;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp16_.height;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.top = CLAMP (_tmp15_, 0, _tmp17_ - 2);
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = derotated;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_.bottom;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = derotated;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_.top;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = dim;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_.height;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.bottom = CLAMP (_tmp19_, _tmp21_, _tmp23_ - 1);
#line 4119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = derotated;
#line 4119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp24_);
#line 29900 "Photo.c"
}


gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 4122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (theta) {
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*theta = _vala_theta;
#line 29926 "Photo.c"
		}
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 29930 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (theta) {
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*theta = _vala_theta;
#line 29938 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 29942 "Photo.c"
}


void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 29954 "Photo.c"
}


static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint _tmp1_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp20_;
	GdkPoint _tmp21_;
	gint _tmp22_;
	EditingToolsRedeyeInstance _tmp23_;
	gint _tmp24_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp25_;
	GdkPoint _tmp26_;
	gint _tmp27_;
	EditingToolsRedeyeInstance _tmp28_;
	gint _tmp29_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp30_;
	GdkPoint _tmp31_;
	gint _tmp32_;
	EditingToolsRedeyeInstance _tmp33_;
	gint _tmp34_;
	gint _tmp35_ = 0;
	gint _tmp36_;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp38_;
	GdkPoint _tmp39_;
	gint _tmp40_;
	gint _tmp41_ = 0;
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp81_;
	GdkPoint _tmp82_;
	gint _tmp83_;
	EditingToolsRedeyeInstance _tmp84_;
	GdkPoint _tmp85_;
	gint _tmp86_;
	EditingToolsRedeyeInstance _tmp87_;
	gint _tmp88_;
	gint* _tmp89_;
	gint _tmp89__length1;
	GdkPixbuf* _tmp123_;
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *inst;
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *inst;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	i = 0;
#line 30040 "Photo.c"
	{
		gdouble y = 0.0;
		gdouble _tmp5_;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = r;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y = _tmp5_;
#line 30048 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = TRUE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 30055 "Photo.c"
				gdouble _tmp8_;
				gdouble theta = 0.0;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gint x = 0;
				gdouble _tmp11_;
				gdouble _tmp12_;
				gint* _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				EditingToolsRedeyeInstance _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp6_) {
#line 30073 "Photo.c"
					gdouble _tmp7_;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = y;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y = _tmp7_ - 1.0;
#line 30079 "Photo.c"
				}
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = FALSE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = y;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp8_ >= 0.0)) {
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 30089 "Photo.c"
				}
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = y;
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = r;
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				theta = asin (_tmp9_ / _tmp10_);
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = r;
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = theta;
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				x = (gint) ((_tmp11_ * cos (_tmp12_)) + 0.5);
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = x_insets_first_quadrant;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13__length1 = x_insets_first_quadrant_length1;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = i;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = *inst;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_.radius;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = x;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_[_tmp14_] = _tmp16_ - _tmp17_;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp13_[_tmp14_];
#line 4152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = i;
#line 4152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				i = _tmp19_ + 1;
#line 30123 "Photo.c"
			}
		}
	}
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = *inst;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_.center;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = _tmp21_.x;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = *inst;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp23_.radius;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_bounds_min = _tmp22_ - _tmp24_;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = *inst;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_.center;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = _tmp26_.x;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = *inst;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = _tmp28_.radius;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_bounds_max = _tmp27_ + _tmp29_;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = *inst;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_.center;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_.y;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = *inst;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_.radius;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp32_ - _tmp34_;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = ymin;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp36_ < 0) {
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = 0;
#line 30169 "Photo.c"
	} else {
		gint _tmp37_;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = ymin;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = _tmp37_;
#line 30176 "Photo.c"
	}
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp35_;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = *inst;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = _tmp38_.center;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_.y;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp40_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = ymax;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = gdk_pixbuf_get_height (pixbuf);
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp42_ > (_tmp44_ - 1)) {
#line 30196 "Photo.c"
		gint _tmp45_;
		gint _tmp46_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = gdk_pixbuf_get_height (pixbuf);
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = _tmp45_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp46_ - 1;
#line 30205 "Photo.c"
	} else {
		gint _tmp47_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = ymax;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp47_;
#line 30212 "Photo.c"
	}
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp41_;
#line 4164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	inset_index = 0;
#line 30218 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp48_;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = ymin;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_it = _tmp48_;
#line 30226 "Photo.c"
		{
			gboolean _tmp49_ = FALSE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49_ = TRUE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 30233 "Photo.c"
				gint _tmp51_;
				gint _tmp52_;
				gint xmin = 0;
				gint _tmp53_;
				gint* _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp57_ = 0;
				gint _tmp58_;
				gint xmax = 0;
				gint _tmp60_;
				gint* _tmp61_;
				gint _tmp61__length1;
				gint _tmp62_;
				gint _tmp63_;
				gint _tmp64_ = 0;
				gint _tmp65_;
				gint _tmp66_;
				gint _tmp67_;
				gint _tmp80_;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp49_) {
#line 30257 "Photo.c"
					gint _tmp50_;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = y_it;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y_it = _tmp50_ + 1;
#line 30263 "Photo.c"
				}
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = FALSE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp51_ = y_it;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp52_ = ymax;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp51_ <= _tmp52_)) {
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 30275 "Photo.c"
				}
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = x_bounds_min;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_ = x_insets_first_quadrant;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54__length1 = x_insets_first_quadrant_length1;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = inset_index;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = _tmp54_[_tmp55_];
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp53_ + _tmp56_;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = xmin;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp58_ < 0) {
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = 0;
#line 30295 "Photo.c"
				} else {
					gint _tmp59_;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp59_ = xmin;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = _tmp59_;
#line 30302 "Photo.c"
				}
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp57_;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = x_bounds_max;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp61_ = x_insets_first_quadrant;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp61__length1 = x_insets_first_quadrant_length1;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp62_ = inset_index;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp63_ = _tmp61_[_tmp62_];
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp60_ - _tmp63_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = xmax;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = gdk_pixbuf_get_width (pixbuf);
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = _tmp66_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp65_ > (_tmp67_ - 1)) {
#line 30326 "Photo.c"
					gint _tmp68_;
					gint _tmp69_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp68_ = gdk_pixbuf_get_width (pixbuf);
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp69_ = _tmp68_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp64_ = _tmp69_ - 1;
#line 30335 "Photo.c"
				} else {
					gint _tmp70_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp70_ = xmax;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp64_ = _tmp70_;
#line 30342 "Photo.c"
				}
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp64_;
#line 30346 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp71_;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp71_ = xmin;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					x_it = _tmp71_;
#line 30354 "Photo.c"
					{
						gboolean _tmp72_ = FALSE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp72_ = TRUE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 30361 "Photo.c"
							gint _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							GdkPixbuf* _tmp78_;
							GdkPixbuf* _tmp79_;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp72_) {
#line 30370 "Photo.c"
								gint _tmp73_;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp73_ = x_it;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								x_it = _tmp73_ + 1;
#line 30376 "Photo.c"
							}
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp72_ = FALSE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp74_ = x_it;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp75_ = xmax;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!(_tmp74_ <= _tmp75_)) {
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 30388 "Photo.c"
							}
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp76_ = x_it;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp77_ = y_it;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp78_ = photo_red_reduce_pixel (self, pixbuf, _tmp76_, _tmp77_);
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp79_ = _tmp78_;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp79_);
#line 30400 "Photo.c"
						}
					}
				}
#line 4174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp80_ = inset_index;
#line 4174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				inset_index = _tmp80_ + 1;
#line 30408 "Photo.c"
			}
		}
	}
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_ = *inst;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = _tmp81_.center;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp83_ = _tmp82_.y;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp83_;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = *inst;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = _tmp84_.center;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_ = _tmp85_.y;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = *inst;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = _tmp87_.radius;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp86_ + _tmp88_;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = x_insets_first_quadrant;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89__length1 = x_insets_first_quadrant_length1;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	inset_index = _tmp89__length1 - 1;
#line 30438 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp90_;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp90_ = ymin;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_it = _tmp90_;
#line 30446 "Photo.c"
		{
			gboolean _tmp91_ = FALSE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp91_ = TRUE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 30453 "Photo.c"
				gint _tmp93_;
				gint _tmp94_;
				gint xmin = 0;
				gint _tmp95_;
				gint* _tmp96_;
				gint _tmp96__length1;
				gint _tmp97_;
				gint _tmp98_;
				gint _tmp99_ = 0;
				gint _tmp100_;
				gint xmax = 0;
				gint _tmp102_;
				gint* _tmp103_;
				gint _tmp103__length1;
				gint _tmp104_;
				gint _tmp105_;
				gint _tmp106_ = 0;
				gint _tmp107_;
				gint _tmp108_;
				gint _tmp109_;
				gint _tmp122_;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp91_) {
#line 30477 "Photo.c"
					gint _tmp92_;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp92_ = y_it;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y_it = _tmp92_ + 1;
#line 30483 "Photo.c"
				}
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp91_ = FALSE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp93_ = y_it;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp94_ = ymax;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp93_ <= _tmp94_)) {
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 30495 "Photo.c"
				}
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp95_ = x_bounds_min;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp96_ = x_insets_first_quadrant;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp96__length1 = x_insets_first_quadrant_length1;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp97_ = inset_index;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp98_ = _tmp96_[_tmp97_];
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp95_ + _tmp98_;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp100_ = xmin;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp100_ < 0) {
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp99_ = 0;
#line 30515 "Photo.c"
				} else {
					gint _tmp101_;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp101_ = xmin;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp99_ = _tmp101_;
#line 30522 "Photo.c"
				}
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp99_;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp102_ = x_bounds_max;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103_ = x_insets_first_quadrant;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103__length1 = x_insets_first_quadrant_length1;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp104_ = inset_index;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp105_ = _tmp103_[_tmp104_];
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp102_ - _tmp105_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp107_ = xmax;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp108_ = gdk_pixbuf_get_width (pixbuf);
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp109_ = _tmp108_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp107_ > (_tmp109_ - 1)) {
#line 30546 "Photo.c"
					gint _tmp110_;
					gint _tmp111_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp110_ = gdk_pixbuf_get_width (pixbuf);
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp111_ = _tmp110_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp106_ = _tmp111_ - 1;
#line 30555 "Photo.c"
				} else {
					gint _tmp112_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp112_ = xmax;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp106_ = _tmp112_;
#line 30562 "Photo.c"
				}
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp106_;
#line 30566 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp113_;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp113_ = xmin;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					x_it = _tmp113_;
#line 30574 "Photo.c"
					{
						gboolean _tmp114_ = FALSE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp114_ = TRUE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 30581 "Photo.c"
							gint _tmp116_;
							gint _tmp117_;
							gint _tmp118_;
							gint _tmp119_;
							GdkPixbuf* _tmp120_;
							GdkPixbuf* _tmp121_;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp114_) {
#line 30590 "Photo.c"
								gint _tmp115_;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp115_ = x_it;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								x_it = _tmp115_ + 1;
#line 30596 "Photo.c"
							}
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp114_ = FALSE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp116_ = x_it;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp117_ = xmax;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!(_tmp116_ <= _tmp117_)) {
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 30608 "Photo.c"
							}
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp118_ = x_it;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp119_ = y_it;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp120_ = photo_red_reduce_pixel (self, pixbuf, _tmp118_, _tmp119_);
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp121_ = _tmp120_;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp121_);
#line 30620 "Photo.c"
						}
					}
				}
#line 4191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp122_ = inset_index;
#line 4191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				inset_index = _tmp122_ - 1;
#line 30628 "Photo.c"
			}
		}
	}
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp123_ = _g_object_ref0 (pixbuf);
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp123_;
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 30640 "Photo.c"
}


static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp20_;
#line 4197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (x >= 0) {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = y >= 0;
#line 30666 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = FALSE;
#line 30670 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 30674 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 30683 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 30687 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 30691 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 30700 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 30704 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 30708 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_;
		guchar _tmp10_;
		guchar b = '\0';
		guchar* _tmp11_;
		gint _tmp11__length1;
		gint _tmp12_;
		guchar _tmp13_;
		guchar r = '\0';
		guchar _tmp14_;
		guchar _tmp15_;
		guchar* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		guchar _tmp18_;
		guchar _tmp19_;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_data = _tmp7_;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_data_length1 = -1;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = px_start_byte_offset;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp8_[_tmp9_ + 1];
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g = _tmp10_;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = pixel_data;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11__length1 = pixel_data_length1;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = px_start_byte_offset;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp11_[_tmp12_ + 2];
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		b = _tmp13_;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = g;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = b;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		r = (guchar) ((_tmp14_ + _tmp15_) / 2);
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = pixel_data;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16__length1 = pixel_data_length1;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = px_start_byte_offset;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = r;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_[_tmp17_] = _tmp18_;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp16_[_tmp17_];
#line 30777 "Photo.c"
	}
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _g_object_ref0 (pixbuf);
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp20_;
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 30785 "Photo.c"
}


void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp3_ = {0};
	gboolean _tmp4_;
	GdkPoint derotated_point = {0};
	Orientation _tmp9_;
	Dimensions _tmp10_;
	GdkPoint _tmp11_;
	GdkPoint _tmp12_ = {0};
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 4227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = unscaled_orientation;
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_dims = _tmp2_;
#line 4233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	crop_box = _tmp3_;
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 30837 "Photo.c"
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = crop_box;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_.left;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		unscaled_x_offset_raw = _tmp6_;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = crop_box;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp7_.top;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		unscaled_y_offset_raw = _tmp8_;
#line 30854 "Photo.c"
	}
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = unscaled_orientation;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = unscaled_dims;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = *unscaled_point;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_derotate_point (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point = _tmp12_;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = derotated_point.x;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = unscaled_x_offset_raw;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point.x = _tmp13_ + _tmp14_;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = derotated_point.y;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = unscaled_y_offset_raw;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point.y = _tmp15_ + _tmp16_;
#line 4249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = derotated_point;
#line 4249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 30882 "Photo.c"
}


void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_;
	gint _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	GdkPoint _tmp44_;
	gint _tmp45_;
	GdkPoint _tmp46_;
	gint _tmp47_;
#line 4252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_.x = 0;
#line 4253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left = _tmp0_;
#line 4254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_.x = 0;
#line 4254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right = _tmp1_;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left = _tmp15_;
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right = _tmp17_;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 30998 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp22_;
		gint _tmp23_;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		temp = _tmp23_;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = temp;
#line 4266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 31021 "Photo.c"
	}
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 31033 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp31_;
		gint _tmp32_;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		temp = _tmp32_;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = temp;
#line 4271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 31056 "Photo.c"
	}
#line 4274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = raw_rect;
#line 4280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 31096 "Photo.c"
}


PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError * _inner_error_ = NULL;
#line 4283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4284 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = NULL;
#line 31113 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31127 "Photo.c"
			goto __catch262_g_error;
		}
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp3_;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 31140 "Photo.c"
	}
	goto __finally262;
	__catch262_g_error:
	{
		GError* e = NULL;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _inner_error_;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4298: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (e);
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31160 "Photo.c"
	}
	__finally262:
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 31173 "Photo.c"
	}
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformations = _tmp5_;
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = transformations;
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31187 "Photo.c"
}


gboolean
photo_enhance (Photo* self)
{
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformations = _tmp0_;
#line 4321 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = transformations;
#line 4321 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31215 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31223 "Photo.c"
		{
			KeyValueMap* _tmp3_;
			KeyValueMap* _tmp4_;
			PixelTransformationBundle* _tmp5_;
#line 4328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_clear_original_transforms (self);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_get_color_adjustments_map (self);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_original_transforms (self, _tmp4_);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp4_);
#line 4330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = transformations;
#line 4330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp5_);
#line 31242 "Photo.c"
		}
		__finally263:
		{
			PhotoRow* _tmp6_;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31251 "Photo.c"
		}
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31255 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp7_;
#line 31265 "Photo.c"
		}
	}
#line 4337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_enhanced (self, TRUE);
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31276 "Photo.c"
}


gboolean
photo_unenhance (Photo* self)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 4341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31287 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31294 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_) {
#line 31304 "Photo.c"
				gboolean _tmp3_ = FALSE;
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->original_transforms;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp5_ == NULL) {
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = TRUE;
#line 31316 "Photo.c"
				} else {
					PhotoRow* _tmp6_;
					GeeHashMap* _tmp7_;
					gpointer _tmp8_;
					KeyValueMap* _tmp9_;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->row;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = _tmp6_->original_transforms;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, "adjustments");
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = (KeyValueMap*) _tmp8_;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = _tmp9_ == NULL;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_key_value_map_unref0 (_tmp9_);
#line 31334 "Photo.c"
				}
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp3_) {
#line 31338 "Photo.c"
					gboolean _result_ = FALSE;
					gboolean _tmp10_;
#line 4345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_remove_transformation (self, "adjustments");
#line 4346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_result_ = FALSE;
#line 4347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_result_ = photo_remove_transformation (self, "adjustments");
#line 4348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 4348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->adjustments = NULL;
#line 4349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformer_unref0 (self->priv->transformer);
#line 4349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->transformer = NULL;
#line 4350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = _result_;
#line 4350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp10_) {
#line 31359 "Photo.c"
						Alteration* _tmp11_;
						Alteration* _tmp12_;
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp11_ = alteration_new ("image", "color-adjustments");
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = _tmp11_;
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						data_object_notify_altered ((DataObject*) self, _tmp12_);
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_alteration_unref0 (_tmp12_);
#line 31370 "Photo.c"
					}
				} else {
					PixelTransformationBundle* _tmp13_;
					PixelTransformationBundle* _tmp14_;
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = photo_locked_original_color_adjustments (self);
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = _tmp13_;
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_color_adjustments (self, _tmp14_);
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (_tmp14_);
#line 31383 "Photo.c"
				}
#line 4355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_set_enhanced (self, FALSE);
#line 4356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 31389 "Photo.c"
				{
					PhotoRow* _tmp15_;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31396 "Photo.c"
				}
#line 4356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 31400 "Photo.c"
			}
		}
		__finally264:
		{
			PhotoRow* _tmp16_;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31410 "Photo.c"
		}
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31414 "Photo.c"
			gboolean _tmp17_ = FALSE;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp17_;
#line 31422 "Photo.c"
		}
	}
#line 4359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 4359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31429 "Photo.c"
}


gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
	gboolean _tmp0_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31444 "Photo.c"
}


void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 31453 "Photo.c"
}


static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31487 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 31493 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31499 "Photo.c"
}


static void
photo_real_raw_development_modified (Photo* self)
{
}


static void
photo_real_baseline_replaced (Photo* self)
{
}


static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}


static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31544 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 31550 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31556 "Photo.c"
}


static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}


static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}


static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}


static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 31587 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments,
                                                 GeeHashMap* original_transformations,
                                                 gboolean enhanced)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	PixelTransformer* _tmp3_;
	PixelTransformationBundle* _tmp4_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->orientation = orientation;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_photo_transformation_state_impl_copy_transformations (original_transformations);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->original_transformations = _tmp2_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _pixel_transformer_ref0 (transformer);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = _tmp3_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = _tmp4_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->enhanced = enhanced;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 31649 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments,
                                           GeeHashMap* original_transformations,
                                           gboolean enhanced)
{
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments, original_transformations, enhanced);
#line 31664 "Photo.c"
}


static gboolean
photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->enhanced;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31681 "Photo.c"
}


static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result = 0;
	Orientation _tmp0_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31698 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31718 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->original_transformations;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31738 "Photo.c"
}


static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31754 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31765 "Photo.c"
	} else {
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 31771 "Photo.c"
	}
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31777 "Photo.c"
}


static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31793 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31804 "Photo.c"
	} else {
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 31810 "Photo.c"
	}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31816 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* result = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (original == NULL) {
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31832 "Photo.c"
	}
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	clone = _tmp0_;
#line 31838 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) original);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_object_it = _tmp5_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 31862 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _object_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 31880 "Photo.c"
			}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _object_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = clone;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = object;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = object;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) original, _tmp11_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp15_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (object);
#line 31910 "Photo.c"
		}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31914 "Photo.c"
	}
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = clone;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31920 "Photo.c"
}


static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!photo_transformation_state_is_broken ((PhotoTransformationState*) self)) {
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_signal_emit ((PhotoTransformationState*) self, photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 31933 "Photo.c"
	}
}


static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass)
{
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31947 "Photo.c"
}


static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self)
{
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 31956 "Photo.c"
}


static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31986 "Photo.c"
}


static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32012 "Photo.c"
}


static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 32021 "Photo.c"
}


static void
photo_value_backing_readers_init (GValue* value)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32030 "Photo.c"
}


static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 32041 "Photo.c"
	}
}


static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 32054 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32058 "Photo.c"
	}
}


static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32068 "Photo.c"
}


static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32080 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32087 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32091 "Photo.c"
		}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 32095 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32099 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32103 "Photo.c"
}


static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32119 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32125 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32129 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 32133 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32137 "Photo.c"
}


static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32157 "Photo.c"
}


static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32168 "Photo.c"
}


static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 32191 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32195 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32201 "Photo.c"
	}
}


static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32223 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32227 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32233 "Photo.c"
	}
}


static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 32245 "Photo.c"
}


static void
photo_backing_readers_instance_init (PhotoBackingReaders * self)
{
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 32254 "Photo.c"
}


static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 32272 "Photo.c"
}


static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 32301 "Photo.c"
}


static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32316 "Photo.c"
	}
}


PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32329 "Photo.c"
}


static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32338 "Photo.c"
}


static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 32349 "Photo.c"
	}
}


static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 32362 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32366 "Photo.c"
	}
}


static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32376 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32388 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32395 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32399 "Photo.c"
		}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 32403 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32407 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32411 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32427 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32433 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32437 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32441 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32445 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32465 "Photo.c"
}


gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32476 "Photo.c"
}


void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32499 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32503 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32509 "Photo.c"
	}
}


void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32531 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32535 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32541 "Photo.c"
	}
}


static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 32553 "Photo.c"
}


static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self)
{
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 32562 "Photo.c"
}


static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32574 "Photo.c"
}


GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 32603 "Photo.c"
}


void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32618 "Photo.c"
	}
}


static gchar**
_vala_array_dup6 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 32633 "Photo.c"
		gchar* _tmp0_;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result[i] = _tmp0_;
#line 32639 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 32643 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            int alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup6 (alterations, alterations_length1) : ((gpointer) alterations);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = _tmp2_;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32689 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      int alterations_length1)
{
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32701 "Photo.c"
}


static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass)
{
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32712 "Photo.c"
}


static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self)
{
	PhotoRow* _tmp0_;
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 1260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32726 "Photo.c"
}


static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32744 "Photo.c"
}


static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32770 "Photo.c"
}


static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32779 "Photo.c"
}


static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32790 "Photo.c"
	}
}


static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32803 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32807 "Photo.c"
	}
}


static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32817 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32829 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32836 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32840 "Photo.c"
		}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32844 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32848 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32852 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32868 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32874 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32878 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32882 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32886 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32906 "Photo.c"
}


gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32917 "Photo.c"
}


void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32940 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32944 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32950 "Photo.c"
	}
}


void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32972 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32976 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32982 "Photo.c"
	}
}


static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 32994 "Photo.c"
}


static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self)
{
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 33003 "Photo.c"
}


static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33015 "Photo.c"
}


GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 33044 "Photo.c"
}


void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33059 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33090 "Photo.c"
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 33100 "Photo.c"
}


static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass)
{
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 33111 "Photo.c"
}


static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self)
{
	BackingPhotoRow* _tmp0_;
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33125 "Photo.c"
}


static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 33141 "Photo.c"
}


static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33167 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33176 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 33187 "Photo.c"
	}
}


static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 33200 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33204 "Photo.c"
	}
}


static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33214 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33226 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33233 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33237 "Photo.c"
		}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 33241 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33245 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33249 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33265 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 33271 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33275 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33279 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33283 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33303 "Photo.c"
}


gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33314 "Photo.c"
}


void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33337 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33341 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33347 "Photo.c"
	}
}


void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33369 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33373 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33379 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 33391 "Photo.c"
}


static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self)
{
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 33400 "Photo.c"
}


static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33412 "Photo.c"
}


GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 33441 "Photo.c"
}


void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33456 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33469 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 33478 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (backing != NULL);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->list;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 33504 "Photo.c"
}


static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->list;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33527 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backing != NULL, NULL);
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing = _tmp0_;
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33557 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 33567 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33576 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33587 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33600 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33604 "Photo.c"
	}
}


static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33614 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33626 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33633 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33637 "Photo.c"
		}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33641 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33645 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33649 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33665 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 33671 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33675 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33679 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33683 "Photo.c"
}


static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33703 "Photo.c"
}


static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33714 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33737 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33741 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33747 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33769 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33773 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33779 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass)
{
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33791 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self)
{
	BackingPhotoRow* _tmp0_;
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing = _tmp0_;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 33805 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33821 "Photo.c"
}


GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 33850 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33865 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass)
{
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 33877 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self)
{
	GeeArrayList* _tmp0_;
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->list = (GeeCollection*) _tmp0_;
#line 1298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33891 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 33905 "Photo.c"
}


static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void
photo_class_init (PhotoClass * klass)
{
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo *, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo *)) photo_real_notify_raw_development_modified;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo *)) photo_real_notify_baseline_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo *, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo *, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo *, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo *, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource *, GError**)) photo_real_internal_delete_backing;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource *, int*)) photo_real_get_backing_files_state;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo *, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource *)) photo_real_get_typename;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource *)) photo_real_get_instance_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource *)) photo_real_get_source_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource *)) photo_real_get_preferred_thumbnail_format;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource *, gint, GError**)) photo_real_create_thumbnail;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource *)) photo_real_get_file;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource *)) photo_real_get_master_file;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource *)) photo_real_get_timestamp;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource *, EventID*)) photo_real_get_event_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource *, ImportID*)) photo_real_get_import_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource *)) photo_real_get_master_md5;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource *, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource *, EventID*)) photo_real_set_event_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject *)) photo_real_to_string;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource *, DataSource*)) photo_real_equals;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource *)) photo_real_get_filesize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource *)) photo_real_get_master_filesize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource *)) photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource *)) photo_real_get_basename;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource *)) photo_real_get_title;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource *)) photo_real_get_comment;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource *, const gchar*)) photo_real_set_title;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource *, const gchar*)) photo_real_set_comment;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource *, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource *)) photo_real_get_metadata;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo *, Rotation)) photo_real_rotate;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource *, Scaling*, GError**)) photo_real_get_pixbuf;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo *)) photo_real_has_user_generated_metadata;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo *, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 34042 "Photo.c"
}


static void
photo_dateable_interface_init (DateableIface * iface)
{
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->get_exposure_time = (time_t (*) (Dateable *)) photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable *, time_t)) photo_real_set_exposure_time;
#line 34055 "Photo.c"
}


static void
photo_instance_init (Photo * self)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = NULL;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->file_title = NULL;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->developments = NULL;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 34106 "Photo.c"
}


static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 34154 "Photo.c"
}


GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (property_id) {
#line 34184 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		break;
#line 34190 "Photo.c"
	}
}


static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (property_id) {
#line 34205 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		break;
#line 34211 "Photo.c"
	}
}


GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34238 "Photo.c"
}


static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34251 "Photo.c"
}


static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34264 "Photo.c"
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return dup;
#line 34278 "Photo.c"
}


static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34291 "Photo.c"
}


static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34303 "Photo.c"
}


static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 34315 "Photo.c"
}


static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 34327 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp1_, "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp3_, "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 34359 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 34368 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34381 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34399 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34412 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4419 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34430 "Photo.c"
}


static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	PhotoMonitor* _tmp0_;
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (workers != NULL, NULL);
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaMonitor*) _tmp0_;
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34454 "Photo.c"
}


static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4427 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4427 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_LIBRARY_PHOTO);
#line 4428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34472 "Photo.c"
}


static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4431 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34490 "Photo.c"
}


static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4435 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4435 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34508 "Photo.c"
}


static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 34520 "Photo.c"
}


static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 34530 "Photo.c"
}


static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (added != NULL) {
#line 34544 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_object_it = _tmp0_;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 34554 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_;
				gint64 _tmp30_ = 0LL;
				LibraryPhoto* _tmp31_;
				BackingPhotoRow* _tmp32_;
				BackingPhotoRow* _tmp33_;
				gboolean _tmp34_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp39_;
				gint64 _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeHashMap* _tmp42_;
				LibraryPhoto* _tmp43_;
				gint64 _tmp44_;
				gint64 _tmp45_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _object_it;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 34601 "Photo.c"
				}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _object_it;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = object;
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp5_;
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo;
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable = _tmp7_;
#line 4446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = editable;
#line 4446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 34625 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = editable;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = photo;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp11_);
#line 34637 "Photo.c"
				}
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo;
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp12_, "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = photo;
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files ((Photo*) _tmp13_);
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_list = _tmp14_;
#line 4451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = raw_list;
#line 4451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 34653 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp16_ = raw_list;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp17_;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34666 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = _f_it;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34680 "Photo.c"
							}
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = _f_it;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = f;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = photo;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, _tmp22_, _tmp23_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 34698 "Photo.c"
						}
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34702 "Photo.c"
					}
				}
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = photo;
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp24_, "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = photo;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row ((Photo*) _tmp25_);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp29_;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = photo;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = photo_get_editable_photo_row ((Photo*) _tmp31_);
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tmp33_ != NULL;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp33_);
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp34_) {
#line 34735 "Photo.c"
					LibraryPhoto* _tmp35_;
					BackingPhotoRow* _tmp36_;
					BackingPhotoRow* _tmp37_;
					gint64 _tmp38_;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp35_ = photo;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp36_ = photo_get_editable_photo_row ((Photo*) _tmp35_);
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp37_ = _tmp36_;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp38_ = _tmp37_->filesize;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = _tmp38_;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp37_);
#line 34752 "Photo.c"
				} else {
#line 4459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = (gint64) -1;
#line 34756 "Photo.c"
				}
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp30_;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = self->priv->filesize_to_photo;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = master_filesize;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = photo;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp39_, &_tmp40_, _tmp41_);
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = self->priv->photo_to_master_filesize;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = photo;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = master_filesize;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp42_, _tmp43_, &_tmp44_);
#line 4462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = editable_filesize;
#line 4462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp45_ >= ((gint64) 0)) {
#line 34780 "Photo.c"
					GeeMultiMap* _tmp46_;
					gint64 _tmp47_;
					LibraryPhoto* _tmp48_;
					GeeHashMap* _tmp49_;
					LibraryPhoto* _tmp50_;
					gint64 _tmp51_;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp47_ = editable_filesize;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp48_ = photo;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp47_, _tmp48_);
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp49_ = self->priv->photo_to_editable_filesize;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = photo;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = editable_filesize;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp49_, _tmp50_, &_tmp51_);
#line 34803 "Photo.c"
				}
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp52_ = photo;
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = photo_get_raw_development_photo_rows ((Photo*) _tmp52_);
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_rows = _tmp53_;
#line 4468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_ = raw_rows;
#line 4468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp54_ != NULL) {
#line 34815 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp55_;
						GeeIterator* _tmp56_;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp55_ = raw_rows;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp56_ = gee_iterable_iterator ((GeeIterable*) _tmp55_);
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_row_it = _tmp56_;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34828 "Photo.c"
							GeeIterator* _tmp57_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp58_;
							gpointer _tmp59_;
							BackingPhotoRow* _tmp60_;
							gint64 _tmp61_;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp57_ = _row_it;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp57_)) {
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34841 "Photo.c"
							}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp58_ = _row_it;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp59_ = gee_iterator_get (_tmp58_);
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp59_;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp60_ = row;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp61_ = _tmp60_->filesize;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (_tmp61_ >= ((gint64) 0)) {
#line 34855 "Photo.c"
								GeeMultiMap* _tmp62_;
								BackingPhotoRow* _tmp63_;
								gint64 _tmp64_;
								LibraryPhoto* _tmp65_;
								GeeMultiMap* _tmp66_;
								LibraryPhoto* _tmp67_;
								BackingPhotoRow* _tmp68_;
								gint64 _tmp69_;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp62_ = self->priv->filesize_to_photo;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp63_ = row;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp64_ = _tmp63_->filesize;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp65_ = photo;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_set (_tmp62_, &_tmp64_, _tmp65_);
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp66_ = self->priv->photo_to_raw_development_filesize;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp67_ = photo;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp68_ = row;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp69_ = _tmp68_->filesize;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_set (_tmp66_, _tmp67_, &_tmp69_);
#line 34884 "Photo.c"
							}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34888 "Photo.c"
						}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34892 "Photo.c"
					}
				}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (object);
#line 34905 "Photo.c"
			}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34909 "Photo.c"
		}
	}
#line 4479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (removed != NULL) {
#line 34914 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp70_;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp70_ = gee_iterable_iterator (removed);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_object_it = _tmp70_;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 34924 "Photo.c"
				GeeIterator* _tmp71_;
				DataObject* object = NULL;
				GeeIterator* _tmp72_;
				gpointer _tmp73_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp74_;
				LibraryPhoto* _tmp75_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp76_;
				GFile* _tmp77_;
				GFile* _tmp78_;
				LibraryPhoto* _tmp86_;
				guint _tmp87_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp88_;
				GeeCollection* _tmp89_;
				GeeCollection* _tmp90_;
				LibraryPhoto* _tmp98_;
				guint _tmp99_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp100_;
				BackingPhotoRow* _tmp101_;
				BackingPhotoRow* _tmp102_;
				gint64 _tmp103_;
				gint64 _tmp104_;
				gint64 _tmp105_ = 0LL;
				LibraryPhoto* _tmp106_;
				BackingPhotoRow* _tmp107_;
				BackingPhotoRow* _tmp108_;
				gboolean _tmp109_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp114_;
				gint64 _tmp115_;
				LibraryPhoto* _tmp116_;
				GeeHashMap* _tmp117_;
				LibraryPhoto* _tmp118_;
				gint64 _tmp119_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp125_;
				GeeCollection* _tmp126_;
				GeeCollection* _tmp127_;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp71_ = _object_it;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp71_)) {
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 34972 "Photo.c"
				}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp72_ = _object_it;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp73_ = gee_iterator_get (_tmp72_);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				object = (DataObject*) _tmp73_;
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp74_ = object;
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp75_;
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp76_ = photo;
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp77_ = photo_get_editable_file ((Photo*) _tmp76_);
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable = _tmp77_;
#line 4484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp78_ = editable;
#line 4484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 34996 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp79_;
					LibraryPhoto* _tmp80_;
					GFile* _tmp81_;
					GFile* _tmp82_;
					gboolean _tmp83_;
					gboolean _tmp84_;
					gboolean _tmp85_;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp79_ = self->priv->by_editable_file;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp80_ = photo;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp81_ = photo_get_editable_file ((Photo*) _tmp80_);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp82_ = _tmp81_;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp83_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp79_, _tmp82_, NULL);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp84_ = _tmp83_;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp82_);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					is_removed = _tmp84_;
#line 4486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp85_ = is_removed;
#line 4486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_vala_assert (_tmp85_, "is_removed");
#line 35025 "Photo.c"
				}
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp86_ = photo;
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp87_, NULL, FALSE);
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp86_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp87_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp88_ = photo;
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp89_ = photo_get_raw_developer_files ((Photo*) _tmp88_);
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_list = _tmp89_;
#line 4491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp90_ = raw_list;
#line 4491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp90_ != NULL) {
#line 35043 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp91_;
						GeeIterator* _tmp92_;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp91_ = raw_list;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp92_ = gee_iterable_iterator ((GeeIterable*) _tmp91_);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp92_;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 35056 "Photo.c"
							GeeIterator* _tmp93_;
							GFile* f = NULL;
							GeeIterator* _tmp94_;
							gpointer _tmp95_;
							GeeHashMap* _tmp96_;
							GFile* _tmp97_;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp93_ = _f_it;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp93_)) {
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 35069 "Photo.c"
							}
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp94_ = _f_it;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp95_ = gee_iterator_get (_tmp94_);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp95_;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp96_ = self->priv->by_raw_development_file;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp97_ = f;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_unset ((GeeAbstractMap*) _tmp96_, _tmp97_, NULL);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 35085 "Photo.c"
						}
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 35089 "Photo.c"
					}
				}
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp98_ = photo;
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp99_, NULL, FALSE);
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp98_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp99_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp100_ = photo;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp101_ = photo_get_master_photo_row ((Photo*) _tmp100_);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp102_ = _tmp101_;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103_ = _tmp102_->filesize;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp104_ = _tmp103_;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp102_);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp104_;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp106_ = photo;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp107_ = photo_get_editable_photo_row ((Photo*) _tmp106_);
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp108_ = _tmp107_;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp109_ = _tmp108_ != NULL;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp108_);
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp109_) {
#line 35124 "Photo.c"
					LibraryPhoto* _tmp110_;
					BackingPhotoRow* _tmp111_;
					BackingPhotoRow* _tmp112_;
					gint64 _tmp113_;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp110_ = photo;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp111_ = photo_get_editable_photo_row ((Photo*) _tmp110_);
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp112_ = _tmp111_;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp113_ = _tmp112_->filesize;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp105_ = _tmp113_;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp112_);
#line 35141 "Photo.c"
				} else {
#line 4499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp105_ = (gint64) -1;
#line 35145 "Photo.c"
				}
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp105_;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp114_ = self->priv->filesize_to_photo;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp115_ = master_filesize;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp116_ = photo;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp114_, &_tmp115_, _tmp116_);
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp117_ = self->priv->photo_to_master_filesize;
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp118_ = photo;
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp117_, _tmp118_, NULL);
#line 4502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp119_ = editable_filesize;
#line 4502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp119_ >= ((gint64) 0)) {
#line 35167 "Photo.c"
					GeeMultiMap* _tmp120_;
					gint64 _tmp121_;
					LibraryPhoto* _tmp122_;
					GeeHashMap* _tmp123_;
					LibraryPhoto* _tmp124_;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp120_ = self->priv->filesize_to_photo;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp121_ = editable_filesize;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp122_ = photo;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_remove (_tmp120_, &_tmp121_, _tmp122_);
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp123_ = self->priv->photo_to_editable_filesize;
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp124_ = photo;
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp123_, _tmp124_, NULL);
#line 35187 "Photo.c"
				}
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp125_ = photo;
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp126_ = photo_get_raw_development_photo_rows ((Photo*) _tmp125_);
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_rows = _tmp126_;
#line 4508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp127_ = raw_rows;
#line 4508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp127_ != NULL) {
#line 35199 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp128_;
						GeeIterator* _tmp129_;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp128_ = raw_rows;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp129_ = gee_iterable_iterator ((GeeIterable*) _tmp128_);
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_row_it = _tmp129_;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 35212 "Photo.c"
							GeeIterator* _tmp130_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp131_;
							gpointer _tmp132_;
							BackingPhotoRow* _tmp133_;
							gint64 _tmp134_;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp130_ = _row_it;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp130_)) {
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 35225 "Photo.c"
							}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp131_ = _row_it;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp132_ = gee_iterator_get (_tmp131_);
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp132_;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp133_ = row;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp134_ = _tmp133_->filesize;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (_tmp134_ >= ((gint64) 0)) {
#line 35239 "Photo.c"
								GeeMultiMap* _tmp135_;
								BackingPhotoRow* _tmp136_;
								gint64 _tmp137_;
								LibraryPhoto* _tmp138_;
								GeeMultiMap* _tmp139_;
								LibraryPhoto* _tmp140_;
								BackingPhotoRow* _tmp141_;
								gint64 _tmp142_;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp135_ = self->priv->filesize_to_photo;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp136_ = row;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp137_ = _tmp136_->filesize;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp138_ = photo;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_remove (_tmp135_, &_tmp137_, _tmp138_);
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp139_ = self->priv->photo_to_raw_development_filesize;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp140_ = photo;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp141_ = row;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp142_ = _tmp141_->filesize;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_remove (_tmp139_, _tmp140_, &_tmp142_);
#line 35268 "Photo.c"
							}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35272 "Photo.c"
						}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 35276 "Photo.c"
					}
				}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (object);
#line 35289 "Photo.c"
			}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 35293 "Photo.c"
		}
	}
#line 4519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), added, removed);
#line 35298 "Photo.c"
}


static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old_file != NULL) {
#line 35314 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, old_file, NULL);
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		is_removed = _tmp1_;
#line 4525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = is_removed;
#line 4525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (_tmp2_, "is_removed");
#line 35329 "Photo.c"
	}
#line 4528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (new_file != NULL) {
#line 35333 "Photo.c"
		GeeHashMap* _tmp3_;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->priv->by_editable_file;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 35339 "Photo.c"
	}
}


static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 4533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 4533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp0_;
#line 4534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo;
#line 4534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 35377 "Photo.c"
	}
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo;
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 35385 "Photo.c"
		GeeMultiMap* _tmp18_;
		LibraryPhoto* _tmp19_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_s_it = _tmp9_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35414 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				gint64 _tmp16_;
				LibraryPhoto* _tmp17_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _s_it;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35430 "Photo.c"
				}
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _s_it;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				s = _tmp14_;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = s;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = photo;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &_tmp16_, _tmp17_);
#line 35452 "Photo.c"
			}
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 35456 "Photo.c"
		}
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = self->priv->photo_to_raw_development_filesize;
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = photo;
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 35464 "Photo.c"
	}
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = photo;
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_list = _tmp21_;
#line 4546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = raw_list;
#line 4546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 35476 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp23_;
			GeeIterator* _tmp24_;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = raw_list;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp24_;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35489 "Photo.c"
				GeeIterator* _tmp25_;
				GFile* f = NULL;
				GeeIterator* _tmp26_;
				gpointer _tmp27_;
				GeeHashMap* _tmp28_;
				GFile* _tmp29_;
				LibraryPhoto* _tmp30_;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _f_it;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp25_)) {
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35503 "Photo.c"
				}
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = _f_it;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = gee_iterator_get (_tmp26_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp27_;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = self->priv->by_raw_development_file;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = f;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = photo;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 35521 "Photo.c"
			}
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 35525 "Photo.c"
		}
	}
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = photo;
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = photo_get_raw_development_photo_rows ((Photo*) _tmp31_);
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rows = _tmp32_;
#line 4551 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = raw_rows;
#line 4551 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 35538 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = raw_rows;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_row_it = _tmp35_;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35551 "Photo.c"
				GeeIterator* _tmp36_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp37_;
				gpointer _tmp38_;
				BackingPhotoRow* _tmp39_;
				gint64 _tmp40_;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = _row_it;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp36_)) {
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35564 "Photo.c"
				}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _row_it;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = gee_iterator_get (_tmp37_);
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp38_;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = row;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = _tmp39_->filesize;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp40_ > ((gint64) 0)) {
#line 35578 "Photo.c"
					GeeMultiMap* _tmp41_;
					BackingPhotoRow* _tmp42_;
					gint64 _tmp43_;
					LibraryPhoto* _tmp44_;
					GeeMultiMap* _tmp45_;
					LibraryPhoto* _tmp46_;
					BackingPhotoRow* _tmp47_;
					gint64 _tmp48_;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp42_ = row;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp43_ = _tmp42_->filesize;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp44_ = photo;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp41_, &_tmp43_, _tmp44_);
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp45_ = self->priv->photo_to_raw_development_filesize;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46_ = photo;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp47_ = row;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp45_, _tmp46_, &_tmp48_);
#line 35607 "Photo.c"
				}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35611 "Photo.c"
			}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35615 "Photo.c"
		}
	}
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 35624 "Photo.c"
}


static gpointer
__int64_dup0 (gpointer self)
{
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 35633 "Photo.c"
}


static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (items != NULL);
#line 35646 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_object_it = _tmp4_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 35670 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _object_it;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 35689 "Photo.c"
			}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = object;
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = object;
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp11_;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = alteration;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = TRUE;
#line 35715 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = alteration;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 35722 "Photo.c"
			}
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp12_) {
#line 35726 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				gint64 _tmp31_;
				LibraryPhoto* _tmp32_;
				gint64 _tmp33_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp39_;
				BackingPhotoRow* _tmp40_;
				BackingPhotoRow* _tmp41_;
				gint64 _tmp42_;
				gint64 _tmp43_;
				gint64 _tmp44_ = 0LL;
				LibraryPhoto* _tmp45_;
				BackingPhotoRow* _tmp46_;
				BackingPhotoRow* _tmp47_;
				gboolean _tmp48_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp53_;
				LibraryPhoto* _tmp54_;
				gint64 _tmp55_;
				GeeMultiMap* _tmp56_;
				gint64 _tmp57_;
				LibraryPhoto* _tmp58_;
				gint64 _tmp59_;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = photo;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = photo;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, _tmp22_)) {
#line 35782 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = photo;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, _tmp24_);
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 35796 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 35808 "Photo.c"
				}
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = photo;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp28_, _tmp29_, NULL);
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = old_master_filesize;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = photo;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &_tmp31_, _tmp32_);
#line 4575 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = old_editable_filesize;
#line 4575 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp33_ >= ((gint64) 0)) {
#line 35830 "Photo.c"
					GeeHashMap* _tmp34_;
					LibraryPhoto* _tmp35_;
					GeeMultiMap* _tmp36_;
					gint64 _tmp37_;
					LibraryPhoto* _tmp38_;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp34_ = self->priv->photo_to_editable_filesize;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp35_ = photo;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp34_, _tmp35_, NULL);
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp36_ = self->priv->filesize_to_photo;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp37_ = old_editable_filesize;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp38_ = photo;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_remove (_tmp36_, &_tmp37_, _tmp38_);
#line 35850 "Photo.c"
				}
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = photo;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = photo_get_master_photo_row ((Photo*) _tmp39_);
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = _tmp40_;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = _tmp41_->filesize;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp41_);
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp43_;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = photo;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = photo_get_editable_photo_row ((Photo*) _tmp45_);
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = _tmp47_ != NULL;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp47_);
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp48_) {
#line 35878 "Photo.c"
					LibraryPhoto* _tmp49_;
					BackingPhotoRow* _tmp50_;
					BackingPhotoRow* _tmp51_;
					gint64 _tmp52_;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp49_ = photo;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = photo_get_editable_photo_row ((Photo*) _tmp49_);
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = _tmp50_;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp52_ = _tmp51_->filesize;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp44_ = _tmp52_;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp51_);
#line 35895 "Photo.c"
				} else {
#line 4583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp44_ = (gint64) -1;
#line 35899 "Photo.c"
				}
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp44_;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = self->priv->photo_to_master_filesize;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_ = photo;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = master_filesize;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, _tmp54_, &_tmp55_);
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = self->priv->filesize_to_photo;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = master_filesize;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = photo;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp56_, &_tmp57_, _tmp58_);
#line 4586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = editable_filesize;
#line 4586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp59_ >= ((gint64) 0)) {
#line 35923 "Photo.c"
					GeeHashMap* _tmp60_;
					LibraryPhoto* _tmp61_;
					gint64 _tmp62_;
					GeeMultiMap* _tmp63_;
					gint64 _tmp64_;
					LibraryPhoto* _tmp65_;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp60_ = self->priv->photo_to_editable_filesize;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp61_ = photo;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp62_ = editable_filesize;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp60_, _tmp61_, &_tmp62_);
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp63_ = self->priv->filesize_to_photo;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp64_ = editable_filesize;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp65_ = photo;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp63_, &_tmp64_, _tmp65_);
#line 35946 "Photo.c"
				}
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp20_);
#line 35950 "Photo.c"
			}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (object);
#line 35958 "Photo.c"
		}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35962 "Photo.c"
	}
#line 4593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), items);
#line 35966 "Photo.c"
}


static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (media_sources != NULL);
#line 4598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 35985 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp1_;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 35995 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			PhotoMetadata* _tmp10_;
			LibraryPhoto* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gboolean _tmp18_;
			PhotoMetadata* _tmp49_;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _media_it;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36021 "Photo.c"
			}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = media;
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp6_;
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo;
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo_source_get_metadata ((PhotoSource*) _tmp7_);
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			metadata = _tmp8_;
#line 4604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			global_index = _tmp9_;
#line 4611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			htag_index = NULL;
#line 4612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = metadata;
#line 4612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp10_)) {
#line 36051 "Photo.c"
				PhotoMetadata* _tmp11_;
				GeeSet* _tmp12_;
				GeeSet* _tmp13_;
				HierarchicalTagIndex* _tmp14_;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = metadata;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo_metadata_get_hierarchical_keywords (_tmp11_);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp13_);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				htag_index = _tmp14_;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp13_);
#line 36070 "Photo.c"
			}
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = photo;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = library_photo_get_import_keywords (_tmp15_);
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = _tmp17_ != NULL;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp17_);
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp18_) {
#line 36084 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp19_;
					GeeCollection* _tmp20_;
					GeeCollection* _tmp21_;
					GeeIterator* _tmp22_;
					GeeIterator* _tmp23_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = photo;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = library_photo_get_import_keywords (_tmp19_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_keyword_it = _tmp23_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 36108 "Photo.c"
						GeeIterator* _tmp24_;
						gchar* keyword = NULL;
						GeeIterator* _tmp25_;
						gpointer _tmp26_;
						gboolean _tmp27_ = FALSE;
						HierarchicalTagIndex* _tmp28_;
						gchar* name = NULL;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						HierarchicalTagIndex* _tmp33_;
						const gchar* _tmp34_;
						const gchar* _tmp43_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp24_ = _keyword_it;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!gee_iterator_next (_tmp24_)) {
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 36127 "Photo.c"
						}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp25_ = _keyword_it;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = gee_iterator_get (_tmp25_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						keyword = (gchar*) _tmp26_;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = htag_index;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp28_ != NULL) {
#line 36139 "Photo.c"
							HierarchicalTagIndex* _tmp29_;
							const gchar* _tmp30_;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp29_ = htag_index;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp30_ = keyword;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = hierarchical_tag_index_is_tag_in_index (_tmp29_, _tmp30_);
#line 36148 "Photo.c"
						} else {
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = FALSE;
#line 36152 "Photo.c"
						}
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp27_) {
#line 4620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (keyword);
#line 4620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							continue;
#line 36160 "Photo.c"
						}
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp31_ = keyword;
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp32_ = tag_prep_tag_name (_tmp31_);
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						name = _tmp32_;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp33_ = global_index;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp34_ = name;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_)) {
#line 36174 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp35_;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							GeeHashMultiMap* _tmp38_;
							const gchar* _tmp39_;
							Tag* _tmp40_;
							Tag* _tmp41_;
							LibraryPhoto* _tmp42_;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp35_ = global_index;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp36_ = name;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp37_ = hierarchical_tag_index_get_path_for_name (_tmp35_, _tmp36_);
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							most_derived_path = _tmp37_;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp38_ = map;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp39_ = most_derived_path;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp40_ = tag_for_path (_tmp39_);
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp41_ = _tmp40_;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp42_ = photo;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp38_, _tmp41_, _tmp42_);
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp41_);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (name);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (keyword);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							continue;
#line 36214 "Photo.c"
						}
#line 4630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp43_ = name;
#line 4630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp43_ != NULL) {
#line 36220 "Photo.c"
							GeeHashMultiMap* _tmp44_;
							const gchar* _tmp45_;
							Tag* _tmp46_;
							Tag* _tmp47_;
							LibraryPhoto* _tmp48_;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp44_ = map;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp45_ = name;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp46_ = tag_for_path (_tmp45_);
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp47_ = _tmp46_;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp48_ = photo;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp44_, _tmp47_, _tmp48_);
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp47_);
#line 36240 "Photo.c"
						}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (name);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (keyword);
#line 36246 "Photo.c"
					}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 36250 "Photo.c"
				}
			}
#line 4635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49_ = metadata;
#line 4635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp49_)) {
#line 36257 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp50_;
					GeeCollection* _tmp51_;
					GeeCollection* _tmp52_;
					GeeIterator* _tmp53_;
					GeeIterator* _tmp54_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = htag_index;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = hierarchical_tag_index_get_all_paths (_tmp50_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_path_it = _tmp54_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 36281 "Photo.c"
						GeeIterator* _tmp55_;
						gchar* path = NULL;
						GeeIterator* _tmp56_;
						gpointer _tmp57_;
						gchar* name = NULL;
						const gchar* _tmp58_;
						gchar* _tmp59_;
						const gchar* _tmp60_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp55_ = _path_it;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!gee_iterator_next (_tmp55_)) {
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 36296 "Photo.c"
						}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp56_ = _path_it;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp57_ = gee_iterator_get (_tmp56_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						path = (gchar*) _tmp57_;
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp58_ = path;
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp59_ = tag_prep_tag_name (_tmp58_);
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						name = _tmp59_;
#line 4638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp60_ = name;
#line 4638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp60_ != NULL) {
#line 36314 "Photo.c"
							GeeHashMultiMap* _tmp61_;
							const gchar* _tmp62_;
							Tag* _tmp63_;
							Tag* _tmp64_;
							LibraryPhoto* _tmp65_;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp61_ = map;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp62_ = name;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp63_ = tag_for_path (_tmp62_);
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp64_ = _tmp63_;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp65_ = photo;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp61_, _tmp64_, _tmp65_);
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp64_);
#line 36334 "Photo.c"
						}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (name);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (path);
#line 36340 "Photo.c"
					}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 36344 "Photo.c"
				}
			}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 36357 "Photo.c"
		}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36361 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp66_;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp66_;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36372 "Photo.c"
			GeeIterator* _tmp67_;
			MediaSource* media = NULL;
			GeeIterator* _tmp68_;
			gpointer _tmp69_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp70_;
			LibraryPhoto* _tmp71_;
			LibraryPhoto* _tmp72_;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = _media_it;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp67_)) {
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36387 "Photo.c"
			}
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp68_ = _media_it;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp69_ = gee_iterator_get (_tmp68_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp69_;
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp70_ = media;
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp71_;
#line 4646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp72_ = photo;
#line 4646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp72_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 36409 "Photo.c"
		}
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36413 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp73_;
		GeeSet* _tmp74_;
		GeeSet* _tmp75_;
		GeeIterator* _tmp76_;
		GeeIterator* _tmp77_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = map;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp73_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = gee_iterable_iterator ((GeeIterable*) _tmp75_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp77_ = _tmp76_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp75_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tag_it = _tmp77_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36438 "Photo.c"
			GeeIterator* _tmp78_;
			Tag* tag = NULL;
			GeeIterator* _tmp79_;
			gpointer _tmp80_;
			Tag* _tmp81_;
			GeeHashMultiMap* _tmp82_;
			Tag* _tmp83_;
			GeeCollection* _tmp84_;
			GeeCollection* _tmp85_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp78_ = _tag_it;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp78_)) {
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36454 "Photo.c"
			}
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp79_ = _tag_it;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp80_ = gee_iterator_get (_tmp79_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tag = (Tag*) _tmp80_;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp81_ = tag;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp82_ = map;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp83_ = tag;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp84_ = gee_multi_map_get ((GeeMultiMap*) _tmp82_, _tmp83_);
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp85_ = _tmp84_;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tag_attach_many (_tmp81_, _tmp85_);
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp85_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (tag);
#line 36478 "Photo.c"
		}
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 36482 "Photo.c"
	}
#line 4652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (map);
#line 36488 "Photo.c"
}


static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36501 "Photo.c"
}


void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 36514 "Photo.c"
}


static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36527 "Photo.c"
}


void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 36540 "Photo.c"
}


static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36553 "Photo.c"
}


void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 36566 "Photo.c"
}


static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36579 "Photo.c"
}


void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 36592 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
#line 4675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSource*) _tmp1_;
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36614 "Photo.c"
}


static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36627 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = media_source_is_trashed ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36647 "Photo.c"
}


static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36660 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = media_source_is_offline ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36680 "Photo.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1336 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1337 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1338 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 36704 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1340 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 36713 "Photo.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1347 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 36734 "Photo.c"
	} else {
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36738 "Photo.c"
	}
#line 1349 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1351 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 36744 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1353 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 36754 "Photo.c"
	}
#line 1356 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 36758 "Photo.c"
		glong _tmp3_;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1357 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1358 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 36766 "Photo.c"
	} else {
		glong _tmp4_;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1360 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 36773 "Photo.c"
	}
#line 1362 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 36777 "Photo.c"
		glong _tmp5_;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1363 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 36783 "Photo.c"
	}
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1365 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1366 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 36795 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
#line 4699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix (Photo.TYPENAME)");
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	numeric_only = _tmp2_;
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id ((MediaSourceCollection*) self, parse_int64 (numeric_only, 16));
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36832 "Photo.c"
}


static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
#line 4706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = (GeeCollection*) _tmp3_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36867 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_;
#line 4710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key ((DatabaseSourceCollection*) self, _tmp1_);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36893 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36916 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36939 "Photo.c"
}


static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_development != NULL);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row ((Photo*) photo);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 4726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 36985 "Photo.c"
	}
#line 4728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row ((Photo*) photo);
#line 4728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable = _tmp3_;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = editable;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 36995 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = editable;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 37001 "Photo.c"
	} else {
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = FALSE;
#line 37005 "Photo.c"
	}
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 4730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 37011 "Photo.c"
	}
#line 4732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows ((Photo*) photo);
#line 4732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	development = _tmp7_;
#line 4733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = development;
#line 4733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 37021 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = development;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_row_it = _tmp10_;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 37034 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _row_it;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 37046 "Photo.c"
				}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _row_it;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = row;
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 37064 "Photo.c"
				}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 37068 "Photo.c"
			}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 37072 "Photo.c"
		}
	}
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (development);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 37079 "Photo.c"
}


void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matched_development != NULL);
#line 37100 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 37127 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 37139 "Photo.c"
			}
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 37153 "Photo.c"
		}
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37157 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents ((MediaSourceCollection*) self);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp13_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 37179 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _media_it;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 37191 "Photo.c"
			}
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _media_it;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = media;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 37205 "Photo.c"
		}
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37209 "Photo.c"
	}
}


void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp15_ = {0};
#line 4755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 37225 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp4_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 37249 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 37265 "Photo.c"
			}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = media_source_get_master_file ((MediaSource*) _tmp8_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp12_) {
#line 37287 "Photo.c"
				LibraryPhoto* _tmp13_;
				PhotoID _tmp14_ = {0};
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = photo;
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id ((Photo*) _tmp13_, &_tmp14_);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*result = _tmp14_;
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 37302 "Photo.c"
			}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 37306 "Photo.c"
		}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37310 "Photo.c"
	}
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp15_, PHOTO_ID_INVALID);
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp15_;
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 37318 "Photo.c"
}


gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 4765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37339 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp3_;
#line 4771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo;
#line 4771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 37374 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 37390 "Photo.c"
	}
#line 4775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo;
#line 4775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37396 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37427 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp3_;
#line 4784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo;
#line 4784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 37462 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 37478 "Photo.c"
	}
#line 4788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo;
#line 4788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37484 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37515 "Photo.c"
}


gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
#line 4795 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37540 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
#line 4799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file ((MediaSourceCollection*) self, file);
#line 4800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo;
#line 4801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37584 "Photo.c"
		}
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37588 "Photo.c"
	}
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp2_;
#line 4808 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo;
#line 4808 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37608 "Photo.c"
		}
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37612 "Photo.c"
	}
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp4_;
#line 4815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo;
#line 4815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37632 "Photo.c"
		}
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37636 "Photo.c"
	}
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 37646 "Photo.c"
	}
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp7_;
#line 4822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo;
#line 4822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4823 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37664 "Photo.c"
		}
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37668 "Photo.c"
	}
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 37678 "Photo.c"
	}
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp10_;
#line 4829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo;
#line 4829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37696 "Photo.c"
		}
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37700 "Photo.c"
	}
#line 4835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = NULL;
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 37712 "Photo.c"
	}
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37716 "Photo.c"
}


static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
#line 4840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 4841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink)) {
#line 4842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37742 "Photo.c"
	}
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 4845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37758 "Photo.c"
	}
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp4_, backlink);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 4848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37774 "Photo.c"
	}
#line 4850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 4850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37780 "Photo.c"
}


static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4853 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4853 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (backlink != NULL);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp3_, backlink);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink);
#line 37815 "Photo.c"
}


static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37832 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new ((MediaSourceCollection*) self);
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->_transaction_controller = (TransactionController*) _tmp1_;
#line 37840 "Photo.c"
	}
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37848 "Photo.c"
}


static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37859 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37885 "Photo.c"
	} else {
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 37891 "Photo.c"
	}
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37897 "Photo.c"
}


static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37908 "Photo.c"
}


static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37919 "Photo.c"
}


static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37930 "Photo.c"
}


static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass)
{
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection *)) library_photo_source_collection_real_create_trashcan;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection *)) library_photo_source_collection_real_create_offline_bin;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection *, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection *, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection *)) library_photo_source_collection_real_get_typename;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection *, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection *, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection *, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection *, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection *, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection *, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection *, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection *, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection *, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection *, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection *, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection *, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection *, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 37997 "Photo.c"
}


static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4382 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->filesize_to_photo = (GeeMultiMap*) _tmp2_;
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = (GeeMultiMap*) _tmp5_;
#line 38038 "Photo.c"
}


static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4382 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 38064 "Photo.c"
}


GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 38087 "Photo.c"
}


static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
	guint64 _tmp1_;
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 4881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 4883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 4888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = row->flags;
#line 4888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp1_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38116 "Photo.c"
		LibraryPhotoSourceCollection* _tmp2_;
		const gchar* _tmp3_;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = library_photo_global;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = row->backlinks;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp2_, _tmp3_);
#line 38125 "Photo.c"
	}
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 38129 "Photo.c"
}


static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 38138 "Photo.c"
}


static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
	guint64 _tmp5_;
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_params != NULL, NULL);
#line 4893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = import_params->row;
#line 4893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = import_params->row;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_->flags;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp5_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38179 "Photo.c"
		LibraryPhotoSourceCollection* _tmp6_;
		PhotoRow* _tmp7_;
		const gchar* _tmp8_;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = library_photo_global;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = import_params->row;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp7_->backlinks;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp6_, _tmp8_);
#line 38191 "Photo.c"
	}
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 38195 "Photo.c"
}


static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 38204 "Photo.c"
}


void
library_photo_init (ProgressMonitor monitor,
                    void* monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp32_;
	GeeArrayList* _tmp33_;
	GeeCollection* _tmp34_;
	GeeCollection* _tmp35_;
	LibraryPhotoSourceCollection* _tmp36_;
	GeeArrayList* _tmp37_;
	LibraryPhotoSourceCollection* _tmp38_;
	GeeArrayList* _tmp39_;
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	all = _tmp4_;
#line 4909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	all_photos = _tmp5_;
#line 4910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 4911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	offline_photos = _tmp7_;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = all;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	count = _tmp10_;
#line 38274 "Photo.c"
	{
		gint ctr = 0;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ctr = 0;
#line 38279 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = TRUE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 38286 "Photo.c"
				gint _tmp13_;
				gint _tmp14_;
				PhotoRow* row = NULL;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp18_;
				LibraryPhoto* _tmp19_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp20_;
				guint64 _tmp21_;
				guint64 _tmp22_;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp11_) {
#line 38302 "Photo.c"
					gint _tmp12_;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = ctr;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 38308 "Photo.c"
				}
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = FALSE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = ctr;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = count;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 38320 "Photo.c"
				}
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = all;
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = ctr;
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (PhotoRow*) _tmp17_;
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = row;
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = library_photo_new (_tmp18_);
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp19_;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = row;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = _tmp20_->flags;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				flags = _tmp21_;
#line 4918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = flags;
#line 4918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if ((_tmp22_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 38346 "Photo.c"
					GeeArrayList* _tmp23_;
					LibraryPhoto* _tmp24_;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = trashed_photos;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = photo;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 38355 "Photo.c"
				} else {
					guint64 _tmp25_;
#line 4920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = flags;
#line 4920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if ((_tmp25_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 38362 "Photo.c"
						GeeArrayList* _tmp26_;
						LibraryPhoto* _tmp27_;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = offline_photos;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = photo;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 38371 "Photo.c"
					} else {
						GeeArrayList* _tmp28_;
						LibraryPhoto* _tmp29_;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = all_photos;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp29_ = photo;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 38381 "Photo.c"
					}
				}
#line 4925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (monitor != NULL) {
#line 38386 "Photo.c"
					gint _tmp30_;
					gint _tmp31_;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = ctr;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = count;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					monitor ((guint64) _tmp30_, (guint64) _tmp31_, TRUE, monitor_target);
#line 38395 "Photo.c"
				}
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_row_unref0 (row);
#line 38401 "Photo.c"
			}
		}
	}
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = library_photo_global;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = all_photos;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = data_collection_add_many ((DataCollection*) _tmp32_, (GeeCollection*) _tmp33_, NULL, NULL);
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp35_);
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = library_photo_global;
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = trashed_photos;
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_collection_add_many_to_trash ((MediaSourceCollection*) _tmp36_, (GeeCollection*) _tmp37_);
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = library_photo_global;
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = offline_photos;
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_collection_add_many_to_offline ((MediaSourceCollection*) _tmp38_, (GeeCollection*) _tmp39_);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (all);
#line 38435 "Photo.c"
}


void
library_photo_terminate (void)
{
}


ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto* * photo)
{
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
#line 4941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = params->row;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id = _tmp4_;
#line 4944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 4945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 4945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_photo = NULL;
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo) {
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*photo = _vala_photo;
#line 38486 "Photo.c"
		} else {
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38490 "Photo.c"
		}
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 38494 "Photo.c"
	}
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_photo = _tmp5_;
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo) {
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*photo = _vala_photo;
#line 38508 "Photo.c"
	} else {
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38512 "Photo.c"
	}
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38516 "Photo.c"
}


void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError * _inner_error_ = NULL;
#line 4956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 38526 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id ((Photo*) photo, &_tmp2_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 38545 "Photo.c"
				goto __catch265_database_error;
			}
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 38554 "Photo.c"
		}
	}
	goto __finally265;
	__catch265_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = err;
#line 4960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38572 "Photo.c"
	}
	__finally265:
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38583 "Photo.c"
	}
}


static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 4964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 4967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 4967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 38602 "Photo.c"
}


static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 4970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 4973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 4973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 38620 "Photo.c"
}


static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 4976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 4979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 4979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 38638 "Photo.c"
}


static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 4982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 4985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 4985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 38656 "Photo.c"
}


static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError * _inner_error_ = NULL;
#line 4988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 38666 "Photo.c"
	{
#line 4990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		thumbnail_cache_import_from_source ((ThumbnailSource*) self, TRUE, &_inner_error_);
#line 4990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38672 "Photo.c"
			goto __catch266_g_error;
		}
	}
	goto __finally266;
	__catch266_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = err;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4992: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38702 "Photo.c"
	}
	__finally266:
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38713 "Photo.c"
	}
#line 4996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38717 "Photo.c"
}


GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 5000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38737 "Photo.c"
}


void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38750 "Photo.c"
}


static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 5008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (alteration != NULL);
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 38771 "Photo.c"
	} else {
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 38775 "Photo.c"
	}
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 38779 "Photo.c"
		OneShotScheduler* _tmp2_;
#line 5011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->thumbnail_scheduler;
#line 5011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp2_, G_PRIORITY_LOW);
#line 38785 "Photo.c"
	}
#line 5013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), alteration);
#line 38789 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError * _inner_error_ = NULL;
#line 5016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) self, (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp0_;
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 38818 "Photo.c"
	}
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38828 "Photo.c"
}


static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError * _inner_error_ = NULL;
#line 5022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5024 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5025 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5026 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38846 "Photo.c"
	{
#line 5034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		thumbnail_cache_rotate ((ThumbnailSource*) self, rotation, &_inner_error_);
#line 5034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38852 "Photo.c"
			goto __catch267_g_error;
		}
	}
	goto __finally267;
	__catch267_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = err;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:5037: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38882 "Photo.c"
	}
	__finally267:
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38893 "Photo.c"
	}
#line 5040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38897 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 5044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch ((ThumbnailSource*) self, scale, &_inner_error_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 38924 "Photo.c"
	}
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38936 "Photo.c"
}


static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 38947 "Photo.c"
}


static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError * _inner_error_ = NULL;
#line 5050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (backing == NULL) {
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 38972 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 38979 "Photo.c"
	}
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 5053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result = backing_id;
#line 5053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38987 "Photo.c"
	}
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = file;
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 38999 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = file;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dupe_file = _tmp6_;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 39023 "Photo.c"
		}
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row ((Photo*) self, _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error_);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		detected = _tmp8_;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		state = _tmp9_;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 39047 "Photo.c"
		}
#line 5062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = state;
#line 5062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 39053 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = state;
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 39083 "Photo.c"
			}
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = state;
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_id = _tmp15_;
#line 39091 "Photo.c"
		}
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 39099 "Photo.c"
	}
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = backing_id;
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 39107 "Photo.c"
}


LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GError * _inner_error_ = NULL;
#line 5071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_file = _tmp3_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39195 "Photo.c"
	}
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row ((Photo*) self);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39217 "Photo.c"
	}
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_SHOTWELL);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39239 "Photo.c"
	}
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_CAMERA);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39261 "Photo.c"
	}
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_EMBEDDED);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39283 "Photo.c"
	}
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp22_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_id = _tmp31_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_row = _tmp36_;
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe = _tmp38_;
#line 5093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = dupe;
#line 5093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_cache_duplicate ((ThumbnailSource*) self, (ThumbnailSource*) _tmp39_);
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = dupe;
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_collection_add ((DataCollection*) _tmp40_, (DataObject*) _tmp41_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = dupe;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = media_source_get_event ((MediaSource*) _tmp42_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp45_) {
#line 39357 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = dupe;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = media_source_get_event ((MediaSource*) _tmp46_);
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = dupe;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		event_attach (_tmp48_, (MediaSource*) _tmp49_);
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 39374 "Photo.c"
	}
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = tag_global;
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, (MediaSource*) self);
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags = (GeeCollection*) _tmp51_;
#line 5104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp52_ = tags;
#line 5104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 39386 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = tags;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_it = _tmp54_;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 39399 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 39412 "Photo.c"
				}
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = tag;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = dupe;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp58_, (MediaSource*) _tmp59_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39428 "Photo.c"
			}
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 39432 "Photo.c"
		}
	}
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = dupe;
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39445 "Photo.c"
}


static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spin_event_loop ();
#line 39458 "Photo.c"
}


static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH);
#line 5119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39473 "Photo.c"
}


static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39485 "Photo.c"
}


static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39497 "Photo.c"
}


static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39512 "Photo.c"
}


static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39524 "Photo.c"
}


static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39536 "Photo.c"
}


static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39551 "Photo.c"
}


static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39571 "Photo.c"
}


static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39591 "Photo.c"
}


static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_inner_error_);
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 39609 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp1_;
#line 39615 "Photo.c"
	}
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp0_) {
#line 5158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 5158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 39623 "Photo.c"
	}
#line 5160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = media_source_delete_original_file ((MediaSource*) self);
#line 5160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39629 "Photo.c"
}


static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError * _inner_error_ = NULL;
#line 5163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp0_);
#line 5164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id = _tmp0_;
#line 5167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_cache_remove ((ThumbnailSource*) self);
#line 39648 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_id;
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 39667 "Photo.c"
				goto __catch268_database_error;
			}
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 39676 "Photo.c"
		}
	}
	goto __finally268;
	__catch268_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 5175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 5175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 39694 "Photo.c"
	}
	__finally268:
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 39705 "Photo.c"
	}
#line 5178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 39709 "Photo.c"
}


gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39727 "Photo.c"
}


void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids = _tmp1_;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = ids;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = TRUE;
#line 39765 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = ids;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 39775 "Photo.c"
	}
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 39779 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result = _tmp5_;
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 39789 "Photo.c"
	}
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = ids;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 39795 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		id_collection = _tmp6_;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		for (id_it = 0; id_it < _tmp6__length1; id_it = id_it + 1) {
#line 39807 "Photo.c"
			PhotoID id = {0};
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			id = id_collection[id_it];
#line 39811 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = id;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp9_;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = photo;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 39831 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = photo;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = !media_source_is_trashed ((MediaSource*) _tmp12_);
#line 39837 "Photo.c"
				} else {
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = FALSE;
#line 39841 "Photo.c"
				}
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*result = id;
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 39853 "Photo.c"
				}
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 39857 "Photo.c"
			}
		}
	}
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp13_;
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 39869 "Photo.c"
}


static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp9_;
	GeeSet* _tmp10_;
	gint _tmp11_ = 0;
	GeeList* _tmp12_;
	gint tags_count = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_;
	gint keywords_count = 0;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_ = FALSE;
	GeeList* _tmp24_;
#line 5202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags = _tmp1_;
#line 5205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata ((PhotoSource*) self);
#line 5205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp2_;
#line 5206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = metadata;
#line 5206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 39913 "Photo.c"
		gboolean _tmp4_ = FALSE;
		GeeList* _tmp5_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = tags;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp5_ != NULL) {
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = TRUE;
#line 39922 "Photo.c"
		} else {
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = tags;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp8_ > 0;
#line 39935 "Photo.c"
		}
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp4_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 39945 "Photo.c"
	}
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = metadata;
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_metadata_get_keywords (_tmp9_, NULL, NULL, NULL);
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords = _tmp10_;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = tags;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 39957 "Photo.c"
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = tags;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp15_;
#line 39969 "Photo.c"
	} else {
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = 0;
#line 39973 "Photo.c"
	}
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags_count = _tmp11_;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = keywords;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 39981 "Photo.c"
		GeeSet* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = keywords;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp20_;
#line 39993 "Photo.c"
	} else {
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = 0;
#line 39997 "Photo.c"
	}
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords_count = _tmp16_;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = tags_count;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = keywords_count;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_ != _tmp22_) {
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 40017 "Photo.c"
	}
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = tags;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 40023 "Photo.c"
		GeeSet* _tmp25_;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = keywords;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp25_ != NULL;
#line 40029 "Photo.c"
	} else {
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = FALSE;
#line 40033 "Photo.c"
	}
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_) {
#line 40037 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp26_;
			GeeList* _tmp27_;
			gint _tag_size = 0;
			GeeList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tag_index = 0;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = tags;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_list = _tmp27_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = _tag_list;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = _tmp29_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_size = _tmp30_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_index = -1;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40065 "Photo.c"
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				Tag* tag = NULL;
				GeeList* _tmp34_;
				gint _tmp35_;
				gpointer _tmp36_;
				GeeSet* _tmp37_;
				Tag* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gboolean _tmp43_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tag_index = _tmp31_ + 1;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tag_size;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40092 "Photo.c"
				}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tag_list;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = gee_list_get (_tmp34_, _tmp35_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp36_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = keywords;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = tag;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = data_object_get_name ((DataObject*) _tmp38_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = _tmp39_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = g_utf8_normalize (_tmp40_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = !gee_collection_contains ((GeeCollection*) _tmp37_, _tmp42_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp42_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp40_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp43_) {
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 40136 "Photo.c"
				}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 40140 "Photo.c"
			}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 40144 "Photo.c"
		}
	}
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 40157 "Photo.c"
}


static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 40184 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp19_;
#line 5229 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5229 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		string_tags = (GeeCollection*) _tmp3_;
#line 40192 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _tag_size = 0;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_index = 0;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_index = -1;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40220 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				Tag* tag = NULL;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40244 "Photo.c"
				}
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = tag;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = data_object_get_name ((DataObject*) _tmp16_);
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 40268 "Photo.c"
			}
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 40272 "Photo.c"
		}
#line 5233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = string_tags;
#line 5233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp19_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 40280 "Photo.c"
	} else {
#line 5235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 40284 "Photo.c"
	}
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 40288 "Photo.c"
}


static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_htag_index = NULL;
#line 5241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 40310 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp1_);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 40326 "Photo.c"
	}
#line 5246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords = (GeeCollection*) _tmp3_;
#line 5247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = keywords;
#line 5247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 40336 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = keywords;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40349 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40375 "Photo.c"
				}
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 40387 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = keyword;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 40396 "Photo.c"
				} else {
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = FALSE;
#line 40400 "Photo.c"
				}
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 5250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40408 "Photo.c"
				}
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = keyword;
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = tag_global;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 40428 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					tag_attach (_tmp22_, (MediaSource*) self);
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40450 "Photo.c"
				}
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = tag_global;
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 40458 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					tag_attach (_tmp27_, (MediaSource*) self);
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40480 "Photo.c"
				}
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = keyword;
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp30_, (MediaSource*) self);
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (keyword);
#line 40498 "Photo.c"
			}
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40502 "Photo.c"
		}
	}
#line 5270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 40509 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_path_it = _tmp36_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40533 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _path_it;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40547 "Photo.c"
				}
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = _path_it;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = path;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp42_, (MediaSource*) self);
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (path);
#line 40567 "Photo.c"
			}
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40571 "Photo.c"
		}
	}
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40578 "Photo.c"
}


static void
library_photo_class_init (LibraryPhotoClass * klass)
{
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject *, Alteration*)) library_photo_real_notify_altered;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource *, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo *, Rotation)) library_photo_real_rotate;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource *, gint, GError**)) library_photo_real_get_thumbnail;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource *)) library_photo_real_is_trashed;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource *)) library_photo_real_trash;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource *)) library_photo_real_untrash;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource *)) library_photo_real_is_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource *)) library_photo_real_mark_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource *)) library_photo_real_mark_online;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource *, GError**)) library_photo_real_internal_delete_backing;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource *)) library_photo_real_destroy;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo *)) library_photo_real_has_user_generated_metadata;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo *, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40629 "Photo.c"
}


static void
library_photo_flaggable_interface_init (FlaggableIface * iface)
{
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable *)) library_photo_real_is_flagged;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable *)) library_photo_real_mark_flagged;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable *)) library_photo_real_mark_unflagged;
#line 40644 "Photo.c"
}


static void
library_photo_monitorable_interface_init (MonitorableIface * iface)
{
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable *)) library_photo_real_is_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable *)) library_photo_real_mark_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable *)) library_photo_real_mark_online;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_master_file = (void (*) (Monitorable *, GFile*)) photo_set_master_file;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Monitorable *, GFileInfo*)) photo_set_master_timestamp;
#line 40663 "Photo.c"
}


static void
library_photo_instance_init (LibraryPhoto * self)
{
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 4876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4877 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40676 "Photo.c"
}


static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4877 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40692 "Photo.c"
}


GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             void* check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             void* get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, (MediaSourceCollection*) sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 40729 "Photo.c"
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       void* check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       void* get_key_target)
{
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 40742 "Photo.c"
}


LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
#line 5293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 5294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = NULL;
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = ret;
#line 5296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = ret;
#line 5297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 40779 "Photo.c"
	}
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, file);
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 40791 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 40803 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 40813 "Photo.c"
}


static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) base;
#line 5304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (added != NULL) {
#line 40827 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) added);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_source_it = _tmp0_;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40837 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _source_it;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40861 "Photo.c"
				}
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _source_it;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = source;
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp5_;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp9_) {
#line 40887 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = photo;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = photo_get_editable_file ((Photo*) _tmp11_);
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = photo;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp13_, _tmp14_);
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = photo;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = photo;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = photo_get_editable_file ((Photo*) _tmp17_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 40926 "Photo.c"
				}
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = photo;
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_files = _tmp21_;
#line 5316 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = raw_files;
#line 5316 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 40938 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp23_ = raw_files;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp24_;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 40951 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = _f_it;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 40968 "Photo.c"
							}
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp26_ = _f_it;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp29_ = f;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp30_ = photo;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp32_ = photo;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp33_ = f;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 40994 "Photo.c"
						}
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 40998 "Photo.c"
					}
				}
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = photo;
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp34_, "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = photo;
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp35_, "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (source);
#line 41015 "Photo.c"
			}
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41019 "Photo.c"
		}
	}
#line 5328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (removed != NULL) {
#line 41024 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_source_it = _tmp36_;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 41034 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _source_it;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 41056 "Photo.c"
				}
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = _source_it;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = source;
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp41_;
#line 41070 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp43_ = photo;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46_ = gee_iterable_iterator ((GeeIterable*) _tmp45_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_f_it = _tmp47_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 41097 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp48_ = _f_it;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 41110 "Photo.c"
						}
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp49_ = _f_it;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp52_ = f;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp51_, _tmp52_, NULL);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (f);
#line 41126 "Photo.c"
					}
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41130 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp54_ = photo;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = gee_iterable_iterator ((GeeIterable*) _tmp56_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_f_it = _tmp58_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 41158 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp59_ = _f_it;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 41171 "Photo.c"
						}
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp60_ = _f_it;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp63_ = f;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp62_, _tmp63_, NULL);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (f);
#line 41187 "Photo.c"
					}
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41191 "Photo.c"
				}
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = photo;
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = photo;
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp68_ = photo;
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp68_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp70_ = photo;
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp70_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (source);
#line 41221 "Photo.c"
			}
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41225 "Photo.c"
		}
	}
#line 5345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), added, removed);
#line 41230 "Photo.c"
}


static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp0_;
#line 5350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo;
#line 5350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old_file != NULL) {
#line 41259 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, old_file, NULL);
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo;
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 41273 "Photo.c"
	}
#line 5357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (new_file != NULL) {
#line 41277 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, new_file, _tmp6_);
#line 41286 "Photo.c"
	}
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo;
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41296 "Photo.c"
}


static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp0_;
#line 5364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo;
#line 5364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo;
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 41331 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp9_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 41360 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _f_it;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 41373 "Photo.c"
				}
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _f_it;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = f;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp13_, _tmp14_, NULL);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 41389 "Photo.c"
			}
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41393 "Photo.c"
		}
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = photo;
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 41401 "Photo.c"
	}
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo;
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files ((Photo*) _tmp17_);
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_list = _tmp18_;
#line 5375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = raw_list;
#line 5375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 41413 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = raw_list;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp21_;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 41426 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = _f_it;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 41443 "Photo.c"
				}
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = _f_it;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = f;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = photo;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp27_);
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = photo;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = f;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 41469 "Photo.c"
			}
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41473 "Photo.c"
		}
	}
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41480 "Photo.c"
}


static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass)
{
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank *, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 41495 "Photo.c"
}


static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reverse_editable_file_map = (GeeMultiMap*) _tmp2_;
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reverse_development_file_map = (GeeMultiMap*) _tmp3_;
#line 41524 "Photo.c"
}


static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41544 "Photo.c"
}


GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



