/* ViewCollection.c generated by valac 0.39.7, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_0_PROPERTY,
	VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES
};
static GParamSpec* view_collection_toggle_lists_properties[VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES];
enum  {
	VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL,
	VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL,
	VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL,
	VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL,
	VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL,
	VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL,
	VIEW_COLLECTION_NUM_SIGNALS
};
static guint view_collection_signals[VIEW_COLLECTION_NUM_SIGNALS] = {0};
typedef struct _ViewManagerPrivate ViewManagerPrivate;
typedef struct _ParamSpecViewManager ParamSpecViewManager;
typedef struct _ViewFilterPrivate ViewFilterPrivate;
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;
enum  {
	VIEW_FILTER_REFRESH_SIGNAL,
	VIEW_FILTER_NUM_SIGNALS
};
static guint view_filter_signals[VIEW_FILTER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected_unselected) (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*notify_view_filter_installed) (ViewCollection* self, ViewFilter* filter);
	void (*notify_view_filter_removed) (ViewCollection* self, ViewFilter* filter);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_first_unrejected) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*view_filter_installed) (ViewCollection* self, ViewFilter* filer);
	void (*view_filter_removed) (ViewCollection* self, ViewFilter* filer);
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*CreateViewPredicate) (DataSource* source, void* user_data);
struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};


static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
gpointer view_filter_ref (gpointer instance);
void view_filter_unref (gpointer instance);
GParamSpec* param_spec_view_filter (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_view_filter (GValue* value,
                            gpointer v_object);
void value_take_view_filter (GValue* value,
                             gpointer v_object);
gpointer value_get_view_filter (const GValue* value);
GType view_filter_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer view_collection_monitor_ref (gpointer instance);
void view_collection_monitor_unref (gpointer instance);
GParamSpec* view_collection_param_spec_monitor (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void view_collection_value_set_monitor (GValue* value,
                                        gpointer v_object);
void view_collection_value_take_monitor (GValue* value,
                                         gpointer v_object);
gpointer view_collection_value_get_monitor (const GValue* value);
GType view_collection_monitor_get_type (void) G_GNUC_CONST;
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
void value_set_data_set (GValue* value,
                         gpointer v_object);
void value_take_data_set (GValue* value,
                          gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
ViewCollection* view_collection_new (const gchar* name);
ViewCollection* view_collection_construct (GType object_type,
                                           const gchar* name);
DataCollection* data_collection_new (const gchar* name);
DataCollection* data_collection_construct (GType object_type,
                                           const gchar* name);
void view_collection_notify_items_selected_unselected (ViewCollection* self,
                                                       GeeCollection* selected,
                                                       GeeCollection* unselected);
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                            GeeCollection* selected,
                                                            GeeCollection* unselected);
void view_collection_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self,
                                               DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self,
                                                    DataView* view);
void view_collection_notify_views_altered (ViewCollection* self,
                                           GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self,
                                                GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self,
                                                   DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                        DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self,
                                                GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                     GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self,
                                         GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self,
                                              GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self,
                                          GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self,
                                               GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self,
                                                      GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                           GeeCollection* changed);
void view_collection_notify_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* filter);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                        ViewFilter* filter);
void view_collection_notify_view_filter_removed (ViewCollection* self,
                                                 ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                      ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
gchar* data_collection_to_string (DataCollection* self);
void data_collection_clear (DataCollection* self);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_all_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                                  gpointer self);
void data_collection_close (DataCollection* self);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_view_manager (GValue* value,
                             gpointer v_object);
void value_take_view_manager (GValue* value,
                              gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self,
                                                                  SourceCollection* sources,
                                                                  ViewManager* manager,
                                                                  Alteration* prereq,
                                                                  GeeCollection* initial,
                                                                  ProgressMonitor progress_monitor,
                                                                  void* progress_monitor_target);
void data_collection_freeze_notifications (DataCollection* self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner,
                                                             SourceCollection* sources,
                                                             ViewManager* manager,
                                                             Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type,
                                                                   ViewCollection* owner,
                                                                   SourceCollection* sources,
                                                                   ViewManager* manager,
                                                                   Alteration* prereq);
DataView* view_manager_create_view (ViewManager* self,
                                    DataSource* source);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         void* monitor_target);
static void view_collection_add_sources (ViewCollection* self,
                                  SourceCollection* sources,
                                  GeeIterable* added,
                                  ProgressMonitor progress_monitor,
                                  void* progress_monitor_target);
GeeCollection* data_collection_get_all (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void view_collection_halt_monitoring (ViewCollection* self,
                                      ViewCollectionMonitor* m);
void view_collection_mirror (ViewCollection* self,
                             ViewCollection* to_mirror,
                             CreateView mirroring_ctor,
                             void* mirroring_ctor_target,
                             CreateViewPredicate should_mirror,
                             void* should_mirror_target);
void data_collection_set_comparator (DataCollection* self,
                                     Comparator comparator,
                                     void* comparator_target,
                                     ComparatorPredicate predicate,
                                     void* predicate_target);
Comparator data_collection_get_comparator (DataCollection* self,
                                           void** result_target);
ComparatorPredicate data_collection_get_comparator_predicate (DataCollection* self,
                                                              void** result_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self,
                                               GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self,
                                                 GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
void view_collection_copy_into (ViewCollection* self,
                                ViewCollection* to_copy,
                                CreateView copying_ctor,
                                void* copying_ctor_target,
                                CreateViewPredicate should_copy,
                                void* should_copy_target);
DataSource* data_view_get_source (DataView* self);
gboolean view_collection_is_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* f);
void view_collection_install_view_filter (ViewCollection* self,
                                          ViewFilter* f);
void view_collection_remove_view_filter (ViewCollection* self,
                                         ViewFilter* f);
static void view_collection_filter_altered_items (ViewCollection* self,
                                           GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self,
                                       DataView* view);
gboolean view_filter_predicate (ViewFilter* self,
                                DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base,
                                          DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self,
                                       DataCollection* sources,
                                       GeeIterable* added);
gboolean view_manager_include_in_view (ViewManager* self,
                                       DataSource* source);
static DataView* _view_manager_create_view_create_view (DataSource* source,
                                                 gpointer self);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
static gboolean view_collection_real_add (DataCollection* base,
                                   DataObject* object);
void data_view_internal_set_visible (DataView* self,
                                     gboolean visible);
GeeCollection* data_collection_get_singleton (DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base,
                                              GeeCollection* objects,
                                              ProgressMonitor monitor,
                                              void* monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self,
                                         GeeIterable* removed);
Marker* data_collection_start_marking (DataCollection* self);
void marker_mark (Marker* self,
                  DataObject* object);
gint marker_get_count (Marker* self);
void data_collection_remove_marked (DataCollection* self,
                                    Marker* m);
static void view_collection_on_sources_altered (ViewCollection* self,
                                         DataCollection* collection,
                                         GeeMap* items);
gboolean alteration_contains_any (Alteration* self,
                                  Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self,
                                              DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self,
                                               DataSource* source);
gboolean data_set_contains (DataSet* self,
                            DataObject* object);
gboolean data_set_resort_object (DataSet* self,
                                 DataObject* object,
                                 Alteration* alteration);
static gboolean view_collection_is_visible (ViewCollection* self,
                                     DataView* view);
Marker* data_collection_mark_many (DataCollection* self,
                                   GeeCollection* objects);
void data_collection_notify_ordering_changed (DataCollection* self);
static void view_collection_real_notify_items_added (DataCollection* base,
                                              GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self,
                                           GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self,
                                        GeeCollection* views);
void data_collection_notify_items_added (DataCollection* self,
                                         GeeIterable* added);
static void view_collection_real_notify_items_removed (DataCollection* base,
                                                GeeIterable* removed);
gboolean data_set_remove (DataSet* self,
                          DataObject* object);
static void view_collection_remove_many_selected (ViewCollection* self,
                                           GeeCollection* views);
void data_collection_notify_items_removed (DataCollection* self,
                                           GeeIterable* removed);
static void view_collection_show_items (ViewCollection* self,
                                 GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self,
                                 GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base,
                                         GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base,
                                          Comparator comparator,
                                          void* comparator_target,
                                          ComparatorPredicate predicate,
                                          void* predicate_target);
void data_set_set_comparator (DataSet* self,
                              Comparator user_comparator,
                              void* user_comparator_target,
                              ComparatorPredicate comparator_predicate,
                              void* comparator_predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
void data_set_reset_comparator (DataSet* self);
void data_collection_reset_comparator (DataCollection* self);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeList* data_set_get_all (DataSet* self);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint data_set_get_count (DataSet* self);
gint data_collection_get_count (DataCollection* self);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base,
                                         gint index);
DataObject* data_set_get_at (DataSet* self,
                             gint index);
DataObject* data_collection_get_at (DataCollection* self,
                                    gint index);
static gint view_collection_real_index_of (DataCollection* base,
                                    DataObject* object);
gint data_set_index_of (DataSet* self,
                        DataObject* object);
gint data_collection_index_of (DataCollection* self,
                               DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base,
                                        DataObject* object);
gboolean data_collection_contains (DataCollection* self,
                                   DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_first_unrejected (ViewCollection* self);
static DataView* view_collection_real_get_first_unrejected (ViewCollection* self);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
DataView* view_collection_get_next (ViewCollection* self,
                                    DataView* view);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
static DataView* view_collection_real_get_next (ViewCollection* self,
                                         DataView* view);
DataView* view_collection_get_previous (ViewCollection* self,
                                        DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self,
                                             DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self,
                                                  DataSource* home,
                                                  DataSource* * next,
                                                  DataSource* * prev,
                                                  const gchar* type_selector);
gchar* data_source_get_typename (DataSource* self);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self,
                                                DataSource* home,
                                                const gchar* typename);
gboolean data_set_add_many (DataSet* self,
                            GeeCollection* objects);
gboolean data_set_remove_many (DataSet* self,
                               GeeCollection* objects);
void view_collection_select_marked (ViewCollection* self,
                                    Marker* marker);
void data_collection_act_on_marked (DataCollection* self,
                                    Marker* m,
                                    MarkedAction action,
                                    void* action_target,
                                    ProgressMonitor monitor,
                                    void* monitor_target,
                                    GObject* user);
static gboolean view_collection_select_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
void view_collection_select_all (ViewCollection* self);
void marker_mark_all (Marker* self);
void data_view_internal_set_selected (DataView* self,
                                      gboolean selected);
void view_collection_unselect_marked (ViewCollection* self,
                                      Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self,
                                        DataObject* object,
                                        GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object,
                                                       GObject* user,
                                                       gpointer self);
void view_collection_unselect_all (ViewCollection* self);
void marker_mark_many (Marker* self,
                       GeeCollection* list);
GeeList* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self,
                                       DataView* exception);
void view_collection_unselect_and_select_marked (ViewCollection* self,
                                                 Marker* unselect,
                                                 Marker* select);
void view_collection_toggle_marked (ViewCollection* self,
                                    Marker* marker);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static gboolean view_collection_toggle_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self,
                                                            DataSource* source);
DataView* view_collection_get_view_for_source_filtered (ViewCollection* self,
                                                        DataSource* source);
GeeCollection* view_collection_get_sources (ViewCollection* self);
gboolean view_collection_has_source_of_type (ViewCollection* self,
                                             GType t);
gint view_collection_get_sources_of_type_count (ViewCollection* self,
                                                GType t);
GeeList* view_collection_get_sources_of_type (ViewCollection* self,
                                              GType t);
GeeList* view_collection_get_selected_sources (ViewCollection* self);
DataSource* view_collection_get_selected_source_at (ViewCollection* self,
                                                    gint index);
GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self,
                                                       GType t);
gint view_collection_index_of_source (ViewCollection* self,
                                      DataSource* source);
void view_collection_internal_notify_view_altered (ViewCollection* self,
                                                   DataView* view);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self,
                                                       DataView* view);
static void view_collection_real_notify_thawed (DataCollection* base);
void data_collection_notify_thawed (DataCollection* self);
gboolean view_collection_are_items_filtered_out (ViewCollection* self);
static void view_collection_real_items_selected (ViewCollection* self,
                                          GeeIterable* selected);
static void view_collection_real_items_unselected (ViewCollection* self,
                                            GeeIterable* unselected);
static void view_collection_real_items_state_changed (ViewCollection* self,
                                               GeeIterable* changed);
static void view_collection_real_selection_group_altered (ViewCollection* self);
static void view_collection_real_items_shown (ViewCollection* self,
                                       GeeCollection* visible);
static void view_collection_real_items_hidden (ViewCollection* self,
                                        GeeCollection* hidden);
static void view_collection_real_items_visibility_changed (ViewCollection* self,
                                                    GeeCollection* changed);
static void view_collection_real_item_view_altered (ViewCollection* self,
                                             DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self,
                                                 DataView* view);
static void view_collection_real_views_altered (ViewCollection* self,
                                         GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self,
                                              GeeCollection* views);
static void view_collection_real_view_filter_installed (ViewCollection* self,
                                                 ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void view_collection_real_view_filter_removed (ViewCollection* self,
                                               ViewFilter* filer);
ViewCollectionMonitor* view_collection_monitor_new (void);
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor * obj);
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                                    GeeIterable* added,
                                                                    gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                        GeeIterable* removed,
                                                                        gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                        GeeMap* items,
                                                                        gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj);
static void view_collection_toggle_lists_finalize (GObject * obj);
static void view_collection_finalize (DataCollection * obj);
static gboolean view_manager_real_include_in_view (ViewManager* self,
                                            DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self,
                                         DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager * obj);
static gboolean view_filter_real_predicate (ViewFilter* self,
                                     DataView* view);
ViewFilter* view_filter_construct (GType object_type);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter * obj);


ViewCollection*
view_collection_construct (GType object_type,
                           const gchar* name)
{
	ViewCollection* self = NULL;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 956 "ViewCollection.c"
}


ViewCollection*
view_collection_new (const gchar* name)
{
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 965 "ViewCollection.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 974 "ViewCollection.c"
}


static void
view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                       GeeCollection* selected,
                                                       GeeCollection* unselected)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selected = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean has_unselected = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GeeCollection* sum = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_;
	GeeCollection* _tmp22_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (selected != NULL) {
#line 995 "ViewCollection.c"
		gint _tmp1_;
		gint _tmp2_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_collection_get_size (selected);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = _tmp2_ > 0;
#line 1004 "ViewCollection.c"
	} else {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = FALSE;
#line 1008 "ViewCollection.c"
	}
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	has_selected = _tmp0_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (unselected != NULL) {
#line 1014 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (unselected);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 1023 "ViewCollection.c"
	} else {
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 1027 "ViewCollection.c"
	}
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	has_unselected = _tmp3_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp6_ = has_selected;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp6_) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL], 0, (GeeIterable*) selected);
#line 1037 "ViewCollection.c"
	}
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp7_ = has_unselected;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp7_) {
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL], 0, (GeeIterable*) unselected);
#line 1045 "ViewCollection.c"
	}
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp9_ = has_selected;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp9_) {
#line 1051 "ViewCollection.c"
		gboolean _tmp10_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp10_ = has_unselected;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp8_ = !_tmp10_;
#line 1057 "ViewCollection.c"
	} else {
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp8_ = FALSE;
#line 1061 "ViewCollection.c"
	}
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp8_) {
#line 1065 "ViewCollection.c"
		GeeCollection* _tmp11_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp11_ = _g_object_ref0 (selected);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (sum);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		sum = _tmp11_;
#line 1073 "ViewCollection.c"
	} else {
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp13_ = has_selected;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (!_tmp13_) {
#line 1081 "ViewCollection.c"
			gboolean _tmp14_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp14_ = has_unselected;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = _tmp14_;
#line 1087 "ViewCollection.c"
		} else {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = FALSE;
#line 1091 "ViewCollection.c"
		}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp12_) {
#line 1095 "ViewCollection.c"
			GeeCollection* _tmp15_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp15_ = _g_object_ref0 (unselected);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (sum);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			sum = _tmp15_;
#line 1103 "ViewCollection.c"
		} else {
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp17_ = has_selected;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!_tmp17_) {
#line 1111 "ViewCollection.c"
				gboolean _tmp18_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = has_unselected;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = !_tmp18_;
#line 1117 "ViewCollection.c"
			} else {
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = FALSE;
#line 1121 "ViewCollection.c"
			}
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp16_) {
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				sum = NULL;
#line 1129 "ViewCollection.c"
			} else {
				GeeHashSet* _tmp19_;
				GeeCollection* _tmp20_;
				GeeCollection* _tmp21_;
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp19_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				sum = (GeeCollection*) _tmp19_;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp20_ = sum;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp20_, selected);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp21_ = sum;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp21_, unselected);
#line 1148 "ViewCollection.c"
			}
		}
	}
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp22_ = sum;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp22_ != NULL) {
#line 1156 "ViewCollection.c"
		GeeCollection* _tmp23_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp23_ = sum;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL], 0, (GeeIterable*) _tmp23_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 1164 "ViewCollection.c"
	}
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (sum);
#line 1168 "ViewCollection.c"
}


void
view_collection_notify_items_selected_unselected (ViewCollection* self,
                                                  GeeCollection* selected,
                                                  GeeCollection* unselected)
{
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected_unselected (self, selected, unselected);
#line 1181 "ViewCollection.c"
}


static void
view_collection_real_notify_selection_group_altered (ViewCollection* self)
{
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL], 0);
#line 1190 "ViewCollection.c"
}


void
view_collection_notify_selection_group_altered (ViewCollection* self)
{
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 1201 "ViewCollection.c"
}


static void
view_collection_real_notify_item_view_altered (ViewCollection* self,
                                               DataView* view)
{
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL], 0, view);
#line 1213 "ViewCollection.c"
}


void
view_collection_notify_item_view_altered (ViewCollection* self,
                                          DataView* view)
{
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 1225 "ViewCollection.c"
}


static void
view_collection_real_notify_views_altered (ViewCollection* self,
                                           GeeCollection* views)
{
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL], 0, views);
#line 1237 "ViewCollection.c"
}


void
view_collection_notify_views_altered (ViewCollection* self,
                                      GeeCollection* views)
{
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 1249 "ViewCollection.c"
}


static void
view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                   DataView* view)
{
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL], 0, view);
#line 1261 "ViewCollection.c"
}


void
view_collection_notify_item_geometry_altered (ViewCollection* self,
                                              DataView* view)
{
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 1273 "ViewCollection.c"
}


static void
view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                GeeCollection* views)
{
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL], 0, views);
#line 1285 "ViewCollection.c"
}


void
view_collection_notify_geometries_altered (ViewCollection* self,
                                           GeeCollection* views)
{
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 1297 "ViewCollection.c"
}


static void
view_collection_real_notify_items_shown (ViewCollection* self,
                                         GeeCollection* shown)
{
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (shown != NULL);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL], 0, shown);
#line 1309 "ViewCollection.c"
}


void
view_collection_notify_items_shown (ViewCollection* self,
                                    GeeCollection* shown)
{
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
#line 1321 "ViewCollection.c"
}


static void
view_collection_real_notify_items_hidden (ViewCollection* self,
                                          GeeCollection* hidden)
{
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (hidden != NULL);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL], 0, hidden);
#line 1333 "ViewCollection.c"
}


void
view_collection_notify_items_hidden (ViewCollection* self,
                                     GeeCollection* hidden)
{
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
#line 1345 "ViewCollection.c"
}


static void
view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                      GeeCollection* changed)
{
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL], 0, changed);
#line 1357 "ViewCollection.c"
}


void
view_collection_notify_items_visibility_changed (ViewCollection* self,
                                                 GeeCollection* changed)
{
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
#line 1369 "ViewCollection.c"
}


static void
view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* filter)
{
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (filter != NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL], 0, filter);
#line 1381 "ViewCollection.c"
}


void
view_collection_notify_view_filter_installed (ViewCollection* self,
                                              ViewFilter* filter)
{
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_installed (self, filter);
#line 1393 "ViewCollection.c"
}


static void
view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                 ViewFilter* filter)
{
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (filter != NULL);
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL], 0, filter);
#line 1405 "ViewCollection.c"
}


void
view_collection_notify_view_filter_removed (ViewCollection* self,
                                            ViewFilter* filter)
{
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_removed (self, filter);
#line 1417 "ViewCollection.c"
}


static void
view_collection_real_clear (DataCollection* base)
{
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	GeeHashMultiMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = gee_multi_map_get_size ((GeeMultiMap*) _tmp1_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp3_ > 0) {
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 1441 "ViewCollection.c"
	} else {
		ViewCollection* _tmp4_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->mirroring;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1448 "ViewCollection.c"
	}
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_) {
#line 1452 "ViewCollection.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = data_collection_to_string ((DataCollection*) self);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_warning ("ViewCollection.vala:216: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp6_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_free0 (_tmp6_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 1465 "ViewCollection.c"
	}
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1469 "ViewCollection.c"
}


static void
_view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                             gpointer self)
{
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh ((ViewCollection*) self);
#line 1479 "ViewCollection.c"
}


static void
view_collection_real_close (DataCollection* base)
{
	ViewCollection * self;
	GeeSet* _tmp7_;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 1494 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1507 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
			guint _tmp6_;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 1520 "ViewCollection.c"
			}
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp6_, NULL, FALSE);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1536 "ViewCollection.c"
		}
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 1540 "ViewCollection.c"
	}
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp7_ = self->priv->filters;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_collection_clear ((GeeCollection*) _tmp7_);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1548 "ViewCollection.c"
}


ViewCollectionMonitor*
view_collection_monitor_source_collection (ViewCollection* self,
                                           SourceCollection* sources,
                                           ViewManager* manager,
                                           Alteration* prereq,
                                           GeeCollection* initial,
                                           ProgressMonitor progress_monitor,
                                           void* progress_monitor_target)
{
	ViewCollectionMonitor* result = NULL;
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	ViewCollectionMonitorImpl* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_freeze_notifications ((DataCollection*) self);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_monitor_impl_new (self, sources, manager, prereq);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = monitor;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp1_, sources, _tmp2_);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (initial != NULL) {
#line 1589 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (initial);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 1598 "ViewCollection.c"
	} else {
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 1602 "ViewCollection.c"
	}
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp3_) {
#line 1606 "ViewCollection.c"
		GeeArrayList* created_views = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		created_views = _tmp6_;
#line 1616 "ViewCollection.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp7_;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterable_iterator ((GeeIterable*) initial);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_source_it = _tmp7_;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 1626 "ViewCollection.c"
				GeeIterator* _tmp8_;
				DataSource* source = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				GeeArrayList* _tmp11_;
				DataSource* _tmp12_;
				DataView* _tmp13_;
				DataView* _tmp14_;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = _source_it;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 1641 "ViewCollection.c"
				}
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9_ = _source_it;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				source = (DataSource*) _tmp10_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = created_views;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = view_manager_create_view (manager, _tmp12_);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp14_);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1663 "ViewCollection.c"
			}
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_source_it);
#line 1667 "ViewCollection.c"
		}
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp15_ = created_views;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp16_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp15_, progress_monitor, progress_monitor_target);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp17_ = _tmp16_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp17_);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (created_views);
#line 1679 "ViewCollection.c"
	} else {
		GeeCollection* _tmp18_;
		GeeIterable* _tmp19_;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp18_ = data_collection_get_all ((DataCollection*) sources);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp19_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_add_sources (self, sources, _tmp19_, progress_monitor, progress_monitor_target);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp19_);
#line 1691 "ViewCollection.c"
	}
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_thaw_notifications ((DataCollection*) self);
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = (ViewCollectionMonitor*) monitor;
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 1699 "ViewCollection.c"
}


static gpointer
_view_collection_monitor_ref0 (gpointer self)
{
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self ? view_collection_monitor_ref (self) : NULL;
#line 1708 "ViewCollection.c"
}


void
view_collection_halt_monitoring (ViewCollection* self,
                                 ViewCollectionMonitor* m)
{
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	gboolean removed = FALSE;
	GeeHashMultiMap* _tmp1_;
	SourceCollection* _tmp2_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (m != NULL);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _view_collection_monitor_ref0 (G_TYPE_CHECK_INSTANCE_CAST (m, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl));
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = monitor->sources;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	removed = gee_multi_map_remove ((GeeMultiMap*) _tmp1_, _tmp2_, monitor);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_view_collection_monitor_unref0 (monitor);
#line 1739 "ViewCollection.c"
}


void
view_collection_halt_all_monitoring (ViewCollection* self)
{
	GeeHashMultiMap* _tmp0_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->monitors;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
#line 1753 "ViewCollection.c"
}


static gpointer
_data_collection_ref0 (gpointer self)
{
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1762 "ViewCollection.c"
}


static void
_view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       gpointer self)
{
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added ((ViewCollection*) self, added);
#line 1773 "ViewCollection.c"
}


static void
_view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_removed ((ViewCollection*) self, removed);
#line 1784 "ViewCollection.c"
}


void
view_collection_mirror (ViewCollection* self,
                        ViewCollection* to_mirror,
                        CreateView mirroring_ctor,
                        void* mirroring_ctor_target,
                        CreateViewPredicate should_mirror,
                        void* should_mirror_target)
{
	ViewCollection* _tmp0_;
	void* _tmp1_;
	Comparator _tmp2_;
	void* _tmp3_;
	ComparatorPredicate _tmp4_;
	ViewCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	ViewCollection* _tmp8_;
	ViewCollection* _tmp9_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (to_mirror != NULL);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_clear ((DataCollection*) self);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (to_mirror);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring = _tmp0_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = mirroring_ctor;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = mirroring_ctor_target;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->should_mirror = should_mirror;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->should_mirror_target = should_mirror_target;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_get_comparator ((DataCollection*) to_mirror, &_tmp1_);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_comparator_predicate ((DataCollection*) to_mirror, &_tmp3_);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_set_comparator ((DataCollection*) self, _tmp2_, _tmp1_, _tmp4_, _tmp3_);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = self->priv->mirroring;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_all ((DataCollection*) _tmp5_);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp7_ = _tmp6_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, (GeeIterable*) _tmp7_);
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp7_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp8_ = self->priv->mirroring;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) _tmp8_, "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp9_ = self->priv->mirroring;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) _tmp9_, "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1854 "ViewCollection.c"
}


void
view_collection_halt_mirroring (ViewCollection* self)
{
	ViewCollection* _tmp0_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->mirroring;
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 1868 "ViewCollection.c"
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		guint _tmp4_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = self->priv->mirroring;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = self->priv->mirroring;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1885 "ViewCollection.c"
	}
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 1891 "ViewCollection.c"
}


void
view_collection_copy_into (ViewCollection* self,
                           ViewCollection* to_copy,
                           CreateView copying_ctor,
                           void* copying_ctor_target,
                           CreateViewPredicate should_copy,
                           void* should_copy_target)
{
	GeeArrayList* copy_view = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (to_copy != NULL);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	copy_view = _tmp0_;
#line 1916 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all ((DataCollection*) to_copy);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1937 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
			DataSource* _tmp11_;
			DataSource* _tmp12_;
			gboolean _tmp13_;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 1955 "ViewCollection.c"
			}
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = _tmp9_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = _tmp11_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp13_ = should_copy (_tmp12_, should_copy_target);
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp12_);
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp13_) {
#line 1981 "ViewCollection.c"
				GeeArrayList* _tmp14_;
				DataView* _tmp15_;
				DataSource* _tmp16_;
				DataSource* _tmp17_;
				DataView* _tmp18_;
				DataView* _tmp19_;
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = copy_view;
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp15_ = view;
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = data_view_get_source (_tmp15_);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp17_ = _tmp16_;
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = copying_ctor (_tmp17_, copying_ctor_target);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp19_ = _tmp18_;
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, (DataObject*) _tmp19_);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp19_);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp17_);
#line 2006 "ViewCollection.c"
			}
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2012 "ViewCollection.c"
		}
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2016 "ViewCollection.c"
	}
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp20_ = copy_view;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp21_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp20_, NULL, NULL);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp22_ = _tmp21_;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp22_);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (copy_view);
#line 2028 "ViewCollection.c"
}


gboolean
view_collection_is_view_filter_installed (ViewCollection* self,
                                          ViewFilter* f)
{
	gboolean result = FALSE;
	GeeSet* _tmp0_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (f != NULL, FALSE);
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = gee_collection_contains ((GeeCollection*) _tmp0_, f);
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2048 "ViewCollection.c"
}


void
view_collection_install_view_filter (ViewCollection* self,
                                     ViewFilter* f)
{
	GeeSet* _tmp0_;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (f != NULL);
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (view_collection_is_view_filter_installed (self, f)) {
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 2065 "ViewCollection.c"
	}
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_collection_add ((GeeCollection*) _tmp0_, f);
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect (f, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_installed (self, f);
#line 2077 "ViewCollection.c"
}


void
view_collection_remove_view_filter (ViewCollection* self,
                                    ViewFilter* f)
{
	GeeSet* _tmp0_;
	guint _tmp1_;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (f != NULL);
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!view_collection_is_view_filter_installed (self, f)) {
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 2095 "ViewCollection.c"
	}
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_collection_remove ((GeeCollection*) _tmp0_, f);
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp1_, NULL, FALSE);
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (f, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_removed (self, f);
#line 2109 "ViewCollection.c"
}


static void
view_collection_on_view_filter_refresh (ViewCollection* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 2128 "ViewCollection.c"
}


static gboolean
view_collection_is_in_filter (ViewCollection* self,
                              DataView* view)
{
	gboolean result = FALSE;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 2141 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2154 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 2166 "ViewCollection.c"
			}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!view_filter_predicate (_tmp5_, view)) {
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				result = FALSE;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_view_filter_unref0 (f);
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_f_it);
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				return result;
#line 2186 "ViewCollection.c"
			}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 2190 "ViewCollection.c"
		}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 2194 "ViewCollection.c"
	}
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2200 "ViewCollection.c"
}


static gboolean
view_collection_real_valid_type (DataCollection* base,
                                 DataObject* object)
{
	ViewCollection * self;
	gboolean result = FALSE;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (object, TYPE_DATA_VIEW);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2218 "ViewCollection.c"
}


static void
view_collection_on_sources_added (ViewCollection* self,
                                  DataCollection* sources,
                                  GeeIterable* added)
{
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (sources != NULL);
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_add_sources (self, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_SOURCE_COLLECTION, SourceCollection), added, NULL, NULL);
#line 2235 "ViewCollection.c"
}


static DataView*
_view_manager_create_view_create_view (DataSource* source,
                                       gpointer self)
{
	DataView* result;
	result = view_manager_create_view ((ViewManager*) self, source);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2247 "ViewCollection.c"
}


static void
view_collection_add_sources (ViewCollection* self,
                             SourceCollection* sources,
                             GeeIterable* added,
                             ProgressMonitor progress_monitor,
                             void* progress_monitor_target)
{
	DataView* created_view = NULL;
	GeeArrayList* created_views = NULL;
	DataView* _tmp32_;
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (sources != NULL);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	created_view = NULL;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	created_views = NULL;
#line 2271 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2281 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			CreateView factory = NULL;
			void* factory_target;
			GDestroyNotify factory_target_destroy_notify;
			CreateView _tmp17_;
			void* _tmp17__target;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 2297 "ViewCollection.c"
			}
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory = NULL;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 2311 "ViewCollection.c"
			{
				GeeIterator* _monitor_it = NULL;
				GeeHashMultiMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _tmp8_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp4_ = self->priv->monitors;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = gee_multi_map_get ((GeeMultiMap*) _tmp4_, sources);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp6_ = _tmp5_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = _tmp7_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp6_);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_monitor_it = _tmp8_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2335 "ViewCollection.c"
					GeeIterator* _tmp9_;
					ViewCollectionMonitorImpl* monitor = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					ViewCollectionMonitorImpl* _tmp12_;
					ViewManager* _tmp13_;
					DataSource* _tmp14_;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp9_ = _monitor_it;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						break;
#line 2349 "ViewCollection.c"
					}
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp10_ = _monitor_it;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) _tmp11_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp12_ = monitor;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp13_ = _tmp12_->manager;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp14_ = source;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp13_, _tmp14_)) {
#line 2365 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp15_;
						ViewManager* _tmp16_;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp15_ = monitor;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp16_ = _tmp15_->manager;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory = NULL;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory_target = NULL;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory_target_destroy_notify = NULL;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory = _view_manager_create_view_create_view;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory_target = view_manager_ref (_tmp16_);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						factory_target_destroy_notify = view_manager_unref;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						break;
#line 2390 "ViewCollection.c"
					}
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor);
#line 2394 "ViewCollection.c"
				}
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_it);
#line 2398 "ViewCollection.c"
			}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp17_ = factory;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp17__target = factory_target;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp17_ != NULL) {
#line 2406 "ViewCollection.c"
				DataView* new_view = NULL;
				CreateView _tmp18_;
				void* _tmp18__target;
				DataSource* _tmp19_;
				DataView* _tmp20_;
				GeeArrayList* _tmp21_;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = factory;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18__target = factory_target;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp20_ = _tmp18_ (_tmp19_, _tmp18__target);
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				new_view = _tmp20_;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp21_ = created_views;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp21_ != NULL) {
#line 2427 "ViewCollection.c"
					GeeArrayList* _tmp22_;
					DataView* _tmp23_;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp22_ = created_views;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp23_ = new_view;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 2436 "ViewCollection.c"
				} else {
					DataView* _tmp24_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp24_ = created_view;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp24_ == NULL) {
#line 2443 "ViewCollection.c"
						DataView* _tmp25_;
						DataView* _tmp26_;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp25_ = new_view;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp26_ = _g_object_ref0 (_tmp25_);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						created_view = _tmp26_;
#line 2454 "ViewCollection.c"
					} else {
						GeeArrayList* _tmp27_;
						GeeArrayList* _tmp28_;
						DataView* _tmp29_;
						GeeArrayList* _tmp30_;
						DataView* _tmp31_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp27_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (created_views);
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						created_views = _tmp27_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp28_ = created_views;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp29_ = created_view;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						created_view = NULL;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp30_ = created_views;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp31_ = new_view;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 2483 "ViewCollection.c"
					}
				}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (new_view);
#line 2488 "ViewCollection.c"
			}
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory = NULL;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2500 "ViewCollection.c"
		}
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2504 "ViewCollection.c"
	}
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp32_ = created_view;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp32_ != NULL) {
#line 2510 "ViewCollection.c"
		DataView* _tmp33_;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp33_ = created_view;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_collection_add ((DataCollection*) self, (DataObject*) _tmp33_);
#line 2516 "ViewCollection.c"
	} else {
		gboolean _tmp34_ = FALSE;
		GeeArrayList* _tmp35_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp35_ = created_views;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp35_ != NULL) {
#line 2524 "ViewCollection.c"
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp36_ = created_views;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp38_ = _tmp37_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp34_ = _tmp38_ > 0;
#line 2536 "ViewCollection.c"
		} else {
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp34_ = FALSE;
#line 2540 "ViewCollection.c"
		}
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp34_) {
#line 2544 "ViewCollection.c"
			GeeArrayList* _tmp39_;
			GeeCollection* _tmp40_;
			GeeCollection* _tmp41_;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp39_ = created_views;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp40_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp39_, progress_monitor, progress_monitor_target);
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp41_ = _tmp40_;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp41_);
#line 2556 "ViewCollection.c"
		}
	}
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (created_views);
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (created_view);
#line 2563 "ViewCollection.c"
}


static gboolean
view_collection_real_add (DataCollection* base,
                          DataObject* object)
{
	ViewCollection * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView), TRUE);
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = FALSE;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 2587 "ViewCollection.c"
	}
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_singleton (object);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 415 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 415 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2601 "ViewCollection.c"
}


static GeeCollection*
view_collection_real_add_many (DataCollection* base,
                               GeeCollection* objects,
                               ProgressMonitor monitor,
                               void* monitor_target)
{
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* return_list = NULL;
	GeeCollection* _tmp5_;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (objects != NULL, NULL);
#line 2619 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2629 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataObject* _tmp4_;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 2641 "ViewCollection.c"
			}
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView), TRUE);
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2655 "ViewCollection.c"
		}
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2659 "ViewCollection.c"
	}
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), objects, monitor, monitor_target);
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return_list = _tmp5_;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, G_TYPE_CHECK_INSTANCE_CAST (return_list, GEE_TYPE_COLLECTION, GeeCollection));
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = return_list;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 2671 "ViewCollection.c"
}


static void
view_collection_on_sources_removed (ViewCollection* self,
                                    GeeIterable* removed)
{
	Marker* marker = NULL;
	gboolean _tmp12_ = FALSE;
	Marker* _tmp13_;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker = NULL;
#line 2688 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2698 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			GeeHashMap* _tmp4_;
			DataSource* _tmp5_;
			gpointer _tmp6_;
			DataView* _tmp7_;
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 2714 "ViewCollection.c"
			}
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = self->priv->source_map;
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = source;
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = (DataView*) _tmp6_;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp7_ != NULL) {
#line 2734 "ViewCollection.c"
				Marker* _tmp8_;
				Marker* _tmp10_;
				DataView* _tmp11_;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = marker;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp8_ == NULL) {
#line 2742 "ViewCollection.c"
					Marker* _tmp9_;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp9_ = data_collection_start_marking ((DataCollection*) self);
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (marker);
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					marker = _tmp9_;
#line 2750 "ViewCollection.c"
				}
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = marker;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = view;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				marker_mark (_tmp10_, (DataObject*) _tmp11_);
#line 2758 "ViewCollection.c"
			}
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2764 "ViewCollection.c"
		}
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2768 "ViewCollection.c"
	}
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 2774 "ViewCollection.c"
		Marker* _tmp14_;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp14_ = marker;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp12_ = marker_get_count (_tmp14_) != 0;
#line 2780 "ViewCollection.c"
	} else {
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp12_ = FALSE;
#line 2784 "ViewCollection.c"
	}
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 2788 "ViewCollection.c"
		Marker* _tmp15_;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp15_ = marker;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_collection_remove_marked ((DataCollection*) self, _tmp15_);
#line 2794 "ViewCollection.c"
	}
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 2798 "ViewCollection.c"
}


static void
view_collection_on_sources_altered (ViewCollection* self,
                                    DataCollection* collection,
                                    GeeMap* items)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* to_remove = NULL;
	gboolean ordering_changed = FALSE;
	GeeArrayList* _tmp69_;
	GeeArrayList* _tmp73_;
	gboolean _tmp77_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (collection != NULL);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (items != NULL);
#line 452 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	to_add = NULL;
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	to_remove = NULL;
#line 454 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	ordering_changed = FALSE;
#line 2825 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2849 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			DataSource* source = NULL;
			DataObject* _tmp10_;
			DataSource* _tmp11_;
			ViewCollectionMonitorImpl* monitor = NULL;
			gboolean ignored = FALSE;
			gboolean _tmp31_;
			gboolean _tmp33_ = FALSE;
			ViewCollectionMonitorImpl* _tmp34_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 2871 "ViewCollection.c"
			}
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			alteration = (Alteration*) _tmp9_;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource));
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 459 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			monitor = NULL;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			ignored = TRUE;
#line 2895 "ViewCollection.c"
			{
				GeeIterator* _monitor_impl_it = NULL;
				GeeHashMultiMap* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
				GeeIterator* _tmp16_;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = self->priv->monitors;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = gee_multi_map_get ((GeeMultiMap*) _tmp12_, G_TYPE_CHECK_INSTANCE_CAST (collection, TYPE_SOURCE_COLLECTION, SourceCollection));
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = _tmp15_;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_monitor_impl_it = _tmp16_;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2919 "ViewCollection.c"
					GeeIterator* _tmp17_;
					ViewCollectionMonitorImpl* monitor_impl = NULL;
					GeeIterator* _tmp18_;
					gpointer _tmp19_;
					gboolean _tmp20_ = FALSE;
					ViewCollectionMonitorImpl* _tmp21_;
					Alteration* _tmp22_;
					ViewCollectionMonitorImpl* _tmp26_;
					ViewManager* _tmp27_;
					DataSource* _tmp28_;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp17_ = _monitor_impl_it;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp17_)) {
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						break;
#line 2936 "ViewCollection.c"
					}
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp18_ = _monitor_impl_it;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp19_;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp21_ = monitor_impl;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp22_ = _tmp21_->prereq;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp22_ != NULL) {
#line 2950 "ViewCollection.c"
						Alteration* _tmp23_;
						ViewCollectionMonitorImpl* _tmp24_;
						Alteration* _tmp25_;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp23_ = alteration;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp24_ = monitor_impl;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp25_ = _tmp24_->prereq;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp20_ = !alteration_contains_any (_tmp23_, _tmp25_);
#line 2962 "ViewCollection.c"
					} else {
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp20_ = FALSE;
#line 2966 "ViewCollection.c"
					}
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp20_) {
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						continue;
#line 2974 "ViewCollection.c"
					}
#line 465 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					ignored = FALSE;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp26_ = monitor_impl;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp27_ = _tmp26_->manager;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp28_ = source;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp27_, _tmp28_)) {
#line 2986 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp29_;
						ViewCollectionMonitorImpl* _tmp30_;
#line 468 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp29_ = monitor_impl;
#line 468 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp30_ = _view_collection_monitor_ref0 (_tmp29_);
#line 468 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 468 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						monitor = _tmp30_;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						break;
#line 3001 "ViewCollection.c"
					}
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor_impl);
#line 3005 "ViewCollection.c"
				}
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_impl_it);
#line 3009 "ViewCollection.c"
			}
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp31_ = ignored;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp31_) {
#line 3015 "ViewCollection.c"
				ViewCollectionMonitorImpl* _tmp32_;
#line 475 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp32_ = monitor;
#line 475 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_vala_assert (_tmp32_ == NULL, "monitor == null");
#line 477 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_view_collection_monitor_unref0 (monitor);
#line 477 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 477 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_alteration_unref0 (alteration);
#line 477 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (object);
#line 477 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				continue;
#line 3031 "ViewCollection.c"
			}
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp34_ = monitor;
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp34_ != NULL) {
#line 3037 "ViewCollection.c"
				DataSource* _tmp35_;
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp35_ = source;
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp33_ = !view_collection_has_view_for_source (self, _tmp35_);
#line 3043 "ViewCollection.c"
			} else {
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp33_ = FALSE;
#line 3047 "ViewCollection.c"
			}
#line 480 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp33_) {
#line 3051 "ViewCollection.c"
				GeeArrayList* _tmp36_;
				GeeArrayList* _tmp38_;
				ViewCollectionMonitorImpl* _tmp39_;
				ViewManager* _tmp40_;
				DataSource* _tmp41_;
				DataView* _tmp42_;
				DataView* _tmp43_;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp36_ = to_add;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp36_ == NULL) {
#line 3063 "ViewCollection.c"
					GeeArrayList* _tmp37_;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp37_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (to_add);
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					to_add = _tmp37_;
#line 3071 "ViewCollection.c"
				}
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp38_ = to_add;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp39_ = monitor;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp40_ = _tmp39_->manager;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp41_ = source;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp42_ = view_manager_create_view (_tmp40_, _tmp41_);
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp43_ = _tmp42_;
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp43_);
#line 484 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp43_);
#line 3089 "ViewCollection.c"
			} else {
				gboolean _tmp44_ = FALSE;
				ViewCollectionMonitorImpl* _tmp45_;
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp45_ = monitor;
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp45_ == NULL) {
#line 3097 "ViewCollection.c"
					DataSource* _tmp46_;
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp46_ = source;
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp44_ = view_collection_has_view_for_source (self, _tmp46_);
#line 3103 "ViewCollection.c"
				} else {
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp44_ = FALSE;
#line 3107 "ViewCollection.c"
				}
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp44_) {
#line 3111 "ViewCollection.c"
					GeeArrayList* _tmp47_;
					GeeArrayList* _tmp49_;
					DataSource* _tmp50_;
					DataView* _tmp51_;
					DataView* _tmp52_;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp47_ = to_remove;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp47_ == NULL) {
#line 3121 "ViewCollection.c"
						GeeArrayList* _tmp48_;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp48_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (to_remove);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						to_remove = _tmp48_;
#line 3129 "ViewCollection.c"
					}
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp49_ = to_remove;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp50_ = source;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp51_ = view_collection_get_view_for_source (self, _tmp50_);
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp52_ = _tmp51_;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp52_);
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp52_);
#line 3143 "ViewCollection.c"
				} else {
					gboolean _tmp53_ = FALSE;
					ViewCollectionMonitorImpl* _tmp54_;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp54_ = monitor;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp54_ != NULL) {
#line 3151 "ViewCollection.c"
						DataSource* _tmp55_;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp55_ = source;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp53_ = view_collection_has_view_for_source (self, _tmp55_);
#line 3157 "ViewCollection.c"
					} else {
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp53_ = FALSE;
#line 3161 "ViewCollection.c"
					}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp53_) {
#line 3165 "ViewCollection.c"
						DataView* view = NULL;
						DataSource* _tmp56_;
						DataView* _tmp57_;
						DataSet* _tmp58_;
						DataView* _tmp59_;
						gboolean _tmp63_ = FALSE;
						DataSet* _tmp64_;
#line 491 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp56_ = source;
#line 491 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp57_ = view_collection_get_view_for_source (self, _tmp56_);
#line 491 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						view = _tmp57_;
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp58_ = self->priv->selected;
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp59_ = view;
#line 493 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						if (data_set_contains (_tmp58_, (DataObject*) _tmp59_)) {
#line 3185 "ViewCollection.c"
							DataSet* _tmp60_;
							DataView* _tmp61_;
							Alteration* _tmp62_;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp60_ = self->priv->selected;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp61_ = view;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp62_ = alteration;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							data_set_resort_object (_tmp60_, (DataObject*) _tmp61_, _tmp62_);
#line 3197 "ViewCollection.c"
						}
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp64_ = self->priv->visible;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						if (_tmp64_ != NULL) {
#line 3203 "ViewCollection.c"
							DataView* _tmp65_;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp65_ = view;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp63_ = view_collection_is_visible (self, _tmp65_);
#line 3209 "ViewCollection.c"
						} else {
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp63_ = FALSE;
#line 3213 "ViewCollection.c"
						}
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						if (_tmp63_) {
#line 3217 "ViewCollection.c"
							DataSet* _tmp66_;
							DataView* _tmp67_;
							Alteration* _tmp68_;
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp66_ = self->priv->visible;
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp67_ = view;
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp68_ = alteration;
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							if (data_set_resort_object (_tmp66_, (DataObject*) _tmp67_, _tmp68_)) {
#line 498 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
								ordering_changed = TRUE;
#line 3231 "ViewCollection.c"
							}
						}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (view);
#line 3236 "ViewCollection.c"
					}
				}
			}
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_collection_monitor_unref0 (monitor);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_alteration_unref0 (alteration);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3248 "ViewCollection.c"
		}
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3252 "ViewCollection.c"
	}
#line 503 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp69_ = to_add;
#line 503 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp69_ != NULL) {
#line 3258 "ViewCollection.c"
		GeeArrayList* _tmp70_;
		GeeCollection* _tmp71_;
		GeeCollection* _tmp72_;
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp70_ = to_add;
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp71_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp70_, NULL, NULL);
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp72_ = _tmp71_;
#line 504 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp72_);
#line 3270 "ViewCollection.c"
	}
#line 506 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp73_ = to_remove;
#line 506 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp73_ != NULL) {
#line 3276 "ViewCollection.c"
		GeeArrayList* _tmp74_;
		Marker* _tmp75_;
		Marker* _tmp76_;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp74_ = to_remove;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp75_ = data_collection_mark_many ((DataCollection*) self, (GeeCollection*) _tmp74_);
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp76_ = _tmp75_;
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_collection_remove_marked ((DataCollection*) self, _tmp76_);
#line 507 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp76_);
#line 3290 "ViewCollection.c"
	}
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp77_ = ordering_changed;
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp77_) {
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_collection_notify_ordering_changed ((DataCollection*) self);
#line 3298 "ViewCollection.c"
	}
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (to_remove);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3304 "ViewCollection.c"
}


static void
view_collection_on_mirror_contents_added (ViewCollection* self,
                                          GeeIterable* added)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 514 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	to_add = _tmp0_;
#line 3325 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (added);
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3335 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataSource* source = NULL;
			DataObject* _tmp5_;
			DataSource* _tmp6_;
			gboolean _tmp7_ = FALSE;
			CreateViewPredicate _tmp8_;
			void* _tmp8__target;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 3352 "ViewCollection.c"
			}
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = _tmp6_;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = self->priv->should_mirror;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8__target = self->priv->should_mirror_target;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp8_ == NULL) {
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = TRUE;
#line 3374 "ViewCollection.c"
			} else {
				CreateViewPredicate _tmp9_;
				void* _tmp9__target;
				DataSource* _tmp10_;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9_ = self->priv->should_mirror;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9__target = self->priv->should_mirror_target;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = source;
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = _tmp9_ (_tmp10_, _tmp9__target);
#line 3387 "ViewCollection.c"
			}
#line 518 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp7_) {
#line 3391 "ViewCollection.c"
				GeeArrayList* _tmp11_;
				CreateView _tmp12_;
				void* _tmp12__target;
				DataSource* _tmp13_;
				DataView* _tmp14_;
				DataView* _tmp15_;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = to_add;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = self->priv->mirroring_ctor;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12__target = self->priv->mirroring_ctor_target;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = source;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = _tmp12_ (_tmp13_, _tmp12__target);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp15_ = _tmp14_;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp15_);
#line 3414 "ViewCollection.c"
			}
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3420 "ViewCollection.c"
		}
#line 515 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3424 "ViewCollection.c"
	}
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp16_ = to_add;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp18_ = _tmp17_;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp18_ > 0) {
#line 3434 "ViewCollection.c"
		GeeArrayList* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp19_ = to_add;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp20_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp19_, NULL, NULL);
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp21_ = _tmp20_;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp21_);
#line 3446 "ViewCollection.c"
	}
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3450 "ViewCollection.c"
}


static void
view_collection_on_mirror_contents_removed (ViewCollection* self,
                                            GeeIterable* removed)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp15_;
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 3469 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (removed);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3479 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataView* view = NULL;
			DataObject* _tmp5_;
			DataView* _tmp6_;
			DataView* our_view = NULL;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			DataView* _tmp11_;
			DataView* _tmp12_;
			Marker* _tmp13_;
			DataView* _tmp14_;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 3502 "ViewCollection.c"
			}
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 529 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = _tmp6_;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view_collection_get_view_for_source (self, _tmp9_);
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			our_view = _tmp11_;
#line 532 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = our_view;
#line 532 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_vala_assert (_tmp12_ != NULL, "our_view != null");
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp13_ = marker;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp14_ = our_view;
#line 534 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			marker_mark (_tmp13_, (DataObject*) _tmp14_);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (our_view);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3546 "ViewCollection.c"
		}
#line 528 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3550 "ViewCollection.c"
	}
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 537 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_remove_marked ((DataCollection*) self, _tmp15_);
#line 526 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 3558 "ViewCollection.c"
}


static void
view_collection_real_notify_items_added (DataCollection* base,
                                         GeeIterable* added)
{
	ViewCollection * self;
	GeeArrayList* added_visible = NULL;
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp28_;
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 542 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	added_visible = NULL;
#line 543 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	added_selected = NULL;
#line 3579 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3589 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			gboolean _tmp11_ = FALSE;
			DataView* _tmp12_;
			gboolean _tmp18_ = FALSE;
			DataView* _tmp19_;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 3612 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = _tmp5_;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = view;
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (data_view_is_selected (_tmp12_)) {
#line 3644 "ViewCollection.c"
				DataView* _tmp13_;
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = data_view_is_visible (_tmp13_);
#line 3650 "ViewCollection.c"
			} else {
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = FALSE;
#line 3654 "ViewCollection.c"
			}
#line 549 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp11_) {
#line 3658 "ViewCollection.c"
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp16_;
				DataView* _tmp17_;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = added_selected;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp14_ == NULL) {
#line 3666 "ViewCollection.c"
					GeeArrayList* _tmp15_;
#line 551 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp15_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 551 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (added_selected);
#line 551 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					added_selected = _tmp15_;
#line 3674 "ViewCollection.c"
				}
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = added_selected;
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp17_ = view;
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 3682 "ViewCollection.c"
			}
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp19_ = view;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (data_view_is_visible (_tmp19_)) {
#line 3688 "ViewCollection.c"
				DataSet* _tmp20_;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp20_ = self->priv->visible;
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = _tmp20_ != NULL;
#line 3694 "ViewCollection.c"
			} else {
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = FALSE;
#line 3698 "ViewCollection.c"
			}
#line 557 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp18_) {
#line 3702 "ViewCollection.c"
				GeeArrayList* _tmp21_;
				GeeArrayList* _tmp23_;
				DataView* _tmp24_;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp21_ = added_visible;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp21_ == NULL) {
#line 3710 "ViewCollection.c"
					GeeArrayList* _tmp22_;
#line 559 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp22_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 559 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (added_visible);
#line 559 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					added_visible = _tmp22_;
#line 3718 "ViewCollection.c"
				}
#line 561 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp23_ = added_visible;
#line 561 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp24_ = view;
#line 561 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 3726 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3732 "ViewCollection.c"
		}
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3736 "ViewCollection.c"
	}
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp25_ = added_visible;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp25_ != NULL) {
#line 3742 "ViewCollection.c"
		gboolean is_added = FALSE;
		GeeArrayList* _tmp26_;
		gboolean _tmp27_;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp26_ = added_visible;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		is_added = view_collection_add_many_visible (self, (GeeCollection*) _tmp26_);
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp27_ = is_added;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_vala_assert (_tmp27_, "is_added");
#line 3754 "ViewCollection.c"
	}
#line 570 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp28_ = added_selected;
#line 570 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp28_ != NULL) {
#line 3760 "ViewCollection.c"
		GeeArrayList* _tmp29_;
		GeeArrayList* _tmp30_;
#line 571 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp29_ = added_selected;
#line 571 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, (GeeCollection*) _tmp29_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp30_ = added_selected;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp30_, NULL);
#line 3771 "ViewCollection.c"
	}
#line 575 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), added);
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 541 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (added_visible);
#line 3779 "ViewCollection.c"
}


static void
view_collection_real_notify_items_removed (DataCollection* base,
                                           GeeIterable* removed)
{
	ViewCollection * self;
	GeeArrayList* selected_removed = NULL;
	GeeArrayList* _tmp33_;
#line 579 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 579 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 580 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	selected_removed = NULL;
#line 3796 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3806 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gboolean _tmp10_;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 3825 "ViewCollection.c"
			}
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = _tmp5_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp9_);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 3853 "ViewCollection.c"
				gboolean is_removed = FALSE;
				GeeHashMap* _tmp11_;
				DataView* _tmp12_;
				DataSource* _tmp13_;
				DataSource* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				DataView* _tmp18_;
				gboolean _tmp27_ = FALSE;
				DataView* _tmp28_;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = self->priv->source_map;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = data_view_get_source (_tmp12_);
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp15_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp11_, _tmp14_, NULL);
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = _tmp15_;
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 589 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				is_removed = _tmp16_;
#line 590 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp17_ = is_removed;
#line 590 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_vala_assert (_tmp17_, "is_removed");
#line 592 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp18_ = view;
#line 592 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp18_)) {
#line 3889 "ViewCollection.c"
					DataSet* _tmp19_;
					DataView* _tmp20_;
					DataView* _tmp21_;
					DataView* _tmp22_;
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp19_ = self->priv->selected;
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp20_ = view;
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp21_ = view;
#line 594 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_vala_assert (data_set_contains (_tmp19_, (DataObject*) _tmp20_) == data_view_is_visible (_tmp21_), "selected.contains (view) == view.is_visible ()");
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp22_ = view;
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (data_view_is_visible (_tmp22_)) {
#line 3906 "ViewCollection.c"
						GeeArrayList* _tmp23_;
						GeeArrayList* _tmp25_;
						DataView* _tmp26_;
#line 597 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp23_ = selected_removed;
#line 597 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						if (_tmp23_ == NULL) {
#line 3914 "ViewCollection.c"
							GeeArrayList* _tmp24_;
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_tmp24_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							_g_object_unref0 (selected_removed);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
							selected_removed = _tmp24_;
#line 3922 "ViewCollection.c"
						}
#line 600 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp25_ = selected_removed;
#line 600 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp26_ = view;
#line 600 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 3930 "ViewCollection.c"
					}
				}
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp28_ = view;
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp28_)) {
#line 3937 "ViewCollection.c"
					DataSet* _tmp29_;
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp29_ = self->priv->visible;
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp27_ = _tmp29_ != NULL;
#line 3943 "ViewCollection.c"
				} else {
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp27_ = FALSE;
#line 3947 "ViewCollection.c"
				}
#line 604 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp27_) {
#line 3951 "ViewCollection.c"
					DataSet* _tmp30_;
					DataView* _tmp31_;
					gboolean _tmp32_;
#line 605 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp30_ = self->priv->visible;
#line 605 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp31_ = view;
#line 605 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					is_removed = data_set_remove (_tmp30_, (DataObject*) _tmp31_);
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp32_ = is_removed;
#line 606 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_vala_assert (_tmp32_, "is_removed");
#line 3965 "ViewCollection.c"
				}
			}
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3972 "ViewCollection.c"
		}
#line 581 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3976 "ViewCollection.c"
	}
#line 611 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp33_ = selected_removed;
#line 611 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp33_ != NULL) {
#line 3982 "ViewCollection.c"
		GeeArrayList* _tmp34_;
#line 612 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp34_ = selected_removed;
#line 612 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, (GeeCollection*) _tmp34_);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 3990 "ViewCollection.c"
	}
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), removed);
#line 579 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (selected_removed);
#line 3996 "ViewCollection.c"
}


static void
view_collection_filter_altered_items (ViewCollection* self,
                                      GeeCollection* views)
{
	GeeArrayList* to_show = NULL;
	GeeArrayList* to_hide = NULL;
	GeeArrayList* _tmp15_;
	GeeArrayList* _tmp17_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 626 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	to_show = NULL;
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	to_hide = NULL;
#line 4016 "ViewCollection.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp0_;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) views);
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_view_it = _tmp0_;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 4026 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataView* view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* _tmp4_;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = _view_it;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 4038 "ViewCollection.c"
			}
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = _view_it;
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = (DataView*) _tmp3_;
#line 633 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 633 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (view_collection_is_in_filter (self, _tmp4_)) {
#line 4050 "ViewCollection.c"
				DataView* _tmp5_;
#line 634 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = view;
#line 634 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!data_view_is_visible (_tmp5_)) {
#line 4056 "ViewCollection.c"
					GeeArrayList* _tmp6_;
					GeeArrayList* _tmp8_;
					DataView* _tmp9_;
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp6_ = to_show;
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp6_ == NULL) {
#line 4064 "ViewCollection.c"
						GeeArrayList* _tmp7_;
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (to_show);
#line 636 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						to_show = _tmp7_;
#line 4072 "ViewCollection.c"
					}
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp8_ = to_show;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp9_ = view;
#line 638 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 4080 "ViewCollection.c"
				}
			} else {
				DataView* _tmp10_;
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = view;
#line 641 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp10_)) {
#line 4088 "ViewCollection.c"
					GeeArrayList* _tmp11_;
					GeeArrayList* _tmp13_;
					DataView* _tmp14_;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp11_ = to_hide;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					if (_tmp11_ == NULL) {
#line 4096 "ViewCollection.c"
						GeeArrayList* _tmp12_;
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						_g_object_unref0 (to_hide);
#line 643 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
						to_hide = _tmp12_;
#line 4104 "ViewCollection.c"
					}
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp13_ = to_hide;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp14_ = view;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 4112 "ViewCollection.c"
				}
			}
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 4117 "ViewCollection.c"
		}
#line 632 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 4121 "ViewCollection.c"
	}
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp15_ = to_show;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp15_ != NULL) {
#line 4127 "ViewCollection.c"
		GeeArrayList* _tmp16_;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp16_ = to_show;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_show_items (self, (GeeList*) _tmp16_);
#line 4133 "ViewCollection.c"
	}
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp17_ = to_hide;
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp17_ != NULL) {
#line 4139 "ViewCollection.c"
		GeeArrayList* _tmp18_;
#line 658 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp18_ = to_hide;
#line 658 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_hide_items (self, (GeeList*) _tmp18_);
#line 4145 "ViewCollection.c"
	}
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (to_hide);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (to_show);
#line 4151 "ViewCollection.c"
}


static void
view_collection_real_items_altered (DataCollection* base,
                                    GeeMap* map)
{
	ViewCollection * self;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeCollection* _tmp2_;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (map != NULL);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_map_get_keys (map);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp2_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 665 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), map);
#line 4179 "ViewCollection.c"
}


static void
view_collection_real_set_comparator (DataCollection* base,
                                     Comparator comparator,
                                     void* comparator_target,
                                     ComparatorPredicate predicate,
                                     void* predicate_target)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 668 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 669 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_set_set_comparator (_tmp0_, comparator, comparator_target, predicate, predicate_target);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4203 "ViewCollection.c"
		DataSet* _tmp2_;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_set_set_comparator (_tmp2_, comparator, comparator_target, predicate, predicate_target);
#line 4209 "ViewCollection.c"
	}
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), comparator, comparator_target, predicate, predicate_target);
#line 4213 "ViewCollection.c"
}


static void
view_collection_real_reset_comparator (DataCollection* base)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_set_reset_comparator (_tmp0_);
#line 678 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 678 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4233 "ViewCollection.c"
		DataSet* _tmp2_;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data_set_reset_comparator (_tmp2_);
#line 4239 "ViewCollection.c"
	}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 4243 "ViewCollection.c"
}


static GeeCollection*
view_collection_real_get_all (DataCollection* base)
{
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 684 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4260 "ViewCollection.c"
		DataSet* _tmp2_;
		GeeList* _tmp3_;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_all (_tmp2_);
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = (GeeCollection*) _tmp3_;
#line 4271 "ViewCollection.c"
	} else {
		GeeCollection* _tmp4_;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4280 "ViewCollection.c"
	}
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 685 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4286 "ViewCollection.c"
}


GeeCollection*
view_collection_get_all_unfiltered (ViewCollection* self)
{
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
#line 688 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 689 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4303 "ViewCollection.c"
}


static gint
view_collection_real_get_count (DataCollection* base)
{
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 692 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4320 "ViewCollection.c"
		DataSet* _tmp2_;
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_set_get_count (_tmp2_);
#line 4326 "ViewCollection.c"
	} else {
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 4330 "ViewCollection.c"
	}
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 693 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4336 "ViewCollection.c"
}


gint
view_collection_get_unfiltered_count (ViewCollection* self)
{
	gint result = 0;
#line 696 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4350 "ViewCollection.c"
}


static DataObject*
view_collection_real_get_at (DataCollection* base,
                             gint index)
{
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 700 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4368 "ViewCollection.c"
		DataSet* _tmp2_;
		DataObject* _tmp3_;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_at (_tmp2_, index);
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = _tmp3_;
#line 4379 "ViewCollection.c"
	} else {
		DataObject* _tmp4_;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), index);
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4388 "ViewCollection.c"
	}
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 701 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4394 "ViewCollection.c"
}


static gint
view_collection_real_index_of (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 704 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 704 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, 0);
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4414 "ViewCollection.c"
		DataSet* _tmp2_;
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_set_index_of (_tmp2_, object);
#line 4420 "ViewCollection.c"
	} else {
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object);
#line 4424 "ViewCollection.c"
	}
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4430 "ViewCollection.c"
}


static gboolean
view_collection_real_contains (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gboolean result = FALSE;
#line 708 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 708 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 711 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 712 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = FALSE;
#line 712 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4450 "ViewCollection.c"
	}
#line 715 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = view_collection_is_visible (self, G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 715 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4456 "ViewCollection.c"
}


static DataView*
view_collection_real_get_first (ViewCollection* self)
{
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) > 0) {
#line 4467 "ViewCollection.c"
		DataObject* _tmp1_;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at ((DataCollection*) self, 0);
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 4475 "ViewCollection.c"
	} else {
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4481 "ViewCollection.c"
	}
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4487 "ViewCollection.c"
}


DataView*
view_collection_get_first (ViewCollection* self)
{
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 4498 "ViewCollection.c"
}


/**
     * @brief A helper method for places in the app that need a
     *  non-rejected media source (namely Events, when looking to
     *  automatically choose a thumbnail).
     *
     * @note If every view in this collection is rejected, we
     *  return the first view; this is intentional.  This prevents
     *  pathological events that have nothing but rejected images
     *  in them from breaking.
     */
static DataView*
view_collection_real_get_first_unrejected (ViewCollection* self)
{
	DataView* result = NULL;
	DataView* dv = NULL;
	DataView* _tmp0_;
	gint num_views = 0;
	DataView* _tmp11_;
#line 734 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) < 1) {
#line 735 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 735 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4526 "ViewCollection.c"
	}
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_first (self);
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	dv = _tmp0_;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	num_views = data_collection_get_count ((DataCollection*) self);
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4536 "ViewCollection.c"
		gboolean _tmp1_ = FALSE;
		DataView* _tmp2_;
		MediaSource* tmp = NULL;
		DataView* _tmp5_;
		DataSource* _tmp6_;
		MediaSource* _tmp7_;
		MediaSource* _tmp8_;
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = dv;
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp2_ != NULL) {
#line 4548 "ViewCollection.c"
			DataView* _tmp3_;
			gint _tmp4_;
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = dv;
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = num_views;
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = data_collection_index_of ((DataCollection*) self, (DataObject*) _tmp3_) < (_tmp4_ - 1);
#line 4557 "ViewCollection.c"
		} else {
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = FALSE;
#line 4561 "ViewCollection.c"
		}
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (!_tmp1_) {
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			break;
#line 4567 "ViewCollection.c"
		}
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = dv;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = data_view_get_source (_tmp5_);
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_MEDIA_SOURCE) ? ((MediaSource*) _tmp6_) : NULL;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp7_ == NULL) {
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp6_);
#line 4579 "ViewCollection.c"
		}
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		tmp = _tmp7_;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp8_ = tmp;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp8_ != NULL) {
#line 746 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			result = dv;
#line 746 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (tmp);
#line 746 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return result;
#line 4593 "ViewCollection.c"
		} else {
			DataView* _tmp9_;
			DataView* _tmp10_;
#line 748 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = dv;
#line 748 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view_collection_get_next (self, _tmp9_);
#line 748 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (dv);
#line 748 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			dv = _tmp10_;
#line 4605 "ViewCollection.c"
		}
#line 741 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (tmp);
#line 4609 "ViewCollection.c"
	}
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp11_ = view_collection_get_first (self);
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp11_;
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (dv);
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4619 "ViewCollection.c"
}


DataView*
view_collection_get_first_unrejected (ViewCollection* self)
{
#line 732 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 732 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first_unrejected (self);
#line 4630 "ViewCollection.c"
}


static DataView*
view_collection_real_get_last (ViewCollection* self)
{
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) > 0) {
#line 4641 "ViewCollection.c"
		DataObject* _tmp1_;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at ((DataCollection*) self, data_collection_get_count ((DataCollection*) self) - 1);
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 4649 "ViewCollection.c"
	} else {
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4655 "ViewCollection.c"
	}
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4661 "ViewCollection.c"
}


DataView*
view_collection_get_last (ViewCollection* self)
{
#line 757 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 757 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 4672 "ViewCollection.c"
}


static DataView*
view_collection_real_get_next (ViewCollection* self,
                               DataView* view)
{
	DataView* result = NULL;
	gint index = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	DataObject* _tmp4_;
#line 761 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 762 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) == 0) {
#line 763 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 763 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4695 "ViewCollection.c"
	}
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	index = data_collection_index_of ((DataCollection*) self, (DataObject*) view);
#line 766 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = index;
#line 766 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_ < 0) {
#line 767 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 767 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4707 "ViewCollection.c"
	}
#line 769 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 769 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	index = _tmp1_ + 1;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = index;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp2_ >= data_collection_get_count ((DataCollection*) self)) {
#line 771 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		index = 0;
#line 4719 "ViewCollection.c"
	}
#line 773 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 773 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_at ((DataCollection*) self, _tmp3_);
#line 773 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView);
#line 773 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4729 "ViewCollection.c"
}


DataView*
view_collection_get_next (ViewCollection* self,
                          DataView* view)
{
#line 761 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 761 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 4741 "ViewCollection.c"
}


static DataView*
view_collection_real_get_previous (ViewCollection* self,
                                   DataView* view)
{
	DataView* result = NULL;
	gint index = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	DataObject* _tmp4_;
#line 776 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 777 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) == 0) {
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4764 "ViewCollection.c"
	}
#line 780 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	index = data_collection_index_of ((DataCollection*) self, (DataObject*) view);
#line 781 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = index;
#line 781 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_ < 0) {
#line 782 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 782 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4776 "ViewCollection.c"
	}
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	index = _tmp1_ - 1;
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = index;
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp2_ < 0) {
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		index = data_collection_get_count ((DataCollection*) self) - 1;
#line 4788 "ViewCollection.c"
	}
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_at ((DataCollection*) self, _tmp3_);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 4798 "ViewCollection.c"
}


DataView*
view_collection_get_previous (ViewCollection* self,
                              DataView* view)
{
#line 776 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 776 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 4810 "ViewCollection.c"
}


gboolean
view_collection_get_immediate_neighbors (ViewCollection* self,
                                         DataSource* home,
                                         DataSource* * next,
                                         DataSource* * prev,
                                         const gchar* type_selector)
{
	DataSource* _vala_next = NULL;
	DataSource* _vala_prev = NULL;
	gboolean result = FALSE;
	DataView* home_view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* next_view = NULL;
	DataView* _tmp2_;
	DataView* _tmp3_;
	DataView* prev_view = NULL;
	DataView* _tmp16_;
	DataView* _tmp17_;
#line 791 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 791 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (home != NULL, FALSE);
#line 793 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_next);
#line 793 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_next = NULL;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_prev);
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_prev = NULL;
#line 796 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, home);
#line 796 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	home_view = _tmp0_;
#line 797 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = home_view;
#line 797 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ == NULL) {
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = FALSE;
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (home_view);
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (next) {
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			*next = _vala_next;
#line 4861 "ViewCollection.c"
		} else {
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 4865 "ViewCollection.c"
		}
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (prev) {
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			*prev = _vala_prev;
#line 4871 "ViewCollection.c"
		} else {
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 4875 "ViewCollection.c"
		}
#line 798 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 4879 "ViewCollection.c"
	}
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = home_view;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_next (self, _tmp2_);
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	next_view = _tmp3_;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4889 "ViewCollection.c"
		DataView* _tmp4_;
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
		DataView* _tmp14_;
		DataView* _tmp15_;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = next_view;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = home_view;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (!(_tmp4_ != _tmp5_)) {
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			break;
#line 4903 "ViewCollection.c"
		}
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = TRUE;
#line 4909 "ViewCollection.c"
		} else {
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = next_view;
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = data_source_get_typename (_tmp9_);
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = g_strcmp0 (_tmp11_, type_selector) == 0;
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_free0 (_tmp11_);
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 4932 "ViewCollection.c"
		}
#line 802 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp6_) {
#line 4936 "ViewCollection.c"
			DataView* _tmp12_;
			DataSource* _tmp13_;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = next_view;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp13_ = data_view_get_source (_tmp12_);
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_vala_next = _tmp13_;
#line 804 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			break;
#line 4949 "ViewCollection.c"
		}
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp14_ = next_view;
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp15_ = view_collection_get_next (self, _tmp14_);
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_view);
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		next_view = _tmp15_;
#line 4959 "ViewCollection.c"
	}
#line 809 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp16_ = home_view;
#line 809 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp17_ = view_collection_get_previous (self, _tmp16_);
#line 809 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	prev_view = _tmp17_;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4969 "ViewCollection.c"
		DataView* _tmp18_;
		DataView* _tmp19_;
		gboolean _tmp20_ = FALSE;
		DataView* _tmp28_;
		DataView* _tmp29_;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp18_ = prev_view;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp19_ = home_view;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (!(_tmp18_ != _tmp19_)) {
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			break;
#line 4983 "ViewCollection.c"
		}
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp20_ = TRUE;
#line 4989 "ViewCollection.c"
		} else {
			DataView* _tmp21_;
			DataSource* _tmp22_;
			DataSource* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp21_ = prev_view;
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp22_ = data_view_get_source (_tmp21_);
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp23_ = _tmp22_;
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp24_ = data_source_get_typename (_tmp23_);
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp25_ = _tmp24_;
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp20_ = g_strcmp0 (_tmp25_, type_selector) == 0;
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_free0 (_tmp25_);
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp23_);
#line 5012 "ViewCollection.c"
		}
#line 811 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp20_) {
#line 5016 "ViewCollection.c"
			DataView* _tmp26_;
			DataSource* _tmp27_;
#line 812 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp26_ = prev_view;
#line 812 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp27_ = data_view_get_source (_tmp26_);
#line 812 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 812 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_vala_prev = _tmp27_;
#line 813 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			break;
#line 5029 "ViewCollection.c"
		}
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp28_ = prev_view;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp29_ = view_collection_get_previous (self, _tmp28_);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_view);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		prev_view = _tmp29_;
#line 5039 "ViewCollection.c"
	}
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (prev_view);
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (next_view);
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (home_view);
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (next) {
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*next = _vala_next;
#line 5053 "ViewCollection.c"
	} else {
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_next);
#line 5057 "ViewCollection.c"
	}
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (prev) {
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*prev = _vala_prev;
#line 5063 "ViewCollection.c"
	} else {
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_prev);
#line 5067 "ViewCollection.c"
	}
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5071 "ViewCollection.c"
}


GeeSet*
view_collection_get_extended_neighbors (ViewCollection* self,
                                        DataSource* home,
                                        const gchar* typename)
{
	GeeSet* result = NULL;
	GeeSet* neighbors = NULL;
	GeeHashSet* _tmp0_;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_ = NULL;
	DataSource* _tmp2_ = NULL;
	gboolean _tmp3_;
	DataSource* _tmp4_;
	DataSource* _tmp13_;
	GeeSet* _tmp22_;
#line 822 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 822 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (home != NULL, NULL);
#line 824 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 824 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	neighbors = (GeeSet*) _tmp0_;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_immediate_neighbors (self, home, &_tmp1_, &_tmp2_, typename);
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	next = _tmp1_;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	prev = _tmp2_;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = neighbors;
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (prev);
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next);
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 5119 "ViewCollection.c"
	}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = next;
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 5125 "ViewCollection.c"
		GeeSet* _tmp5_;
		DataSource* _tmp6_;
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp9_ = NULL;
		DataSource* _tmp10_;
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = neighbors;
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = next;
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_collection_add ((GeeCollection*) _tmp5_, _tmp6_);
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp7_ = next;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp7_, &_tmp8_, &_tmp9_, typename);
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		next_next = _tmp8_;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		next_prev = _tmp9_;
#line 839 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp10_ = next_next;
#line 839 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp10_ != NULL) {
#line 5156 "ViewCollection.c"
			GeeSet* _tmp11_;
			DataSource* _tmp12_;
#line 840 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = neighbors;
#line 840 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = next_next;
#line 840 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			gee_collection_add ((GeeCollection*) _tmp11_, _tmp12_);
#line 5165 "ViewCollection.c"
		}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 5171 "ViewCollection.c"
	}
#line 844 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp13_ = prev;
#line 844 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 5177 "ViewCollection.c"
		GeeSet* _tmp14_;
		DataSource* _tmp15_;
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp16_;
		DataSource* _tmp17_ = NULL;
		DataSource* _tmp18_ = NULL;
		DataSource* _tmp19_;
#line 845 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp14_ = neighbors;
#line 845 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp15_ = prev;
#line 845 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_collection_add ((GeeCollection*) _tmp14_, _tmp15_);
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp16_ = prev;
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp16_, &_tmp17_, &_tmp18_, typename);
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		next_prev = _tmp17_;
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 848 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		prev_prev = _tmp18_;
#line 851 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp19_ = prev_prev;
#line 851 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp19_ != NULL) {
#line 5208 "ViewCollection.c"
			GeeSet* _tmp20_;
			DataSource* _tmp21_;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp20_ = neighbors;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp21_ = prev_prev;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
#line 5217 "ViewCollection.c"
		}
#line 844 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 844 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 5223 "ViewCollection.c"
	}
#line 856 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp22_ = neighbors;
#line 856 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_collection_remove ((GeeCollection*) _tmp22_, home);
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = neighbors;
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5237 "ViewCollection.c"
}


static void
view_collection_add_many_selected (ViewCollection* self,
                                   GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean added = FALSE;
	DataSet* _tmp7_;
	gboolean _tmp8_;
#line 863 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 863 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 865 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 5262 "ViewCollection.c"
	}
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp2_;
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) views);
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_view_it = _tmp2_;
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5273 "ViewCollection.c"
			GeeIterator* _tmp3_;
			DataView* view = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			DataView* _tmp6_;
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = _view_it;
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 5285 "ViewCollection.c"
			}
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = _view_it;
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = (DataView*) _tmp5_;
#line 868 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 868 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_vala_assert (data_view_is_visible (_tmp6_), "view.is_visible ()");
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 5299 "ViewCollection.c"
		}
#line 867 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 5303 "ViewCollection.c"
	}
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp7_ = self->priv->selected;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	added = data_set_add_many (_tmp7_, views);
#line 871 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp8_ = added;
#line 871 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (_tmp8_, "added");
#line 5313 "ViewCollection.c"
}


static void
view_collection_remove_many_selected (ViewCollection* self,
                                      GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean removed = FALSE;
	DataSet* _tmp2_;
	gboolean _tmp3_;
#line 874 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 874 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 5338 "ViewCollection.c"
	}
#line 878 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->selected;
#line 878 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp2_, views);
#line 879 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = removed;
#line 879 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (_tmp3_, "removed");
#line 5348 "ViewCollection.c"
}


static gboolean
_view_collection_select_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_select_item ((ViewCollection*) self, object, user);
#line 885 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5361 "ViewCollection.c"
}


void
view_collection_select_marked (ViewCollection* self,
                               Marker* marker)
{
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	selected = _tmp0_;
#line 885 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = selected;
#line 885 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_select_item_marked_action, self, NULL, NULL, (GObject*) _tmp1_);
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = selected;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 5395 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 888 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = selected;
#line 888 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, (GeeCollection*) _tmp5_);
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = selected;
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp6_, NULL);
#line 5406 "ViewCollection.c"
	}
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 5410 "ViewCollection.c"
}


void
view_collection_select_all (ViewCollection* self)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
#line 894 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker_mark_all (marker);
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_select_marked (self, marker);
#line 894 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5431 "ViewCollection.c"
}


static gboolean
view_collection_select_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	gboolean result = FALSE;
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp5_;
	DataView* _tmp6_;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 901 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 901 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view = _tmp0_;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_view_is_selected (_tmp1_)) {
#line 5458 "ViewCollection.c"
		DataView* _tmp2_;
#line 903 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 903 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp2_)) {
#line 5464 "ViewCollection.c"
			DataSet* _tmp3_;
			DataView* _tmp4_;
#line 904 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = self->priv->selected;
#line 904 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 904 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_vala_assert (data_set_contains (_tmp3_, (DataObject*) _tmp4_), "selected.contains (view)");
#line 5473 "ViewCollection.c"
		}
#line 906 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = TRUE;
#line 906 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 906 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 5481 "ViewCollection.c"
	}
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp5_, TRUE);
#line 913 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp6_ = view;
#line 913 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_view_is_visible (_tmp6_)) {
#line 5491 "ViewCollection.c"
		DataView* _tmp7_;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp7_ = view;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp7_);
#line 5497 "ViewCollection.c"
	}
#line 916 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 916 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 916 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5505 "ViewCollection.c"
}


static gboolean
_view_collection_unselect_item_marked_action (DataObject* object,
                                              GObject* user,
                                              gpointer self)
{
	gboolean result;
	result = view_collection_unselect_item ((ViewCollection*) self, object, user);
#line 922 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5518 "ViewCollection.c"
}


void
view_collection_unselect_marked (ViewCollection* self,
                                 Marker* marker)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 922 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = unselected;
#line 922 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, (GObject*) _tmp1_);
#line 924 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = unselected;
#line 924 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 924 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 924 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 5552 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 925 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = unselected;
#line 925 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, (GeeCollection*) _tmp5_);
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp6_ = unselected;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, (GeeCollection*) _tmp6_);
#line 5563 "ViewCollection.c"
	}
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5567 "ViewCollection.c"
}


void
view_collection_unselect_all (ViewCollection* self)
{
	DataSet* _tmp0_;
	Marker* marker = NULL;
	Marker* _tmp1_;
	Marker* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	Marker* _tmp5_;
#line 931 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 932 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 932 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp0_) == 0) {
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return;
#line 5589 "ViewCollection.c"
	}
#line 935 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_start_marking ((DataCollection*) self);
#line 935 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker = _tmp1_;
#line 936 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = marker;
#line 936 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_selected (self);
#line 936 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 936 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker_mark_many (_tmp2_, (GeeCollection*) _tmp4_);
#line 936 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp4_);
#line 938 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = marker;
#line 938 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp5_);
#line 931 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5611 "ViewCollection.c"
}


void
view_collection_unselect_all_but (ViewCollection* self,
                                  DataView* exception)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp13_;
#line 942 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 942 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (exception != NULL);
#line 943 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 943 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 5630 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all ((DataCollection*) self);
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5651 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 5666 "ViewCollection.c"
			}
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = _tmp9_;
#line 946 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 946 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp10_ != exception) {
#line 5684 "ViewCollection.c"
				Marker* _tmp11_;
				DataView* _tmp12_;
#line 947 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = marker;
#line 947 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 947 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				marker_mark (_tmp11_, (DataObject*) _tmp12_);
#line 5693 "ViewCollection.c"
			}
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 5699 "ViewCollection.c"
		}
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 5703 "ViewCollection.c"
	}
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp13_);
#line 942 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5711 "ViewCollection.c"
}


static gboolean
view_collection_unselect_item (ViewCollection* self,
                               DataObject* object,
                               GObject* user)
{
	gboolean result = FALSE;
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp4_;
	DataView* _tmp5_;
#line 953 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 953 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 954 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 954 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view = _tmp0_;
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!data_view_is_selected (_tmp1_)) {
#line 5738 "ViewCollection.c"
		DataSet* _tmp2_;
		DataView* _tmp3_;
#line 956 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->selected;
#line 956 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 956 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_vala_assert (!data_set_contains (_tmp2_, (DataObject*) _tmp3_), "!selected.contains (view)");
#line 958 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = TRUE;
#line 958 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 958 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 5753 "ViewCollection.c"
	}
#line 961 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 961 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp4_, FALSE);
#line 962 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 962 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp5_);
#line 964 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 964 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 964 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5769 "ViewCollection.c"
}


void
view_collection_unselect_and_select_marked (ViewCollection* self,
                                            Marker* unselect,
                                            Marker* select)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp1_;
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (unselect != NULL);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (select != NULL);
#line 969 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 969 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 970 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, unselect, _view_collection_unselect_item_marked_action, self, NULL, NULL, (GObject*) unselected);
#line 972 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) unselected);
#line 974 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 974 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	selected = _tmp1_;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, select, _view_collection_select_item_marked_action, self, NULL, NULL, (GObject*) selected);
#line 977 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) selected);
#line 979 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, (GeeCollection*) selected, (GeeCollection*) unselected);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5810 "ViewCollection.c"
}


static gboolean
_view_collection_toggle_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_toggle_item ((ViewCollection*) self, object, user);
#line 986 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5823 "ViewCollection.c"
}


void
view_collection_toggle_marked (ViewCollection* self,
                               Marker* marker)
{
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
#line 984 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 984 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 985 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_toggle_lists_new ();
#line 985 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	lists = _tmp0_;
#line 986 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, (GObject*) lists);
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = lists->selected;
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) _tmp1_);
#line 990 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = lists->unselected;
#line 990 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) _tmp2_);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = lists->selected;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = lists->unselected;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
#line 984 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 5863 "ViewCollection.c"
}


static gboolean
view_collection_toggle_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	gboolean result = FALSE;
	DataView* view = NULL;
	DataView* _tmp0_;
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp1_;
	DataView* _tmp2_;
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 996 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 996 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view = _tmp0_;
#line 997 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (user, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists));
#line 997 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	lists = _tmp1_;
#line 1003 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1003 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_view_internal_toggle (_tmp2_)) {
#line 5894 "ViewCollection.c"
		DataView* _tmp3_;
#line 1004 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1004 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp3_)) {
#line 5900 "ViewCollection.c"
			ViewCollectionToggleLists* _tmp4_;
			GeeArrayList* _tmp5_;
			DataView* _tmp6_;
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = lists;
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _tmp4_->selected;
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 5912 "ViewCollection.c"
		}
	} else {
		ViewCollectionToggleLists* _tmp7_;
		GeeArrayList* _tmp8_;
		DataView* _tmp9_;
#line 1007 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp7_ = lists;
#line 1007 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp8_ = _tmp7_->unselected;
#line 1007 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp9_ = view;
#line 1007 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 5926 "ViewCollection.c"
	}
#line 1010 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 1010 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 1010 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1010 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5936 "ViewCollection.c"
}


gint
view_collection_get_selected_count (ViewCollection* self)
{
	gint result = 0;
	DataSet* _tmp0_;
#line 1013 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1014 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1014 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = data_set_get_count (_tmp0_);
#line 1014 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5953 "ViewCollection.c"
}


GeeList*
view_collection_get_selected (ViewCollection* self)
{
	GeeList* result = NULL;
	DataSet* _tmp0_;
	GeeList* _tmp1_;
#line 1017 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5973 "ViewCollection.c"
}


DataView*
view_collection_get_selected_at (ViewCollection* self,
                                 gint index)
{
	DataView* result = NULL;
	DataSet* _tmp0_;
	DataObject* _tmp1_;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1022 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1022 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1022 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 1022 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 5994 "ViewCollection.c"
}


static gboolean
view_collection_is_visible (ViewCollection* self,
                            DataView* view)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
#line 1025 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1025 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 6013 "ViewCollection.c"
		DataSet* _tmp2_;
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_set_contains (_tmp2_, (DataObject*) view);
#line 6019 "ViewCollection.c"
	} else {
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 6023 "ViewCollection.c"
	}
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 1026 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6029 "ViewCollection.c"
}


static gboolean
view_collection_add_many_visible (ViewCollection* self,
                                  GeeCollection* many)
{
	gboolean result = FALSE;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
	DataSet* _tmp2_;
#line 1029 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1029 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (many != NULL, FALSE);
#line 1030 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->visible;
#line 1030 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_ == NULL) {
#line 1031 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = TRUE;
#line 1031 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 6053 "ViewCollection.c"
	}
#line 1033 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1033 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!data_set_add_many (_tmp1_, many)) {
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = FALSE;
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 6063 "ViewCollection.c"
	}
#line 1037 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->visible;
#line 1037 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp2_) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 1038 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1038 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		self->priv->visible = NULL;
#line 6073 "ViewCollection.c"
	}
#line 1040 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 1040 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6079 "ViewCollection.c"
}


static void
view_collection_hide_items (ViewCollection* self,
                            GeeList* to_hide)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp17_;
	gboolean removed = FALSE;
	DataSet* _tmp19_;
	gboolean _tmp20_;
	GeeArrayList* _tmp21_;
	GeeArrayList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp26_;
	gint _tmp27_;
#line 1044 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1044 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (to_hide != NULL);
#line 1045 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1045 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 1047 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) to_hide);
#line 1047 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1047 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	count = _tmp2_;
#line 6116 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		ctr = 0;
#line 6121 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6128 "ViewCollection.c"
				gint _tmp5_;
				gint _tmp6_;
				DataView* view = NULL;
				gint _tmp7_;
				gpointer _tmp8_;
				DataView* _tmp9_;
				DataView* _tmp10_;
				DataView* _tmp16_;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 6139 "ViewCollection.c"
					gint _tmp4_;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 6145 "ViewCollection.c"
				}
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = ctr;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp6_ = count;
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 6157 "ViewCollection.c"
				}
#line 1049 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 1049 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = gee_list_get (to_hide, _tmp7_);
#line 1049 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view = (DataView*) _tmp8_;
#line 1050 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9_ = view;
#line 1050 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_vala_assert (data_view_is_visible (_tmp9_), "view.is_visible ()");
#line 1052 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = view;
#line 1052 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp10_)) {
#line 6173 "ViewCollection.c"
					DataView* _tmp11_;
					GeeArrayList* _tmp12_;
					DataView* _tmp13_;
#line 1053 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp11_ = view;
#line 1053 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					data_view_internal_set_selected (_tmp11_, FALSE);
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp12_ = unselected;
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp13_ = view;
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 6187 "ViewCollection.c"
				} else {
					DataSet* _tmp14_;
					DataView* _tmp15_;
#line 1056 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp14_ = self->priv->selected;
#line 1056 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp15_ = view;
#line 1056 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp14_, (DataObject*) _tmp15_), "!selected.contains (view)");
#line 6197 "ViewCollection.c"
				}
#line 1059 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 1059 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp16_, FALSE);
#line 1048 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6205 "ViewCollection.c"
			}
		}
	}
#line 1062 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp17_ = self->priv->visible;
#line 1062 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp17_ == NULL) {
#line 6213 "ViewCollection.c"
		DataSet* _tmp18_;
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp18_ = data_collection_get_dataset_copy ((DataCollection*) self);
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		self->priv->visible = _tmp18_;
#line 6221 "ViewCollection.c"
	}
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp19_ = self->priv->visible;
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp19_, (GeeCollection*) to_hide);
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp20_ = removed;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (_tmp20_, "removed");
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp21_ = unselected;
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) _tmp21_);
#line 1072 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp22_ = unselected;
#line 1072 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 1072 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp24_ = _tmp23_;
#line 1072 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp24_ > 0) {
#line 6243 "ViewCollection.c"
		GeeArrayList* _tmp25_;
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp25_ = unselected;
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, (GeeCollection*) _tmp25_);
#line 6249 "ViewCollection.c"
	}
#line 1075 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp26_ = gee_collection_get_size ((GeeCollection*) to_hide);
#line 1075 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp27_ = _tmp26_;
#line 1075 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp27_ > 0) {
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_hidden (self, (GeeCollection*) to_hide);
#line 1077 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, (GeeCollection*) to_hide);
#line 6261 "ViewCollection.c"
	}
#line 1044 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6265 "ViewCollection.c"
}


static void
view_collection_show_items (ViewCollection* self,
                            GeeList* to_show)
{
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	gboolean added = FALSE;
	gboolean _tmp16_;
	GeeArrayList* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (to_show != NULL);
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	added_selected = _tmp0_;
#line 1085 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) to_show);
#line 1085 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1085 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	count = _tmp2_;
#line 6297 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		ctr = 0;
#line 6302 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6309 "ViewCollection.c"
				gint _tmp5_;
				gint _tmp6_;
				DataView* view = NULL;
				gint _tmp7_;
				gpointer _tmp8_;
				DataView* _tmp9_;
				DataView* _tmp10_;
				DataView* _tmp11_;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 6320 "ViewCollection.c"
					gint _tmp4_;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 6326 "ViewCollection.c"
				}
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = ctr;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp6_ = count;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 6338 "ViewCollection.c"
				}
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = gee_list_get (to_show, _tmp7_);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view = (DataView*) _tmp8_;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9_ = view;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_vala_assert (!data_view_is_visible (_tmp9_), "!view.is_visible ()");
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = view;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp10_, TRUE);
#line 1093 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = view;
#line 1093 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp11_)) {
#line 6358 "ViewCollection.c"
					DataSet* _tmp12_;
					DataView* _tmp13_;
					GeeArrayList* _tmp14_;
					DataView* _tmp15_;
#line 1094 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp12_ = self->priv->selected;
#line 1094 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp13_ = view;
#line 1094 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp12_, (DataObject*) _tmp13_), "!selected.contains (view)");
#line 1095 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp14_ = added_selected;
#line 1095 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp15_ = view;
#line 1095 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 6375 "ViewCollection.c"
				}
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6379 "ViewCollection.c"
			}
		}
	}
#line 1099 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	added = view_collection_add_many_visible (self, (GeeCollection*) to_show);
#line 1100 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp16_ = added;
#line 1100 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (_tmp16_, "added");
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp17_ = added_selected;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) _tmp17_);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp18_ = gee_collection_get_size ((GeeCollection*) to_show);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp19_ = _tmp18_;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp19_ > 0) {
#line 1105 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_shown (self, (GeeCollection*) to_show);
#line 1106 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, (GeeCollection*) to_show);
#line 6403 "ViewCollection.c"
	}
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 6407 "ViewCollection.c"
}


gboolean
view_collection_has_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	gboolean result = FALSE;
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
#line 1111 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1111 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1112 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6435 "ViewCollection.c"
}


DataView*
view_collection_get_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	DataView* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 1116 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, source);
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = (DataView*) _tmp1_;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6458 "ViewCollection.c"
}


gboolean
view_collection_has_view_for_source_with_filtered (ViewCollection* self,
                                                   DataSource* source)
{
	gboolean result = FALSE;
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
#line 1121 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1121 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source_filtered (self, source);
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6486 "ViewCollection.c"
}


DataView*
view_collection_get_view_for_source_filtered (ViewCollection* self,
                                              DataSource* source)
{
	DataView* result = NULL;
	DataView* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	DataView* _tmp3_;
#line 1126 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1126 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 1127 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1127 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, source);
#line 1127 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view = (DataView*) _tmp1_;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = view;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 6514 "ViewCollection.c"
		DataView* _tmp4_;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = !view_collection_is_in_filter (self, _tmp4_);
#line 6520 "ViewCollection.c"
	} else {
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = FALSE;
#line 6524 "ViewCollection.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp2_) {
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		result = NULL;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return result;
#line 6534 "ViewCollection.c"
	}
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = view;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6540 "ViewCollection.c"
}


GeeCollection*
view_collection_get_sources (ViewCollection* self)
{
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeCollection* _tmp6_;
#line 1135 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = gee_set_get_read_only_view (_tmp3_);
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp6_ = (GeeCollection*) _tmp5_;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp6_;
#line 1136 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6577 "ViewCollection.c"
}


gboolean
view_collection_has_source_of_type (ViewCollection* self,
                                    GType t)
{
	gboolean result = FALSE;
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 6590 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->source_map;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_source_it = _tmp5_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6617 "ViewCollection.c"
			GeeIterator* _tmp6_;
			DataSource* source = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			DataSource* _tmp9_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _source_it;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 6629 "ViewCollection.c"
			}
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = _source_it;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp8_;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = source;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_), t)) {
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				result = TRUE;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_source_it);
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				return result;
#line 6649 "ViewCollection.c"
			}
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 6653 "ViewCollection.c"
		}
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 6657 "ViewCollection.c"
	}
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = FALSE;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6663 "ViewCollection.c"
}


gint
view_collection_get_sources_of_type_count (ViewCollection* self,
                                           GType t)
{
	gint result = 0;
	gint count = 0;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	count = 0;
#line 6679 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all ((DataCollection*) self);
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6700 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gboolean _tmp10_;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 6715 "ViewCollection.c"
			}
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_), t);
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 6735 "ViewCollection.c"
				gint _tmp11_;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = count;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				count = _tmp11_ + 1;
#line 6741 "ViewCollection.c"
			}
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6745 "ViewCollection.c"
		}
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6749 "ViewCollection.c"
	}
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = count;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6755 "ViewCollection.c"
}


GeeList*
view_collection_get_sources_of_type (ViewCollection* self,
                                     GType t)
{
	GeeList* result = NULL;
	GeeList* sources = NULL;
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 1166 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	sources = NULL;
#line 6771 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all ((DataCollection*) self);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6792 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataSource* source = NULL;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 6807 "ViewCollection.c"
			}
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1168 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1168 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1168 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = _tmp8_;
#line 1169 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = source;
#line 1169 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_), t)) {
#line 6825 "ViewCollection.c"
				GeeList* _tmp10_;
				GeeList* _tmp12_;
				DataSource* _tmp13_;
#line 1170 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = sources;
#line 1170 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp10_ == NULL) {
#line 6833 "ViewCollection.c"
					GeeArrayList* _tmp11_;
#line 1171 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp11_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1171 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1171 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					sources = (GeeList*) _tmp11_;
#line 6841 "ViewCollection.c"
				}
#line 1173 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = sources;
#line 1173 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = source;
#line 1173 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp12_, _tmp13_);
#line 6849 "ViewCollection.c"
			}
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6855 "ViewCollection.c"
		}
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6859 "ViewCollection.c"
	}
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = sources;
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6865 "ViewCollection.c"
}


GeeList*
view_collection_get_selected_sources (ViewCollection* self)
{
	GeeList* result = NULL;
	GeeList* sources = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	DataSet* _tmp1_;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	sources = (GeeList*) _tmp0_;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->selected;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	count = data_set_get_count (_tmp1_);
#line 6887 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		ctr = 0;
#line 6892 "ViewCollection.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = TRUE;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6899 "ViewCollection.c"
				gint _tmp4_;
				gint _tmp5_;
				GeeList* _tmp6_;
				DataSet* _tmp7_;
				gint _tmp8_;
				DataObject* _tmp9_;
				DataView* _tmp10_;
				DataSource* _tmp11_;
				DataSource* _tmp12_;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!_tmp2_) {
#line 6911 "ViewCollection.c"
					gint _tmp3_;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp3_ = ctr;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					ctr = _tmp3_ + 1;
#line 6917 "ViewCollection.c"
				}
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp2_ = FALSE;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp4_ = ctr;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = count;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 6929 "ViewCollection.c"
				}
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp6_ = sources;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp7_ = self->priv->selected;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp8_ = ctr;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp9_ = data_set_get_at (_tmp7_, _tmp8_);
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_DATA_VIEW, DataView);
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = data_view_get_source (_tmp10_);
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = _tmp11_;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp6_, _tmp12_);
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp12_);
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp10_);
#line 6951 "ViewCollection.c"
			}
		}
	}
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = sources;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 6959 "ViewCollection.c"
}


DataSource*
view_collection_get_selected_source_at (ViewCollection* self,
                                        gint index)
{
	DataSource* result = NULL;
	DataObject* object = NULL;
	DataSet* _tmp0_;
	DataObject* _tmp1_;
	DataSource* _tmp2_ = NULL;
	DataObject* _tmp3_;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	object = _tmp1_;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = object;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 6985 "ViewCollection.c"
		DataObject* _tmp4_;
		DataSource* _tmp5_;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = object;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = _tmp5_;
#line 6996 "ViewCollection.c"
	} else {
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = NULL;
#line 7002 "ViewCollection.c"
	}
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (object);
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 7010 "ViewCollection.c"
}


GeeList*
view_collection_get_selected_sources_of_type (ViewCollection* self,
                                              GType t)
{
	GeeList* result = NULL;
	GeeList* sources = NULL;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	sources = NULL;
#line 7024 "ViewCollection.c"
	{
		GeeList* _view_list = NULL;
		GeeList* _tmp0_;
		gint _view_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _view_index = 0;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = view_collection_get_selected (self);
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_view_list = _tmp0_;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = _view_list;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_view_size = _tmp3_;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_view_index = -1;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		while (TRUE) {
#line 7049 "ViewCollection.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			DataView* view = NULL;
			GeeList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			DataSource* source = NULL;
			DataView* _tmp10_;
			DataSource* _tmp11_;
			DataSource* _tmp12_;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp4_ = _view_index;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_index = _tmp4_ + 1;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp5_ = _view_index;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp6_ = _view_size;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				break;
#line 7073 "ViewCollection.c"
			}
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp7_ = _view_list;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp8_ = _view_index;
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = gee_list_get (_tmp7_, _tmp8_);
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			view = (DataView*) _tmp9_;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp12_), t)) {
#line 7093 "ViewCollection.c"
				GeeList* _tmp13_;
				GeeList* _tmp15_;
				DataSource* _tmp16_;
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = sources;
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (_tmp13_ == NULL) {
#line 7101 "ViewCollection.c"
					GeeArrayList* _tmp14_;
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_tmp14_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					sources = (GeeList*) _tmp14_;
#line 7109 "ViewCollection.c"
				}
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp15_ = sources;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp16_ = source;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp15_, _tmp16_);
#line 7117 "ViewCollection.c"
			}
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 7123 "ViewCollection.c"
		}
#line 1198 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_list);
#line 7127 "ViewCollection.c"
	}
#line 1208 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = sources;
#line 1208 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 7133 "ViewCollection.c"
}


gint
view_collection_index_of_source (ViewCollection* self,
                                 DataSource* source)
{
	gint result = 0;
	DataView* view = NULL;
	DataView* _tmp0_;
	gint _tmp1_ = 0;
	DataView* _tmp2_;
#line 1212 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1212 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, 0);
#line 1213 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1213 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view = _tmp0_;
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp2_ != NULL) {
#line 7158 "ViewCollection.c"
		DataView* _tmp3_;
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_index_of ((DataCollection*) self, (DataObject*) _tmp3_);
#line 7164 "ViewCollection.c"
	} else {
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = -1;
#line 7168 "ViewCollection.c"
	}
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = _tmp1_;
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1215 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 7176 "ViewCollection.c"
}


void
view_collection_internal_notify_view_altered (ViewCollection* self,
                                              DataView* view)
{
#line 1219 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1219 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 1220 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen ((DataCollection*) self)) {
#line 7190 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton ((DataObject*) view);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, _tmp1_);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 7203 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1224 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_views_altered;
#line 1224 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 7211 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_views_altered);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			self->priv->frozen_views_altered = _tmp3_;
#line 7219 "ViewCollection.c"
		}
#line 1226 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_views_altered;
#line 1226 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, view);
#line 7225 "ViewCollection.c"
	}
}


void
view_collection_internal_notify_geometry_altered (ViewCollection* self,
                                                  DataView* view)
{
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen ((DataCollection*) self)) {
#line 7240 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton ((DataObject*) view);
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp1_);
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 7253 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1236 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_geometries_altered;
#line 1236 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 7261 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			self->priv->frozen_geometries_altered = _tmp3_;
#line 7269 "ViewCollection.c"
		}
#line 1238 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_geometries_altered;
#line 1238 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, view);
#line 7275 "ViewCollection.c"
	}
}


static void
view_collection_real_notify_thawed (DataCollection* base)
{
	ViewCollection * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp8_;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->frozen_views_altered;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 7292 "ViewCollection.c"
		GeeHashSet* _tmp7_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp1_;
			GeeIterator* _tmp2_;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp1_ = self->priv->frozen_views_altered;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_it = _tmp2_;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7306 "ViewCollection.c"
				GeeIterator* _tmp3_;
				DataView* view = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				DataView* _tmp6_;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp3_ = _view_it;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 7318 "ViewCollection.c"
				}
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp4_ = _view_it;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view_collection_notify_item_view_altered (self, _tmp6_);
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7332 "ViewCollection.c"
			}
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7336 "ViewCollection.c"
		}
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_views_altered;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, (GeeCollection*) _tmp7_);
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_views_altered);
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		self->priv->frozen_views_altered = NULL;
#line 7346 "ViewCollection.c"
	}
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp8_ = self->priv->frozen_geometries_altered;
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (_tmp8_ != NULL) {
#line 7352 "ViewCollection.c"
		GeeHashSet* _tmp15_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp9_;
			GeeIterator* _tmp10_;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp9_ = self->priv->frozen_geometries_altered;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_tmp10_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp9_);
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_view_it = _tmp10_;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7366 "ViewCollection.c"
				GeeIterator* _tmp11_;
				DataView* view = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				DataView* _tmp14_;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp11_ = _view_it;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
					break;
#line 7378 "ViewCollection.c"
				}
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp12_ = _view_it;
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view = (DataView*) _tmp13_;
#line 1252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1252 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				view_collection_notify_item_geometry_altered (self, _tmp14_);
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7392 "ViewCollection.c"
			}
#line 1251 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7396 "ViewCollection.c"
		}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_tmp15_ = self->priv->frozen_geometries_altered;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, (GeeCollection*) _tmp15_);
#line 1254 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1254 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		self->priv->frozen_geometries_altered = NULL;
#line 7406 "ViewCollection.c"
	}
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 7410 "ViewCollection.c"
}


gboolean
view_collection_are_items_filtered_out (ViewCollection* self)
{
	gboolean result = FALSE;
#line 1260 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1261 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) != data_collection_get_count ((DataCollection*) self);
#line 1261 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 7424 "ViewCollection.c"
}


static void
view_collection_real_items_selected (ViewCollection* self,
                                     GeeIterable* selected)
{
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (selected != NULL);
#line 7434 "ViewCollection.c"
}


static void
view_collection_real_items_unselected (ViewCollection* self,
                                       GeeIterable* unselected)
{
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (unselected != NULL);
#line 7444 "ViewCollection.c"
}


static void
view_collection_real_items_state_changed (ViewCollection* self,
                                          GeeIterable* changed)
{
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 7454 "ViewCollection.c"
}


static void
view_collection_real_selection_group_altered (ViewCollection* self)
{
}


static void
view_collection_real_items_shown (ViewCollection* self,
                                  GeeCollection* visible)
{
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (visible != NULL);
#line 7470 "ViewCollection.c"
}


static void
view_collection_real_items_hidden (ViewCollection* self,
                                   GeeCollection* hidden)
{
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (hidden != NULL);
#line 7480 "ViewCollection.c"
}


static void
view_collection_real_items_visibility_changed (ViewCollection* self,
                                               GeeCollection* changed)
{
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 7490 "ViewCollection.c"
}


static void
view_collection_real_item_view_altered (ViewCollection* self,
                                        DataView* view)
{
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 7500 "ViewCollection.c"
}


static void
view_collection_real_item_geometry_altered (ViewCollection* self,
                                            DataView* view)
{
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 7510 "ViewCollection.c"
}


static void
view_collection_real_views_altered (ViewCollection* self,
                                    GeeCollection* views)
{
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 7520 "ViewCollection.c"
}


static void
view_collection_real_geometries_altered (ViewCollection* self,
                                         GeeCollection* views)
{
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 7530 "ViewCollection.c"
}


static void
view_collection_real_view_filter_installed (ViewCollection* self,
                                            ViewFilter* filer)
{
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (filer != NULL);
#line 7540 "ViewCollection.c"
}


static void
g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (n_param_values == 2);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data1 = closure->data;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 7566 "ViewCollection.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		data2 = closure->data;
#line 7572 "ViewCollection.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	callback (data1, value_get_view_filter (param_values + 1), data2);
#line 7578 "ViewCollection.c"
}


static void
view_collection_real_view_filter_removed (ViewCollection* self,
                                          ViewFilter* filer)
{
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (filer != NULL);
#line 7588 "ViewCollection.c"
}


ViewCollectionMonitor*
view_collection_monitor_construct (GType object_type)
{
	ViewCollectionMonitor* self = NULL;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 7600 "ViewCollection.c"
}


ViewCollectionMonitor*
view_collection_monitor_new (void)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 7609 "ViewCollection.c"
}


static void
view_collection_value_monitor_init (GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 7618 "ViewCollection.c"
}


static void
view_collection_value_monitor_free_value (GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_monitor_unref (value->data[0].v_pointer);
#line 7629 "ViewCollection.c"
	}
}


static void
view_collection_value_monitor_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
#line 7642 "ViewCollection.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7646 "ViewCollection.c"
	}
}


static gpointer
view_collection_value_monitor_peek_pointer (const GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7656 "ViewCollection.c"
}


static gchar*
view_collection_value_monitor_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 7668 "ViewCollection.c"
		ViewCollectionMonitor * object;
		object = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7675 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7679 "ViewCollection.c"
		}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_collection_monitor_ref (object);
#line 7683 "ViewCollection.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7687 "ViewCollection.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 7691 "ViewCollection.c"
}


static gchar*
view_collection_value_monitor_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	ViewCollectionMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!object_p) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7707 "ViewCollection.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 7713 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 7717 "ViewCollection.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
#line 7721 "ViewCollection.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 7725 "ViewCollection.c"
}


GParamSpec*
view_collection_param_spec_monitor (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ViewCollectionParamSpecMonitor* spec;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 7745 "ViewCollection.c"
}


gpointer
view_collection_value_get_monitor (const GValue* value)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7756 "ViewCollection.c"
}


void
view_collection_value_set_monitor (GValue* value,
                                   gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_monitor_ref (value->data[0].v_pointer);
#line 7779 "ViewCollection.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7783 "ViewCollection.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7789 "ViewCollection.c"
	}
}


void
view_collection_value_take_monitor (GValue* value,
                                    gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 7811 "ViewCollection.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7815 "ViewCollection.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7821 "ViewCollection.c"
	}
}


static void
view_collection_monitor_class_init (ViewCollectionMonitorClass * klass)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_finalize;
#line 7833 "ViewCollection.c"
}


static void
view_collection_monitor_instance_init (ViewCollectionMonitor * self)
{
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 7842 "ViewCollection.c"
}


static void
view_collection_monitor_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitor * self;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 7854 "ViewCollection.c"
}


GType
view_collection_monitor_get_type (void)
{
	static volatile gsize view_collection_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&view_collection_monitor_type_id__volatile, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__volatile;
}


gpointer
view_collection_monitor_ref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return instance;
#line 7883 "ViewCollection.c"
}


void
view_collection_monitor_unref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7898 "ViewCollection.c"
	}
}


static void
_view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                               GeeIterable* added,
                                                               gpointer self)
{
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_sources_added ((ViewCollection*) self, _sender, added);
#line 7910 "ViewCollection.c"
}


static void
_view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                   GeeIterable* removed,
                                                                   gpointer self)
{
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_sources_removed ((ViewCollection*) self, removed);
#line 7921 "ViewCollection.c"
}


static void
_view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                   GeeMap* items,
                                                                   gpointer self)
{
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_on_sources_altered ((ViewCollection*) self, _sender, items);
#line 7932 "ViewCollection.c"
}


static gpointer
_view_manager_ref0 (gpointer self)
{
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self ? view_manager_ref (self) : NULL;
#line 7941 "ViewCollection.c"
}


static gpointer
_alteration_ref0 (gpointer self)
{
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self ? alteration_ref (self) : NULL;
#line 7950 "ViewCollection.c"
}


static ViewCollectionMonitorImpl*
view_collection_monitor_impl_construct (GType object_type,
                                        ViewCollection* owner,
                                        SourceCollection* sources,
                                        ViewManager* manager,
                                        Alteration* prereq)
{
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	SourceCollection* _tmp1_;
	ViewManager* _tmp2_;
	Alteration* _tmp3_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (owner);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->owner = _tmp0_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (sources);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->sources = _tmp1_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = _view_manager_ref0 (manager);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->manager = _tmp2_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = _alteration_ref0 (prereq);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->prereq = _tmp3_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, owner);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, owner);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, owner);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 8006 "ViewCollection.c"
}


static ViewCollectionMonitorImpl*
view_collection_monitor_impl_new (ViewCollection* owner,
                                  SourceCollection* sources,
                                  ViewManager* manager,
                                  Alteration* prereq)
{
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 8018 "ViewCollection.c"
}


static void
view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass)
{
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_impl_finalize;
#line 8029 "ViewCollection.c"
}


static void
view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self)
{
}


static void
view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitorImpl * self;
	SourceCollection* _tmp0_;
	ViewCollection* _tmp1_;
	guint _tmp2_;
	SourceCollection* _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_;
	SourceCollection* _tmp6_;
	ViewCollection* _tmp7_;
	guint _tmp8_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = self->sources;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = self->owner;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp1_);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = self->sources;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp4_ = self->owner;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp4_);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp6_ = self->sources;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp7_ = self->owner;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp7_);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
#line 8088 "ViewCollection.c"
}


static GType
view_collection_monitor_impl_get_type (void)
{
	static volatile gsize view_collection_monitor_impl_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_monitor_impl_type_id__volatile, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__volatile;
}


static ViewCollectionToggleLists*
view_collection_toggle_lists_construct (GType object_type)
{
	ViewCollectionToggleLists * self = NULL;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 8114 "ViewCollection.c"
}


static ViewCollectionToggleLists*
view_collection_toggle_lists_new (void)
{
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 8123 "ViewCollection.c"
}


static void
view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass)
{
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
#line 8134 "ViewCollection.c"
}


static void
view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->selected = _tmp0_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->unselected = _tmp1_;
#line 8151 "ViewCollection.c"
}


static void
view_collection_toggle_lists_finalize (GObject * obj)
{
	ViewCollectionToggleLists * self;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->selected);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->unselected);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
#line 8167 "ViewCollection.c"
}


static GType
view_collection_toggle_lists_get_type (void)
{
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void
view_collection_class_init (ViewCollectionClass * klass)
{
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->finalize = view_collection_finalize;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_selected_unselected = (void (*) (ViewCollection *, GeeCollection*, GeeCollection*)) view_collection_real_notify_items_selected_unselected;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_selection_group_altered = (void (*) (ViewCollection *)) view_collection_real_notify_selection_group_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_view_altered = (void (*) (ViewCollection *, DataView*)) view_collection_real_notify_item_view_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_views_altered = (void (*) (ViewCollection *, GeeCollection*)) view_collection_real_notify_views_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_geometry_altered = (void (*) (ViewCollection *, DataView*)) view_collection_real_notify_item_geometry_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_geometries_altered = (void (*) (ViewCollection *, GeeCollection*)) view_collection_real_notify_geometries_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_shown = (void (*) (ViewCollection *, GeeCollection*)) view_collection_real_notify_items_shown;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_hidden = (void (*) (ViewCollection *, GeeCollection*)) view_collection_real_notify_items_hidden;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_visibility_changed = (void (*) (ViewCollection *, GeeCollection*)) view_collection_real_notify_items_visibility_changed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_installed = (void (*) (ViewCollection *, ViewFilter*)) view_collection_real_notify_view_filter_installed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_removed = (void (*) (ViewCollection *, ViewFilter*)) view_collection_real_notify_view_filter_removed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->clear = (void (*) (DataCollection *)) view_collection_real_clear;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->close = (void (*) (DataCollection *)) view_collection_real_close;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->valid_type = (gboolean (*) (DataCollection *, DataObject*)) view_collection_real_valid_type;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add = (gboolean (*) (DataCollection *, DataObject*)) view_collection_real_add;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add_many = (GeeCollection* (*) (DataCollection *, GeeCollection*, ProgressMonitor, void*)) view_collection_real_add_many;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_added = (void (*) (DataCollection *, GeeIterable*)) view_collection_real_notify_items_added;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_removed = (void (*) (DataCollection *, GeeIterable*)) view_collection_real_notify_items_removed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection *, GeeMap*)) view_collection_real_items_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->set_comparator = (void (*) (DataCollection *, Comparator, void*, ComparatorPredicate, void*)) view_collection_real_set_comparator;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->reset_comparator = (void (*) (DataCollection *)) view_collection_real_reset_comparator;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_all = (GeeCollection* (*) (DataCollection *)) view_collection_real_get_all;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_count = (gint (*) (DataCollection *)) view_collection_real_get_count;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_at = (DataObject* (*) (DataCollection *, gint)) view_collection_real_get_at;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->index_of = (gint (*) (DataCollection *, DataObject*)) view_collection_real_index_of;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->contains = (gboolean (*) (DataCollection *, DataObject*)) view_collection_real_contains;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first = (DataView* (*) (ViewCollection *)) view_collection_real_get_first;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first_unrejected = (DataView* (*) (ViewCollection *)) view_collection_real_get_first_unrejected;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_last = (DataView* (*) (ViewCollection *)) view_collection_real_get_last;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_next = (DataView* (*) (ViewCollection *, DataView*)) view_collection_real_get_next;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_previous = (DataView* (*) (ViewCollection *, DataView*)) view_collection_real_get_previous;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_thawed = (void (*) (DataCollection *)) view_collection_real_notify_thawed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_selected = view_collection_real_items_selected;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_unselected = view_collection_real_items_unselected;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_state_changed = view_collection_real_items_state_changed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->selection_group_altered = view_collection_real_selection_group_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_shown = view_collection_real_items_shown;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_hidden = view_collection_real_items_hidden;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_view_altered = view_collection_real_item_view_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->views_altered = view_collection_real_views_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->geometries_altered = view_collection_real_geometries_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_installed = view_collection_real_view_filter_installed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_removed = view_collection_real_view_filter_removed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL] = g_signal_new ("items-selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL] = g_signal_new ("items-unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL] = g_signal_new ("items-state-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL] = g_signal_new ("selection-group-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL] = g_signal_new ("items-shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL] = g_signal_new ("items-hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("items-visibility-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL] = g_signal_new ("item-view-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL] = g_signal_new ("item-geometry-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL] = g_signal_new ("views-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL] = g_signal_new ("geometries-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL] = g_signal_new ("view-filter-installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL] = g_signal_new ("view-filter-removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 8310 "ViewCollection.c"
}


static void
view_collection_instance_init (ViewCollection * self)
{
	GeeHashMultiMap* _tmp0_;
	GeeHashSet* _tmp1_;
	DataSet* _tmp2_;
	GeeHashMap* _tmp3_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, (GDestroyNotify) view_collection_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->monitors = _tmp0_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = NULL;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = self;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->should_mirror = NULL;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->should_mirror_target = self;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, (GDestroyNotify) view_filter_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->filters = (GeeSet*) _tmp1_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp2_ = data_set_new ();
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->selected = _tmp2_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->visible = NULL;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->frozen_views_altered = NULL;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->frozen_geometries_altered = NULL;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_tmp3_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->priv->source_map = _tmp3_;
#line 8355 "ViewCollection.c"
}


static void
view_collection_finalize (DataCollection * obj)
{
	ViewCollection * self;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_COLLECTION, ViewCollection);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->monitors);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->filters);
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->selected);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->visible);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_views_altered);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->source_map);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
#line 8383 "ViewCollection.c"
}


GType
view_collection_get_type (void)
{
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}


static gboolean
view_manager_real_include_in_view (ViewManager* self,
                                   DataSource* source)
{
	gboolean result = FALSE;
#line 1271 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	result = TRUE;
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return result;
#line 8412 "ViewCollection.c"
}


gboolean
view_manager_include_in_view (ViewManager* self,
                              DataSource* source)
{
#line 1271 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1271 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 8424 "ViewCollection.c"
}


static DataView*
view_manager_real_create_view (ViewManager* self,
                               DataSource* source)
{
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 8436 "ViewCollection.c"
}


DataView*
view_manager_create_view (ViewManager* self,
                          DataSource* source)
{
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 8448 "ViewCollection.c"
}


ViewManager*
view_manager_construct (GType object_type)
{
	ViewManager* self = NULL;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewManager*) g_type_create_instance (object_type);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 8460 "ViewCollection.c"
}


static void
value_view_manager_init (GValue* value)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8469 "ViewCollection.c"
}


static void
value_view_manager_free_value (GValue* value)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_manager_unref (value->data[0].v_pointer);
#line 8480 "ViewCollection.c"
	}
}


static void
value_view_manager_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
#line 8493 "ViewCollection.c"
	} else {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8497 "ViewCollection.c"
	}
}


static gpointer
value_view_manager_peek_pointer (const GValue* value)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8507 "ViewCollection.c"
}


static gchar*
value_view_manager_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8519 "ViewCollection.c"
		ViewManager * object;
		object = collect_values[0].v_pointer;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8526 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8530 "ViewCollection.c"
		}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_manager_ref (object);
#line 8534 "ViewCollection.c"
	} else {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8538 "ViewCollection.c"
	}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 8542 "ViewCollection.c"
}


static gchar*
value_view_manager_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	ViewManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8558 "ViewCollection.c"
	}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8564 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8568 "ViewCollection.c"
	} else {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = view_manager_ref (value->data[0].v_pointer);
#line 8572 "ViewCollection.c"
	}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 8576 "ViewCollection.c"
}


GParamSpec*
param_spec_view_manager (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecViewManager* spec;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8596 "ViewCollection.c"
}


gpointer
value_get_view_manager (const GValue* value)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8607 "ViewCollection.c"
}


void
value_set_view_manager (GValue* value,
                        gpointer v_object)
{
	ViewManager * old;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_manager_ref (value->data[0].v_pointer);
#line 8630 "ViewCollection.c"
	} else {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8634 "ViewCollection.c"
	}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8640 "ViewCollection.c"
	}
}


void
value_take_view_manager (GValue* value,
                         gpointer v_object)
{
	ViewManager * old;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8662 "ViewCollection.c"
	} else {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8666 "ViewCollection.c"
	}
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8672 "ViewCollection.c"
	}
}


static void
view_manager_class_init (ViewManagerClass * klass)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_manager_parent_class = g_type_class_peek_parent (klass);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->finalize = view_manager_finalize;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->include_in_view = (gboolean (*) (ViewManager *, DataSource*)) view_manager_real_include_in_view;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->create_view = (DataView* (*) (ViewManager *, DataSource*)) view_manager_real_create_view;
#line 8688 "ViewCollection.c"
}


static void
view_manager_instance_init (ViewManager * self)
{
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8697 "ViewCollection.c"
}


static void
view_manager_finalize (ViewManager * obj)
{
	ViewManager * self;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_MANAGER, ViewManager);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 8709 "ViewCollection.c"
}


GType
view_manager_get_type (void)
{
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer
view_manager_ref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return instance;
#line 8738 "ViewCollection.c"
}


void
view_manager_unref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
#line 1267 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8753 "ViewCollection.c"
	}
}


static gboolean
view_filter_real_predicate (ViewFilter* self,
                            DataView* view)
{
	gboolean _tmp0_ = FALSE;
#line 1299 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1299 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return _tmp0_;
#line 8767 "ViewCollection.c"
}


gboolean
view_filter_predicate (ViewFilter* self,
                       DataView* view)
{
#line 1299 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1299 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return VIEW_FILTER_GET_CLASS (self)->predicate (self, view);
#line 8779 "ViewCollection.c"
}


ViewFilter*
view_filter_construct (GType object_type)
{
	ViewFilter* self = NULL;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = (ViewFilter*) g_type_create_instance (object_type);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return self;
#line 8791 "ViewCollection.c"
}


static void
view_filter_real_refresh (ViewFilter* self)
{
}


static void
value_view_filter_init (GValue* value)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8806 "ViewCollection.c"
}


static void
value_view_filter_free_value (GValue* value)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_filter_unref (value->data[0].v_pointer);
#line 8817 "ViewCollection.c"
	}
}


static void
value_view_filter_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
#line 8830 "ViewCollection.c"
	} else {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8834 "ViewCollection.c"
	}
}


static gpointer
value_view_filter_peek_pointer (const GValue* value)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8844 "ViewCollection.c"
}


static gchar*
value_view_filter_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8856 "ViewCollection.c"
		ViewFilter * object;
		object = collect_values[0].v_pointer;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8863 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8867 "ViewCollection.c"
		}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_filter_ref (object);
#line 8871 "ViewCollection.c"
	} else {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8875 "ViewCollection.c"
	}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 8879 "ViewCollection.c"
}


static gchar*
value_view_filter_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	ViewFilter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8895 "ViewCollection.c"
	}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8901 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8905 "ViewCollection.c"
	} else {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		*object_p = view_filter_ref (value->data[0].v_pointer);
#line 8909 "ViewCollection.c"
	}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return NULL;
#line 8913 "ViewCollection.c"
}


GParamSpec*
param_spec_view_filter (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecViewFilter* spec;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8933 "ViewCollection.c"
}


gpointer
value_get_view_filter (const GValue* value)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8944 "ViewCollection.c"
}


void
value_set_view_filter (GValue* value,
                       gpointer v_object)
{
	ViewFilter * old;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_filter_ref (value->data[0].v_pointer);
#line 8967 "ViewCollection.c"
	} else {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8971 "ViewCollection.c"
	}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 8977 "ViewCollection.c"
	}
}


void
value_take_view_filter (GValue* value,
                        gpointer v_object)
{
	ViewFilter * old;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (v_object) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8999 "ViewCollection.c"
	} else {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9003 "ViewCollection.c"
	}
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (old) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 9009 "ViewCollection.c"
	}
}


static void
view_filter_class_init (ViewFilterClass * klass)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_filter_parent_class = g_type_class_peek_parent (klass);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->finalize = view_filter_finalize;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter *, DataView*)) view_filter_real_predicate;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->refresh = view_filter_real_refresh;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	view_filter_signals[VIEW_FILTER_REFRESH_SIGNAL] = g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9027 "ViewCollection.c"
}


static void
view_filter_instance_init (ViewFilter * self)
{
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 9036 "ViewCollection.c"
}


static void
view_filter_finalize (ViewFilter * obj)
{
	ViewFilter * self;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_FILTER, ViewFilter);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 9048 "ViewCollection.c"
}


GType
view_filter_get_type (void)
{
	static volatile gsize view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&view_filter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_filter_type_id;
		view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_filter_type_id__volatile, view_filter_type_id);
	}
	return view_filter_type_id__volatile;
}


gpointer
view_filter_ref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	return instance;
#line 9077 "ViewCollection.c"
}


void
view_filter_unref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9092 "ViewCollection.c"
	}
}



